/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/

#include "MAGE.H"

/*mageBbox.c*/

/****SetsinGrafWindow()******************************************************/
void    SetsinGrafWindow()   /* called from Mac Main.c or PC MENUCMD3.C*/
{
  /* set up check box in on-screen graphics window */
  /* Mac defines a button in terms of a handles to the created button*/
  /* PC defines a button in terms of an index to the created button*/
  /*  PC index is treated like a menucommand ID number: */
  /*    MM_BUTTONINDEX  to  (MM_BUTTONINDEX + MAXG + MAXXG + MAXS + MAXL) */
  /* UNIX PEX uses Widget gadgets as toggle buttons, indexed:  */
  /* lists as nlist, subgroups as nset+MAXL, groups as ngrp+MAXS+MAXL */
  /* i.e. PEX indexing is backwards from PC indexing.  This lets the PEX */
  /* name for picking structures use the list indexed by nlist as the */
  /* simple way */
  /*   920920 maximum extra groups now 8 not 7 so define MAXXG = 8 */
  /* this index has to be worked out here where it is known what kind of */
  /* button, group, subgroup (set), or list, that is being created */

  int              top,right,left,bottom,nbox,nn,indexPC,i;
  int              markanimbox,boxhigh,Lcycle,jlist;
  ControlHandle    buttonbox; /*PC typedef as HANDLE, PEX typedef Widget */
  char             name[13];
  static int       iyspacer;
  getbuttonplace();       /*___BBOX.C*/ 
  left   = brect.left;
  right  = brect.right;
  top    = brect.top;
  bottom = brect.bottom;
      
  if(IPC == 1) nn = 17; /* Mac uses 15, but PC font needs more space */
  else nn = 15;
  /* reasonable spacing for button boxes, compressed later if needed */
  jlist = 0;
  Lcycle = 1;
  while(Lcycle == 1)
  /*allow button boxes to get stuffed closer if many of them*/
  {/*Lcycle loop*/

    killgrafcontrols(); /*MACBBOX.C MPCBBOX.C*/

    strcpy(name,"            ");
    mybuttonspacer(left,iyspacer,name); /*macbxmc.c, mpcbxpc.c*/


    nbox = 0;    /* absolute box number for spacing boxes on screen */
    markbox = 0;  /* marker box number */
    animbox = 0;  /* 1st animate box number initialized to unused number */
    anim2box = 0; /* 2nd animate box number initialized to unused number */
    pickbox = 0;
    zclipbox = 0;
    measurebox = 0;
    drawlinebox = 0;
    eraselinebox = 0;
    constructlinebox = 0;
    markanimbox = 0;
    /* counter to allow animate box placed right if no marker box */
    /*do animate accounting here so it can be changed by PICKSHOW*/
    nanimate = 0; /*revision930221*/
    nnanimate = 0;
    for(ngrp = 1; ngrp <= maxgrp; ngrp++)
    {/*groups*/
      /*count actual animation groups here, before any filtering*/
      if(igrp[ngrp][3] == 1) nanimate++; /*revision930221*/
      if(igrp[ngrp][3] == 2) nnanimate++;
      if(igrp[ngrp][4] < 2)
      {/*not a nobutton group with no buttons at all*/
        nbox++;
        indexPC = ngrp;
                           /*Bx*/  /*PC MPCMENU.C */
        makebuttonbox(
          &grpbox[ngrp]      /*Handle: needed by Mac && X11, not used by PC*/
          ,left              /*int left: x , used straight*/
          ,top               /*int top:  y , not used: top = nbox*nn */
          ,right             /*int right: Mac right, PC width*/
          ,bottom            /*int bottom: Mac bottom, PC height=nn */
          ,groupname[ngrp]   /*char name */
          ,igrp[ngrp][0]     /*int on-off flag */
          ,nbox              /*int number of this box*/
          ,nn                /*int pixel height of box*/
          ,indexPC           /*int index to PC buttons as menu cmds*/
          );
        if(igrp[ngrp][4] == 0)
        {/*not a dominant group hiding subgroups and lists*/
          for(nset = igrp[ngrp][1]; nset <= igrp[ngrp][2]; nset++)
          {/*sets*/
            if(iset[nset][3] <= 1)   /* set button not created if >= 2 */
            {
              nbox++;
              indexPC = MAXG+MAXXG + nset;
              
/*Bx*/        makebuttonbox(
                &setbox[nset]
                ,left+5
                ,top
                ,right
                ,top
                ,setname[nset]
                ,iset[nset][0]
                ,nbox
                ,nn
                ,indexPC
                );
            }
            if(iset[nset][3]==0 || iset[nset][3]==2 || iset[nset][3]==3) 
            {/*not dominant subgroup, no hidden lists*/
              /*NOTE: set nobutton allows list buttons*/
              for(nlist = iset[nset][1];nlist <= iset[nset][2];nlist++)
              {/*lists*/
                if(ilist[nlist][6] == 0)
                {/*not nobutton*/
                  jlist++;
                  nbox++;
                  indexPC = MAXG+MAXXG+MAXS + nlist;
/*Bx*/            makebuttonbox(
                    &listbox[nlist]
                    ,left+10
                    ,top
                    ,right
                    ,top
                    ,listname[nlist]
                    ,ilist[nlist][0]
                    ,nbox
                    ,nn
                    ,indexPC
                  );
                }/*not nobutton*/
              }/*lists*/
            }/*not dominant subgroup, no hidden lists*/
          }/*sets*/
        }/*not a dominant group hiding subgroups and lists*/
      }/*not a nobutton group with no buttons at all*/
    }/*groups*/
    if(nmaster > 0)
    {
     nbox++; /*spacer between groups and master buttons */

      for(i=1; i<=nmaster; i++)
      {
        nbox++;
        indexPC = MAXG+MAXXG+MAXS+MAXL + i;
/*Bx*/  makebuttonbox(
            &masterbox[i]      /*Handle: needed by Mac, not used by PC*/
            ,left              /*int left: x */
            ,top               /*int top:  y */
            ,right             /*int right: Mac right, PC width*/
            ,bottom            /*int bottom: Mac bottom, PC height*/
            ,mastername[i]     /*char name */
            ,1                 /*int on-off flag */
            ,nbox              /*int number of this box*/
            ,nn                /*int pixel height of box*/
            ,indexPC           /*int index to PC buttons as menu cmds*/
             );
      }
    }
    nbox++; /*spacer before operations buttons */
    iyspacer = top + ((nbox)*nn);
    /*strcpy(name," -----------");*/ /*c*/ /*fill with ------- */
    /*mybuttonspacer(left,iyspacer,name);*/ /*macbxmc.c, mpcextra.c*/

    if(Lmarkers)  /* create marker button, as maxgrp+1 */
    {
        nbox++;
        markanimbox++;
        markbox = maxgrp + markanimbox; /*maxgrp <= MAXG */
/*c*/   strcpy(name,"markers");
/*Mx*/  condition(name);
        indexPC = markbox;
            /*moves into MAXXG reserved space just beyond maxgrp<=MAXG*/
/*Bx*/  makebuttonbox(
          &grpbox[markbox]
          ,left
          ,top
          ,right
          ,top
          ,name
          ,igrp[maxgrp+1][0]
          ,nbox
          ,nn
          ,indexPC
          );
    }
    /* create pickcenter button after marker button */
    if(Lpickcenter)
    {
        nbox++;
        markanimbox++;
        pickbox = maxgrp + markanimbox;
/*c*/   strcpy(name,"pickcenter");
/*Mx*/  condition(name);
        indexPC = pickbox;
/*Bx*/  makebuttonbox(
          &grpbox[pickbox]
          ,left
          ,top
          ,right
          ,top
          ,name
          ,Lpickon
          ,nbox
          ,nn
          ,indexPC
          );
    }
    if(Lpickshow)
    {
        nbox++;
        markanimbox++;
        pickshowbox = maxgrp + markanimbox;
/*c*/   strcpy(name,"PICKSHOW");
/*Mx*/  condition(name);
        indexPC = pickshowbox;
/*Bx*/  makebuttonbox(
          &grpbox[pickshowbox]
          ,left
          ,top
          ,right
          ,top
          ,name
          ,Lpickshowon
          ,nbox
          ,nn
          ,indexPC
          );
    }
    /* create zclip after pickcenter, PICKSHOW, & marker buttons */
    if(Lzclip)
    {
        nbox++;
        markanimbox++;
        zclipbox = maxgrp + markanimbox;
/*c*/   strcpy(name,"zclip");
/*Mx*/  condition(name);
        indexPC = zclipbox;
/*Bx*/  makebuttonbox(
          &grpbox[zclipbox]
          ,left
          ,top
          ,right
          ,top
          ,name
          ,(int)Lzclipon
          ,nbox
          ,nn
          ,indexPC
          );
    }
    /*create measure after zclip, pickcenter, & marker buttons*/
    if(Lmeasures)
    {
        nbox++;
        markanimbox++;
        measurebox = maxgrp + markanimbox;
/*c*/   strcpy(name,"measure");
/*Mx*/  condition(name);
        indexPC = measurebox;
/*Bx*/  makebuttonbox(
          &grpbox[measurebox]
          ,left
          ,top
          ,right
          ,top
          ,name
          ,(int)Lmeasureson
          ,nbox
          ,nn
          ,indexPC
          );
    }
    if(Ldrawline)  /* create draw stuff & eraseline buttons after */
        /* measure, zclip, pickcenter, & marker buttons */
    {/*draw new stuff*/
        nbox++;
        markanimbox++;
        drawlabelsbox = maxgrp + markanimbox;
            strcpy(name,"Labelson"); /*c*/
        condition(name); /*Mx*/
          indexPC = drawlabelsbox;
          makebuttonbox(         /*Bx*/ 
          &grpbox[drawlabelsbox]
          ,left
          ,top
          ,right
          ,top
          ,name
          ,Lnewlabelson
          ,nbox
          ,nn
          ,indexPC
          );
        nbox++;
        markanimbox++;
        drawlinebox = maxgrp + markanimbox;
            strcpy(name,"drawlineon"); /*c*/ 
        condition(name); /*Mx*/
          indexPC = drawlinebox;
          makebuttonbox(         /*Bx*/ 
          &grpbox[drawlinebox]
          ,left
          ,top
          ,right
          ,top
          ,name
          ,Ldrawlineon
          ,nbox
          ,nn
          ,indexPC
          );

            nbox++;
            markanimbox++;
            constructlinebox = maxgrp + markanimbox;
/*c*/       strcpy(name,"constructon");
/*Mx*/      condition(name);
            indexPC = constructlinebox;
/*Bx*/      makebuttonbox(
              &grpbox[constructlinebox]
              ,left
              ,top
              ,right
              ,top
              ,name
              ,Lconstructon
              ,nbox
              ,nn
              ,indexPC
              );
            nbox++;
            markanimbox++;
            draglinebox = maxgrp + markanimbox;
/*c*/       strcpy(name,"draglineon");
/*Mx*/      condition(name);
            indexPC = draglinebox;
/*Bx*/      makebuttonbox(
              &grpbox[draglinebox]
              ,left
              ,top
              ,right
              ,top
              ,name
              ,Ldraglineon
              ,nbox
              ,nn
              ,indexPC
              );
        if(Lmonitor)
        {
            nbox++;
            markanimbox++;
            monitorbox = maxgrp + markanimbox;
/*c*/       strcpy(name,"monitoron");
/*Mx*/      condition(name);
            indexPC = monitorbox;
/*Bx*/      makebuttonbox(
              &grpbox[monitorbox]
              ,left
              ,top
              ,right
              ,top
              ,name
              ,Lmonitoron
              ,nbox
              ,nn
              ,indexPC
              );
        }
        nbox++;
        markanimbox++;
        eraselinebox = maxgrp + markanimbox;
/*c*/   strcpy(name,"eraselast");
/*Mx*/  condition(name);
        indexPC = eraselinebox;
/*Bx*/  makebuttonbox(
          &grpbox[eraselinebox]
          ,left
          ,top
          ,right
          ,top
          ,name
          ,0
          ,nbox
          ,nn
          ,indexPC
          );

        nbox++;
        markanimbox++;
        drawgroupbox = maxgrp + markanimbox;
/*c*/   /*strcpy(name,"draw group");*//*revision930221*/
/*Mx*/  /*condition(name);*/
        indexPC = drawgroupbox;
/*Bx*/  makebuttonbox(
          &grpbox[drawgroupbox]
          ,left
          ,top
          ,right
          ,top
          ,groupname[maxgrp+3]  /*name*//*revision930221*/
          /*,1  */    /*always start with new group visible*/
          ,igrp[maxgrp+3][0] /*on-off state of new group*/ /*931001*/
          ,nbox
          ,nn
          ,indexPC
          );
        if(igrp[maxgrp+3][3]==1) nanimate++; /*revision930221*/
        if(igrp[maxgrp+3][3]==2) nnanimate++;
    }/*draw new stuff*/

    if(Lprune)  /* create prune, punch, undo buttons after */
        /* measure, zclip, pickcenter, & marker buttons */
        /* , & any draw-erase-construct line buttons */
    {
        nbox++;
        markanimbox++;
        prunebox = maxgrp + markanimbox;
/*c*/       strcpy(name,"prune");
/*Mx*/      condition(name);
          indexPC = prunebox;
/*Bx*/        makebuttonbox(
          &grpbox[prunebox]
          ,left
          ,top
          ,right
          ,top
          ,name
          ,(int)Lpruneon
          ,nbox
          ,nn
          ,indexPC
          );
        nbox++;
        markanimbox++;
        punchbox = maxgrp + markanimbox;
/*c*/   strcpy(name,"punch");
/*Mx*/  condition(name);
        indexPC = punchbox;
/*Bx*/  makebuttonbox(
          &grpbox[punchbox]
          ,left
          ,top
          ,right
          ,top
          ,name
          ,(int)Lpunchon
          ,nbox
          ,nn
          ,indexPC
          );
        nbox++;
        markanimbox++;
        undopbox = maxgrp + markanimbox;
/*c*/   strcpy(name,"undo p");
/*Mx*/  condition(name);
        indexPC = undopbox;
/*Bx*/  makebuttonbox(
          &grpbox[undopbox]
          ,left
          ,top
          ,right
          ,top
          ,name
          ,0
          ,nbox
          ,nn
          ,indexPC
          );
    }

    if(nanimate > 1)  /* create animate button, after other buttons */
    {
        nbox++;
        markanimbox++;
        animbox = maxgrp + markanimbox;
        if(Lcompareon) strcpy(name,"switch"); /*c*/
        else strcpy(name,"ANIMATE"); /*c*/
          /*revision930206 "animate grp" almost too long*/
/*Mx*/  condition(name);
        indexPC = animbox;
/*Bx*/  makebuttonbox(
          &grpbox[animbox]
          ,left
          ,top
          ,right
          ,top
          ,name
          ,0
          ,nbox
          ,nn
          ,indexPC
          );
    }
    if(nnanimate > 1)  /* create animate button, after other buttons */
    {
        nbox++;
        markanimbox++;
        anim2box = maxgrp + markanimbox;
        if(Lcompareon) strcpy(name,"2switch"); /*c*/
        else strcpy(name,"2ANIMATE"); /*c*/
          /*revision930206 "2animate grp" too long*/
/*Mx*/  condition(name);
        indexPC = anim2box;
/*Bx*/  makebuttonbox(
          &grpbox[anim2box]
          ,left
          ,top
          ,right
          ,top
          ,name
          ,0
          ,nbox
          ,nn
          ,indexPC
          );
    }
    strcpy(name," -----------");
    mybuttonspacer(left,iyspacer,name); /*MACBBOX.C, MPCBBOX.C*/

    if(nbox == 0) nbox = 1;
    
    boxhigh = (bottom - top)/nbox; /* needed interval per button box*/
    if(IPC) boxhigh = (bottom - top)/(nbox+1);
        /*PC measures from top of Char, needs one more space allocated*/

    if(boxhigh < nn)  /*interval needed less than what used, try again*/
    {
        while( boxhigh < nn) nn = nn -1;

        if(boxhigh < 12 && Ltest)
        {
            sprintf(alertstr,"%d buttons more than fill screen,"
                " expect squirrelly buttons",nbox);
          
            sprintf(alertstr2,"boxhigh = (bottom - top)/nbox,"
                "\015 %d = (%d - %d)/%d"
                , boxhigh,bottom,top,nbox);
            sprintf(alertstr3," ");
            DoMageDLOGreport(); /*alertstr,alertstr2,alertstr3*/ /*___DLOG.C*/
        }
        nn = boxhigh;
        Lcycle = 1;
    }
    else Lcycle = 0;
  }/*Lcycle loop*/

  /*Mac needs these below, since it kills all controls each time, */
  /*PC creates once, by a call to NewSliderWindows() from MPCINIT.C */
  /* then dummies these create...s in MPCBAR.C */
  /*UNIX creates once, uses the same names as Mac routines */
  if(Lzoom)
  {
#ifdef MACINTOSH
        creategrafzoomBar(); /*___BAR.c*/
#endif
        resetgrafzoomBar();  /*___BAR.c*/
  }
  if(Lzclip)
  {
#ifdef MACINTOSH
        creategrafzclipBar(); /*___BAR.c*/
#endif
        resetgrafzclipBar();  /*___BAR.c*/
  }
  if(Lztran)
  {
#ifdef MACINTOSH
        creategrafztranBar(); /*___BAR.c*/
#endif
        resetgrafztranBar();  /*___BAR.c*/
  }
#ifdef MACINTOSH
  placewindowresizemark();  /*MACBBOX.C, dummied in MPCBBOX.C*/
#endif
  if(nbondrot > 0)
  {
       for(i=1; i<=nbondrot; i++)
       {
#ifndef PCWINDOWS
/*printf("about to creategrafbondrotBar(%d)\n",i);*/
        creategrafbondrotBar(i); /*___BAR.c*/
#endif
        resetgrafbondrotBar(i);  /*___BAR.c*/
       }
  }

  if(nmaster > 0) for(i=1; i<=nmaster; i++) resetmaster(i);

  if(nanimate > 1) 
  {
         Lcompare = 1;
         /*Lcompareon set ==0 initially, may later be set ==1 before here*/
         if(Lcomparestart) 
         {
             Lcompareon = 1;
             Lcomparestart = 0; /*so compare can be turned off later*/
             adjustanimate(0); /*turns off all animate marked groups*/
             adjustanimate(1); /*sets up first two as a comparison*/
         }
         if(Lstereo) Lcompareon = 0; /*Lstereo incompatible with Lcompareon*/
         /*myenableitem(),mycheckitem()  MPCMENU.C, MACMENU.C */
         mycheckitem(otherMenu, compareItem, Lcompareon ); /*check or uncheck*/
         if(Lstereo) myenableitem(otherMenu, compareItem, 0); /*disable*/
         else        myenableitem(otherMenu, compareItem, 1); /*enable*/
         if(Lcompareon) 
         {   
             myenableitem(otherMenu, stereoItem, 0); /*disable stereo*/
             if(nanimate>0) mylabelbutton(animbox,"switch"); /*MPCMENU.C*/ 
                         /* dummied in MACPMENU.C*/
             if(nnanimate>0) mylabelbutton(anim2box,"2switch"); /*MPCMENU.C*/ 
         }
  }
  else
  {
         Lcompare = 0;
         Lcompareon = 0;
         mycheckitem( otherMenu, compareItem, 0); /*uncheck compare*/
         myenableitem(otherMenu, compareItem, 0); /*disable compare*/
         myenableitem(otherMenu, stereoItem, 1); /*enable stereo*/
         if(nanimate>0) mylabelbutton(animbox,"ANIMATE"); /*MPCMENU.C*/ 
                         /* dummied in MACPMENU.C*/
         if(nnanimate>0) mylabelbutton(anim2box,"2ANIMATE"); /*MPCMENU.C*/ 
         
  }
}
/*___SetsinGrafWindow()_____________________________________________________*/

/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****adjustanimate()**********************************************************/
void    adjustanimate(int nthanimate)
{/*begin adjust animation */
  static    int    first = 1,last,ioff,istep=1; /*remember these controls*/
            int    limitgrp, next, ifind, icycle = 1,ihitfirst,nextafter,ng;
            
        if(Ldrawline && igrp[maxgrp+3][3]==nthanimate) limitgrp=maxgrp+3;
        else limitgrp = maxgrp;
        if(first == 1) last = limitgrp + 1;
        icycle = 0;
        next = 1;
        ifind = 0; /* flag for first on group */
        ioff = 0; /* 0 not a possible group */
        nextafter = 0; /*flag to look for animate group following current*/     
        ihitfirst = 0; /*flag to find first of these animate groups */
        nextanimategroup = 0;
        while(next == 1)
        {/*begin while next flag set*/
             icycle = icycle + 1;
             if(icycle == 1) next = 0; /* clear flag for first cycle */
                 /*first cycle will at least turn all animatable groups OFF*/
                 /*Does second cycle if not find a group of the desired */
                 /*animate set ON to turn OFF */
                 /*Third cycle only if called with nthanimate==0 to turn all*/
                 /*animatable groups off.  e.g. when starting Lcompareon*/
             if(icycle == 3){ifind = 1; next = 0; break;}
             for(ng = first; ng != last; ng = ng + istep)
             {/*begin scan over all groups*/

                 if(igrp[ng][3] > 0) /* only check those with animate flag*/                 
                 {/*begin check animatable groups*/             
                     if(    /* nthanimate == 1 */
                         /*&&*/ igrp[ng][3] == nthanimate 
                         && !ihitfirst)
                     {/*first animategroup of desired set, first cycle*/
                         nextanimategroup = ng;
                         ihitfirst = 1;
                     }
                     if(igrp[ng][0] == 1) /* ON: turn OFF */
                     {
                         igrp[ng][0] = 0;
                         setgrpboxcheck(ng,0);   /*___BBOX.C */

                         if(ifind == 0 && igrp[ng][3] == nthanimate)
                                        /* looking for first ON group */
                                        /* of this animate set */
                         {
                             next = 1;    /* set flag looking for next*/
                             ioff = ng; /*remember which one just turned off*/
                             /*ifind = 1;*/    /* found an ON group to turn OFF*/
                         }
                     }
                     else /* off */
                     { 
                         if(    next == 1 
                             && ng != ioff
                             && igrp[ng][3] == nthanimate)
                         {   /*off, just turned one off, and this is not it,*/
                             /* or in second cycle, where first left all off */
                             /* so turn on if in current nthanimate*/

                             igrp[ng][0] = 1;
                             setgrpboxcheck(ng,1);  /*___BBOX.C */
                             next = 0;    /* clear flag */
                             /*check and adjust moview*/
                             if(igrp[ng][8] > 0) resetrot(igrp[ng][8]);/*MAGEANGL.c*/
                             nextafter = 1; /*set to find what would come next*/
                             ifind = 1;    /* found an OFF group to turn ON*/
                         }
                         else if(   next == 0 
                               /*&& nthanimate == 1 */
                               /*&& ng != ioff */
                                 && igrp[ng][3] == nthanimate 
                                 && nextafter == 1)
                         {/*this is the group that will be turned on next animate*/
                             nextanimategroup = ng;
                             nextafter = 0;
                         }
                     }
                }/*endof check animatable groups*/
             }/*endof scan over all groups*/
             if(next == 1) /* set up to continue scan, possible in either */
             /*direction, but reversing animation jumpered out, now cyclic*/
             {
                 if(first == 1)
                 {
                 /*first = limitgrp;*/ /*commented out: reversing animation*/
                     /*last = 0;*/
                     /*istep = -1;*/
                         
                     first = 1;   /* repeats else stuff for cyclic animation*/
                     last = limitgrp + 1;
                     istep = +1;

                 }
                 else
                 {
                     first = 1;
                     last = limitgrp + 1;
                     istep = +1;
                 }
             }
             if(ifind == 0) next = 1;
        }/*endof while next flag set*/          
}/*endof adjust animation */
/*___adjustanimate()_________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****adjustmaster()**********************************************************/
void    adjustmaster(int i, int ion)
{/*begin adjust master flagged groups, subgroups, lists */         
         int    limitgrp,ng;
         unsigned long mask;
         
         /*master index: 1 == 1, 2 == 2, 3 == 4, 4 == 8, ...     */
         /*                2^0     2^1     2^2     2^3           */
         /*                1<<0   1<<1    1<<2     1<<3          */
         mask = 1<<(i-1);
         if(Ldrawline && igrp[maxgrp+3][5]!=0) limitgrp=maxgrp+3;
         else limitgrp = maxgrp;/*revision930221*/
         for(ng = 1; ng <= limitgrp; ng++)
         {/*begin scan over all groups*/
             if(groupmaster[ng]&mask)
           /*if(igrp[ng][5] == i)*/ /*only check those with this master flag*/
             {/*begin check groups*/             
                 igrp[ng][0] = ion; /* set to current master state */
/*x*/            setgrpboxcheck(ng,ion);  /* PC EXTRA.C */
             }
         }

         for(nset = 1; nset <= maxset; nset++)
         {/*begin scan over all subgroups*/
             if(subgroupmaster[nset]&mask)
           /*if(iset[nset][4] == i)*/ /*only check those with this master flag*/
             {/*begin check subgroups*/             
                 iset[nset][0] = ion; /* set to current master state */
/*x*/            setsetboxcheck(nset,ion);   /* PC EXTRA.C */
             }
         }
                              
         for(nlist = 1; nlist <= maxlist; nlist++)
         {/*begin scan over all lists*/
            if(listmaster[nlist]&mask)
          /*if(ilist[nlist][4] == i)*//*only check those with this master flag*/
            {/*begin check lists*/             
                 ilist[nlist][0] = ion; /* set to current master state */
/*x*/            setlistboxcheck(nlist,ion);   /* PC EXTRA.C */
            }
         }
         masterboxcheck(i,ion);   /*MACBBOX.C MPCBBOX.C*/
}/*endof adjust master flagged groups, subgroups, lists */
/*___adjustmaster()_________________________________________________________*/

/****resetmaster()***********************************************************/
void    resetmaster(int i)
{/*begin reset master flagged groups, subgroups, lists */
         int    ireset,limitgrp,ng;
         unsigned long mask;
         
         mask = 1<<(i-1);
         
         if(Ldrawline && igrp[maxgrp+3][5]!=0) limitgrp=maxgrp+3;
         else limitgrp = maxgrp;/*revision930221*/
         
         ireset = 0; /*turn master off unless any one client is on */
         for(ng = 1; ng <= limitgrp; ng++)
         {/*begin scan over all subgroups*/
             if(groupmaster[ng]&mask) 
           /*if(igrp[ng][5] == i)*/ /*only check those with this master flag*/                 
             {/*begin check groups*/             
                 if(igrp[ng][0] == 1) ireset = 1; /* look for on state */
             }
         }

         for(nset = 1; nset <= maxset; nset++)
         {/*begin scan over all subgroups*/
             if(subgroupmaster[nset]&mask) 
           /*if(iset[nset][4] == i)*/ /*only check those with this master flag*/                 
             {/*begin check subgroups*/             
                 if(iset[nset][0] == 1) ireset = 1; /* look for on state */
             }
         }
                              
         for(nlist = 1; nlist <= maxlist; nlist++)
         {/*begin scan over all lists*/
             if(listmaster[nlist]&mask)
           /*if(ilist[nlist][4] ==i)*//*only check those with this master flag*/                 
             {/*begin check lists*/             
                 if(ilist[nlist][0] == 1) ireset = 1; /* look for on state */
             }
         }
         masterboxcheck(i,ireset);   /*MACBBOX.C MPCBBOX.C*/


}/*endof reset master flagged groups, subgroups, lists */
/*___resetmaster()__________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
