/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/*mageDraw.c*/
#include "MAGE.H"
/****drawvec()***************************************************************/
void    drawvec()
{
  int    k,m,n,i,j,ideep,iwide,idecue,ioffset,igraystart,neyes,ilook,ideepcue;
  int    iytop, iybottom, iyhigh, ideepcueold;
  int    grpmin, grpmax, setmin, setmax, jmin, jmax;
  int    maxdeep,maximumgroup;
  int    ixset,iyset,izset;
  int    izadjust,izbinsize;
  long   i11,i12,i13,i21,i22,i23,i31,i32,i33;
  double dist;    
  int    ncount,icolor,oldcolor,ithick,ipen;
  int    ifudgx,ifudgy,ifudgz,idelx,idely,idelz,itemp;
  int    Lmove,Lclip,misspick,itrypick;
  double sinang,cosang,fvalue;
  int    iedge,imiddle,xminleft,xmaxleft,xminright,xmaxright;
  int    izmin,izmax,ixmax,ixmin;
  static    int        Lexcessvec=0,Lsetexcess=0;
  static    float detmatrix;
  static    float scaleitold,scaleitnew;
  static    int   pickxold=0,pickyold=0,pickzold=0;
  static    int   pickz,ipicklistold,pickvecold;
  int     oldx,oldy,postscriptcnt,inewpoint; /*used in PS output*/

  int  ithefirst[100],ithelast[100];/*bin indices into the display list*/
  int  jx2orig, jy2orig, jz2orig;
  int  jxyz1,jxyz2,ixseting[3],ioldside; /*931128PS*/
  float fthex[3],fthey[3],radius; /*931128PS*/
  double sinangle[3],cosangle[3]; /*931128PS*/
  long   nowticks;

/*begin executable********/
     Lmultibins = 1;
     multibins = 20;
     for(i=0;i<5*multibins;i++) ithefirst[i] = 0;
     inewpoint = 0;/*check point number, helps avoid duplicates in PS output*/
  /* perspective option in integer arithmetic requires a bit of fudging: */
  /*without zooming scaling allows numbers to be at most +-280 around center*/
  /* but 280*280 = 56000 > 32768, the limit of signed regular integers */
  /* so work with halves in z:  280*140 = 28000, so dynamic halving done! */

  if(IMAC == 1 || IUX == 1) /*UNIX*/
  {
     iytop =  + infofontsize;
         /*mac sets text at left-bottom of character*/
     iybottom = 10 ;    
         /*offset from bottom of window*/
       /*Mac uses same metric for bitmap as for grafwindow*/
       /* infofontsize initially from MACWINX.C SetUpGrafPort() */
  }
  else if(IPC == 1)
  {
     iyhigh = getgrafwindowheight(); /*MPCEXTRA.C*/  /*MACDXMC.C*/
     iytop = 0;       /*pc sets text at left-top of character*/
     iybottom = (int)( (float)infofontsize
                            *3.0*( (float)ISOSCALE/(float)iyhigh ) );
                           /* infofontsize from MCPZBAR.C */
    /* iybottom = 40*(ISOSCALE/iyhigh);*/  /*offset from bottom of window*/
       /*ISOSCALE == 200, iyhigh starts ~= 400,*/
       /* so need factor of 2 at least*/
      /*text remains same absolute size, but offset scales */
      /*PC uses constant bitmap but scaled grafwindow size*/

    /* sprintf(word,"iyhigh: %d, iybottom: %d",iyhigh,iybottom); */
    /* stringtoscreen(word,ixmin+5,(ymin+ymax)/2 );              */
  }
  /*depth queing by writing in bin batches, rear to front */    
  if(!Lmultibins) multibins = 1;
  maxdeep = ((5*multibins)-1);
  izadjust = izclip - izctr;
  if(2*izclip <= 5*multibins) izbinsize = 1;
  else                        izbinsize = 2*izclip/(5*multibins);
  izmin = izctr - izclip;
  izmax = izctr + izclip;

  /* establish integer array,  8192* for reasonable percision 2**13 */
  i11=8192*a11; i12=8192*a12; i13=8192*a13;
  i21=8192*a21; i22=8192*a22; i23=8192*a23;
  i31=8192*a31; i32=8192*a32; i33=8192*a33;

  ncount = 0;  /* clear vector counter */
  LOK = 1;    /* used for sideclipping if in that mode */
  if(!Lzoom) zoom = 1.0;

  ixset = ixctr; 
  iyset = iyctr;
  izset = izctr;
  ixseting[1] = ixset; /*931128 x offset by eye for postscript calc*/ 
  sinangle[1] = 0; /*931128 stereo offset by eye for postscript calc*/
  cosangle[1] = 1; /*931128 stereo offset by eye for postscript calc*/
  
  if(Lztran) izset = (izctr + iztran);
    
  oldcolor = 9999;
  if(Lonewidth) ithick = 2;
  if(Lthin) ithick = 1;

  Lpickwhen = 1;
      /*and will be readjusted when point picked */
      /*if(!Ldraglineon) Lpickwhen = !Lpick;*/
      /*(ipick==2 && Lpickwhen==!Lpick)      first, enters with Lpick==0*/  
      /*(ipick==2 && Lpickwhen==TRUE always)  last*/ 

/*  nowticks = theclockcount(); */  /*MACMAIN.C*/ /*MPCMAIN.C*/
/*  preloopticks = (nowticks - icountticks); */
/*  icountticks = nowticks; */

  if(Loriginatctr) /*Mac =0 origin at upper left, PC =1 origin screen center*/
  {   /*PC*/
      ixmin = -ISOSCALE /*-WIDTH/2*/;
      ixmax = ISOSCALE /* WIDTH/2*/;
      ymin = -ISOSCALE /*-HEIGHT/2*/;
      ymax =  ISOSCALE /*HEIGHT/2*/;
      misspick = 25;
      WIDTH = 2*ISOSCALE;
  }
  else
  {   /*Mac*/
      ixmin = 0; 
      ixmax = WIDTH;
      ymin = 0;
      ymax = HEIGHT;
      misspick = 25;
  }
  xmin = ixmin;
  xmax = ixmax;
  
  neyes = 1;
  if(Lstereo || Lcompareon) 
  {
      neyes = 2;
      iedge = 0;
      imiddle = 0;
      if(IMAC||IUX)
      {
          if(ieyewide < WIDTH/2) iedge = WIDTH/2 - ieyewide;
          else if(ieyewide > WIDTH/2) imiddle = ieyewide - WIDTH/2;
      }
      if(IPC)
      {
          if(ieyewide < WIDTH/2) iedge = WIDTH/2 - ieyewide;
          else if(ieyewide > WIDTH/2) imiddle = ieyewide - WIDTH/2;
      }
      xminleft  = ixmin + iedge;  /*clipping inside visable window*/
      xmaxleft  = ( (ixmax+ixmin)/2 ) - imiddle;
      xminright = ( (ixmax+ixmin)/2 ) + imiddle;
      xmaxright = ixmax - iedge;
  }
    if(Lmonitoron && numberline>1 ) /*so it's in newgroup */
    {
        n = nxyz + nmarkers + maxmeasures + 3*ndrawpoint + numberline;
        xyz(1,n) = xyz(1,nlast); /*nlast and nprelast set in ANGLE.C*/
        xyz(2,n) = xyz(2,nlast);
        xyz(3,n) = xyz(3,nlast);
        fxyz(0,n) = fxyz(0,nlast); 
        fxyz(1,n) = fxyz(1,nlast); 
        fxyz(2,n) = fxyz(2,nlast); 
        xyz(1,n-1) = xyz(1,nprelast);
        xyz(2,n-1) = xyz(2,nprelast);
        xyz(3,n-1) = xyz(3,nprelast);
        fxyz(0,n-1) = fxyz(0,nprelast); 
        fxyz(1,n-1) = fxyz(1,nprelast); 
        fxyz(2,n-1) = fxyz(2,nprelast); 

        dist= sqrt(  
                   (fxyz(0,n)-fxyz(0,n-1))*(fxyz(0,n)-fxyz(0,n-1)) +  
                   (fxyz(1,n)-fxyz(1,n-1))*(fxyz(1,n)-fxyz(1,n-1)) +
                   (fxyz(2,n)-fxyz(2,n-1))*(fxyz(2,n)-fxyz(2,n-1))  );

        if(Lmeasureson)
        {
/*c*/       sprintf(dstring,"%.3lf, ang=%.1f, dhr=%.1f\0",
            dist,anglemeasure,dihedralmeasure);
        }
        else    sprintf(dstring,"%.3lf\0",dist);
        /*sprintf(dstring,"%.3lf",dist);*/
        condition(dstring);
        /* Mx for Mac make it a Pascal string, PC EXTRA dummy*/
        if( infofontsize <= 12)
            stringtoscreen(dstring,ixctr+5,(ymax-iybottom));/*Mx*/
        else    
            stringtoscreen(dstring,ixmin+5,(ymax-iybottom-infofontsize));
    }

  /* DOUBLE PASS MOVE-DRAW, PRIMATIVE Z-BUFFERING */
  /*FIRST OUTER LOOP--__------___-------------------------------------------*/
  for(ilook = 1; ilook <= neyes; ilook++)
  {/*ilook pass*/
    if(ilook == 1 && neyes == 2)
    {
      ixset = (ixctr - ieyewide/2);
      ixseting[1] = ixset; /*931128 x offset by eye for postscript calc*/ 
      if(Lmiddle) 
      {
        xmin = xminleft; 
        xmax = xmaxleft;
      }
    }
    if(ilook == 2 )
    {
      if(Lmiddle) 
      {
        xmin = xminright; 
        xmax = xmaxright;
      }
      if(!Lcompareon)
      {
         fvalue = (-stereoangle/360.0)*6.283;
/*c*/    sinang = sin(fvalue);
/*c*/    cosang = cos(fvalue);
         /* update: aij-matrix X y-matrix:              */
         /*    a11 a12 a13     cosang    0   -sinang    */
         /*    a21 a22 a23  X    0       1      0       */
         /*    a31 a32 a33     sinang    0    cosang    */

         i11 = 8192*(a11*cosang     + a13*sinang);
         i12 = 8192*(a12);
         i13 = 8192*(a11*(-sinang)     + a13*cosang);
         i21 = 8192*(a21*cosang     + a23*sinang);
         i22 = 8192*(a22);
         i23 = 8192*(a21*(-sinang)     + a23*cosang);
         i31 = 8192*(a31*cosang     + a33*sinang);
         i32 = 8192*(a32);
         i33 = 8192*(a31*(-sinang)     + a33*cosang);
      }
      ixset = (ixctr + ieyewide/2);
      ixseting[2] = ixset; /*931128 x offset by eye for postscript calc*/ 
      sinangle[2] = sinang; /*931128 stereo offset by eye for postscript calc*/
      cosangle[2] = cosang; /*931128 stereo offset by eye for postscript calc*/

    }
                 
    if(Lmarkers) 
    {
      maximumgroup = maxgrp+1; /* maxgrp+1 does markers */
      if(Lmeasures) maximumgroup = maxgrp+2; /* maxgrp+2 does measures */
      if(Ldrawline) maximumgroup = maxgrp+3; /* maxgrp+3 does drawline */
    }
    else maximumgroup = maxgrp;

    if(Lflat){ ixset = ixset + ixtran; iyset = iyset + iytran; }
    
    for(ngrp = 1; ngrp <= maximumgroup ; ngrp++) 
    { /*begin-loop-over-groups*/
      if(   (igrp[ngrp][0] > 0 && !Lcompareon)
         || (Lcompareon && ilook==1 && igrp[ngrp][0]>0  )
            /*first pass put left everything that is ON */
            
         || (Lcompareon && ilook==2 && igrp[ngrp][0]>0  
                        && igrp[ngrp][3]==0)
            /*second pass put right, all non-animate groups that are ON */
         || (Lcompareon && ilook==2 && igrp[ngrp][0]==0 
                        && ngrp == nextanimategroup) )
            /* and the OFF animate group that is flagged as being next */
      {    /*begin-visible-group*/
        grpmin = igrp[ngrp][1];
        grpmax = igrp[ngrp][2];
        for(nset = grpmin; nset <= grpmax ; nset++)
        {    /*begin-loop-over-sets*/
          if(iset[nset][0] > 0)
          { /*begin-visible-set*/
            setmin = iset[nset][1];
            setmax = iset[nset][2];
          
            for(nlist = setmin; nlist <= setmax ; nlist++)
            { /*begin-loop-over-lists*/              
              if(ilist[nlist][0] > 0)
              {    /*begin-visible-list*/
                jmin = ilist[nlist][1];
                jmax = ilist[nlist][2];
                for( j = jmin ; j <= jmax ; j++)
                {/*begin-draw-loop*/     /*950113*/
                 /*FIRST INNER LOOP------__-------__------------------*/
                 if( xyz(0,j) >= 0 && xyz(0,j) < 100)   /*950113*/
                 {/*point currently valid*/           /*950113*/
                  /*ctr of rot moved to 0,0,0 by subtracting xctr,yctr,zctr*/
                  /* before storing coordinates.  Restore ctr of rot by */
                  /* adding xctr,yctr,zctr adjusted for scaling*/
                  /* and any translations after multiply step*/
                  /*For efficiency: color sets, not individual vectors */
                  /*Matrix components integers 8192 larger than aij matrix*/
                  /*            i11 i12 i13 */
                  /*            i21 i22 i23 */
                  /*            i31 i32 i33 */
if(ilist[nlist][9]==0)
{
    jx2 = ((xyz(1,j)*i11 + xyz(2,j)*i21 + xyz(3,j)*i31)>>13) +ixset;
    jy2 = ((xyz(1,j)*i12 + xyz(2,j)*i22 + xyz(3,j)*i32)>>13) +iyset;
    jz2 = ((xyz(1,j)*i13 + xyz(2,j)*i23 + xyz(3,j)*i33)>>13) +izset;
                    /*shift by 13 bits rather than divide by 8192 */
}
else
{
    jx2 =  xyz(1,j) + ixset;
    jy2 = -xyz(2,j) + iyset;
    jz2 =  xyz(3,j) + izset;
}
                    jxyz2 = j; /*931128PS associate index with these coords*/   
                    if(Lperspec)
                    {
                      ifudgz = 1;
                      idelz = ( (jz2/2) - izctr/2 );
                      while(idelz > 181 || idelz < -181)
                      {
                        idelz = idelz/2;
                        ifudgz = ifudgz*2;
                      }
                      ifudgx = 1;
                      idelx = jx2 - ixset;
                      while(idelx > 181 || idelx < -181)
                      {
                        idelx = idelx/2;
                        ifudgx = ifudgx*2;
                      }
                      itemp = ((idelx*idelz)/1000);
                      jx2 = itemp*ifudgx*ifudgz + jx2;
                      ifudgy = 1;
                      idely = jy2 - iyset;
                      while(idely > 181 || idely < -181)
                      {
                        idely = idely/2;
                        ifudgy = ifudgy*2;
                      }
                      itemp = ((idely*idelz)/1000);
                      jy2 = itemp*ifudgy*ifudgz + jy2;
                    }
                    /*(ipick==2 && Lpickwhen==!Lpick)      first*/  
                    /*(ipick==2 && Lpickwhen==TRUE always)  last*/  
                    if(ipick==2 && Lpickwhen)
                    {
                      if( (long)(jx2-pickx)*(long)(jx2-pickx) + 
                          (long)(jy2-picky)*(long)(jy2-picky) < misspick) 
                      {
                         itrypick = 1;        /*unpickable draw = 1,3 */
                         if(!Lsuperpick) 
                             if(xyz(0,j)==1 || xyz(0,j)==3) itrypick = 0; 
                         if(Lzclipon &&(jz2<izmin||jz2>izmax)) itrypick=0;
                         if(Lstereo &&(jx2 > xmax||jx2 < xmin)) itrypick=0;
                         if(itrypick)
                         {
                             Lpick = 1;
                             if(!Ldraglineon) Lpickwhen = !Lpick;
                             pickvec = j;
                             ipickgrp=ngrp;
                             ipickset=nset;
                             ipicklist=nlist;
                             /*make exact so can use as picked coord*/
                             pickx = jx2;
                             picky = jy2;
                             pickz = jz2;
                         }
                      }
                    }                      

                  /* define point with respect to  Move vs Draw */
                  /*xyz(0,j) DRAW=0,1,2,3 */   
                  /*xyz(0,j) MOVE=10,11,12,13, DOT=20,BALL=25,LABEL=30,WORD=40*/
                  /*xyz(0,j) >=50 not displayed*/ 

                  if(xyz(0,j) >= 10 && xyz(0,j) < 50)  
                  {/*MOVE,LABEL,DOT*/
                      /*MOVE is a first point, later DRAW is new second point*/
                      /*one point DOT,LABEL: flesh out with dummy first point*/
                      jx1 = jx2;
                      jy1 = jy2;
                      jz1 = jz2;
                      jxyz1 = jxyz2; /*931128PS index for first point*/
                  }/*MOVE,LABEL,DOT*/

                  /*if(xyz(0,j) < 10 )*/ /*DRAW=0,1,2,3*/ 
                  /*DRAW */ /*should already have a preceeding point */
                  /*so this jxyz2 point is what is needed */

                  /*MOVE == 10-19 */ /*>=50 not displayed*/ 
                  /*DRAW=0-9,  DOT=20, BALL=25, LABEL=30, WORD=40 */ 
                  if( (xyz(0,j) < 10) || (xyz(0,j) >= 20 && xyz(0,j) < 50) ) 
                  {/*DISPLAY: draw-vector dot ball label word*/ 
                    /* depth cueing: initially 400 deep (jz1=0-400), */
                    /*scaled so diagonals  will fit,     */
                    /*divide into exactly 5 bins or 5*multibins */
                    /*from above: izadjust = izclip - izctr;*/
                    /*from above: izbinsize = 2*izclip/(5*multibins);*/
                    /*if(jz2 < jz1)    ideep = (jz2 + izadjust)/izbinsize;*/
                    /*else             ideep = (jz1 + izadjust)/izbinsize;*/    
                    /* used to use minimum of iz1,iz2 for z-level: */
                    /* so then later written dots will not be obscured */
                    /*use average so balls==disks at correct relative depth*/
                    ideep = ( ((jz1+jz2)/2) + izadjust)/izbinsize;    
              
                    if(ideep <= 0) ideep = 0;
                    /*if(ideep >  4) ideep = 4;*/  
                    /*from above: maxdeep = ((5*multibins)-1); */
                    if(ideep >  maxdeep ) ideep = maxdeep; 
                    if(ncount >= MAXDRAWS-1)
                    {/*try to reallocate storage*/
                        allocdisplayarrays(1000); /*try 1000 more*/
                    }
                    if(ncount >= MAXDRAWS-1) /*protects if reallocation fails*/
                    {
                       Lexcessvec = 1;
                       Lsetexcess = 1;
                    }
                    else if(Lplotpoint) ncount = 1;
                    /*for plotonly plotting and kaleidoscope effect */
                    else                ncount++;    /* increase counter*/
                    LOK = 1; /*flag for passing clip checks */
                    /*jx1,jy1,jx2,jy2 are changed at edges to truncate line*/
                    /*before doing this clipping save originals that might*/
                    /* be used to make a vector with a later point */
                    jx2orig = jx2; /* save to set up for next draw since */
                    jy2orig = jy2; /* there may be no intervening move */
                    jz2orig = jz2;
/*.*/               checksideclip();/*always do this, it is relatively cheap*/
                    if(Lzclipon && LOK == 1) 
                    {  /* pass altered coord values*/
/*.*/                  checkzclip(jx1,jy1,jz1,jx2,jy2,jz2); 
                    }
                    if(LOK == 1)
                    {/*-enter item in 2D display list */
                      it(0,ncount) = ilist[nlist][3];     /* color */
                      it(1,ncount) = jx1;                /* xmove */
                      it(2,ncount) = jy1;                /* ymove */
                      it(3,ncount) = jx2;                /* xdraw */
                      it(4,ncount) = jy2;                /* ydraw */
                      if(xyz(0,j) == 30)    it(5,ncount) = j; /*label*/
                      else if(xyz(0,j) == 40)    it(5,ncount) = -j; /*words*/
                      else if(xyz(0,j) == 25)  /*ball*/
                      {
                          it(5,ncount) = 32767;
                          it(4,ncount) = nlist;
                              /*so ball can reference list radius*/
                          /*note: jx2==jx1 && jy2==jy1 for balllists*/
                      }
                      else        it(5,ncount) = 0; /*vector or dot*/
                       
                      it(6,ncount) = ideep;                /* z-depth */
                      /*if PC && (line or dot) && (farthest||thin) */
                      if( IPC && (xyz(0,j)<=20) && ((ideep == 0)||Lthin) )
                      {/*PC can't draw zero length vector*/
                         if(jx1==jx2 && jy1==jy2)
                         {/*make a line of finite length*/
                           it(3,ncount) = jx1+1;
                           it(4,ncount) = jy1+1;
                           /*PC won't show single pixel dot*/
                         }
                      }
                      it(7,ncount) = 0; 
                          /*cheapest way to zero this array position*/
                      if(ithefirst[ideep]==0) ithefirst[ideep] = ncount;
                      else it(7,ithelast[ideep]) = ncount;
                      ithelast[ideep] = ncount;
                      
                      if(Lpostscript && LspecialPS)
                      {
                          it(1,ncount) = jxyz1;
                          it(2,ncount) = jxyz2; 
                          it(3,ncount) = ilook;
                       }
                      
                    }/*-enter item in 2D display list */
                    else
                    {
                       ncount--; /* didn't do vector, decrement counter*/
                    }
                    jx1 = jx2orig; /* set up for next draw since */
                    jy1 = jy2orig; /* there may be no intervening move */
                    jz1 = jz2orig;
                    jxyz1 = jxyz2; /*931128PS*/
                  }/*DISPLAY: draw-vector dot ball label word*/ 
                 }/*point currently valid*/   /*950113*/
                 /*FIRST INNER LOOP-----^^-------^^------------*/
                }/*endof-draw-loop*/
              }/*endof-visible-list*/
            }/*endof-loop-over-lists*/                
          }/*endof-visible-set*/
        }/*endof-loop-over-sets*/
      }/*endof-visible-group*/
    }/*endof-loop-over-groups*/
  }/*ilook pass*/
  /*FIRST OUTER LOOP--^^---------^^-----------------------------------------*/
 /* nowticks = theclockcount();*/   /*MACMAIN.C*/ /*MPCMAIN.C*/
 /* firstloopticks = (nowticks - icountticks); */
 /* icountticks = nowticks; */

 /*SECOND OUTER LOOP--__---------__--------__----------------------------*/
  oldx = 0; /*unlikely x,y values */
  oldy = 32767;
  postscriptcnt = 0;
  inewpoint = 1;
  ideepcueold = -1; /*so will get initialization of ideepcue==0 level*/
  for(ideep = 0; ideep <= maxdeep ; ideep++)
  {/*SECOND OUTER LOOP--over bins */
    if(ithefirst[ideep] > 0)
    {/*this bin has entries*/
      /*ideep is the bin, ideepcue is the 0-4 depth cue bin */
      ideepcue = ideep/multibins;
      if(ideepcue != ideepcueold)
      {/*ideepcue has changed*/
          ideepcueold = ideepcue;
          iwide = ideepcue + 1;
          icolor = 0; /*black*/ 
             /*stays 0 for black unless color or gray palette*/
          rgbColor.red = 0;
          rgbColor.green = 0;
          rgbColor.blue = 0;
          idecue = 0;
          if(Lwhitebkg) idecue = 25;

          ioffset = 50;    /* so can get 5 depths within 250 color choices */
          igraystart = 7; /* B, W default entries */
          if(npixelbits == 4 && Lcolor) /*Lcolor TRUE if gray, FALSE if B&W */
          {
              ioffset = 1; /* only have 16 numbers, all gray packed together */
              igraystart = 1;
              if(Lwhitebkg) idecue =  5;  /* gray: 1-5: W on B, 6-10: B on W */
              icolor = igraystart + ioffset*ideepcue + idecue;
          }
          oldcolor = 9999;

          if(!LLcolor && Lcolor)  /* Gray scale monitor but color QuickDraw */
          {/*do gray tones*/    /* B&W set Lcolor FALSE */
              icolor = igraystart + ioffset*ideepcue + idecue;
          }   /*real color gets set in inner loop */
      
          if(Lonewidth || Lthin)    ipen = ithick;
          else                      ipen = iwide;

          setdrawcolorpen(ipen,ipen,icolor);  /*MACDRAW.C & MPCDRAW.C*/
                     /* pen x,y size and color code*/

          if(Lpostscript && ( !LLcolor || !Lcolor) )
          {/*some sort of gray postscript output*/
              /* set this once for each depth cue level */
              if(icolor > 0)
              {   /*MACDRAW.C & MPCDRAW.C*/
                  myGetEntryColor(icolor);
              }
              /*paint current path if any vectors in it, sets newpath*/
              if(postscriptcnt>0) fprintf(fpout,"stroke\n"); 
              postscriptcnt = 0;
              inewpoint = 1;
              fprintf(fpout,"%d setlinewidth %f setgray\n"
                    ,ipen,(float)rgbColor.green/(float)65535); 
          }/*some sort of gray postscript output*/
      }/*ideepcue has changed*/   
      if(!Lspecialloop)
      {/*normal loop */
        /*SECOND INNER LOOP--__-touches all ncount vectors 5*multibins times*/
        /*SECOND INNER LOOP--__-touches only vectors at this depth once */
        for( i = ithefirst[ideep]; i <= ncount ; ) /*i gets set internally*/
        {/*loop on i: up to all ncount vectors 5*multibins times*/
          /*if(it(6,i) == ideep)*/ /*this has to be true*/
          {/*bin==ideep*/
            
            if(LLcolor && Lcolor)
            {
              if(it(0,i) != oldcolor) /*all at same ideep in this loop*/
              {
                icolor = it(0,i) + 50*ideepcue + idecue;
               
                setdrawcolorpen(ipen,ipen,icolor); /*MACDRAW.C & MPCDRAW.C*/
                oldcolor = it(0,i);
              }
            }     
            /*MoveTo and LineTo same command Mac & PC */
            /* but PC has extra field to define where to move,draw*/
            /* mac defines XTR = ' '  PC defines XTR = 'cDC,'  */
            if(!IUX) /*UNIX doesn't do a separate move step*/
              MoveTo(XTR it(1,i),it(2,i)); /*THE MOVE, MAC & PC command */  
            if( it(5,i)  == 0) 
            {/*vector or dot*/
              
                LineTo(XTR it(3,i),it(4,i)); /*THE DRAW, MAC & PC & UNIX_X11 command */
             
                /*UNIX_X11 defines:  (MAGE.H) */
                /*     LineTo =   'XDrawLine' */
                /*     XTR    =   'dpy,offscreen,offgc,it(1,i),it(2,i),'  */
                /*XDrawLine(dpy,offscreen,offgc,it(1,i),it(2,i),it(3,i),it(4,i));  */
            
            }/*vector or dot*/
            else if( it(5,i)  > 0 && it(5,i)<32767 ) /* label list */
            {/*label*/
              /* offset for giant character array */
              /*16*2048=32768 so if number > 2048, index must be long!*/
              /*even worse with (MAXPTIDCHAR+1) which started at 21*/
              /* use pointer arith to avoid using a long integer as an*/
              /* array index: see K&R A7.7 pg 205 2nd ed.: */        
              /* pointer + integer: integer promoted to make new */
              /*  pointer work for its type */
               
              /*copy char str from storage */
              /*note: define  com1(icom) (com + icom) */   
              /* unfortunately, Mac and PC are quite different for strings */
              /*copy char str from storage */
              for(k=0; k<(MAXPTIDCHAR+1); k++)
              {
                icom = (long)(MAXPTIDCHAR+1)*(long)it(5,i) + (long)k;
                /*note: define  pcom1(icom)  *(com + icom)  */
                /*word[k] = *( com1(icom) ); */
                /*word[256] is a general use common variable */
                word[k] = ( pcom1(icom) );
              }
              /*stored pointID string already conditioned */
              
              labeltoscreen( word  ,it(1,i),it(2,i), icolor ); 
                      /*MACDRAW.C & MPCDRAW.C*/
            }/*label*/
            else if( it(5,i)==32767 ) /* ball list */
            {/*ball*/
                balltoscreen(it(1,i),it(2,i),it(3,i),it(4,i),ipen,icolor);
                /*it(4,ncount) = nlist;  so ball can reference list radius*/
                /*note: jx2==jx1 && jy2==jy1 for balllists*/
                    /*MACDRAW.C & MPCDRAW.C*/
            }/*ball*/
            else if( it(5,i)  < 0) /* word list */
            {
                wordstoscreen( -it(5,i)  ,it(1,i),it(2,i), icolor );
                    /*MACDRAW.C & MPCDRAW.C*/
            }
            i = it(7,i);/*this ith point has the link to the next point*/
          }/*bin==ideep*/
          if(i==0) break;
        }/*loop on i:  all ncount vectors once*/
        /*SECOND INNER LOOP-----^^--special cases----*/
      }/*normal loop */ 
      if(Lspecialloop)
      {/*special loop for postscript output ... */
        /*SECOND INNER LOOP--__-touches only vectors at this depth once */
        for( i = ithefirst[ideep]; i <= ncount ; ) /*i gets set internally*/
        {/*loop on i: up to all ncount vectors 5*multibins times*/
          /*if(it(6,i) == ideep)*/ /*this has to be true*/
          {/*bin==ideep*/
            
            if(LLcolor && Lcolor)
            {
              if(it(0,i) != oldcolor) /*all at same ideep in this loop*/
              {
                icolor = it(0,i) + 50*ideepcue + idecue;
                if(icolor > 0 )
                {    /*MACDRAW.C & MPCDRAW.C*/
                     myGetEntryColor(icolor);
                }
                /*paint current path if any vectors in it, sets newpath*/
                if(postscriptcnt>0) fprintf(fpout," stroke\n"); 
                postscriptcnt = 0;
                inewpoint = 1;
                if( it(0,i) == 7 || it(0,i) == 13) /*wht||blk||gray*/
                {
                    fprintf(fpout,"%d setlinewidth %f setgray\n"
                        ,ipen,(float)rgbColor.green/(float)65535); 
                } 
                else
                {
                    fprintf(fpout,"%d setlinewidth "
                            "%f %f %f setrgbcolor\n"
                            ,ipen
                            ,(float)rgbColor.red/(float)65535
                            ,(float)rgbColor.green/(float)65535
                            ,(float)rgbColor.blue/(float)65535
                            );
                    /*should not be able to get here if doing graytones*/
                }
                oldcolor = it(0,i);
              }
            }     
            
            if(LspecialPS)
            {/*doing non-clipped floating point recalculation*/
                if(ioldside != it(3,i)) /*keep track of which eye view*/
                {
                    fprintf(fpout," stroke\n"); 
                    postscriptcnt = 0;
                    inewpoint = 1;
                }
                ioldside = it(3,i);
                for(j=1;j<=2;j++)
                {/*do the rotation matrix on original float coordinates*/
                 /*i11=8192*(a11*cosangle[it(3,i)]+a13*sinangle[it(3,i)]);   */
                 /*i12=8192*(a12);                                           */
                 /*i13=8192*(a11*(-sinangle[it(3,i)])+a13*cosangle[it(3,i)]);*/
                 /*i21=8192*(a21*cosangle[it(3,i)]+a23*sinangle[it(3,i)]);   */
                 /*i22=8192*(a22);                                           */
                 /*i23=8192*(a21*(-sinangle[it(3,i)])+a23*cosangle[it(3,i)]);*/
                 /*i31=8192*(a31*cosangle[it(3,i)]+a33*sinangle[it(3,i)]);   */
                 /*i32=8192*(a32);                                           */
                 /*i33=8192*(a31*(-sinangle[it(3,i)])+a33*cosangle[it(3,i)]);*/

                    fthex[j]=
((( (fxyz(0,it(j,i))-fxcenternew)*(a11*cosangle[it(3,i)]+a13*sinangle[it(3,i)]) 
   +(fxyz(1,it(j,i))-fycenternew)*(a21*cosangle[it(3,i)]+a23*sinangle[it(3,i)]) 
   +(fxyz(2,it(j,i))-fzcenternew)*(a31*cosangle[it(3,i)]+a33*sinangle[it(3,i)]) )
                                *scalenew)+(float)ixseting[it(3,i)]);
                    fthey[j]=((( (fxyz(0,it(j,i))-fxcenternew)*a12 
                                +(fxyz(1,it(j,i))-fycenternew)*a22 
                                +(fxyz(2,it(j,i))-fzcenternew)*a32 )
                                *scalenew)+(float)iyset);
                }
                if(it(1,i)!=oldx) inewpoint = 1;/*check point number*/
            }/*doing non-clipped floating point recalculation*/
            else
            {/*load working x,y with stored x,y*/
                fthex[1] = (float)it(1,i);
                fthey[1] = (float)it(2,i);
                fthex[2] = (float)it(3,i);
                fthey[2] = (float)it(4,i);
                if(it(1,i)!=oldx || it(2,i)!=oldy) inewpoint = 1;
                    /*check x,y coordinates*/
            }
            /*now have working x,y for current move or move-draw*/
            if( it(5,i)  == 0)  /*defined MAGE.H "it[5][i]" in bulk storage*/
            {/*vector or dot*/
                    if(postscriptcnt>1400) 
                    {
                        fprintf(fpout,"stroke\n"); 
                        postscriptcnt = 0;
                        inewpoint = 1;
                    }
                    if( inewpoint==1 )
                    {
                        fprintf(fpout,"%f %f moveto\n"
                           ,fthex[1],fthey[1]);
                    }
                    fprintf(fpout,"%f %f lineto\n"
                           ,fthex[2],fthey[2]);
                    postscriptcnt++;
                    /*reset duplicate move indicators*/
                    if(LspecialPS) oldx = it(2,i);
                    else
                    {
                        oldx = it(3,i);
                        oldy = it(4,i);
                    }
                    inewpoint = 0;
            }/*vector or dot*/
            else if( it(5,i)  > 0 && it(5,i)<32767 ) /* label list */
            {/*label*/
              /* offset for giant character array */
              /*16*2048=32768 so if number > 2048, index must be long!*/
              /*even worse with (MAXPTIDCHAR+1) which started at 21 */
              /* use pointer arith to avoid using a long integer as an*/
              /* array index: see K&R A7.7 pg 205 2nd ed.: */        
              /* pointer + integer: integer promoted to make new */
              /*  pointer work for its type */
               
              /*copy char str from storage */
              /*note: define  com1(icom) (com + icom) */   
              /* unfortunately, Mac and PC are quite different for strings */
              /*copy char str from storage */
              for(k=0; k<(MAXPTIDCHAR+1); k++)
              {
                icom = (long)(MAXPTIDCHAR+1)*(long)it(5,i) + (long)k;
                /*note: define  pcom1(icom)  *(com + icom)  */
                /*word[k] = *( com1(icom) ); */
                /*word[256] is a general use common variable */
                word[k] = ( pcom1(icom) );
              }
              /*stored pointID string already conditioned */

                  if(postscriptcnt>1300 || ipen>1 ) 
                  {
                      fprintf(fpout,"stroke\n");  
                      postscriptcnt = 0; /*inewpoint = 1; doing move anyway*/
                  }
                  recondition(word);
                  /*fprintf(fpout,"(%s) false charpath\n",word );*/
                  fprintf(fpout,"%f %f moveto\n",fthex[1],fthey[1]);
                  fprintf(fpout,"(%s) show\n",word );
                  /*postscriptcnt = postscriptcnt + 100;*/ /*show does what?? */ 
                                    /*each char has many parts*/
            }/*label*/
            else if( it(5,i)==32767 ) /* ball list */
            {/*ball*/
                /*balltoscreen(it(1,i),it(2,i),it(3,i),it(4,i),ipen,icolor);*/
                /*it(4,ncount) = nlist;  so ball can reference list radius*/
                /*note: jx2==jx1 && jy2==jy1 for balllists*/ 
                
                if(radiuslist[it(4,i)] < .001) radius = (scalenew*.2);
                else radius = (scalenew*radiuslist[it(4,i)]);
                /*ball at current color*/
                
                fprintf(fpout,"stroke\n");  
                postscriptcnt = 0; /*inewpoint = 1; not needed*/
                fprintf(fpout,"%f %f %f 0 360 arc fill\n"
                          ,fthex[1],fthey[1],radius ); 
                /*set highlight "color" */
                if( ( !LLcolor || !Lcolor) || (it(0,i)==7 || it(0,i)==13) )
                {/*some sort of gray || B&W postscript output*/
                    fprintf(fpout,"%d setlinewidth %f setgray\n"
                        ,ipen,(float)65535);
                }/*some sort of gray || B&W postscript output*/
                else
                {
                    fprintf(fpout,"%d setlinewidth "
                            "%f %f %f setrgbcolor\n"
                            ,ipen
                            ,(float)65535
                            ,(float)65535
                            ,(float)65535
                            );
                    /*should not be able to get here if doing graytones*/
                }     
                /*highlight spot is a white disk offset & overlaid on ball*/
                fprintf(fpout,"%f %f %f 0 360 arc fill\n"
                          ,fthex[1]-radius/4.0,fthey[1]-radius/4.0,radius/4.0 ); 
                /*restore current color*/
                if( ( !LLcolor || !Lcolor) || (it(0,i)==7 || it(0,i)==13) )
                {/*some sort of gray || B&W postscript output*/
                    fprintf(fpout,"%d setlinewidth %f setgray\n"
                        ,ipen,(float)rgbColor.green/(float)65535);
                }/*some sort of gray || B&W postscript output*/
                else
                {
                    fprintf(fpout,"%d setlinewidth "
                            "%f %f %f setrgbcolor\n"
                            ,ipen
                            ,(float)rgbColor.red/(float)65535
                            ,(float)rgbColor.green/(float)65535
                            ,(float)rgbColor.blue/(float)65535
                            );
                    /*should not be able to get here if doing graytones*/
                }     
            }/*ball*/
            else if( it(5,i)  < 0) /* word list */
            {
                /*wordstoscreen( -it(5,i)  ,it(1,i),it(2,i), icolor );*/
            }   /*No postscript equivalence yet worked out ???? */
            i = it(7,i);/*this ith point has the link to the next point*/
          }/*bin==ideep*/
          if(i==0) break;
        }/*loop on i:  all ncount vectors once*/
        /*SECOND INNER LOOP-----^^--special cases----*/
      }/*special loop for postscript output ... */ 

    }/*this bin has entries*/
  }/*SECOND OUTER LOOP--over bins */
 /*SECOND OUTER LOOP----^^--------^^----------^^---------------------*/

 if(Lpostscript)
 {/*finish anything left*/
     if(postscriptcnt > 0) fprintf(fpout," stroke \n");
     postscriptcnt = 0;
     fprintf(fpout," showpage restore\n"); 
     fclose(fpout);
     Lpostscript = 0;
     Lspecialloop = 0;
 }
  if(Lstereo || Lcompareon)
  {
        if(Lonewidth || Lthin)    ipen = 2;
        else                      ipen = 4;

        setdrawcolorpen(ipen,ipen,igraystart); /*pen x,y size and color code*/
               /* (igraystart set above)*/ /*MACDRAW.C & MPCDRAW.C*/
        /*MoveTo,LineTo common commands for Mac and PC */
        /* but PC has extra field to define place */
        /* mac defines XTR = ' '  PC defines XTR = 'cDC,'  */
#ifndef UNIX_X11
            MoveTo(XTR (ixmax+ixmin)/2,ymin);   /*THE MOVE, MAC & PC command */
            LineTo(XTR (ixmax+ixmin)/2,ymax);   /*THE DRAW, MAC & PC command */ 
#else
            XDrawLine(dpy,offscreen,offgc,(ixmax+ixmin)/2,ymin
                                         ,(ixmax+ixmin)/2,ymax);
#endif
  }
  /* note about performance of dotlist vs vectorlist: */
  /*  182 dots as dotlist: 1st loop: 3, 2nd: 8 for: 14 total ticks */
  /*  182 dots as zerolength vectors as vectorlist: 5,9  17 total ticks */
    
  nowticks = theclockcount();  /*___MAIN.C*/    /*950113*/
  secondloopticks = (nowticks - icountticks); 
  icountticks = nowticks; 
  nmovedraws = ncount; 

  if(Lexcessvec)
  {
    if(Lsetexcess) /* really set too many vectors this drawing cycle*/
    {
         sprintf(comstr," too many vectors\0");
         condition(comstr);  /*MACMAIN.C & MPCMAIN.C*/
         Lsetexcess = 0;
    }
    else /* no longer has too many vectors, clear comment */
    {    
         sprintf(comstr,"\0");
         condition(comstr);  /*MACMAIN.C & MPCMAIN.C*/
         Lexcessvec = 0;
    }
  }
    
  if(ipick==2||Lprepick)
  {/*pick request, ipick==2*/
    if(Lpick)
    {/*process pick, Lpick==1*/
      if( !Ldraglineactive )
      {/*regular pick stuff*/
        /* offset for giant character array */ 
        /* 16*2048=32768  so if number > 2048, index must be long! */
        /*even worse with (MAXPTIDCHAR+1) which started with 21 */
        /* use pointer arith to avoid using a long integer as an array */        
        /*  index:  see K&R A7.7 pg 205 2nd ed.: pointer + integer: */
        /*  integer promoted to make new pointer work for its type. */
        
        /*copy char str from storage */
        for(k=0; k<=MAXPTIDCHAR; k++) 
        {
          icom =  (long)(MAXPTIDCHAR+1)*(long)pickvec + (long)k;
          /*note: define  pcom1(icom)  *(com + icom)  */
          comstr[k] = ( pcom1(icom) ); 
          grafselection[0][k]=grafselection[1][k]; /*931113 shift to previous*/
          grafselection[1][k]=comstr[k]; /*931108 load this pick point ID*/
        }
        /*stored pointID string already conditioned */
        stringtoscreen(comstr,(ixmin+5),(ymax-iybottom) ); /*___DRAW.C */        
        if(Lmarkers)
        {/*marker placing*/
            if(imarker == 1) 
            {
                imarker = 7;
                /*set marker list to static of picklist*/
                ilist[maxlist+2][9] = ilist[ipicklist][9];
            }
            else 
            {
                imarker = 1; 
                /*set marker list to static of picklist*/
                ilist[maxlist+1][9] = ilist[ipicklist][9];
            }
           
            for(n=imarker; n<=imarker+5 ; n++)
            {
              k = n + nxyz;
              xyz(0,k) = marker[n][0];
              /*recreate pseudo-original float markers */
              /*at new position*/
              fxyz(0,k) = fmarker[n][0]  + fxyz(0,pickvec);
              fxyz(1,k) = fmarker[n][1]  + fxyz(1,pickvec);
              fxyz(2,k) = fmarker[n][2]  + fxyz(2,pickvec);
              /*reset the integer-scaled,centered coords*/
              if(ilist[ipicklist][9]==0) /*non-static*/
              {
                  xyz(1,k) = scalenew*(fxyz(0,k)-fxcenternew);
                  xyz(2,k) = scalenew*(fxyz(1,k)-fycenternew);
                  xyz(3,k) = scalenew*(fxyz(2,k)-fzcenternew);
              }
              else  /*marker on a static list*/
              {
                  xyz(1,k) = scale*(fxyz(0,k)-fxcenter);
                  xyz(2,k) = scale*(fxyz(1,k)-fycenter);
                  xyz(3,k) = scale*(fxyz(2,k)-fzcenter);
              }
            }
        }/*marker placing*/
          
        /* markers now defined in original coord, but are unpickable */
        /* use original coord for distance calculation*/
        /* unless successive picks are between static and non-static lists*/
        if(ilist[ipicklist][9] == ilist[ipicklistold][9])
        {
/*c*/      dist=sqrt(  
                     (oldxyz[1]-fxyz(0,pickvec))*(oldxyz[1]-fxyz(0,pickvec)) +  
                     (oldxyz[2]-fxyz(1,pickvec))*(oldxyz[2]-fxyz(1,pickvec)) +
                     (oldxyz[3]-fxyz(2,pickvec))*(oldxyz[3]-fxyz(2,pickvec))  );
        }
        else
        {
            if(ilist[ipicklist][9] == 1) scaleitnew = scale;
            else scaleitnew = scalenew;
            if(ilist[ipicklistold][9] == 1) scaleitold = scale;
            else scaleitold = scalenew;
/*c*/       dist=sqrt(  
                      ((float)pickxold/scaleitold-(float)pickx/scaleitnew)*
                      ((float)pickxold/scaleitold-(float)pickx/scaleitnew) +
                      ((float)pickyold/scaleitold-(float)picky/scaleitnew)*
                      ((float)pickyold/scaleitold-(float)picky/scaleitnew) +
                      ((float)pickzold/scaleitold-(float)pickz/scaleitnew)*
                      ((float)pickzold/scaleitold-(float)pickz/scaleitnew) 
                     );
        }
        pickvecold = pickvec;
        ipicklistold = ipicklist;
        pickxold = pickx;
        pickyold = picky;
        pickzold = pickz;

        distmeasure = dist; /*constructline needs global distmeasure*/
        if(Lmeasureson) 
        {
            domeasures();  /*MAGEANGL.C*/
            /*puts anglemeasure,dihedralmeasure into common storage*/
/*c*/       sprintf(dstring,"%.3lf, ang=%.1f, dhr=%.1f\0",
            dist,anglemeasure,dihedralmeasure);
        }
        else    sprintf(dstring,"%.3lf\0",dist);
        condition(dstring);  /* for Mac make it a Pascal string */
           /*MACDRAW.C & MPCDRAW.C*/
        if( infofontsize <= 12)
            stringtoscreen(dstring,ixctr+5,(ymax-iybottom));
        else    
            stringtoscreen(dstring,ixmin+5,(ymax-iybottom-infofontsize));
                 /*MACDRAW.C & MPCDRAW.C*/
          /*ibigtype for PC with clunky old big type font*/
        oldxyz[1] = fxyz(0,pickvec); /* use original coord */
        oldxyz[2] = fxyz(1,pickvec);
        oldxyz[3] = fxyz(2,pickvec);
        
/*c*/   sprintf(focusxyzstr,"  %.3f   %.3f   %.3f\0"
            , (float)fxyz(0,pickvec)
            , (float)fxyz(1,pickvec)
            , (float)fxyz(2,pickvec));

        if(Lxyzpoint)
        {
           condition(focusxyzstr); /*MACDRAW.C & MPCDRAW.C*/
           /*stringtoscreen(focusxyzstr,ixctr+5-ibigfont,ymin+iytop);*/ 
           if( infofontsize <= 12)
             stringtoscreen(focusxyzstr,ixctr+5,ymin+iytop);
           else    
             stringtoscreen(focusxyzstr,ixmin+5,ymin+iytop);

        }        
        if(Lpickcenter && Lpickon && ilist[ipicklist][9]==0) /*non-static*/
        {/*recentering operation*/
          fxcenternew = fxyz(0,pickvec);
          fycenternew = fxyz(1,pickvec);
          fzcenternew = fxyz(2,pickvec);
          Lrecalculate = 1;
        }
        if(Ldrawline && (Ldrawlineon || Lconstructon || Lnewlabelson) ) 
                   /* &&!Ldraglineon */
        {/*line stuff: Ldrawline TRUE, including labels stuff*/
          Ldrawactive = 1; /*at least this one thing actually happened*/
          if(Ldrawlineon) n = 1;
          if(Lnewlabelson) n = 1;
          if(Lconstructon) n = 3;
          if(Lpoint < n) 
          {/*set point*/
             for(n=1; n<=ndrawpoint ; n++)
             {
                k = n + nxyz + nmarkers + maxmeasures + Lpoint*ndrawpoint;
                xyz(0,k) = drawpt[n][0];
                xyz(1,k) = drawpt[n][1]  + xyz(1,pickvec);
                xyz(2,k) = drawpt[n][2]  + xyz(2,pickvec);
                xyz(3,k) = drawpt[n][3]  + xyz(3,pickvec);
                fxyz(0,k) = fdrawpt[n][0]  + fxyz(0,pickvec);
                fxyz(1,k) = fdrawpt[n][1]  + fxyz(1,pickvec);
                fxyz(2,k) = fdrawpt[n][2]  + fxyz(2,pickvec); 
             }
             ilist[maxlist+7][0] = 1; /*turn on point indicater*/ /*950113*/
             ilist[maxlist+7][2] =
                  nxyz+nmarkers+maxmeasures+(Lpoint+1)*ndrawpoint; /*950113*/
                /*end of marked point mark set for this point*/
          }
          Lpoint++; /*increased flag, also needed for end of pointers*/
          /*Lpoint is now set for current state:*/
          if(Ldrawlineon||Lnewlabelson) dodrawline();  /*MAGEANGL.C*/
          if(Lconstructon) doconstructline();          /*MAGEANGL.C*/
          /*either drawlineon or constructon*/
          if( (Ldrawlineon && (Lpoint>1)) || (Lconstructon && (Lpoint>2)) )
          {
              ilist[maxlist+7][0] = 0; /*turn off point indicater*/ /*950113*/
              Lpoint = 0;          
          }
          /*Lnewlabels resets Lpoint=0 so leaves marker on last label place*/  
        }/*line stuff: Ldrawline TRUE, including Labels stuff*/
        
        if(Lprune && (Lpruneon || Lpunchon) )
        {/*prune stuff: Lprune TRUE*/
            Lpruneactive = 1; /*at least this one thing actually happened*/
            nundop++; /*set undo information */
            if(nundop > 10)
            {
                for(j=1;j<=9;j++)
                    for(k=0;k<=2;k++)
                        nprune[j][k] = nprune[j+1][k];/*931125*/
                nundop = 10;
            }
            if(Lpruneon)
            {
                nprune[nundop][1] = pickvec;/*at least this one*/
                nprune[nundop][2] = pickvec;
                if(xyz(0,pickvec) < 10) /*a DRAW operation*/
                {/*prune back to initiating P == MOVE operation*/
                    j = pickvec - 1;
                    while(xyz(0,j) < 10) /*a DRAW operation*/
                    {
                        xyz(0,j) = 100 + xyz(0,j);
                        nprune[nundop][1] = j;
                        j = j - 1;
                    }
                    /*see if there is an initiating move to prune*/
                    /*there will always be one if a DRAW was picked */
                    /* but if a MOVE (P) was picked, then not*/
                    /* so perhaps this next if in not needed */
                    if( xyz(0,j) >= 10 && xyz(0,j) < 20)
                    {/*now isolated vector move, prune it*/                    
                        xyz(0,j) = xyz(0,j) + 100;
                        nprune[nundop][1] = j;
                    }
                }
                xyz(0,pickvec) = 100 + xyz(0,pickvec);/*prune this one*/
                /*prune forward*/
                j = pickvec + 1;
                while(xyz(0,j) < 10) /*a DRAW operation*/
                {
                    xyz(0,j) = 100 + xyz(0,j);
                    nprune[nundop][2] = j;
                    j = j + 1;
                }
                nprune[nundop][0] = 0; /* nop on next move*/
            }
            else if(Lpunchon)
            {
                xyz(0,pickvec) = 100 + xyz(0,pickvec);
                nprune[nundop][1] = pickvec;
                nprune[nundop][2] = pickvec; /*just one punched out*/
                nprune[nundop][0] = 0; /*initially nop on next vector*/
                /*look forward*/
                if( xyz(0,pickvec+1) < 10 ) 
                {/*DRAW operation*/
                    if(xyz(0,pickvec+2) < 10) 
                    {/*DRAW operation that continues*//*change to MOVE*/
                        xyz(0,pickvec+1) = xyz(0,pickvec+1)+10; 
                        nprune[nundop][0] = 1; /*flag that this was changed*/
                    }
                    else
                    {/*DRAW operation isolate, so prune it*/
                        xyz(0,pickvec+1) = xyz(0,pickvec+1) + 100;
                        nprune[nundop][2] = pickvec+1;
                    }
                }
                /*look back*/
                if( xyz(0,pickvec-1) >= 10 && xyz(0,pickvec-1) < 20)
                {/*now isolated vector move, prune it*/
                    xyz(0,pickvec-1) = xyz(0,pickvec-1) + 100;
                    nprune[nundop][1] = pickvec-1;
                } 
            }
        }/*prune stuff: Lprune TRUE*/
        /*can't reset Lpick yet since may be needed to redraw markers */
        /* but ipick can be reset to avoid re-entry to here */
        /* if DopickshowDialog() does a redraw of the vectors */
        ipick = 1;
        Lprepick = 0; /*clear flag that might have been set by FIND dialog*/
        if(Lpickshowon) DocolorshowDialog(); /*MACDLOG.C*/ /*MPCDLOG.C*/

      }/*regular pick stuff*/
        if(Ldraglineon)
        {/*set a point from which to drag a (force) line */
            Ldrawactive = 1; /*at least this one thing actually happened*/
            if(Lnewmatrix)
            {/*calculate inverse rotation matrix*/
                detmatrix = a11*a22*a33+a12*a23*a31+a13*a21*a32
                           -a13*a22*a31-a11*a23*a32-a12*a21*a33;
                ma[0][1] = (+a22*a33-a23*a32)/detmatrix;
                ma[0][4] = (-a21*a33+a23*a31)/detmatrix;
                ma[0][7] = (+a21*a32-a22*a31)/detmatrix;
                ma[0][2] = (-a12*a33+a13*a32)/detmatrix;
                ma[0][5] = (+a11*a33-a13*a31)/detmatrix;
                ma[0][8] = (-a11*a32+a12*a31)/detmatrix;
                ma[0][3] = (+a12*a23-a13*a22)/detmatrix;
                ma[0][6] = (-a11*a23+a13*a21)/detmatrix;
                ma[0][9] = (+a11*a22-a12*a21)/detmatrix;
            /*11=[1];12=[2];13=[3];21=[4];22=[5];23=[6];31=[7];32=[8];33=[9];*/
            /*use otherwise unused 0th matrix entries */

                Lnewmatrix = 0;
            }/*calculate inverse rotation matrix*/
            if(Lnewdrag)
            {/*see if new drag or pick up of previous drag*/
              Lnewdrag = 0; /*clear this flag*/
              if(pickvec!=nxyz+nmarkers+maxmeasures+3*ndrawpoint+numberline)
              {/*pin a new end to the picked point*/
                Lpoint = 0;
                ilist[maxlist+7][0] = 0; /*turn off point indicater*/ /*950113*/
                dodrawline();
                Lpoint = 1; /*one point of a line*/
                numberline++;
              }/*pin a new end to the picked point*/
            }/*see if new drag or pick up of previous drag*/
        }/*set a point from which to drag a (force) line */


    }/*process pick, Lpick==1*/
      ipick = 1;
  }/*pick request, ipick==2||Lprepick*/
  else
  {/*ipick!=2*/
        stringtoscreen(comstr,(ixmin+5),(ymax - iybottom)); /*Mx*//*EXTRA*/
        if(!Ldraglineactive)          /*Mx*//*EXTRA*/
        if( infofontsize <= 12)
            stringtoscreen(dstring,ixctr+5,(ymax-iybottom));
        else    
            stringtoscreen(dstring,ixmin+5,(ymax-iybottom-infofontsize));
        if(Lrate && IMAC)
        {
            sprintf(word,"%.3f\0",mousetickrate); /*c*/
            condition(word); /*Mx*//*EXTRA*/
            stringtoscreen(word,ixmin+5,ymin+iytop+infofontsize);
        }             /*Mx*//*EXTRA*/
        if(Lxyzpoint)
        {            
           /*stringtoscreen(focusxyzstr,ixctr+5-ibigfont,ymin+iytop );*/ 
           if( infofontsize <= 12)
             stringtoscreen(focusxyzstr,ixctr+5,ymin+iytop);
           else    
             stringtoscreen(focusxyzstr,ixmin+5,ymin+iytop);

        }       /*Mx*//*EXTRA*/
        if(Lpick&&Ldraglineactive)
        {/*place free end at mouse position*/
            n = nxyz + nmarkers + maxmeasures + 3*ndrawpoint + numberline;
            jx1 = pickx-ixset;
            jy1 = picky-iyset;
            jz1 = pickz-izset;
            /*11=[1];12=[2];13=[3];21=[4];22=[5];23=[6];31=[7];32=[8];33=[9];*/
            xyz(1,n) = (jx1*ma[0][1] + jy1*ma[0][4] + jz1*ma[0][7]);
            xyz(2,n) = (jx1*ma[0][2] + jy1*ma[0][5] + jz1*ma[0][8]);
            xyz(3,n) = (jx1*ma[0][3] + jy1*ma[0][6] + jz1*ma[0][9]);
            fxyz(0,n) = (xyz(1,n)/scalenew)+fxcenternew; 
            fxyz(1,n) = (xyz(2,n)/scalenew)+fycenternew; 
            fxyz(2,n) = (xyz(3,n)/scalenew)+fzcenternew; 
            ilist[maxlist+8][2] = n; /*add this line to show list*/ /*950113*/
            igrp[maxgrp+3][0] = 1; /* turn on display */
            maxnxyz = n;
            xyz(0,n-1) = 10;  /* Point == Move */
            xyz(0,n) = 0;  /* Line == Draw */   
            ilist[maxlist+8][0] = 1; /*insure: drawn lines are on*/  /*950113*/
            Ldraglineactive = 0; 
            Lpoint = 0; /*line fully formed*/       
            /*create pointID into this new position in com array */
            icom = (long)(MAXPTIDCHAR+1)*(long)n; /*offset for character array*/ 
            for(i=0; i<(MAXPTIDCHAR+1); i++) com2(icom+(long)i)=draglinestr[i]; 
            dist= sqrt(  
                   (fxyz(0,n)-fxyz(0,n-1))*(fxyz(0,n)-fxyz(0,n-1)) +  
                   (fxyz(1,n)-fxyz(1,n-1))*(fxyz(1,n)-fxyz(1,n-1)) +
                   (fxyz(2,n)-fxyz(2,n-1))*(fxyz(2,n)-fxyz(2,n-1))  );

            sprintf(dstring,"%.3lf",dist);
            condition(dstring); 
            if( infofontsize <= 12)
                stringtoscreen(dstring,ixctr+5,(ymax-iybottom));
            else    
             stringtoscreen(dstring,ixmin+5,(ymax-iybottom-infofontsize));
        }/*place free end at mouse position*/

    }/*ipick!=2*/
/*
    izmin = izctr - izclip;
    izmax = izctr + izclip;
            sprintf(alertstr,"%d|%d:0:%d|%d",theminz,izmin,izmax,themaxz);
            condition(alertstr); 
            stringtoscreen(alertstr,ixmin+5,(ymax-iybottom-2*infofontsize));
*/
}
/*___drawvec()______________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****checksideclip()******************************************/
void    checksideclip()
{
    int    L1,L2,idelx,ifudgx,idely,ifudgy,idel,ifudg;

    LOK = 0;
    L1 = 0;
    L2 = 0;       
    if(jx1 >= xmin && jx1 <= xmax && jy1 >= ymin && jy1 <= ymax) L1 = 1;
    if(jx2 >= xmin && jx2 <= xmax && jy2 >= ymin && jy2 <= ymax) L2 = 1;
    
    if( L1 && L2) {LOK = 1; return;} /* all inside, accept */
    
    if(jx1 < xmin && jx2 < xmin) return;           /* all outside, reject */
    if(jy1 < ymin && jy2 < ymin) return;
    if(jx1 > xmax && jx2 > xmax) return;
    if(jy1 > ymax && jy2 > ymax) return;
    
    /* Easy ones done, now have to do some work */
    
    /* cases: y1 < ymin,  y1 > ymax */
    /*        y2 < ymin,  y2 > ymax */
    /*        x1 < xmin,  x1 > xmax  */
    /*        x2 < xmin,  x2 > xmax  */
    /* first bring y in to y bounds , always work on adjusted coordinates */
    if(jy2 > ymax) /* ymax fault */
    {
            idel = ymax - jy1; ifudg = 1;
            while(idel > 181 || idel < -181)
            {idel = idel/2; ifudg = ifudg*2;}
            idelx = jx2 - jx1;ifudgx = 1;
            while(idelx > 181 || idelx < -181)
            {idelx = idelx/2; ifudgx = ifudgx*2;}
            idely = jy2-jy1;
            if(idely == 0) idely = 1;
            jy2 = ymax;
            jx2 = jx1 + ((idel)*(idelx)/(idely))*(ifudgx*ifudg);
    }
    else if(jy2 < ymin) /* ymin fault */
    {
            idel = ymin - jy1; ifudg = 1;
            while(idel > 181 || idel < -181)
            {idel = idel/2; ifudg = ifudg*2;}
            idelx = jx2 - jx1;ifudgx = 1;
            while(idelx > 181 || idelx < -181)
            {idelx = idelx/2; ifudgx = ifudgx*2;}
            idely = jy2-jy1;
            if(idely == 0) idely = 1;

            jy2 = ymin;
            jx2 = jx1 + ((idel)*(idelx)/(idely))*(ifudgx*ifudg);
    }
    if(jy1 > ymax) /* ymax fault */
    {
            idel = ymax - jy1; ifudg = 1;
            while(idel > 181 || idel < -181)
            {idel = idel/2; ifudg = ifudg*2;}
            idelx = jx2 - jx1;ifudgx = 1;
            while(idelx > 181 || idelx < -181)
            {idelx = idelx/2; ifudgx = ifudgx*2;}
            idely = jy2-jy1;
            if(idely == 0) idely = 1;                    
            jy1 = ymax;
            jx1 = jx1 + ((idel)*(idelx)/(idely))*(ifudgx*ifudg);
    }
    else if(jy1 < ymin) /* ymin fault */
    {
            idel = ymin - jy1; ifudg = 1;
            while(idel > 181 || idel < -181)
            {idel = idel/2; ifudg = ifudg*2;}
            idelx = jx2 - jx1;ifudgx = 1;
            while(idelx > 181 || idelx < -181)
            {idelx = idelx/2; ifudgx = ifudgx*2;}
            idely = jy2-jy1;
            if(idely == 0) idely = 1;    
            jy1 = ymin;
            jx1 = jx1 + ((idel)*(idelx)/(idely))*(ifudgx*ifudg);
    }
    /* y coord adjusted on to y bounds, now adjust x coord */
    if(jx2 > xmax) /* xmax fault */
    {
      idel = xmax - jx1; ifudg = 1;
      while(idel > 181 || idel < -181)
        {idel = idel/2; ifudg = ifudg*2;}
      idely = jy2 - jy1;ifudgy = 1;
      while(idely > 181 || idely < -181)
        {idely = idely/2; ifudgy = ifudgy*2;}
            idelx = jx2-jx1;
            if(idelx == 0) idelx = 1;                    
      jx2 = xmax;
      jy2 = jy1 + ((idel)*(idely)/(idelx))*(ifudgy*ifudg);
    }
    else if(jx2 < xmin) /* xmin fault */
    {
      idel = xmin - jx1; ifudg = 1;
      while(idel > 181 || idel < -181)
        {idel = idel/2; ifudg = ifudg*2;}
      idely = jy2 - jy1;ifudgy = 1;
      while(idely > 181 || idely < -181)
        {idely = idely/2; ifudgy = ifudgy*2;}
            idelx = jx2-jx1;
            if(idelx == 0) idelx = 1;                        
      jx2 = xmin;
      jy2 = jy1 + ((idel)*(idely)/(idelx))*(ifudgy*ifudg);
    }
    if(jx1 > xmax) /* xmax fault */
    {
      idel = xmax - jx1; ifudg = 1;
      while(idel > 181 || idel < -181)
        {idel = idel/2; ifudg = ifudg*2;}
      idely = jy2 - jy1;ifudgy = 1;
      while(idely > 181 || idely < -181)
        {idely = idely/2; ifudgy = ifudgy*2;}
            idelx = jx2-jx1;
            if(idelx == 0) idelx = 1;                            
      jx1 = xmax;
      jy1 = jy1 + ((idel)*(idely)/(idelx))*(ifudgy*ifudg);
    }
    else if(jx1 < xmin) /* xmin fault */
    {
      idel = xmin - jx1; ifudg = 1;
      while(idel > 181 || idel < -181)
        {idel = idel/2; ifudg = ifudg*2;}
      idely = jy2 - jy1;ifudgy = 1;
      while(idely > 181 || idely < -181)
        {idely = idely/2; ifudgy = ifudgy*2;}
            idelx = jx2-jx1;
            if(idelx == 0) idelx = 1;                            
      jx1 = xmin;
      jy1 = jy1 + ((idel)*(idely)/(idelx))*(ifudgy*ifudg);
    }
    LOK = 1;
    return;
}
/*___checksideclip()_________________________________________*/

/****checkzclip()************************************************************/
void    checkzclip(int ix1,int iy1,int iz1,int ix2,int iy2,int iz2) 
            /* passed altered coord values*/
           /* local overrides global meaning*/
{
    int            L1,L2;
    int            izmin,izmax,idelx,idely,ifudgx,ifudgy;
    int            idelmin1,idelmax1,ifudgmin1,ifudgmax1;
    int            idelmin2,idelmax2,ifudgmin2,ifudgmax2;
    
    izmin = izctr - izclip;
    izmax = izctr + izclip;
    L1 = 0;
    L2 = 0;
    if(iz1 >= (izmin) && iz1 <= (izmax) ) L1 = 1;
    if(iz2 >= (izmin) && iz2 <= (izmax) ) L2 = 1;
    
    if(L1 && L2) {LOK = 1; return;}
    
    if(iz1 < izmin && iz2 < izmin) {LOK = 0; return;}
    if(iz1 > izmax && iz2 > izmax) {LOK = 0; return;}
    
    /*so neither fully accepted, nor fully rejected, so got to do some work:*/
    idelx = ix2 - ix1;ifudgx = 1;
    while(idelx > 181 || idelx < -181){idelx = idelx/2; ifudgx = ifudgx*2;}
    idely = iy2 - iy1;ifudgy = 1;
    while(idely > 181 || idely < -181){idely = idely/2; ifudgy = ifudgy*2;}
    idelmin1 = izmin-iz1; ifudgmin1 = 1;
    while(idelmin1 > 181 || idelmin1 < -181)
    {idelmin1 = idelmin1/2; ifudgmin1 = ifudgmin1*2;}
    idelmax1 = izmax-iz1; ifudgmax1 = 1;
    while(idelmax1 > 181 || idelmax1 < -181)
    {idelmax1 = idelmax1/2; ifudgmax1 = ifudgmax1*2;}
    idelmin2 = izmin-iz2; ifudgmin2 = 1;
    while(idelmin2 > 181 || idelmin2 < -181)
    {idelmin2 = idelmin2/2; ifudgmin2 = ifudgmin2*2;}
    idelmax2 = izmax-iz2; ifudgmax2 = 1;
    while(idelmax2 > 181 || idelmax2 < -181)
    {idelmax2 = idelmax2/2; ifudgmax2 = ifudgmax2*2;}
    
    if(L1) /* 2 fault */
    {
      if(iz2 < izmin)  /* back plane */
      {
        jx2 = ix1 + ((idelx)*(idelmin1)/(iz2-iz1))*(ifudgx*ifudgmin1);
        jy2 = iy1 + ((idely)*(idelmin1)/(iz2-iz1))*(ifudgy*ifudgmin1);
        LOK = 1;
        return;
      }
      else /* front plane */
      {
        jx2 = ix1 + ((idelx)*(idelmax1)/(iz2-iz1))*(ifudgx*ifudgmax1);
        jy2 = iy1 + ((idely)*(idelmax1)/(iz2-iz1))*(ifudgy*ifudgmax1);
        LOK = 1;
        return;
      }
    }
    else if(L2) /* 1 fault */
    {
      if(iz1 < izmin)  /* back plane */
      {
        jx1 = ix2 + (( idelx)*(idelmin2)/(iz2-iz1))*(ifudgx*ifudgmin2);
        jy1 = iy2 + (( idely)*(idelmin2)/(iz2-iz1))*(ifudgy*ifudgmin2);
        LOK = 1;
        return;
      }
      else /* front plane */
       {
        jx1 = ix2 + (( idelx)*(idelmax2)/(iz2-iz1))*(ifudgx*ifudgmax2);
        jy1 = iy2 + (( idely)*(idelmax2)/(iz2-iz1))*(ifudgy*ifudgmax2);
        LOK = 1;
        return;
      }
    }
    else /* vector spans both planes, just leave the whole damn thing */
    {
      if(iz1 < izmin)  /* 1 at back plane, 2 at front plane */
      {
        jx1 = ix2 + ( ( idelx)*(idelmin2)/(iz2-iz1) )*(ifudgx*ifudgmin2);
        jy1 = iy2 + ( ( idely)*(idelmin2)/(iz2-iz1) )*(ifudgy*ifudgmin2);
        jx2 = ix1 + ( ( idelx)*(idelmax1)/(iz2-iz1) )*(ifudgx*ifudgmax1);
        jy2 = iy1 + ( ( idely)*(idelmax1)/(iz2-iz1) )*(ifudgy*ifudgmax1);

        LOK = 1;
        return;
      }
      else /* 1 at front plane, 2 at back plane */
      {
        jx1 = ix2 + ( ( idelx)*(idelmax2)/(iz2-iz1) )*(ifudgx*ifudgmax2);
        jy1 = iy2 + ( ( idely)*(idelmax2)/(iz2-iz1) )*(ifudgy*ifudgmax2);
        jx2 = ix1 + ( ( idelx)*(idelmin1)/(iz2-iz1) )*(ifudgx*ifudgmin1);
        jy2 = iy1 + ( ( idely)*(idelmin1)/(iz2-iz1) )*(ifudgy*ifudgmin1);

        LOK = 1;
        return;
      }
    }
}
/*___checkzclip()___________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/  
/****getrot()****************************************************************/
void    getrot(int idelx,int idely)
{    /*called from MACDRAW, MUXMDRAW, MPCMAIN:Mousemove */
    int idel;
    float b11,b12,b13,b21,b22,b23,b31,b32,b33;
    double sinang,cosang,fvalue;
     
     if(irotxy == 1 && Lflat)
     {
         ixtran = ixtran + idelx;
         iytran = iytran + idely;
     }
     else if (irotxy == 1)
     { /* xy rotation around center */
      /* get sin and cos of angle from change in mouse position */
            fvalue = idelx;
            fvalue = fvalue/100.0;
      /* sin and cos of current delta angle of this axis */
/*c*/        sinang = sin(fvalue);
/*c*/        cosang = cos(fvalue);
      /* update: aij-matrix X y-matrix: a11 a12 a13     cosang   0   -sinang  
                                        a21 a22 a23  X    0      1      0
                                        a31 a32 a33     sinang   0    cosang
                                                                            */
      b11 = a11*cosang + a13*sinang;
      b12 = a12;
      b13 = a11*(-sinang) + a13*cosang;
      b21 = a21*cosang + a23*sinang;
      b22 = a22;
      b23 = a21*(-sinang) + a23*cosang;
      b31 = a31*cosang + a33*sinang;
      b32 = a32;
      b33 = a31*(-sinang) + a33*cosang;

      a11 = b11; a12 = b12; a13 = b13;
      a21 = b21; a22 = b22; a23 = b23;
      a31 = b31; a32 = b32; a33 = b33;

     /* get sin and cos of angle from change in mouse position */
            fvalue = -idely;
            fvalue = fvalue/100.0;
      /* sin and cos of current delta angle of this axis */
/*c*/        sinang = sin(fvalue);
/*c*/        cosang = cos(fvalue);

      /* update: aij-matrix X x-matrix: a11 a12 a13      1       0      0     
                                        a21 a22 a23  X   0     cosang sinang
                                        a31 a32 a33      0    -sinang cosang
                                                                            */
      b11 = a11;
      b12 = a12*cosang - a13*sinang;
      b13 = a12*sinang + a13*cosang;
      b21 = a21;
      b22 = a22*cosang - a23*sinang;
      b23 = a22*sinang + a23*cosang;
      b31 = a31;
      b32 = a32*cosang - a33*sinang;
      b33 = a32*sinang + a33*cosang;

      a11 = b11; a12 = b12; a13 = b13;
      a21 = b21; a22 = b22; a23 = b23;
      a31 = b31; a32 = b32; a33 = b33;

     } /* xy rotation around center */
     
     else
     { /* z rotation around center */
      /* get sin and cos of angle from change in mouse position */
            fvalue = idelx;
            fvalue = fvalue/100.0;
      /* sin and cos of current delta angle of this axis */
/*c*/        sinang = sin(fvalue);
/*c*/        cosang = cos(fvalue);
      /* update: aij-matrix X z-matrix: a11 a12 a13     cosang sinang   0
                                        a21 a22 a23  X -sinang cosang   0
                                        a31 a32 a33       0      0      1 */
      /* accummulate into temporary matrix */
      b11 = a11*cosang - a12*sinang;
      b12 = a11*sinang + a12*cosang;
      b13 = a13;
      b21 = a21*cosang - a22*sinang;
      b22 = a21*sinang + a22*cosang;
      b23 = a23;
      b31 = a31*cosang - a32*sinang;
      b32 = a31*sinang + a32*cosang;
      b33 = a33;

      /* restore working matrix */
      a11 = b11; a12 = b12; a13 = b13;
      a21 = b21; a22 = b22; a23 = b23;
      a31 = b31; a32 = b32; a33 = b33;

     } /* z rotation around center */
}
/*___getrot()_______________________________________________________________*/
  
