/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/

#include "MAGE.H"
/*mageGrup.c*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****getgroup(c,Lnew)*********************************************/
void    getgroup(int c,int Lnew)
{
static    int     Lidn,Lfirst,gotinstance;
static    int     flowID,n,j;
static    char    instancename[MAXNAMECHAR+1],ana1name[MAXNAMECHAR+1];
static    char    ana2name[MAXNAMECHAR+1];
          int     mask, masterfound, Lexcesscounter;
/*need some of these static since getgroup() called repeatedly during input*/
enum    { idenID = 1, numbID = 2, skipID = 3 };

    if(Lnew)   /* initialize */
    {/*Lnew*/
        Lfirst = 1;
        iword = 0;
        Linstance = 0;
        Lmaster = 0;
        if(ngrp >= MAXG-1)
        {
             sprintf(alertstr,"too many groups!");
             dosinglealert(); /*___DLOG.C*/
        }
        else    ngrp++;
        maxgrp = ngrp;
        igrp[ngrp][0] = 1;    /* start with display enabled */
            /*since @group must occur before @set, first set number of this*/
            /*  coming group is the next nset, i.e. nset + 1  */
        igrp[ngrp][1] = nset + 1; /* starting set number of this group */
        igrp[ngrp][2] = nset + 1; /*ending set number of this group, so far*/
            /*the @set routine must adjust the set counters within the group*/
        igrp[ngrp][3] = 0;  /* initialize as static group, */
                            /* flag in first line will set animate */
        igrp[ngrp][4] = 0;    
        /* initialize as recessive; does not hide things below it*/
        igrp[ngrp][5] = 0; /*dummy, used to be master button*/
        igrp[ngrp][6] = 0; /* initially not flagged for special output*/
        igrp[ngrp][7] = 0; /*presume an original, not an instance*/ 
        igrp[ngrp][8] = 0; /* initialize as a regular group, */
                           /* flag in first line will set moview if animate*/
        igrp[ngrp][9] = 0; /*presume no balllists to start*/ 
        for(n=0;n<=MAXNAMECHAR;n++) groupname[ngrp][n] = '\0' ; 
                           /* clear group name */
        groupname[ngrp][0] = ' ';/*1st char animate flag or blank*/
        groupmaster[ngrp] = 0; /*unsigned long for master button flags*/
    }/*Lnew*/

    /* test character and set flow controls  */
    /* screen for button identifier */
    if(c == '{')  /* start a button identifier */
    {
        Lidn = 0; /* Lidn only set = 1 after next identifier char read */
        iword = 0;
        flowID = idenID;
        Lexcesscounter = 0; /*overflow only flagged once per {...} */
    }
    else if(c == '}')  /* end a button identifier, require both {...} ??*/
    {/*button identifier complete*/
        for(n=iword ; n<MAXNAMECHAR ; n++) word[n] = '\0';
          /*revision930207 pad out identifier with '\0' rather than ' '*/
        word[MAXNAMECHAR] = '\0';  /* pad & end the string in c manner */
        if(Linstance)
        {/*should hold identifier of a previously defined group */
        
            /* group named, copy it to instancename */ 
            for(n=0; n<=MAXNAMECHAR ; n++)
            {    
                instancename[n+1] = word[n];
                ana1name[n+1] = word[n]; 
                ana2name[n+1] = word[n];
            }
            instancename[0] = ' ';
            ana1name[0] = '*';
            ana2name[0] = '%';
            condition(instancename);  /*MACMAIN.C, dummied in other ___MAIN.C */
            condition(ana1name);  
            condition(ana2name); 
            gotinstance = 0; /*flag*/               
            for(j=1;j<ngrp;j++)
            {
                if(  (strncompare(instancename,groupname[j],MAXNAMECHAR+1)==0)
                   ||(strncompare(ana1name,groupname[j],MAXNAMECHAR+1)==0)
                   ||(strncompare(ana2name,groupname[j],MAXNAMECHAR+1)==0)    )
                {
                    igrp[ngrp][0] = 1;/*do not inherit on-off!! start enabled*/
                    igrp[ngrp][1] = igrp[j][1];
                        /* starting list number of this group */
                    igrp[ngrp][2] = igrp[j][2];
                        /* ending list number of this group */
                    /*igrp[ngrp][3] = igrp[j][3];*/
                        /* animate flag of this new group has to be explicit*/
                    /*groupname[ngrp][0] = groupname[n][0];*/ 
                        /* animate flag character for this group */
                    igrp[ngrp][4] = igrp[j][4];
                        /* dominance of this group set to be same as orig.*/
                    /*if(igrp[ngrp][5] == 0)*/ /*no master set yet for new grp*/
                       /*igrp[ngrp][5] = igrp[j][5];*/ 
                    if(groupmaster[ngrp] == 0) /*no master set yet for new grp*/
                       groupmaster[ngrp] = groupmaster[j];
                        /* master button flag for this group set as old one*/
                        /*this would be overridden by later new master */
                    igrp[ngrp][6] = igrp[j][6]; 
                        /* special output flag for this group set as old one*/
                    igrp[ngrp][7] = j; /*identity of original group*/ 
                    igrp[ngrp][8] = igrp[j][8];
                        /* moview flag of this group set as old one*/
                    gotinstance = 1;
                    break; /*out of for... loop*/
                }
            }
            if(!gotinstance)
            {
                sprintf(alertstr,
                    "instance failed, no previous group has name: %s"
                    ,instancename);
                dosinglealert(); /*___DLOG.C*/ 
            }
            gotinstance = 0;
            Linstance = 0;
        }
        else if(Lmaster)
        {/*should hold identifier of a master button for this group */
        
            /* master named,*/
            condition(word); /*make into a Pascal string if on Mac*/ /*MACMAIN.C*/
            
            if(nmaster > 0) /*previous master button requested */ 
            {/*see if this one matches a previous master name */ 
                masterfound = 0;
                for(j=1;j<=nmaster;j++)
                {
                  /*if(strncompare(word,mastername[j],MAXNAMECHAR+1) == 0)*/
                    if(strncompare(word,mastername[j],MAXNAMECHAR) == 0)
                    {
                         mask = 1<<(j-1);
                         groupmaster[ngrp] = mask + groupmaster[ngrp]; 
                             /*add to any others*/
                       /*igrp[ngrp][5] = j;*/ 
                         masterfound = 1;      
                    }
                }
            }
            if(nmaster == 0 || masterfound == 0)
          /*if(nmaster == 0 || igrp[ngrp][5] == 0)*//*make a new master button*/
            {
                if(nmaster+1 > 8*((int)sizeof(long)) )
                {
                    sprintf(alertstr,"#master buttons limited to %d in %s",
                                     8*((int)sizeof(long)),version); 
                    grouperrorreport(); /*alertstr and word*/ /*MAGEGRUP.c*/
                }
                else
                {
                    nmaster++;
                    for(n=0; n<=MAXNAMECHAR ; n++)
                    {    
                        mastername[nmaster][n] = word[n]; 
                    }
                    mask = 1<<(nmaster-1);
                    groupmaster[ngrp] = mask + groupmaster[ngrp]; 
                        /*add to any others*/
                  /*igrp[ngrp][5] = nmaster;*/
                }
            }                
            Lmaster = 0;
        }
        else
        {/*should hold identifier of this group */
            /*group name: copy it to groupname */
            for(n=0; n<=MAXNAMECHAR; n++)/*just copy it all, word[iword]='\0'*/
            {  
                groupname[ngrp][n+1] = word[n];/*groupname starts at char 1 */
            }
            /*groupname was blanked earlier, don't mess with [0] so an*/
            /*animate before groupname could leave its * in the [0]th place*/
            groupname[ngrp][MAXNAMECHAR+1] = '\0' ; /*insurance*/
                /* array has MAXNAMECHAR+2 chars indexed: 0,...,MAXNAMECHAR+1 */
                /* truncate to MAXNAMECHAR chars, [0] reserved for animate flag */
                /* array is defined as MAXNAMECHAR+2 to allow for flag and \0 */
            if(Ltest)
            {
                 sprintf(alertstr,"debug test for groupname");
                 grouperrorreport(); /*alertstr and word*/ /*MAGEGRUP.c*/
            }
            /*don't condition groupname yet, wait for possible animate flags  950113*/
        }/*should hold identifier of this group */

        iword = 0;
        Lidn = 0;
        flowID = skipID;
    }/*button identifier complete*/

    /* now either in a comment in which any other char accepted */
    /* or must check the char */
    if( !Lidn && (flowID != idenID) )
    {
        if(Lfirst)  
        /* first line with @group can have {name} & animate control */
        /* also off control */
        {
            if(  c == ' '||c == ','||c == ';'||c == '\t'
               ||c == '\015'||c == '\012'||c == EOL) /*950110*/
                    /* white space */
            {
                if(iword > 0)  /* after a word */
                {
                    word[iword] = '\0';  /* end string in c manner */
                    if(Lmoview)
                    {/*expecting an integer from 1 - 9*/
                         sscanf(word,"%d",&n);
                         if(n < 1 || n > 9) n = 1;
                         igrp[ngrp][8] = n;
                         Lmoview = 0;
                    }
                    else
                    {
/*.*/                    interpretgroupkeyword(word,iword);
                    }
                    iword = 0;
                }
            }
            else  /* accummulate character in word */
            {
/*c*/            c = tolower(c);  /*make lowercase so case independent */
                word[iword] = c;
                iword = iword + 1;
            }
            if(c == EOL)   /*950113*/
            {
                Lfirst = 0;  /* ends first line */
/*Mx*/          condition(groupname[ngrp]);
            }
        }
        else 
        {
            flowID = skipID;  
            /* if not first line, skip until upper routine finds an @ */
        }
    }

    /* Now control by flowID cases */
    /*begin-of-switch(flowID)*/                        
    switch(flowID)
    {
        case idenID:
            if(Lidn)
            {
                if(iword >= MAXNAMECHAR) 
                {
                    word[iword] = '\0';
                    {
                        sprintf(alertstr,
                           "next char: %c, exceeds %d char name limit"
                           "\015expect truncated group {Name}"
                           ,c,MAXNAMECHAR);
                        grouperrorreport(); /*alertstr and word*/ /*MAGEGRUP.c*/
                        flowID = skipID;  /*ignore char until end of name*/
                    }
                }
                else
                {
                    word[iword] = c;
                    iword = iword + 1;
                }
            }
            else
            {
                Lidn = 1; /* get ready for the actual comment characters*/                                
            }
        break;
                            
        case skipID:
        break;
    }
    /*end-of-switch(flowID)*/
}
/*___getgroup(c,Lnew)____________________________________________________*/

/****interpretgroupkeyword()*************************************************/
void    interpretgroupkeyword(char keyns[256],int ikeyn)
{
         ikeyn = ikeyn; /*to avoid warning of no use */

/*I*/    if(strncompare(keyns,"off",3) == 0) igrp[ngrp][0] = 0;
                                /* starts with display disabled */ ;
/*I*/    if(strncompare(keyns,"-",1  ) == 0) igrp[ngrp][0] = 0; /* historic */
/*I*/    if( (strncompare(keyns,"*",1  ) == 0) || 
            (strncompare(keyns,"animat",6) == 0) )
         {
            igrp[ngrp][3] = 1;  /* flag for animation group */
            
            if(groupname[ngrp][0] != '*')  nanimate++;    
                        /* double flags, eg "* animate" only count once */
            
            groupname[ngrp][0] = '*';  /* otherwise char[0] left blank */

            if(nanimate > 1 ) igrp[ngrp][0] = 0; 
                        /*only first animated group starts visible*/
         }
/*I*/    if( (strncompare(keyns,"2animat",7) == 0) )
         {
            igrp[ngrp][3] = 2;  /* flag for animation group */
            nnanimate++;    
            groupname[ngrp][0] = '%';  /* otherwise char[0] left blank */
              /*revision930206 %2animate: PC menu '&' does next char underline*/
            if(nanimate > 1 || nnanimate > 1 ) igrp[ngrp][0] = 0; 
                        /*only first animated group starts visible*/
         }

/*I*/    if( (strncompare(keyns,"dominant",8) == 0) )
         {
            if(igrp[ngrp][4] == 2) ; /*nobutton takes precedence*/
            else igrp[ngrp][4] = 1;  /* dominant group: hides all subgroups */
                                /* and lists below itself */
         }
/*I*/    if( (strncompare(keyns,"nobutton",8) == 0) )
         {
            igrp[ngrp][4] = 2;  /* nobutton group: has no button itself*/
                                /* and hides all subgroups */
                                /* and lists below itself */
         }

/*I*/    if(strncompare(keyns,"master=",7) == 0) Lmaster = TRUE;
/*I*/    if(strncompare(keyns,"instance=",9) == 0) Linstance = TRUE;
/*I*/    if(strncompare(keyns,"moview=",7) == 0) Lmoview = TRUE;
}
/*___interpretgroupkeyword()_________________________________________________*/

/****grouperrorreport()*******************************************************/
void grouperrorreport()
{
    /*groupname not conditioned at this point   950113*/
    /*recondition(groupname[ngrp]);*/  /*MACMAIN.C, dummied in MPCMAIN.C, etc.*/
    sprintf(alertstr2,"%s",word);
    sprintf(alertstr3,"\015in group[%d]: %s",ngrp,groupname[ngrp]);
    DoMageDLOGreport(); /*alertstr,alertstr2,alertstr3*/ /*___DLOG.C*/
    /*condition(groupname[ngrp]);*/
}
/*___grouperrorreport()______________________________________________________*/

