/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/

#include "MAGE.H"

/*keywords, BEWARE: some have NOT been used in published work and will
                           NOT be included in the future!
@text
@caption
@group
@set
@subgroup
@vectorlist   @vector
@labellist    @label
@dotlist      @dot
@wordlist     @word
@balllist     @ball 
@kinemage
@matrix
@2matrix
@3matrix
@4matrix
@5matrix
@6matrix
@7matrix
@8matrix
@9matrix
@10matrix
@onewidth
@noscale
@thinline
@perspective
@plotonly
@multibin
@zoom
@2zoom
@3zoom
@4zoom
@5zoom
@6zoom
@7zoom
@8zoom
@9zoom
@10zoom
@center
@2center
@3center
@4center
@5center
@6center
@7center
@8center
@9center
@10center
@viewid
@2viewid
@3viewid
@4viewid
@5viewid
@6viewid
@7viewid
@8viewid
@9viewid
@10viewid
@pickcenter
@zoomonly
@sideclip
@zclip
@zclipoff
@zslab
@2zslab
@3zslab
@4zslab
@5zslab
@6zslab
@7zslab
@8zslab
@9zslab
@10zslab
@ztran
@whitebkg
@ignore
@keepstereo
@keepthinline
@keepperspective     @keepperspec
@stereoangle
@localrotation       @localrotat  @localmatrix
@endlocalrotation    @endlocalrot @endlocalmatrix
@localprecenter      @localcenter
@localpostcenter
@endlocalcenter      @endlocalcen
@compare
@scale
@fontsizeinfo        @fontsizeinfo
@fontsizelabels      @fontsizelabel
@fontsizewords       @fontsizeword

@specialps
@flat
*/
/****GetStuffFromFile()******************************************************/
void    GetStuffFromFile()
{
    char     wkeys[256],capts[256],buffs[256];
    int     c,ikeyw,icapt,ibuff,n,ididit,i,j,icounter,icnt,iflag;/*,itestit*/
    int        flowID, storID;  /* switch controls for input */
    
    enum
    {
         neutID = 1
        ,cntlID
        ,keywID
        ,grupID
        ,kineID
        ,captID
        ,vectID
        ,matrID
        ,viewID
        ,setsID
        ,onewID
        ,mbinsID
        ,zoomID
        ,centerID
        ,zclipID
        ,stereoID
        ,scaleID
        ,isizeID
    };     
    int        Lcmnt,Lcapt,Llist,Lpass; 
                /* Logicals for input flow */
    int        Lnew,Lprekey,Lcaptstate,Lknow;
    
    /*executable statements:*/
    
   
    Lkinemagecount++; /*increment each kinemage in this file*/
    Lnew=1;          /*initialize first encounter of an object */
    Lprekey=0;       /* help skip white spaces */
    Lcaptstate=0;    /*allow @ to be a character inside of a caption*/
    Lknow=0;         /*to stop searching when interpret a key word*/

#ifdef MACINTOSH
         for(j=1;j<10;j++) HandleEvent();/*MACMAIN.C *//*anti-hang magic*/
#endif

         clearcapts();   /*MACWIND.C*/  /*MPCWIND.C*/
#ifdef MACINTOSH
         for(j=1;j<10;j++) HandleEvent();/*MACMAIN.C *//*anti-hang magic*/
#endif

    /*write new kinemage number to caption window */
         insertcapts(KineName);   /*MACWIND.C*/  /*MPCWIND.C*/
            /*so captWindow will be updated and readable*/

#ifdef MACINTOSH
/*Mx*/   for(j=1 ; j<10 ; j++)    HandleEvent(); /*anti-hang magic*/
#endif

    thiskinenum = kinemagenum;
    /* enters with file positioned within a particular kinemage */
    /* so next @kinemage keyword or EOF ends this section */

    /*Initiate kinemage: reset logicals and counters */
    Lexcessivepoints = 0; /*only warn once per kinemage*/
    LpointIDtoolong = 0;  /*only warn once per kinemage*/
    LOK = TRUE;
    Lplotonly = FALSE;
    Lflat = FALSE;
    Lfirstcall = TRUE;
    Lplotpoint = FALSE;
    LnextOK = 1;
    Lgnomon = 0;
    Lscale = TRUE;/* which vectors get scaled, set false*/
    /* by NOSCALE control card */
    DOscale = TRUE; /* whether any scaling to be done*/
    /* set false if NOSCALE before any vectors */
    Newscale = TRUE; /* set false on first vector set */
    fxmin =  9999.0; /* scaling limits initialized wimperwhump*/
    fxmax = -9999.0;
    fymin =  9999.0;
    fymax = -9999.0;
    fzmin =  9999.0;
    fzmax = -9999.0;
    x2 = 9999.0; y2 = 9999.0; z2 = 9999.0;

    scale = 0.0;   /*set by scalekinemage() by actual data or set to be 1.0 */
/*c*/     sprintf(dstring,"\0");   /* clear distance report on graph screen */
/*Mx*/    condition(dstring);
/*c*/     sprintf(comstr,"%c\0",' ');   /*clear label report on graph screen*/
/*Mx*/    condition(comstr);
    Lset = 0;
    nanimate = 0;
    nnanimate = 0;
    nmaster = 0;
    ngrp = 0;    /* counter for groups, incremented before use */    
    maxgrp = 0;
    nset = 0;    /* counter for sets, incremented before use */
    maxset = 0;
    nlist = 0;    /* counter for lists, incremented before use */
    maxlist = 0;
    nxyz = 1;    /* counter for triplets of numbers */
    igrp[maxgrp][0] = 0; /* turn off all display*/
    Lmarkers = FALSE;
    Lonewidth = FALSE;

    Lwhitebkg = FALSE;
    Ldragline = 0;
    Lnewdrag = 0;
    Lnewmatrix = 0;
    Ldraglineon = 0;
    Ldraglineactive = 0;
        Lzoom = TRUE;  /* zoom, zclip, ztran sliders are now constitutive*/
        Lpickcenter = TRUE;
        Lpickon = FALSE;
        Lcenterpoint = FALSE;
        Lzclip = TRUE;
        Lzclipon = TRUE;
        Lztran = TRUE;
        Lmultibins = TRUE;
        multibins = 20;
        
        Lprune = FALSE;
        Lpruneactive = FALSE;
        Lpruneon = FALSE;
        Lpunchon = FALSE;
        nundop = 0;
        Lsuperpick = FALSE;
        Lpickshowon = FALSE;
        Lpickshow = FALSE;
        Lmeasures = FALSE;
        Lmeasureson = FALSE;
        Ldrawactive = 0;
        Lnewviewactive = 0;
        Ldrawline = 0;
        Ldrawlineon = 0;
        Lconstructon = FALSE;
        Lpoint = 0;
        shortenline = 0.0;
        Lcmnt = 0;
        Lpass = 1; /*has to start by accepting any char */
        ibuff = 0;
        flowID = neutID;
        Lcapt = 0;
        erasezoomvalue();
        erasezclipvalue();
        eraseztranvalue();
        zoom = 1.0;
        izclip = 200;/*fzclip may not be ==1.0 if screen box resized! */
        iztran = 0;
        ixtran = 0;
        iytran = 0;
        iviewset = 1;
        
        for(i=1; i<= MAXRESETS ; i++)
        {
            Lreset[i] = 0;  /* [1] = 1, see below */
            Lview[i] = 0;   /* [1] = 1, see below */
            Lzoomer[i] = 0; /* [1] = 1, see below */
            zoomold[i] = 1.0;
            /*scaleold[i] = 1.0;*/
            Lcenter[i] = 0;
            fxcenterold[i] = 0.0;
            fycenterold[i] = 0.0;
            fzcenterold[i] = 0.0;
            Lzcliper[i] = 0; /* [1] = 1, see below */
            izclipold[i] = 200;
            Lztraner[i] = 0; /* [1] = 1, see below */
            iztranold[i] = 0;
            viewcom[i][0] = '\0'; /*comment associated with ith view*//*931126*/
                sprintf(temps,"View%d",i);
                if(i==MAXRESETS) sprintf(temps,"Reader's View");
                condition(temps);
        
                if(i==1)  mymodifymenuitem(viewMenu, reset1Item, temps);
                if(i==2)  mymodifymenuitem(viewMenu, reset2Item, temps);
                if(i==3)  mymodifymenuitem(viewMenu, reset3Item, temps);
                if(i==4)  mymodifymenuitem(viewMenu, reset4Item, temps);
                if(i==5)  mymodifymenuitem(viewMenu, reset5Item, temps);
                if(i==6)  mymodifymenuitem(viewMenu, reset6Item, temps);
                if(i==7)  mymodifymenuitem(viewMenu, reset7Item, temps);
                if(i==8)  mymodifymenuitem(viewMenu, reset8Item, temps);
                if(i==9)  mymodifymenuitem(viewMenu, reset9Item, temps);
                if(i==10) mymodifymenuitem(viewMenu, resetRItem, temps);
        }
        Lreset[1] = 1;
        Lview[1] = 1;
        Lzoomer[1] = 1;
        Lzcliper[1] = 1;
        Lztraner[1] = 1;
        for(i=1; i<= MAXBONDROT ; i++)
        {
            for(j=0; j<=MAXNAMECHAR ; j++) bondname[i][j] = '\0';
            bondrotin[i] = 0.0;
            bondrotout[i] = 0.0;
        }
        if(nbondrot > 0)
        {
            for(i=1; i<=nbondrot; i++)
            {
                erasebondrotvalue(i);
                /*removes any previous kinemage bond rotation text*/
#ifdef PCWINDOWS
sprintf(alertstr,"about to destroy bondrotsliders");
/*dosinglealert();*/
/*sometimes this doesn't work, maybe needs delay of some sort here*/
/*since seems always to work if it has to report */
                DestroyWindow( bondrotWindow[i] );
                bondrotWindow[i] = 0;
#endif
#ifdef UNIX_MOTIF
     XtDestroyWidget(hgrafbondrot[i]);
     XtDestroyWidget(bondrotvalue[i]);
     XtDestroyWidget(bondrotstart[i]);
     XtDestroyWidget(bondrotname[i]);
#endif
            }
        }
        Lbondrotscope = 0;
        nbondrot = 0;

        if(Lkeepstereo) Lstereo = TRUE;
        else            Lstereo = FALSE;

        if(Lkeepthinline) Lthin = TRUE;
        else              Lthin = FALSE;

        if(Lkeepperspective) Lperspec = TRUE;
        else                 Lperspec = FALSE;

        Lcompare = 0;
        Lcompareon = 0;
        Lcomparestart = 0;
        nextanimategroup = 0;
        
        Llocalrotation = 0;
        Llocalprecenter = 0;
        Llocalpostcenter = 0;
        Lnewlabels = 0;
        Lsearchatend = 1;
        
        LspecialPS = 0; /*931128PS*/
        
        resetmenuchecks();/*MACMENU.C, calls AdjustMenus() to set enables;*/

/*itestit = 1; delete this line 950113*/
    while (Lfile)  /* flow controls and logicals together direct the flow */
    {    /*begin-loop-while-file-not-at-EOF*/        
/*c*/   /* c = getc(fp);*/  /* getnextchar() defined getc(fp); for Mac */
        c = getnextchar();  /*MENUCMD3.C PCMAGE return(*filebuf++)*/

        if(c == EOF)
        {
            Lfile = FALSE;  /* will terminate loop at next cycle */
            c = EOL;     
            /* carraige return will allow any active line to finish */
        }
        if(Lcmnt)  /* ignore characters until hit a > unless passing to vect*/
        {    /*begin-a-<comment>*/
            if( c == '>')
            {
                Lcmnt = 0; /* next character will not be ignored */
                /* but Lpass == 1 will let this '>' get to vect */
                flowID = storID;  
                /* note: flowID not used until next char comes in */
                /* if Lpass == 0, but since Lcmnt now 0, Lpass will
                /* be set to 1 after the if(Lpass){} routine */
            }
        }    /*endof-a-<comment>*/
        if(Lpass)
        {    /*begin-not-a-<comment> or pass anyway*/
            if (c == '<')
            {
                Lcmnt = 1; /* establish a comment */
                storID = flowID;  /* comments can be within anything */
                        
                if(flowID == vectID) /*allow comment chars to get to vect */
                {
                    Lpass = 1;
                }
                else
                { 
                    flowID = neutID;  /* this keeps < char out of flow */
                    Lpass = 0; /*this stops anything later */
                }
            }
            /*if (c == '\n') c = '\015';*//* whatever newline is, */
            if (c == '\n') c = EOL;/* whatever newline is, */
            if (c == '\r') c = EOL;/* whatever newline is, */
                                      /*it needs to be CR in caption for Mac*/
            if (c == '@')                 
            {
                flowID = keywID; /* need to get begin's key word */
                ikeyw = 0;  /* set keyw character counter */
                Lprekey = 1; /* Logical to skip blank spaces before key*/
                if(Lcapt)
                {
                    Lcaptstate = 1; 
                    /* allows @ to be in caption if not a keyword */
                    getcaptend(); /*PC MENUCMD3.C, sets possible captend*/
                    /* captstart,captend: caption part of buffer*/
                }
            }
            switch(flowID)
            {
                case neutID:  
                    /* neutral: no flow designated, discard characters */
                break;                    
                    
                case keywID: 
                    /* try to interpret next set of characters as a key word*/
                    if(Lcaptstate && ibuff<255)
                    {/* continue to accummulate caption in case this */
                        /* is not a key word */
                        buffs[ibuff] = c;
                        ibuff++;
                    }
                    /* skip blank spaces, or tabs, in the beginning */
                    if(Lprekey && (c == ' ') || Lprekey && (c == '\t'))  
                    /* Lprekey set = 1 where keywID set */
                    {
                        ;  /* skip white space */
                    }
                    else if(c == '@')
                    {
                        ;  /* @ discarded */
                    }
                    else
                    {
                        Lprekey = 0;  /* hit a non-blank character */
                        ikeyw++; /* ikeyw set =0 when flowID set = keywID */
                        
                        wkeys[ikeyw] = c;
                        
/*c*/                    wkeys[ikeyw] = tolower(wkeys[ikeyw]);  
                                        /*case independent */
                        
                        if( (c == ' ')||(c == '\015')||(c == ',')||(c == ';')
                                    ||(c == '\t')||(ikeyw >= 21) )
                        {/*stop looking when hit white space or 20 char max*/
                            /* pad ends so can treat wkeys as a real string */
                            wkeys[ikeyw] = '\0';
                            wkeys[0] = ' ';
                            /* try to interpret as a keyword string */
                            
                            if(Ltest)
                            {
/*c*/                          sprintf(alertstr,"Putative keyword: %s",wkeys);
                               dosinglealert(); /*MACDLOG.C,MPCDLOG.C*/
                            }

                          if(!Lknow)
                          {
                            /* search for ignore as key word*/
                                               /* note leading space */
/*.*/                       if(strncompare(wkeys," ignore",7) == 0) Lknow=1;
                            if(Lknow) 
                            {
                                flowID = neutID; 
                            }
                          }
                                                
                          if(!Lknow)
                          {
                            /* search for caption as key word*/
                            Lcapt = 0;            /* note leading space */
/*.*/                       if(strncompare(wkeys," caption",8) == 0) Lknow=1;
                            if(Lknow) 
                            {
                                Lcapt = 1;
                                flowID = captID; 
                                icapt = 0;
                                Lnew = 1;
                                ibuff = 0;
                            }
                          }
                          if(!Lknow)
                          {
/*.*/                       if(strncompare(wkeys," group",6) == 0) Lknow = 1;
                            if(Lknow) 
                            {
                                flowID = grupID; 
                                Lset = 0; 
                                /* need new set definition for this group*/
                                Lnew = 1;  
                                /*Lnew passed to casegroup: initialize list*/
                            }
                          }
                          if(!Lknow)
                          {
/*.*/                        if(strncompare(wkeys," set",4) == 0) Lknow = 1;
                            if(Lknow) 
                            {
                                flowID = setsID; 
                                Lset = 1; /*new set definition here */
                                Lnew = 1;  
                                /*Lnew passed to casegroup: initialize list*/
                            }
                          }
                          if(!Lknow)
                          {
/*.*/                       if(strncompare(wkeys," subgroup",9) == 0) Lknow=1;
                            if(Lknow)
                            {
                                flowID = setsID; 
                                Lset = 1; /*new set definition here */
                                Lnew = 1;  
                                /*Lnew passed to casegroup: initialize list*/
                            }
                          }
                          if(!Lknow)
                          {
/*.*/                       if(strncompare(wkeys," vector",7) == 0) Lknow = 1;
                            if(Lknow) 
                            {
                                Label = 0; 
                                /* this is the only difference from labels */
                                Ldot  = 0; 
                                /* this is the only difference from dots   */
                                Lword = 0;  /*not a wordlist*/ 
                                Lball = 0; 
                                Lvect = 1;                                
                                flowID = vectID; 
                                Lnew = 1;  
                                /*Lnew passed to casevect to initialize list*/
                            }
                          }
                          if(!Lknow)
                          {
/*.*/                       if(strncompare(wkeys," label",6) == 0) Lknow = 1;
                            if(Lknow) 
                            {
                                Label = 1; 
                                /* identical to vector except for Label flag*/
                                Ldot  = 0; 
                                /* this is the only difference from dots   */
                                Lball = 0;    
                                Lvect = 0;    /* but not a real vector */    
                                Lword = 0;  /*not a wordlist*/                      
                                flowID = vectID; 
                                Lnew = 1;  
                                /*Lnew passed to casevect to initialize list*/
                            }
                          }
                          if(!Lknow)
                          {
/*.*/                       if(strncompare(wkeys," dot",4) == 0) Lknow = 1;
                            if(Lknow) 
                            {
                                Ldot = 1; 
                                /* identical to vector except for DOT flag */
                                Lball = 0;
                                Label = 0; 
                                /* this is the only difference from labels */
                                Lvect = 0;  /* but not a real vector */ 
                                Lword = 0;  /*not a wordlist*/   
                                flowID = vectID; 
                                Lnew = 1;  
                                /*Lnew passed to casevect to initialize list*/
                            }
                          }
                          if(!Lknow)
                          {
/*.*/                       if(strncompare(wkeys," ball",5) == 0) Lknow = 1;
                            if(Lknow) 
                            {
                                Lball = 1; 
                                /* identical to vector except for ball flag */
                                Ldot = 0; 
                                /* identical to dot except for ball flag */
                                Label = 0; 
                                /* this is the only difference from labels */
                                Lvect = 0;  /* but not a real vector */ 
                                Lword = 0;  /*not a wordlist*/   
                                flowID = vectID; 
                                Lnew = 1;  
                                /*Lnew passed to casevect to initialize list*/
                            }
                          }

                          if(!Lknow)
                          {
/*.*/                       if(strncompare(wkeys," word",5) == 0) Lknow = 1;
                            if(Lknow) 
                            {
                                Lword = 1; /*is a wordlist !! */
                                Ldot = 0; 
                                /* identical to vector except for WORD flag */
                                Label = 0; 
                                /* this is the only difference from labels */
                                Lvect = 0;  /* but not a real vector */ 
                                Lball = 0;   
                                flowID = vectID; 
                                Lnew = 1;  
                                /*Lnew passed to casevect to initialize list*/
                            }
                          }

                          if(!Lknow)
                          {
/*.*/                       if(strncompare(wkeys," kinemage",9) == 0) Lknow=1;
                            if(Lknow) 
                            {
                                flowID = kineID; 
                                Lnew = 1;  
                                /* flag start of scan for kinemage number */
                            }
                          }
                          if(!Lknow)
                          {
                            icounter = 0;
/*.*/                       if(strncompare(wkeys," matrix",7) == 0)icounter=1;
/*.*/                       else if(strncompare(wkeys," 2matrix",8)==0)
                                                                   icounter=2;
/*.*/                       else if(strncompare(wkeys," 3matrix",8)==0)
                                                                   icounter=3;
/*.*/                       else if(strncompare(wkeys," 4matrix",8)==0)
                                                                   icounter=4;
/*.*/                       else if(strncompare(wkeys," 5matrix",8)==0)
                                                                   icounter=5;
/*.*/                       else if(strncompare(wkeys," 6matrix",8)==0)
                                                                   icounter=6;
/*.*/                       else if(strncompare(wkeys," 7matrix",8)==0)
                                                                   icounter=7;
/*.*/                       else if(strncompare(wkeys," 8matrix",8)==0)
                                                                   icounter=8;
/*.*/                       else if(strncompare(wkeys," 9matrix",8)==0)
                                                                   icounter=9;
/*.*/                       else if(strncompare(wkeys," 10matrix",9)==0)
                                                                   icounter=10;

                            if(icounter > 0) Lknow = 1;
                            if(Lknow) 
                            {
                                flowID = matrID; 
                                Lnew = 1;  
                                /* flag start of scan for matrix numbers */
                                Lreset[icounter] = 1;
                            }
                          }
                          if(!Lknow)
                          {
                            icounter = 0;
/*.*/                       if(strncompare(wkeys," viewid",7) == 0)icounter=1;
/*.*/                       else if(strncompare(wkeys," 2viewid",8)==0)
                                                                   icounter=2;
/*.*/                       else if(strncompare(wkeys," 3viewid",8)==0)
                                                                   icounter=3;
/*.*/                       else if(strncompare(wkeys," 4viewid",8)==0)
                                                                   icounter=4;
/*.*/                       else if(strncompare(wkeys," 5viewid",8)==0)
                                                                   icounter=5;
/*.*/                       else if(strncompare(wkeys," 6viewid",8)==0)
                                                                   icounter=6;
/*.*/                       else if(strncompare(wkeys," 7viewid",8)==0)
                                                                   icounter=7;
/*.*/                       else if(strncompare(wkeys," 8viewid",8)==0)
                                                                   icounter=8;
/*.*/                       else if(strncompare(wkeys," 9viewid",8)==0)
                                                                   icounter=9;
/*.*/                       else if(strncompare(wkeys," 10viewid",9)==0)
                                                                   icounter=10;

                            if(icounter > 0) Lknow = 1;
                            if(Lknow) 
                            {
                                flowID = viewID;
                                Lnew = 1; /* flag start of scan for viewid */
                            }
                          }
                          if(!Lknow)
                          {
/*.*/                       if(  strncompare(wkeys," localrotat",11)==0
                               ||strncompare(wkeys," localmatrix",12)==0
                              ) Lknow=1;
                            if(Lknow) 
                            {
                                icounter=0;
                                Llocalrotation = 1;
                                flowID = matrID; 
                                Lnew = 1;  
                                /* flag start of scan for matrix numbers */
                            
                            }
                          }
                          if(!Lknow)
                          {
/*.*/                       if(  strncompare(wkeys," endlocalrot",12)==0
                               ||strncompare(wkeys," endlocalmatrix",15)==0
                              ) Lknow=1;
                            if(Lknow) 
                            {
                                Llocalrotation = 0;
                                flowID = neutID;  /*that's all this one does*/
                            }
                          }

                          if(!Lknow)
                          {
/*.*/                       if(strncompare(wkeys," onewidth",9) == 0) Lknow=1;
                            if(Lknow) 
                            {
                                Lonewidth = TRUE;  /* set flag */
                               if(IPC)checkmarkmenu(1,0L,widthItem,0);
                               else checkmarkmenu(1,optiMenu,widthItem,0);

          /*checkmarkmenu(int ion, MenuHandle menu, int item, int iredraw)*/

                                flowID = neutID;  /*that's all this one does*/
                            }
                          }

                          if(!Lknow)
                          {
/*.*/                       if(strncompare(wkeys," compare",8) == 0) Lknow=1;
                            if(Lknow) 
                            {
                                Lcomparestart = 1;  /* set flag */
                                Lstereo = 0; /*overrides previous keepstereo */
                                  /*everything else will be done in MAGEBBOX.C*/
                                  /*if more than one animate group*/
                                flowID = neutID;  /*that's all this one does*/
                            }
                          }
                          
                          
                          if(!Lknow)
                          {
/*.*/                       if(strncompare(wkeys," noscale",8) == 0) Lknow =1;
                            if(Lknow) 
                            {
                                DOscale = FALSE;  /* set flag */
                                flowID = neutID;  /*that's all this one does*/
                            }
                          }
                          if(!Lknow)
                          {
/*.*/                       if(strncompare(wkeys," thinline",9) == 0) Lknow=1;
                            if(Lknow)  /* flag set */
                            {
                                Lthin = TRUE;
                                if(IPC)checkmarkmenu(1,0L,thinItem,0);
                                else checkmarkmenu(1,optiMenu,thinItem,0);
    /*checkmarkmenu(int ion, MenuHandle menu, int item, int iredraw)*/
                                flowID = neutID;  /*that's all this one does*/
                            }
                          }
                          if(!Lknow)
                          {
/*.*/                      if(strncompare(wkeys," perspective",12)==0)Lknow=1;
                            if(Lknow)  /* flag set */
                            {
                                Lperspec = 1; 
                                if(IPC)checkmarkmenu(1,0L,perspecItem,0);
                                else checkmarkmenu(1,optiMenu,perspecItem,0);
/*NOTE: checkmarkmenu(int ion, MenuHandle menu, int item, int iredraw)*/
                                flowID = neutID;
                            }
                          }
                          if(!Lknow)
                          {
/*.*/                       if(strncompare(wkeys," flat",5) == 0) Lknow=1;
                            if(Lknow) /* flag set */
                            {
                                Lflat = 1;
                                if(IPC)checkmarkmenu(1,0L,flatItem,0);
                                else checkmarkmenu(1,kludgeMenu,flatItem,0);
                                flowID = neutID;
                            }
                          }
                          if(!Lknow)
                          {
/*.*/                       if(strncompare(wkeys," plotonly",9) == 0) Lknow=1;
                            if(Lknow) /* flag set */
                            {
                                Lfirstcall = TRUE;
                                Lplotonly = 1;
                                if(IPC)checkmarkmenu(1,0L,plotonlyItem,0);
                                else checkmarkmenu(1,kludgeMenu,plotonlyItem,0);
                                flowID = neutID;  /*that's all this one does*/
                            }
                          }
                          if(!Lknow)
                          {
/*.*/                       if(strncompare(wkeys," multibin",9) == 0) Lknow=1;
                            if(Lknow) /* flag set */
                            {
                                flowID = neutID;  /*multibins dummied*/
                                /*Lmultibins = 1;*/
              /*if(IMAC)checkmarkmenu(1,kludgeMenu,multibinItem,0);*/
              /*if(IPC)checkmarkmenu(1,0L,MM_KMMULTIBINS,0);*/
    /*checkmarkmenu(int ion, MenuHandle menu, int item, int iredraw)*/
               /* flowID = mbinsID;*/
                                /*Lnew = 1;*/ 
                                /* flag start of scan for an integer */
                            }
                          }
                          if(!Lknow)
                          {
                              icounter = 0;
/*.*/                        if     (strncompare(wkeys," zoom",5 ) == 0) 
                                                                  icounter=1;
/*.*/                        else if(strncompare(wkeys," 2zoom",6 )== 0) 
                                                                  icounter=2;
/*.*/                        else if(strncompare(wkeys," 3zoom",6 )== 0) 
                                                                  icounter=3;
/*.*/                        else if(strncompare(wkeys," 4zoom",6 )== 0) 
                                                                  icounter=4;
/*.*/                        else if(strncompare(wkeys," 5zoom",6 )== 0) 
                                                                  icounter=5;
/*.*/                        else if(strncompare(wkeys," 6zoom",6 )== 0) 
                                                                  icounter=6;
/*.*/                        else if(strncompare(wkeys," 7zoom",6 )== 0) 
                                                                  icounter=7;
/*.*/                        else if(strncompare(wkeys," 8zoom",6 )== 0) 
                                                                  icounter=8;
/*.*/                        else if(strncompare(wkeys," 9zoom",6 )== 0) 
                                                                  icounter=9;
/*.*/                        else if(strncompare(wkeys," 10zoom",7 )== 0) 
                                                                 icounter=10;

                            if(icounter > 0) Lknow = 1;
                            if(Lknow) /* flag set */
                            {
                                Lnew = 1;  
                                /* flag start of scan for zoom setting */                    
                                flowID = zoomID;
                            }
                          }

                          if(!Lknow)
                          {
                              icounter = 0;
/*.*/                        if     (strncompare(wkeys," center",7 )== 0) 
                                                                  icounter=1;
/*.*/                        else if(strncompare(wkeys," 2center",8)== 0) 
                                                                  icounter=2;
/*.*/                        else if(strncompare(wkeys," 3center",8)== 0) 
                                                                  icounter=3;
/*.*/                        else if(strncompare(wkeys," 4center",8)== 0) 
                                                                  icounter=4;
/*.*/                        else if(strncompare(wkeys," 5center",8)== 0) 
                                                                  icounter=5;
/*.*/                        else if(strncompare(wkeys," 6center",8)== 0) 
                                                                  icounter=6;
/*.*/                        else if(strncompare(wkeys," 7center",8)== 0) 
                                                                  icounter=7;
/*.*/                        else if(strncompare(wkeys," 8center",8)== 0) 
                                                                  icounter=8;
/*.*/                        else if(strncompare(wkeys," 9center",8)== 0) 
                                                                  icounter=9;
/*.*/                        else if(strncompare(wkeys," 10center",9)== 0) 
                                                                  icounter=10;

                            if(icounter > 0) Lknow= 1;
                            if(Lknow) /* flag set */
                            {
                                Lnew = 1;  
                                /* flag start of scan for center setting */                    
                                flowID = centerID;
                            }
                          }
                          if(!Lknow)
                          {
/*.*/                       if(  strncompare(wkeys," localcenter",12)==0
/*.*/                          ||strncompare(wkeys," localprecenter",15)==0
                              )Lknow=1;

                            if(Lknow) /* flag set */
                            {
                                Llocalprecenter = 1;
                                icounter=0;/*store before usual views*/
                                Lnew = 1;  
                                /* flag start of scan for center setting */                    
                                flowID = centerID;
                            }
                          }
                          if(!Lknow)
                          {
/*.*/                       if(strncompare(wkeys," localpostcenter",16)== 0)
                              Lknow=1;
                                                                  
                            if(Lknow) /* flag set */
                            {
                                Llocalpostcenter = 1;
                                icounter=MAXRESETS+1;/*store beyond usual views*/
                                Lnew = 1;  
                                /* flag start of scan for center setting */                    
                                flowID = centerID;
                            }
                          }
                          if(!Lknow)
                          {
/*.*/                       if(  strncompare(wkeys," endlocalcen",12)==0
                               ||strncompare(wkeys," endlocalprecen",15)==0
                               ||strncompare(wkeys," endlocalpostcen",16)==0
                              ) Lknow=1;
                                                                  
                            if(Lknow) /* flag set */
                            {
                                Llocalprecenter = 0;
                                Llocalpostcenter = 0;
                                flowID = neutID;  /*that's all this one does*/
                            }
                          }

                          if(!Lknow)
                          {
/*.*/                       if(strncompare(wkeys," pickcenter",11)==0)Lknow=1;
                            if(Lknow) /* flag set */
                            {
                                Lpickcenter = TRUE;
                                Lpickon = TRUE;
                                flowID = neutID;  /*that's all this one does*/
                            }
                          }
                          if(!Lknow)
                          {
/*.*/                       if(strncompare(wkeys," zoomonly",9) == 0) Lknow=1;
                            if(Lknow) /* flag set */
                            {
                                flowID = neutID;  /*this one does nothing*/
                            }
                          }
                          if(!Lknow)
                          {
/*.*/                       if(strncompare(wkeys," sideclip",9) == 0) Lknow=1;
                            if(Lknow) /* flag set */
                            {
                                flowID = neutID;  /*this one does nothing*/
                            }
                          }
                          if(!Lknow)
                          {
/*.*/                       if(strncompare(wkeys," zclipoff",9) == 0) Lknow=1;
                            if(Lknow) /* flag set */
                            {
                                Lzclipon = 0;
                                flowID = neutID;  /*this one does nothing*/
                            }
                          }
                          if(!Lknow)
                          {
                              icounter = 0;
/*.*/                        if(strncompare(wkeys," zclip",6) == 0 ||
                                strncompare(wkeys," zslab",6) == 0    )       
                                                                   icounter=1;
/*.*/                        else if(strncompare(wkeys," 2zslab",7) == 0    ) 
                                                                   icounter=2;
/*.*/                        else if(strncompare(wkeys," 3zslab",7) == 0    ) 
                                                                   icounter=3;
/*.*/                        else if(strncompare(wkeys," 4zslab",7) == 0    ) 
                                                                   icounter=4;
/*.*/                        else if(strncompare(wkeys," 5zslab",7) == 0    ) 
                                                                   icounter=5;
/*.*/                        else if(strncompare(wkeys," 6zslab",7) == 0    ) 
                                                                   icounter=6;
/*.*/                        else if(strncompare(wkeys," 7zslab",7) == 0    )
                                                                   icounter=7;
/*.*/                        else if(strncompare(wkeys," 8zslab",7) == 0    ) 
                                                                   icounter=8;
/*.*/                        else if(strncompare(wkeys," 9zslab",7) == 0    ) 
                                                                   icounter=9;
/*.*/                        else if(strncompare(wkeys," 10zslab",8) == 0    )
                                                                   icounter=10;

                            if(icounter > 0) Lknow= 1;
                            if(Lknow) /* flag set */
                            {
                               Lnew = 1;
                               flowID = zclipID;
                            }
                          }

                          if(!Lknow)
                          {
/*.*/                       if(strncompare(wkeys," ztran",6) == 0) Lknow = 1;
                            if(Lknow) /* flag set */
                            {
                                flowID = neutID;  /*this one does nothing*/
                            }
                          }
                          if(!Lknow)
                          {
/*.*/                       if( strncompare(wkeys," whitebkg",9) == 0  || 
                             strncompare(wkeys," whiteback",10) == 0) Lknow=1;
                            if(Lknow) /* flag set */
                            {
                                setwhtbkg(); /*MACMENU.C, Dummied in MPCMENU.C */
                                /*invokes Pulldown Menu routines */                        
                                flowID = neutID;  /*that's all this one does*/
                            }
                          }

                          if(!Lknow)
                          {
/*.*/                       if( strncompare(wkeys," keepstereo",11) == 0) 
                                                                      Lknow=1;
                            if(Lknow) /* flag set */
                            {
                                Lkeepstereo = 1;
/*Px*/                          forcestereo();
                                /*invokes simulated-Pulldown-Menu routine */                        
                                flowID = neutID;  /*that's all this one does*/
                            }
                          }
                          if(!Lknow)
                          {
/*.*/                       if( strncompare(wkeys," keepthinline",13) == 0) 
                                                                      Lknow=1;
                            if(Lknow) /* flag set */
                            {
                                Lkeepthinline = 1;
/*Px*/                          forcethinline();
                                /*invokes simulated-Pulldown-Menu routine */                        
                                flowID = neutID;  /*that's all this one does*/
                            }
                          }
                          if(!Lknow)
                          {
/*.*/                       if( strncompare(wkeys," keepperspec",12) == 0) 
                                                                      Lknow=1;
                            if(Lknow) /* flag set */
                            {
                                Lkeepperspective = 1;
/*Px*/                          forceperspective();
                                /*invokes simulated-Pulldown-Menu routine */                        
                                flowID = neutID;  /*that's all this one does*/
                            }
                          }

                          if(!Lknow)
                          {
/*.*/                       if( strncompare(wkeys," stereoangle",12) == 0) 
                                                                      Lknow=1;
                            if(Lknow) /* flag set */
                            {
                                Lnew = 1;  
                                /*flag start of scan for stereoangle setting*/                    
                                flowID = stereoID;
                            }
                          }
                          if(!Lknow)
                          {
/*.*/                       if( strncompare(wkeys," scale",6) == 0) Lknow=1;
                            if(Lknow) /* flag set */
                            {
                                Lnew = 1;  
                                /*flag start of scan for scale value*/
                                DOscale = FALSE; /*no auto-scaling*/                    
                                flowID = scaleID;
                            }
                          }

                          if(!Lknow)
                          {
/*.*/                       if(strncompare(wkeys," fontsizeinfo",13) == 0) Lknow = 1;
                            if(Lknow) /* flag set */
                            {
                                Lnew = 1;
                                iflag = 1;    
                                flowID = isizeID;
                            }
                          }
                          if(!Lknow)
                          {
/*.*/                       if(strncompare(wkeys," fontsizelabel",14) == 0) Lknow = 1;
                            if(Lknow) /* flag set */
                            {
                                Lnew = 1;
                                iflag = 2;    
                                flowID = isizeID;
                            }
                          }
                          if(!Lknow)
                          {
/*.*/                       if(strncompare(wkeys," fontsizeword",13) == 0) Lknow = 1;
                            if(Lknow) /* flag set */
                            {
                                Lnew = 1;
                                iflag = 3;    
                                flowID = isizeID;
                            }
                          }
                          if(!Lknow)
                          {
/*.*/                       if(strncompare(wkeys," specialps",10) == 0) Lknow = 1;
                            if(Lknow) /* flag set */
                            {
                                LspecialPS = 1; /*931128PS*/
                                flowID = neutID;
                            }
                          }

                          /*______________________________________________*/
                          /* end try to interpret as control string */
                          if(Lknow && Lcaptstate) /* real keyword found*/
                          {
                              Lcaptstate = 0;
                              docompletecapt();
                          }
                          if(!Lknow && Lcaptstate)
                          {/*write key word buffer to capt*/
                              for(n=0;n<=ibuff;n++)
                              {
                                  capts[icapt] = buffs[n];
                                  if (icapt == 254 || c == '\015')
                                  {
                                      capts[icapt+1] = '\0';
/*Tx*/                                insertcapts(capts);
                                      icapt = 0;
                                  }
                                  else
                                  {
                                      icapt++;
                                  }
                              }
                              flowID = captID; /* restore control */
                              Lcapt = 1;
                              ibuff = 0;
                              Lcaptstate = 0;  
                              /* only in effect during putative keyword*/
                          }
                          else if(!Lknow)/*putative keyword not recognized*/
                          {
                              wkeys[0] = '@';
                              /* restore @ for warning message */
                              if(strncompare(wkeys,"@text",5) == 0)
                              {
/*c*/                              sprintf(alertstr,
                                        "%s not expected in this part"
                                        " of kinemage file.",wkeys);
                                   dosinglealert(); /*MACDLOG.C,MPCDLOG.C*/
                              }
                              else
                              {
/*c*/                              sprintf(alertstr,
                                        "%s not recognized as keyword"
                                        " by this version of MAGE.",wkeys);
                                   dosinglealert(); /*MACDLOG.C,MPCDLOG.C*/
                              }                                
                              flowID = neutID;  
                              /* skip along until another keyword */
                          }
                          /* reset search flags: */
                          Lknow = 0;
                          ikeyw = 0;
                            
                        }/* endof-loop at white space after possible keyword*/
                    }/* endof-passed blank spaces before key word */
                break; /* case = keywID */

                case captID: 
                    if(Lcapt)/*caption expected, send characters to captText*/
                    {
                        if(Lnew)
                        {
                            /*clearcapts();*/ /*done in entry()*/
                            Lnew = 0;
                            getcaptstart();  /*MPCFILE.C sets captstart*/
                                /*MACTXMC.C dummied*/
                        }
#ifdef UNIX_X11
                        if(c == '\015') c='\n';
#endif
                        capts[icapt] = c;
                        if (icapt >= 253 || c == '\015' || c == '\n')
                        { 
                            capts[icapt+1] = '\0';/*make array of characters*/
                                             /*into properly ended C string*/
                            if(Ltest)
                            {
                                  sprintf(alertstr,"%s",capts);
                                  dosinglealert(); /*MACDLOG.C,MPCDLOG.C*/
                            }
                            insertcapts(capts); /*MACWIND.C*/ /*MPCWIND.C*/
                            icapt = 0;
                        }
                        else
                        {
                            icapt++;
                        }
                    }
                break;
                
                case grupID:
                    if(LOK)
                    {
/*G*/                    getgroup(c,Lnew);
                        Lnew = 0; /* reset for later calls */
                    }
                break;

                case vectID:
                    if(LOK)
                    {                
/*V*/                getvects(c,Lnew);
                    Lnew = 0; /* reset for later calls */
                    }
                break;

                case kineID: 
                    /* marks legitimate end to previous kinemage */
                    /*when done, getkinemagenum returns as 1  */
/*T*/                if( getkinemagenum(c,Lnew) ) 
                    {
                        goto finishthiskinemage;
                    }
                    Lnew = 0;
                break;
                
                case matrID: 
                    /*when 9 numbers read, getmatrix returns as 1 */
/*.*/                if( getmatrix(c,Lnew,icounter) ) 
                    {
                        flowID = neutID;
                        Lview[icounter] = 1; /* menu choice to access this */
                    }
                    Lnew = 0;
                break;
                case viewID:
                    /*when viewid string read, getviewid returns as 1 */
/*.*/                if( getviewid(c,Lnew,icounter) )
                    {
                        flowID = neutID;
                        Lview[icounter] = 1; /* menu choice to access this */
                    }
                    Lnew = 0;
                break;
                
                case setsID:
                    if(LOK)
                    {                
/*S*/                getset(c,Lnew);
                    Lnew = 0; /* reset for later calls */
                    }
                break;
                case mbinsID: /*obselete, retained for backwards compatibility*/
                    /* needs integer for multibins */
                    /*when done, getinteger returns as 1 */
/*.*/                if( getinteger(c,Lnew) ) 
                    {
                        /*multibins function is now done automatically in drawvec()*/ 
                        flowID = neutID;
                        iflag = 0;
                    }
                    Lnew = 0;
                break;
                
                case zoomID:
                    /* needs float for zoom value */
                    /*when done, getfloat returns as 1 */
                    if(getfloat(c,Lnew) )
                    {
                        zoomold[icounter] = floatpass; 
                        /* floatpass global to pass value back */
                        if(zoomold[icounter] == 0.0) zoomold[icounter] = 1.0;
                        if(icounter == 1) zoom = zoomold[icounter];
                        flowID = neutID;
                        Lzoom = 1; /*set true if any zooms invoked */
                        Lzoomer[icounter] = 1;
                        Lview[icounter] = 1; /* menu choice to access this */
                        if(Ltest)
                        {
                            sprintf(alertstr,"zoomold[%d]= %f",icounter
                                ,zoomold[icounter]);
                            dosinglealert(); /*MACDLOG.C,MPCDLOG.C*/
                        }

                    }
                    Lnew = 0;
                break;
                case centerID:
                    /* needs 3 floats for center values */
                    /*when done, getfloat returns as 1 */
                    if(Lnew) 
                    {
                        icnt = 0;
                        iflag = 1;/* used as Lnew by getfloat() */
                        Lnew = 0;
                    }
                    if(getfloat(c,iflag) )
                    {        /* floatpass global pass value back */
                        icnt++;
                        if(icnt == 1) 
                        {
                            fxcenterold[icounter] = floatpass;   
                            iflag = 1;
                        }
                        else if(icnt == 2) 
                        {
                            fycenterold[icounter] = floatpass;
                            iflag = 1;
                        }
                        else if(icnt == 3) 
                        {
                            fzcenterold[icounter] = floatpass;
                        }
                    }
                    else
                    {
                        iflag = 0;
                    }
                    
                    if(icnt == 3)
                    {
                        flowID = neutID;
                        Lcenterpoint = 1; /* set for any centering */
                        Lcenter[icounter] = 1;
                        Lview[icounter] = 1; /* menu choice to access this */
                    
                        if(Ltest)
                        {
                            sprintf(alertstr,"i-xyz-centerold[%d]= %f %f %f"
                                ,icounter
                                ,fxcenterold[icounter]
                                ,fycenterold[icounter]
                                ,fzcenterold[icounter]);
                            dosinglealert(); /*MACDLOG.C,MPCDLOG.C*/
                        }
                    }
                    if(c=='\015' && icnt < 3)
                    {
/*c*/                   sprintf(alertstr,
                            "@...center failed to get 3 numbers:?! %f %f %f",
                            fxcenterold[icounter],
                            fycenterold[icounter],
                            fzcenterold[icounter]);
                        dosinglealert(); /*MACDLOG.C,MPCDLOG.C*/
                        if(icounter == 0) Llocalprecenter = 0;
                        if(icounter == MAXRESETS+1) Llocalpostcenter = 0;
                        flowID = neutID;
                    }
                break;

                case zclipID:
                    /* needs integer for zclip value */
                    /*when done, getinteger returns as 1 */
/*.*/                if( getinteger(c,Lnew) ) 
                    {
                        izclipold[icounter] = intpass; 
                        /*intpass global to pass int back */
                        Lzcliper[icounter] = 1;
                        if(icounter == 1)
                        {
                            izclip = izclipold[icounter];
                            if(izclip==0) Lzclipon = 0;
                        }
                        Lzclip = 1; /*need things set up*/
                        flowID = neutID;
                        if(Ltest)
                        {
                            sprintf(alertstr,"izclip[%d]= %d",icounter
                                ,izclipold[icounter]);
                            dosinglealert(); /*MACDLOG.C,MPCDLOG.C*/
                        }
                        Lview[icounter] = 1; /* menu choice to access this */
                    }
                    Lnew = 0;
                break;

                case stereoID:
                    /* needs float for stereo value */
                    /*when done, getfloat returns as 1 */
                    if(getfloat(c,Lnew) )
                    {
                        stereoangle = floatpass; 
                        /* floatpass global to pass value back */
                        flowID = neutID;
                        if(Ltest)
                        {
                            sprintf(alertstr,"stereoangle= %f"
                                ,stereoangle);
                            dosinglealert(); /*MACDLOG.C,MPCDLOG.C*/
                        }

                    }
                    Lnew = 0;
                break;

                case scaleID:
                    /* needs float for scale value */
                    /*when done, getfloat returns as 1 */
                    if(getfloat(c,Lnew) )
                    {
                        scale = floatpass; 
                        /* floatpass global to pass value back */
                        flowID = neutID;
                        if(Ltest)
                        {
                            sprintf(alertstr,"scale= %f"
                                ,scale);
                            dosinglealert(); /*MACDLOG.C,MPCDLOG.C*/
                        }

                    }
                    Lnew = 0;
                break;

                case isizeID: 
                    /* needs integer for font size value */
                    /*when done, getinteger returns as 1 */
/*.*/                if( getinteger(c,Lnew) ) 
                    {
                        if(iflag==1) infofontsize = intpass;
                        if(iflag==2) labelsfontsize = intpass;
                        if(iflag==3) wordsfontsize = intpass; 
                        flowID = neutID;
                        iflag = 0;
                    }
                    Lnew = 0;
                break;

                
            }    /* loop switch cases */
        }    /*endof-not-a-<comment> or pass anyway*/ 
        if(Lcmnt == 0) Lpass = 1; /* only comments are blocked*/                 
    }    /*endof-loop-while-file-not-at-EOF*/        
    if(Lcapt)  /* finish out anything in caption buffer */
    {
        docompletecapt(); /*MPCFILE.C does whole caption*/
        capts[icapt+1] = '\0';
        
        if ( icapt >  0 )    
        {
/*Tx*/        insertcapts(capts);
        }
    }
    if(Llist)  /* finish out anything still pending in vector list */
    {
        c = '\015';  
        /*CR will end any number, the most likely useful thing maybe pending*/
/*V*/    getvects(c,Lnew);
    }
        atEOF = 1;
        LnextOK = 0;

        if(Ltest)
        {
/*c*/        sprintf(alertstr,"Reached EOF in input file");
             dosinglealert(); /*MACDLOG.C,MPCDLOG.C*/
        }
    
    finishthiskinemage:
/*sprintf(alertstr,"just got to finishthiskinemage"); dosinglealert();*/

        if(Lbondrotscope) /*current bond rotation active*/
        {    /*end all current bond rotation stuff*/
            for(j=1; j<nbondrot; j++)
              if(bondset[j][2] == bondset[j][1]) /*not ended yet*/
                bondset[j][2] = nxyz-1;/*ending xyz point of scope*/
            Lbondrotscope = 0;
        }

        if(Ltest && nbondrot > 0)
        {
           for(i=1; i<=nbondrot; i++)
           {
/*c*/        sprintf(alertstr,"vectors: %d, %d  define:"
               "\015rotation about: %.3f, %.3f, %.3f to  %.3f, %.3f, %.3f"
               "\015scope: %d, %d"
                                 ,bondset[i][3]
                                 ,bondset[i][4]
                                 ,fxyz(0,bondset[i][3])
                                 ,fxyz(1,bondset[i][3])
                                 ,fxyz(2,bondset[i][3])
                                 ,fxyz(0,bondset[i][4])
                                 ,fxyz(1,bondset[i][4])
                                 ,fxyz(2,bondset[i][4])
                                 ,bondset[i][1]
                                 ,bondset[i][2]
               ); 
             dosinglealert(); /*MACDLOG.C,MPCDLOG.C*/
           }
        }
        for(i=1; i< MAXRESETS ; i++)
        {
            if(viewcom[i][0] != '\0')
            {
                sprintf(temps,"View%d %s",i,viewcom[i]);
                condition(temps);
                if(i==1)  mymodifymenuitem(viewMenu, reset1Item, temps);
                if(i==2)  mymodifymenuitem(viewMenu, reset2Item, temps);
                if(i==3)  mymodifymenuitem(viewMenu, reset3Item, temps);
                if(i==4)  mymodifymenuitem(viewMenu, reset4Item, temps);
                if(i==5)  mymodifymenuitem(viewMenu, reset5Item, temps);
                if(i==6)  mymodifymenuitem(viewMenu, reset6Item, temps);
                if(i==7)  mymodifymenuitem(viewMenu, reset7Item, temps);
                if(i==8)  mymodifymenuitem(viewMenu, reset8Item, temps);
                if(i==9)  mymodifymenuitem(viewMenu, reset9Item, temps);
                if(i==10) mymodifymenuitem(viewMenu, resetRItem, temps);
            }
        }
        AdjustMenus();    /*MACMENU.C*/ /*MPCMENU.C*/
/*.*/   scalekinemage();
        maxnxyz = nxyz;    /*just coords so far*/
/*.*/   addmarkers();      /*will reset maxnxyz if successful*/
/*.*/   rescalekinemage(); /*apply any zooming, centering, etc. */
        /* RWIDTH sets window width if bondrot sliders changed*/

        isavewidth = RWIDTH;
        if(nbondrot > 0) RWIDTH = ROTSWIDTH; /*100 Mac, fraction of screen PC */
        else             RWIDTH =   0;
        if(RWIDTH != isavewidth) 
        {
#ifdef MACINTOSH
            for(j=1;j<10;j++) HandleEvent();/*MACMAIN.C *//*anti-crash magic*/
#endif
            adjustwindowwidth(); /*MACWIND.C,MPCWIND.C,MUXMWIND.c*/
        }
        izclip = izclip*fzclip;/*fzclip scales zclip to resized screen box*/
        Lprocessing = 0; /*finished bringing in this kinemage */
        
}
/*___GetStuffFromFile()_____________________________________________________*/

/****scalekinemage()*************************************/
void    scalekinemage()
{
        int        n;

    if(scale == 0.0) scale = 1.0;  /* scale has to be set somewhere */
    /*  data can come in prescaled, e.g. to a coord system */
    if(DOscale)  
    {
        fudge = 1.237;

        fdiff = fxmax-fxmin;  /* find maximum difference across coordinates */
        if(fdiff < (fymax-fymin) ) fdiff = fymax-fymin;
        if(fdiff < (fzmax-fzmin) ) fdiff = fzmax-fzmin;        
        fdiff = fdiff*fudge;  
        /* fudge so corners almost fit along coord direction  1.5? */
        scale = maxwide/(fdiff); /* define scale ,maxwide==GWIDTH*/
        fxcenter = (fxmax + fxmin)/2.0;
        fycenter = (fymax + fymin)/2.0;
        fzcenter = (fzmax + fzmin)/2.0;
        for(n=1;n<=nscale;n++) /*load scaled, centered integer display list */
        {
            if(fxyz(0,n)>=0.0) xyz(1,n) =scale*(fxyz(0,n)-fxcenter) + .5;
            else                xyz(1,n) =scale*(fxyz(0,n)-fxcenter) - .5;
            if(fxyz(1,n)>=0.0) xyz(2,n) =scale*(fxyz(1,n)-fycenter) + .5;
            else                xyz(2,n) =scale*(fxyz(1,n)-fycenter) - .5;
            if(fxyz(2,n)>=0.0) xyz(3,n) =scale*(fxyz(2,n)-fzcenter) + .5;
            else                xyz(3,n) =scale*(fxyz(2,n)-fzcenter) - .5;
        }
        fxcenternew = fxcenter; /*...new factors used for resizing image */
        fycenternew = fycenter;
        fzcenternew = fzcenter;
        scalenew = scale;
        if(!Lcenter[1])
        {
            fxcenterold[1] = fxcenter;
            fycenterold[1] = fycenter;
            fzcenterold[1] = fzcenter;
        }
    }
    else
    {
        fdiff = maxwide/(scale); /* define fdiff */ /*931018*/
    }

    if(Lcenterpoint) /*some centering info was in input file*/
    {
        if(Lcenter[1]) /*centering for first view*/
        {
            fxcenternew = fxcenterold[1]; /*from input file*/
            fycenternew = fycenterold[1];
            fzcenternew = fzcenterold[1];
        }
    }
    if(Lzoom)
    {
        if(Lzoomer[1]) /*zoom set for first view in input*/
        {
            scalenew = scale*zoom;
        }
    }
}
/*___scalekinemage()_____________________________________*/

/****rescalekinemage()*******************************************************/
void    rescalekinemage()
{
       int        n,k,ng,ns,nl;
       int    maximumgroup;
       int    grpmin, grpmax, setmin, setmax, jmin, jmax;

    Lrecalculate = 0;
    makecursorwait(); /*MACMAIN.C*/
    /*scan over all points, scale and center */
    /*hostorically, just: for(n=1;n<=maxnxyz;n++)  but now 940903+ with */
    /*static lists, need to scan over full hierarchy.  MAGE_3.1.2 */

    /*for(n=1;n<=maxnxyz;n++)*/
    if(Lmarkers) 
    {
      maximumgroup = maxgrp+1; /* maxgrp+1 does markers */
      if(Lmeasures) maximumgroup = maxgrp+2; /* maxgrp+2 does measures */
      if(Ldrawline) maximumgroup = maxgrp+3; /* maxgrp+3 does drawline */
    }
    else maximumgroup = maxgrp;
    
    for(ng = 1; ng <= maximumgroup ; ng++) 
    {/*loop-over-groups*/
        grpmin = igrp[ng][1];
        grpmax = igrp[ng][2];
        for(ns = grpmin; ns <= grpmax ; ns++)
        {/*loop-over-sets*/
            setmin = iset[ns][1];
            setmax = iset[ns][2];
            for(nl = setmin; nl <= setmax ; nl++)
            {/*loop-over-lists*/              
                if(ilist[nl][9] == 0)
                {/*nonstatic-list*/
                    jmin = ilist[nl][1];
                    jmax = ilist[nl][2];
                    for( n = jmin ; n <= jmax ; n++)
                    {/*loop-over-points*/
         if(fxyz(0,n)>=0.0) xyz(1,n) =scalenew*(fxyz(0,n)-fxcenternew) + .5;
         else                xyz(1,n) =scalenew*(fxyz(0,n)-fxcenternew) - .5;
         if(fxyz(1,n)>=0.0) xyz(2,n) =scalenew*(fxyz(1,n)-fycenternew) + .5;
         else                xyz(2,n) =scalenew*(fxyz(1,n)-fycenternew) - .5;
         if(fxyz(2,n)>=0.0) xyz(3,n) =scalenew*(fxyz(2,n)-fzcenternew) + .5;
         else                xyz(3,n) =scalenew*(fxyz(2,n)-fzcenternew) - .5;
                    }/*loop-over-points*/
                }/*nonstatic-list*/
            }/*loop-over-lists*/              
        }/*loop-over-sets*/
    }/*loop-over-groups*/
       
       
    if(Lmarkers)
    {
           /* put gnomon on actual center of view*/
           for(n=13; n<=22 ; n++)
           {
              k = n + nxyz;
              xyz(0,k) = marker[n][0];
              /*recreate pseudo-original float markers*/
              /* at new center for first view*/
              fxyz(0,k) = fmarker[n][0]  + fxcenternew;
              fxyz(1,k) = fmarker[n][1]  + fycenternew;
              fxyz(2,k) = fmarker[n][2]  + fzcenternew;
              xyz(1,k) = scalenew*(fxyz(0,k)-fxcenternew);
              xyz(2,k) = scalenew*(fxyz(1,k)-fycenternew);
              xyz(3,k) = scalenew*(fxyz(2,k)-fzcenternew);
            
           }
    }
    makecursoractive(); /*MACMAIN.C*/
}
/*___rescalekinemage()______________________________________________________*/

/****addmarkers()************************************************************/
void    addmarkers()
{
    int        j,k,n;
    
    nmarkers = 22; 
    /*note common arrays marker[nmarkers+1],fmarker[nmarkers+1] */
    if(nxyz + nmarkers > (MAXNUM-1) ) 
    {
/*c*/   sprintf(alertstr,"vector array too small for markers");
        dosinglealert(); /*MACDLOG.C,MPCDLOG.C*/
        Lmarkers = FALSE;
        return;
    }
    else if(maxlist+4 > (MAXL-1) )/*need 4 lists: 2 markers,1 center,1 labels*/
    {
/*c*/   sprintf(alertstr,"list array too small for markers");
        dosinglealert(); /*MACDLOG.C,MPCDLOG.C*/
        Lmarkers = FALSE;
        return;
    }
    else if(maxset+1 > (MAXS-1) )
    {
/*c*/   sprintf(alertstr,"set array too small for markers");
        dosinglealert(); /*MACDLOG.C,MPCDLOG.C*/
        Lmarkers = FALSE;
        return;
    }
    else if(maxgrp+1 > (MAXG-1) )
    {
/*c*/   sprintf(alertstr,"group array too small to add marker group");
        dosinglealert(); /*MACDLOG.C,MPCDLOG.C*/
        Lmarkers = FALSE;
        return;
    }
    else
    {    /*Unpickable MOVE=11, Unpickable DRAW=1 */
        /*marker 1 */
        marker[1][0]= 11; marker[1][1]= -7; marker[1][2]=  0; marker[1][3]= 0;
        marker[2][0]=  1; marker[2][1]=  7; marker[2][2]=  0; marker[2][3]= 0;
        marker[3][0]= 11; marker[3][1]=  0; marker[3][2]= -7; marker[3][3]= 0;
        marker[4][0]=  1; marker[4][1]=  0; marker[4][2]=  7; marker[4][3]= 0;
        marker[5][0]= 11; marker[5][1]=  0; marker[5][2]=  0; marker[5][3]=-7;
        marker[6][0]=  1; marker[6][1]=  0; marker[6][2]=  0; marker[6][3]= 7;
        /*marker 2 */
        marker[7][0]= 11; marker[7][1]= -5; marker[7][2]= -5; marker[7][3]= 5;
        marker[8][0]=  1; marker[8][1]=  0; marker[8][2]=  0; marker[8][3]= 0;
        marker[9][0]=  1; marker[9][1]=  5; marker[9][2]=  5; marker[9][3]= 5;
        marker[10][0]= 11;marker[10][1]=  5;marker[10][2]=-5;marker[10][3]=-5;
        marker[11][0]=  1;marker[11][1]=  0;marker[11][2]= 0;marker[11][3]= 0;
        marker[12][0]=  1;marker[12][1]= -5;marker[12][2]= 5;marker[12][3]=-5;
        /*gnomon, ends and middle pickable for Jane */
        marker[13][0]= 10;marker[13][1]= -9;marker[13][2]= 0;marker[13][3]= 0;
        marker[14][0]=  0;marker[14][1]=  9;marker[14][2]= 0;marker[14][3]= 0;
        marker[15][0]= 10;marker[15][1]=  0;marker[15][2]=-9;marker[15][3]= 0;
        marker[16][0]=  0;marker[16][1]=  0;marker[16][2]= 9;marker[16][3]= 0;
        marker[17][0]= 10;marker[17][1]=  0;marker[17][2]= 0;marker[17][3]=-9;
        marker[18][0]=  0;marker[18][1]=  0;marker[18][2]= 0;marker[18][3]= 0;
        marker[19][0]=  0;marker[19][1]=  0;marker[19][2]= 0;marker[19][3]= 9;
        /* pickable MOVE==10, pickable DRAW==0 */ 
        /* gnomon:  30 for label */
        marker[20][0]= 30;marker[20][1]=  9;marker[20][2]= 0;marker[20][3]= 0;
        marker[21][0]= 30;marker[21][1]=  0;marker[21][2]= 9;marker[21][3]= 0;
        marker[22][0]= 30;marker[22][1]=  0;marker[22][2]= 0;marker[22][3]= 9;
        
        ilist[maxlist+1][0] = 1; /*list display on*/
        ilist[maxlist+1][1] = nxyz + 1;
        ilist[maxlist+1][2] = nxyz + 6;
        ilist[maxlist+1][3] = 7; /*color = white*/
        
        ilist[maxlist+2][0] = 1; /*list display on*/
        ilist[maxlist+2][1] = nxyz + 7;
        ilist[maxlist+2][2] = nxyz +12;
        ilist[maxlist+2][3] = 7; /*color = white*/
        
        ilist[maxlist+3][0] = 0; /*list display off*/
        ilist[maxlist+3][1] = nxyz +13;  /*gnomon axes*/
        ilist[maxlist+3][2] = nxyz +19;
        ilist[maxlist+3][3] = 2; /*color = green*/
        
        ilist[maxlist+4][0] = 0; /*list display off*/
        ilist[maxlist+4][1] = nxyz +20;  /*gnomon labels*/
        ilist[maxlist+4][2] = nxyz +22;
        ilist[maxlist+4][3] = 2; /*color = green*/

        iset[maxset+1][0] = 1; /*set display on*/
        iset[maxset+1][1] = maxlist+1;
        iset[maxset+1][2] = maxlist+4;
        iset[maxset+1][3] = 2; 
        /* no button to be made for invented markers subgroup */
        igrp[maxgrp+1][0] = 0; /*group display off*/
        igrp[maxgrp+1][1] = maxset+1; 
        igrp[maxgrp+1][2] = maxset+1;
        igrp[maxgrp+1][4] = 1; 
        /* markers group is by definition dominant, no buttons below */
        /* grp & set must be fully defined for clean redefinitions */
        /*   in successive kinemages */
        igrp[maxgrp+1][5] = 0; /*no master*/

        /* give word a pointID */
        word[0] = 'm';word[1] = 'a';word[2] = 'r';word[3] = 'k';
        word[4] = 'e';word[5] = 'r';word[6] = '\0';
/*Mx*/  condition(word); /*in Mac this changes word to Pascal str */
        for(n=1; n<=19 ; n++)
        {
            k = n + nxyz;
            icom = (long)(MAXPTIDCHAR+1)*(long)k;/*offset for character array*/
                        /* 16*2048=32768  so if k > 2048, icom must be long!*/
                        /* worse for (MAXPTIDCHAR+1) which started at 21*/
            /* copy pointID */
            for(j=0; j<(MAXPTIDCHAR+1); j++) com2(icom+(long)j) = word[j]; 
        }
        word[0] = 'c';word[1] = 'e';word[2] = 'n';word[3] = 't';
        word[4] = 'e';word[5] = 'r';word[6] = '\0';
/*Mx*/  condition(word); /*in Mac this changes word to Pascal str */
            k = 18 + nxyz;
            icom = (long)(MAXPTIDCHAR+1)*(long)k;/*offset for character array*/
            for(j=0; j<(MAXPTIDCHAR+1); j++) com2(icom+(long)j) = word[j]; 
        word[0] = 'X';word[1] = '\0';
/*Mx*/  condition(word); /*in Mac this changes word to Pascal str */
            k = 20 + nxyz;
            icom = (long)(MAXPTIDCHAR+1)*(long)k;/*offset for character array*/
            for(j=0; j<(MAXPTIDCHAR+1); j++) com2(icom+(long)j) = word[j]; 
        word[0] = 'Y';word[1] = '\0';
/*Mx*/  condition(word); /*in Mac this changes word to Pascal str */
            k = 21 + nxyz;
            icom = (long)(MAXPTIDCHAR+1)*(long)k;/*offset for character array*/
            for(j=0; j<(MAXPTIDCHAR+1); j++) com2(icom+(long)j) = word[j]; 
         word[0] = 'Z';word[1] = '\0';
/*Mx*/  condition(word); /*in Mac this changes word to Pascal str */
            k = 22 + nxyz;
            icom = (long)(MAXPTIDCHAR+1)*(long)k;/*offset for character array*/
            for(j=0; j<(MAXPTIDCHAR+1); j++) com2(icom+(long)j) = word[j]; 
       
        for(n=1; n<=22 ; n++)
        {
            k = n + nxyz;
            xyz(0,k) = marker[n][0];
            xyz(1,k) = marker[n][1];
            xyz(2,k) = marker[n][2];
            xyz(3,k) = marker[n][3];
            
            /*build pseudo-original float markers back from the integer form*/
            fmarker[n][0] = marker[n][1]/scale;
            fmarker[n][1] = marker[n][2]/scale;
            fmarker[n][2] = marker[n][3]/scale;
            /*load float array with pseudo-original float markers*/
            fxyz(0,k) = fmarker[n][0];
            fxyz(1,k) = fmarker[n][1];
            fxyz(2,k) = fmarker[n][2];
        }
        /* put gnomon on actual center of first view*/
        for(n=13; n<=22 ; n++)
        {
              k = n + nxyz;
              xyz(0,k) = marker[n][0];
              /*recreate pseudo-original float markers*/
              /* at new center for first view*/
              fxyz(0,k) = fmarker[n][0]  + fxcenternew;
              fxyz(1,k) = fmarker[n][1]  + fycenternew;
              fxyz(2,k) = fmarker[n][2]  + fzcenternew;
              xyz(1,k) = scalenew*(fxyz(0,k)-fxcenternew);
              xyz(2,k) = scalenew*(fxyz(1,k)-fycenternew);
              xyz(3,k) = scalenew*(fxyz(2,k)-fzcenternew);
            
        }
 
        Lmarkers = TRUE;
        maxnxyz = nxyz + nmarkers;
    }
}
/*___addmarkers()___________________________________________________________*/

/****addmeasures()***********************************************************/
void    addmeasures()  /* only if Lmarkers and room for measures as well */
{
    int        j,k,n;
    
    Lmeasures = FALSE;
    maxmeasures = 7;
    if(Lmarkers)
    {/*Lmarkers TRUE*/
        if(nxyz + nmarkers + maxmeasures > (MAXNUM-1) ) 
        {
/*c*/       sprintf(alertstr,"vector array too small for measures");
            dosinglealert(); /*MACDLOG.C,MPCDLOG.C*/
            return;
        }
        else if(maxlist+6 > (MAXL-1) )/*need 2 more lists beyond 4 for markers*/
        {
/*c*/       sprintf(alertstr,"list array too small for measures");
            dosinglealert(); /*MACDLOG.C,MPCDLOG.C*/
            return;
        }
        else if(maxset+2 > (MAXS-1) )  /*need another subgroup beyond markers*/
        {
/*c*/       sprintf(alertstr,"set array too small for measures");
            dosinglealert(); /*MACDLOG.C,MPCDLOG.C*/
            return;
        }
        else if(maxgrp+2 > (MAXG-1) )  /*need another group beyond markers*/
        {
/*c*/       sprintf(alertstr,"group array too small to add measures group");
            dosinglealert(); /*MACDLOG.C,MPCDLOG.C*/
            return;
        }
        else
        {/*room for measures*/

            ilist[maxlist+5][0] = 1;
            ilist[maxlist+5][1] = nxyz+nmarkers+1; 
                    /* points for angle measures */
            ilist[maxlist+5][2]    = nxyz+nmarkers+1; 
                    /* this will be set by picked points*/
            ilist[maxlist+5][3] = 7; /*color = white*/
            
            ilist[maxlist+6][0] = 1;
            ilist[maxlist+6][1] = nxyz+nmarkers+5; /* average dots */
            ilist[maxlist+6][2]    = nxyz+nmarkers+5; 
                    /* this will be set by picked points*/
            ilist[maxlist+6][3] = 21; /*color = hotpink*/
            
            iset[maxset+2][0] = 1;
            iset[maxset+2][1] = maxlist+5;
            iset[maxset+2][2] = maxlist+6;
            iset[maxset+2][3] = 2; 
                /* no button to be made for invented measures subgroup */
            igrp[maxgrp+2][0] = 0; /* start out turned off for no display */
            igrp[maxgrp+2][1] = maxset+2; 
            igrp[maxgrp+2][2] = maxset+2;
            igrp[maxgrp+2][4] = 1; 
                /*measures group is by definition dominant, no buttons below*/
                /* grp & set must be fully defined for clean redefinitions */
                /*   in successive kinemages */
            igrp[maxgrp+2][5] = 0; /*no master*/
            /* give word a blank,*/ 
            /* \0 ends C word or declares P word of zero length */
            word[0] = '\0';
            
            for(n=1; n<=7 ; n++)
            {
                k = n + nxyz + nmarkers;
                /*coords are loaded when picked*//*offset for character array*/
                icom = (long)(MAXPTIDCHAR+1)*(long)k;
            
                if(n==1) 
                {
                    xyz(0,k) = 10;  /* Point == Move */ 
                                     /* 4 point angle lines */
                    sprintf(word,"#1 point");
                }
                if(n==2) 
                {
                    xyz(0,k) =  0;  /* Line == Draw */
                    sprintf(word,"#2 point");
                }
                if(n==3) 
                {
                    xyz(0,k) =  0;  /* Line == Draw */
                    sprintf(word,"#3 point");
                }
                if(n==4) 
                {
                    xyz(0,k) =  0;  /* Line == Draw */
                    sprintf(word,"#4 point");
                }
                if(n==5) 
                {
                    xyz(0,k) = 20; /* Dot for average points */
                    sprintf(word,"avg of 2 pts");
                }
                if(n==6) 
                {
                    xyz(0,k) = 20; /* Dot for average points */
                    sprintf(word,"avg of 3 pts");
                }
                if(n==7) 
                {
                    xyz(0,k) = 20; /* Dot for average points */
                    sprintf(word,"avg of 4 pts");
                }
/*Mx*/            condition(word);  /* == CtoPstr(word)  on Mac */
                for(j=0; j<(MAXPTIDCHAR+1); j++) com2(icom+(long)j) = word[j]; 
            }

            Lmeasures = TRUE;
            if(!Ldrawline) maxnxyz = nxyz + nmarkers + maxmeasures;
              /*reset maxnxyz, unless already set further*/
            if(Ltest)
            {
/*c*/            sprintf(alertstr,"measures: grp= %d, set= %d, list= %d, %d,  "
                 "nxyz= %d ; %d",maxgrp+2,maxset+2,maxlist+5,maxlist+6,
                 nxyz+nmarkers+1,nxyz+nmarkers+maxmeasures);
                 dosinglealert(); /*MACDLOG.C,MPCDLOG.C*/
            }
        }/*room for measures*/
    }/*Lmarkers TRUE*/
    else
    {
/*c*/    sprintf(alertstr,"angle measures can't be done"
                        " since markers not done");
         dosinglealert(); /*MACDLOG.C,MPCDLOG.C*/
    }
}
/*___addmeasures()__________________________________________________________*/

/****adddrawline()***********************************************************/
void    adddrawline()  
    /* only if Lmarkers and room for measures as well as room for*/
{        /* more lines to be drawn, construct line takes 3 marked points */
    int        j,k,n;
    
    Ldrawline = FALSE;
    ndrawpoint = 7;
    
    maxmeasures = 7; 
    /*must define this since drawlines could be invoked before measures*/
    
    if(Lmarkers)
    {/*Lmarkers TRUE*/
        /* vectors, markers, measures, drawpointer, at-least-one-new-line*/
        if(nxyz + nmarkers + maxmeasures + 3*ndrawpoint + 2> (MAXNUM-1) ) 
        {
/*c*/       sprintf(alertstr,"vector array too small to draw more lines");
            dosinglealert(); /*MACDLOG.C,MPCDLOG.C*/
            return;
        }
        /*lists: markers 4, measures 2, drawlines 2 */
        else if(maxlist+8 > (MAXL-1) ) /*need two more lists*/
        {
/*c*/       sprintf(alertstr,"list array too small for new drawn lines");
            dosinglealert(); /*MACDLOG.C,MPCDLOG.C*/
            return;
        }
        else if(maxset+3 > (MAXS-1) )  /*need another subgroup*/
        {
/*c*/       sprintf(alertstr,"set array too small for new drawm lines");
            dosinglealert(); /*MACDLOG.C,MPCDLOG.C*/
            return;
        }
        else if(maxgrp+3 > (MAXG-1) )  /*need another group*/
        {
/*c*/       sprintf(alertstr,"group array too small to add drawlines group");
            dosinglealert(); /*MACDLOG.C,MPCDLOG.C*/
            return;
        }
        else
        {/*room for drawline*/
        /*Unpickable MOVE=11, Unpickable DRAW=1 */
        drawpt[1][0]= 11; drawpt[1][1]= -2; drawpt[1][2]=  0; drawpt[1][3]= 0;
        drawpt[2][0]=  1; drawpt[2][1]=  2; drawpt[2][2]=  0; drawpt[2][3]= 0;
        drawpt[3][0]=  1; drawpt[3][1]=  0; drawpt[3][2]= -2; drawpt[3][3]= 0;
        drawpt[4][0]=  1; drawpt[4][1]=  0; drawpt[4][2]=  2; drawpt[4][3]= 0;
        drawpt[5][0]=  1; drawpt[5][1]=  0; drawpt[5][2]=  0; drawpt[5][3]=-2;
        drawpt[6][0]=  1; drawpt[6][1]=  0; drawpt[6][2]=  0; drawpt[6][3]= 2;
        drawpt[7][0]=  1; drawpt[7][1]= -2; drawpt[7][2]=  0; drawpt[7][3]= 0;
    
            ilist[maxlist+7][0] = 0;/*point indicater off to start*//*931001*/
            ilist[maxlist+7][1] = nxyz+nmarkers+maxmeasures+1;
            ilist[maxlist+7][2]    = nxyz+nmarkers+maxmeasures+ndrawpoint;
                /*draw pointer, set up for one point marker*/ 
            ilist[maxlist+7][3] = 2; /*color = green*/

            ilist[maxlist+8][0] = 0; /* the new list starts off */
            ilist[maxlist+8][1] = nxyz+nmarkers+maxmeasures+3*ndrawpoint+1;
                    /* set to be just beyond the possible 3 point markers*/
            ilist[maxlist+8][2]    = nxyz+nmarkers+maxmeasures+3*ndrawpoint+1; 
                    /* this will be set by picked points*/
            ilist[maxlist+8][3] = 2; /*color = green*/

            iset[maxset+3][0] = 1; /*subgroup on*/
            iset[maxset+3][1] = maxlist+7;/*little markers*/  /*950113*/
            iset[maxset+3][2] = maxlist+7;
            iset[maxset+3][3] = 2; /*no button for invented subgroup*/ 
            iset[maxset+4][0] = 1; /*subgroup on*/
            iset[maxset+4][1] = maxlist+8;/*new line or label list*/ /*950113*/
            iset[maxset+4][2] = maxlist+8;
            iset[maxset+4][3] = 2; /*no button for invented subgroup*/ 

            igrp[maxgrp+3][0] = 1; /* start out turned on */ /*931001*/
            igrp[maxgrp+3][1] = maxset+3; 
            igrp[maxgrp+3][2] = maxset+4;
            igrp[maxgrp+3][3] = 0; /*not animated to start*/
            igrp[maxgrp+3][4] = 1; 
                /*drawline group starts dominant, no buttons below*/
                /*grp & set must be fully defined for clean redefinitions */
                /*   in successive kinemages */
            igrp[maxgrp+3][5] = 0; /*start with no master*/
            groupname[maxgrp+3][0] = ' ';
            groupname[maxgrp+3][1] = 'n';
            groupname[maxgrp+3][2] = 'e';
            groupname[maxgrp+3][3] = 'w';
            groupname[maxgrp+3][4] = ' ';
            groupname[maxgrp+3][5] = 'g';
            groupname[maxgrp+3][6] = 'r';
            groupname[maxgrp+3][7] = 'o';
            groupname[maxgrp+3][8] = 'u';
            groupname[maxgrp+3][9] = 'p';
            groupname[maxgrp+3][10] = '\0';
            condition(groupname[maxgrp+3]);

            listname[maxlist+8][0] = 'D';
            listname[maxlist+8][1] = 'r';
            listname[maxlist+8][2] = 'a';
            listname[maxlist+8][3] = 'w';
            listname[maxlist+8][4] = 'n';
            listname[maxlist+8][5] = '\0';
            
            condition(listname[maxlist+8]);
            if(!Lmeasures) igrp[maxgrp+2][0] = 0; /* set measures group off */

            /* give word a blank,*/ 
            /* \0 ends C word or declares P word of zero length */
            word[0] = '\0';
            
            for(n=1; n<=3*ndrawpoint+2 ; n++)
            {
                k = n + nxyz + nmarkers + maxmeasures;
                /*coords are loaded when picked*//*offset for character array*/
                icom = (long)(MAXPTIDCHAR+1)*(long)k;
                j = 0;
                com2(icom+(long)j) = word[j]; 
                            /* copy dummy pointID */
            }

            for(n=1; n<=ndrawpoint ; n++)
            {
                k = n + nxyz + nmarkers + maxmeasures;
            
                /*build pseudo-original float drawpointer */
                /*back from the integer form*/
                fdrawpt[n][0] = drawpt[n][1]/scale;
                fdrawpt[n][1] = drawpt[n][2]/scale;
                fdrawpt[n][2] = drawpt[n][3]/scale;
                fxyz(0,k) = fdrawpt[n][0];
                fxyz(1,k) = fdrawpt[n][1];
                fxyz(2,k) = fdrawpt[n][2];
            }
            Ldrawline = TRUE;
            maxnxyz = nxyz + nmarkers + maxmeasures + 3*ndrawpoint; 
                                       /*at least...*/
        }/*room for drawline*/
    }/*Lmarkers TRUE*/
    else
    {
/*c*/    sprintf(alertstr,"drawline can't be done since markers not done");
         dosinglealert(); /*MACDLOG.C,MPCDLOG.C*/
    }
}
/*___adddrawline()__________________________________________________________*/

/****strncompare()****************************************************/
int        strncompare(char cs[256],char ct[256],int j)
{
    int        k,ireturn;
    
    
    for(k=0 ; k<=(j-1) ; k++)
    {
        if(cs[k] == ct[k]) ireturn = 0;
        else               ireturn = 1;
        if(ireturn) break;
    }
    return(ireturn);
}
/*___strncompare()____________________________________________________*/

/****getinteger(c,Lnew)**************************************************/  
int        getinteger(int c,int Lnew)  
                /* sucessful acquisition of number sets IOerr = 0 */
{
    int        ireturn,j;
    
    ireturn = 0;
    if(Lnew)
    {
        inumstr = 0; /*global*/
        /* Lnew local, must reset in calling routine */
        for(j=0 ; j<256 ; j++) numstr[j] = ' '; /*global*/
    }

    if(c==' ' && inumstr==0)
    {
        ;  /* skip beginning spaces */
    }
    else if(c=='0'||c=='1'||c=='2'||c=='3'||c=='4'||c=='5'||
            c=='6'||c=='7'||c=='8'||c=='9'||c=='-'||c=='+')
    {
        numstr[inumstr] = c;
        inumstr++;
    }
    else  /* anything besides numerals ends a number*/
    {
        numstr[inumstr] = '\0';  /* ends a number */
        if(inumstr == 0)
        {
            intpass = 0;
        }
        else
        {
            sscanf(numstr,"%d",&intpass); /* need a pointer */
        }
        ireturn = 1;  /* some number was retrieved or invented*/
        IOerr = 0; 
    }
    return(ireturn);
}
/*___getinteger()_________________________________________________________*/

/****getfloat(c,Lnew)****************************************************/  
int        getfloat(int c,int Lnew)  
                    /* sucessful acquisition of number sets IOerr = 0 */
{
    int        ireturn,j;
    
    ireturn = 0;
    if(Lnew)
    {
        inumstr = 0; /*global*/
        /* Lnew local, must reset in calling routine */
        for(j=0 ; j<256 ; j++) numstr[j] = ' '; /*global*/
    }
    if((inumstr==0&&c==' ')||(inumstr==0&&c=='\n')||(inumstr==0&&c=='\r'))
    {
        ;  /* skip beginning spaces, or CRLF between numbers */
    }
    else if(c=='0'||c=='1'||c=='2'||c=='3'||c=='4'||c=='5'||c=='6'||
            c=='7'||c=='8'||c=='9'||c=='.'||c=='-')
    {
        numstr[inumstr] = c;
        inumstr++;        /* only valid numeric character increases inumstr */
    }
    else  /* anything besides numerals ends a number*/
    {
        numstr[inumstr] = '\0';  /* ends a number */
        if(inumstr == 0)
        {
            floatpass = 0.0; /* complete blank sets default = 0.0 */ 
        }
        else
        {
            sscanf(numstr,"%f",&floatpass); /*needs a pointer */
        }
        ireturn = 1;  /* some number was retrieved or invented*/
        IOerr = 0; 
    }
    return(ireturn);
}
/*___getfloat()_________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****getmatrix(c,Lnew,imatrix)***********************************************/  
                    /* sucessful acquisition of 9 numbers sets IOerr = 0 */
int    getmatrix(char c,int Lnew,int imatrix)
{
static    int     n;      /* n remembers which of nine numbers accummulated*/
static    int     Lidn; /*remembers if in an identifier*/
static    float   matrix[10]; /*matrix accummulates the numbers*/
        int       k, ireturn;
    
    ireturn = 0;
    if(Lnew)
    {
        inumstr = 0;
        n = 1;
        Lidn = 0;
    }
    /*931126 matrix, view identifier */
    if(c == '\{')  /* start an identifier */
    {
        Lidn = 1; 
        iword = 0;
    }
    else if(c == '\}')  /* end an identifier */
    {
        for(k=iword ; k<(MAXVIEWIDCHAR) ; k++) word[k] = '\0';   /*950113*/
          /*revision930207 pad out identifier to } with '\0' rather than ' '*/
        word[(MAXVIEWIDCHAR)] = '\0';  /* pad & end the string in c manner */ /*950113*/
        {/*should hold identifier of this subgroup */
            /* view name: copy it to viewcom_ment */
            for(k=0; k<=(MAXVIEWIDCHAR) ; k++)         /*950113*/
            {
                viewcom[imatrix][k] = word[k]; 
            }
        }
        Lidn = 0;
    }
    else if(Lidn == 1)    /*note: no protection from line > 256 char !!  */ /*950113*/
    {
        word[iword++] = c;
    }
    else if( (c==' ' && inumstr==0)||(c==EOL && inumstr==0) ) /*950113*/
    {
        ;  /* skip beginning spaces */
    }
    else if(c=='0'||c=='1'||c=='2'||c=='3'||c=='4'||c=='5'||
            c=='6'||c=='7'||c=='8'||c=='9'||c=='-'||c=='.')
    {
        numstr[inumstr] = c;
        inumstr++;
    }
    else  /* anything besides numerals ends a number*/
    {
        numstr[inumstr] = '\0';  /* ends a number */
        if(inumstr == 0)
        {
            ;  /* error */
        }
        else
        {
/*c*/        sscanf(numstr,"%f",&matrix[n]); /* get the number */
            inumstr = 0;                     /* reset char counter */
            n++;                            /* increase number counter */
            if(n >= 10)            /* see if nine numbers for matrix in yet */
            {    /* matrix was retrieved */
                /* put into reset matrix storage */
                ma[imatrix][1] =  matrix[1];
                ma[imatrix][2] = -matrix[2];  /*  1  2  3        1   0   0 */
                ma[imatrix][3] =  matrix[3];  /*  4  5  6   X    0  -1   0 */    
                ma[imatrix][4] =  matrix[4];  /*  7  8  9        0   0   1 */
                ma[imatrix][5] = -matrix[5];
                ma[imatrix][6] =  matrix[6];  /*screen handedness correction*/
                ma[imatrix][7] =  matrix[7];
                ma[imatrix][8] = -matrix[8];
                ma[imatrix][9] =  matrix[9];
                ireturn = 1;  
                IOerr = 0;

                if(imatrix == 0)
                {/*local ratation performed as coord input*/
                    ma[0][2] = -ma[0][2]; /*restore original handedness */
                    ma[0][5] = -ma[0][5];
                    ma[0][8] = -ma[0][8];
                }
            } 
        }
    }
    return(ireturn);
}
/*___getmatrix(c,Lnew)______________________________________________________*/

/****getviewid(c,Lnew,imatrix)***********************************************/
int    getviewid(char c,int Lnew,int imatrix) /*931126 view identifier */
{
static    int     Lidn; /*remembers if in an identifier*/
        int       k, ireturn;
    
    ireturn = 0;
    if(Lnew)
    {
        Lidn = 0;
    }
    /*931126 matrix, view identifier */
    if(c == '\{')  /* start an identifier */
    {
        Lidn = 1; 
        iword = 0;
    }
    else if(c == '\}')  /* end an identifier */
    {
        for(k=iword ; k<(MAXVIEWIDCHAR) ; k++) word[k] = '\0';  /*950113*/
          /*revision930207 pad out identifier to } with '\0' rather than ' '*/
        word[(MAXVIEWIDCHAR)] = '\0';  /* pad & end the string in c manner */
        for(k=0; k<=(MAXVIEWIDCHAR) ; k++)  /*950113*/
        {
            viewcom[imatrix][k] = word[k];
        }
        Lidn = 0;
        ireturn = 1;
    }
    else if(Lidn == 1)
    {
        word[iword++] = c;
    }
    else 
    {
        ;  /* skip anything not in brackets */
    }
    return(ireturn);
}
/*___getviewid(c,Lnew)______________________________________________________*/

