                      /*MAGEUTIL.c*/
#include "MAGE.H"

/*****floatfromstr()*********************************************************/
float    floatfromstr(char ins[256])
{
        int            Lstart,n,m,OK;
        char         s[256];
        float        freturn;

        freturn = 0.0;
        Lstart = 1;
        n = 0;
        m = 0;
        OK = 1;
        if(ins[0] != '\0')  /* neither zero length pascal string */
        {                   /*     nor zero length C string */
            recondition(ins); /*MACMAIN.C, dummied in MPCMAIN.C*/
                              /*MAC: changes P to C string */   
            while(OK)
            {
                /* start at position 0 of c str */
                if(ins[n] == ' ' && Lstart)  ;
                else if(ins[n] == '0' || ins[n] == '1' || ins[n] == '2' ||
                        ins[n] == '3' || ins[n] == '4' || ins[n] == '5' ||
                        ins[n] == '6' || ins[n] == '7' || ins[n] == '8' ||
                        ins[n] == '9' || ins[n] == '.' || ins[n] == '-'   ) 
                {
                    s[m] = ins[n];
                    m++;
                    Lstart = 0;
                }
                else
                {
                    s[m] = '\0'; 
                    OK = 0;
                }
                n++;
            }

/*c*/       sscanf(s,"%f",&freturn);
            condition(ins); /*MACMAIN.C, dummied in MPCMAIN.C*/
                    /*MAC: changes C back to P string so can use it again*/   
        }
        return(freturn);
}
/*___floatfromstr()_________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****intfromstr()************************************************************/
int   intfromstr(char  ins[256])
{
        int            Lstart,n,m,OK;
        char         s[256];
        int            ireturn;

        ireturn = 0;
        Lstart = 1;
        n = 0;
        m = 0;
        OK = 1;
        if(ins[0] != '\0')  /* neither zero length pascal string */
        {                   /*     nor zero length C string */
            recondition(ins); /*MACMAIN.C, dummied in MPCMAIN.C*/
                              /*MAC: changes P to C string */   
            while(OK)
            {
                /* start at position 0 of c str */
                if(ins[n] == ' ' && Lstart)  ;
                else if(ins[n] == '0' || ins[n] == '1' ||
                        ins[n] == '2' || ins[n] == '3' || 
                        ins[n] == '4' || ins[n] == '5' ||
                        ins[n] == '6' || ins[n] == '7' || 
                        ins[n] == '8' || ins[n] == '9'    ) 
                {
                    s[m] = ins[n];
                    m++;
                    Lstart = 0;
                }
                else
                {
                    s[m] = '\0'; 
                    OK = 0;
                }
                n++; 
            }
/*c*/       sscanf(s,"%d",&ireturn);
            condition(ins); /*MACMAIN.C, dummied in MPCMAIN.C*/
                /*MAC: changes C back to P string so can use it again*/ 
        }
        return(ireturn);
}
/*___intfromstr()___________________________________________________________*/

/*****doundoprune()**********************************************************/
void    doundoprune()
{
    int    j;
    
    if(nundop > 0)
    {
        for(j=nprune[nundop][1];j<=nprune[nundop][2];j++)
        {
            xyz(0,j) = xyz(0,j) - 100;
        }
        if(nprune[nundop][0] == 1) 
        {/*following vector had been changed from draw to move*/
            xyz(0,nprune[nundop][2]+1) = xyz(0,nprune[nundop][2]+1) - 10;
        }
        nundop = nundop - 1;
    }
    else
    {
        sprintf(alertstr,"reached limit of undo for pruning & punching");
        dosinglealert();
    }
}
/*___doundoprune()__________________________________________________________*/

/*****mysearchpointID()******************************************************/
int    mysearchpointID() /* <- MACDLOG/SearchDialog() */
{
    int    k,kk,ifound,ireturn;
    int    grpmin, grpmax, setmin, setmax, jmin, jmax;
      
    ireturn = 0;
    if(Lsearchbegin) ngrpsearch = 1;
    for(ngrpsearch = ngrpsearch; ngrpsearch <= maxgrp ; ngrpsearch++) 
    {/*begin-loop-over-groups*/
      if(   (igrp[ngrpsearch][0] > 0 && !Lcompareon)
                                        /*ON-OFF flag*/  /*ANIMATE flag*/
         || (Lcompareon && igrp[ngrpsearch][0]>0)  
            /*first pass put left everything that is ON */
         || (Lcompareon && igrp[ngrpsearch][0]>0  
                        && igrp[ngrpsearch][3]==0)
            /*second pass put right, all non-animate groups that are ON */
         || (Lcompareon && igrp[ngrpsearch][0]==0 
                        && ngrpsearch == nextanimategroup) )
            /* and the OFF animate group that is flagged as being next */
      {/*begin-visible-group*/
        grpmin = igrp[ngrpsearch][1];
        grpmax = igrp[ngrpsearch][2];
        if(Lsearchbegin) nsetsearch = grpmin; 
        for(nsetsearch = nsetsearch; nsetsearch <= grpmax ; nsetsearch++)
        {/*begin-loop-over-sets*/
          if(iset[nsetsearch][0] > 0)
          {/*begin-visible-set*/
            setmin = iset[nsetsearch][1];
            setmax = iset[nsetsearch][2];
            if(Lsearchbegin) nlistsearch = setmin; 
            for(nlistsearch = nlistsearch;nlistsearch<=setmax;nlistsearch++)
            {/*begin-loop-over-lists*/              
              if(ilist[nlistsearch][0] > 0)
              {/*begin-visible-list*/
                jmin = ilist[nlistsearch][1];
                jmax = ilist[nlistsearch][2];
                if(Lsearchbegin) jsearch = jmin;
                else            {jsearch = jsearch + 1; /*Next point*/
                                 Lsearchbegin = 1;}/*release restriction*/
                if(jsearch<=jmax)
                {/*valid point for this subgroup*/
                  for( jsearch = jsearch ; jsearch <= jmax ; jsearch++)
                  {/*begin-loop-over-IDs*/
                    if(xyz(0,jsearch) >= 0 && xyz(0,jsearch) < 100 )  /*950113*/
                    {/*begin-valid-point*/   
                     /*copy char str from storage */
                     for(k=0; k<(MAXPTIDCHAR+1); k++)   /*950113*/
                     {                  /*950113*/
                         icom = (long)(MAXPTIDCHAR+1)*(long)jsearch + (long)k;
                         /*note: define  pcom1(icom)  *(com + icom)  */
                         trystr[k] = ( pcom1(icom) ); 
                     }
                     /*stored pointID string is conditioned, so must*/
                     /*recondition to be sure to be getting a char in [0]*/
                     /*search1str is also reconditioned*/
                     recondition(trystr); /*MACMAIN.C, dummied in MPCMAIN.C*/
                     uctolcstr(trystr); /*ignore case */ /*950113*/
                     uctolcstr(search1str);              /*950113*/
                     ifound = 0;
                     if(isearch1>0)
                     {
                         for(k=0; k<(MAXPTIDCHAR+1); k++)  /*950113*/
                         {/*loop over one points ID */
                             if(trystr[k] == search1str[0])
                             {/*first char recognized*/
                             
                                 for(kk = 0; kk < isearch1 ;kk++)
                                 {/*repeat [0] to deal with single character*/
                                     if(k+kk>=(MAXPTIDCHAR)) /*950113*/
                                     {
                                         if(search1str[kk]==' ')
                                         {
                                             ifound = 1;
                                             break;
                                         }
                                         else
                                         {
                                             ifound = 0;
                                             break;
                                         }
                                     }
                                     else if(trystr[k+kk] == search1str[kk])
                                     {
                                         ifound = 1;
                                     }
                                     else
                                     {
                                         ifound = 0;
                                         break;
                                     }
                                 }/*does all isearch1 chars if all good*/
                                 if(ifound) break;
                             }/*first char recognized*/
                             if(ifound) break;
                         }/*loop over one points ID */
                     }
                     if(ifound && isearch2>0)
                     {
                         uctolcstr(search2str);   /*950113*/
                         ifound = 0; /*reset for this char str */
                         for(k=0; k<(MAXPTIDCHAR+1); k++)  /*950113*/
                         {/*loop over one points ID */
                             if(trystr[k] == search2str[0])
                             {/*first char recognized*/
                                 for(kk = 0; kk < isearch2 ;kk++)
                                 {/*repeat [0] to deal with single character*/
                                     if(k+kk>=(MAXPTIDCHAR))  /*950113*/
                                     {
                                         if(search2str[kk]==' ')
                                         {
                                             ifound = 1;
                                             break;
                                         }
                                         else
                                         {
                                             ifound = 0;
                                             break;
                                         }
                                     }
                                     else if(trystr[k+kk] == search2str[kk])
                                     {
                                         ifound = 1;
                                     }
                                     else
                                     {
                                         ifound = 0;
                                         break;
                                     }
                                 }/*does all isearch2 chars if all good*/
                                 if(ifound) break;
                             }/*first char recognized*/
                             if(ifound) break;
                         }/*loop over one points ID */
                     }
                     if(ifound) break;
                    }/*end-valid-point*/  
                  }/*end-loop-over-IDs*/
                  if(ifound) break;
                }/*valid point for this subgroup*/
              }/*end-visible-lists*/
              if(ifound) break;
            }/*end-loop-over-lists*/
            if(ifound) break;              
          }/*end-visible-sets*/
          if(ifound) break;
        }/*end-loop-over-sets*/
        if(ifound) break;
      }/*end-visible-group*/
      if(ifound) break;
    }/*end-loop-over-groups*/
    if(ifound)
    {
        Lsearchatend = 0;
        Lpick = 1; /* flag for successful pick */
        ipick = 0; /*so will not try to find a pickpoint by cursor x,y*/
        Lprepick = 1; /*so will know to apply pick process to pickvec */
        pickvec = jsearch;
        ipickgrp=ngrpsearch;
        ipickset=nsetsearch;
        ipicklist=nlistsearch;
        ireturn = 1;
    }
    return(ireturn);
}
/*____mysearchpointID()_____________________________________________________*/

/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****uctolcstr()***********************************************************/
void  uctolcstr(char texts[256])
{
  int  j,k;
static  char  uc[] = " ABCDEFGHIJKLMNOPQRSTUVWXYZ";
static  char  lc[] = " abcdefghijklmnopqrstuvwxyz";
  
  /*converts upper case alphabetic char to lower case */
  /*test everything for alphabetic character*/
  for(k=0 ;texts[k]!='\0'&&k<256 ; k++) 
  {
    for(j=1 ; j<= 26 ; j++)
    {
      if(texts[k] == uc[j])
      {
        texts[k] = lc[j];
        break;
      }
    }
  }  
  return;
}
/*__uctolcstr()___________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****menuaboutwrite()********************************************************/
void    menuaboutwrite(void)
{
               sprintf(alertstr,
                  "write a file with..."
                  "\015view: current zoom,zslab,center,matrix"
                  "\015focus: current XYZ point picked"
                  "\015modified kin: after pruning, etc."
                  "\015rotated parts: of all bond-rotations possible"
                  "\015PostScript: image as currently displayed"
                  );
               sprintf(alertstr2,"Questions and Answers from TEXT window");
               sprintf(alertstr3," ");
               DoMageDLOGreport(); /*alertstr,alertstr2,alertstr3*/ /*___DLOG.C*/
}
/*___menuaboutwrite()_______________________________________________________*/

/****menuaboutrotated()******************************************************/
void    menuaboutrotated(void)
{
    sprintf(alertstr,
        "MAGE 2.0+ can do nested rotations around given P,L vectors."
        "\015e.g. PREKIN 2.0+ :mutation & CHI rotations:"
        );
    dosinglealert();  
}
/*___menuaboutrotated()_____________________________________________________*/

/****menuaboutedit()*********************************************************/
void    menuaboutedit(void)
{
               sprintf(alertstr,
                   "Editing the kinemage:"
                   "\015Update View: add to VIEWS menu"
                   "\015draw new*: lines, labels"
                   "\015superpick: picking on ALL points"
                   "\015pickshow*: data structure of picked point"
                   );
               sprintf(alertstr2,
                   "\015prune: deletes:"
                   "\015  punch*: just picked point"
                   "\015  prune*: connected points"
                   "\015\015*toggle buttons on screen"
                  );
               sprintf(alertstr3," ");
               DoMageDLOGreport(); /*alertstr,alertstr2,alertstr3*/ /*___DLOG.C*/
}
/*___menuaboutedit()________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****setsuperpick()**********************************************************/
void    setsuperpick()   
{
    mycheckitem(editMenu, superpickItem, Lsuperpick=!Lsuperpick); 
         /*MACMENU.C*/ /*MPCMENU.C*/
}
/*___setsuperpick()_________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****setpickshow()***********************************************************/
void    setpickshow()   
{
    mycheckitem(editMenu, pickshowItem, Lpickshow=!Lpickshow);
             /*MACMENU.C*/ /*MPCMENU.C*/
    if(Lpickshow) Lpickshowon = 1;
    else Lpickshowon = 0;
    SetsinGrafWindow();        /*MAGEBBOX.C*/
    redrawvec();       /*MACDRAW.C*/ /*MPCDRAW.C -> redrawgraphics()*/
}
/*___setpickshow()__________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****setprune()**************************************************************/
void    setprune()   
{
    mycheckitem(editMenu, pruneItem, Lprune=!Lprune); 
             /*MACMENU.C*/ /*MPCMENU.C*/
    if(Lprune) Lpunchon = 1;
    else       Lpunchon = 0;
    Lpruneon = 0;
    Lundop = 0;
    nundop = 0;
    SetsinGrafWindow();        /*MAGEBBOX.C*/
    redrawvec();       /*MACDRAW.C*/ /*MPCDRAW.C -> redrawgraphics()*/
}
/*___setprune()_____________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****getkinemagechoice()*****************************************************/
void    getkinemagechoice(void)
{
    ireturnflag = 1;
    if(Lpruneactive||Ldrawactive) DoChangeCheckDialog();
    if(ireturnflag)  
    {
         DokineDialog();  /*MACDLOG.C*/ /*MPCDLOG.C*/
         findkinemage();  /*MAGEFILE.C*/
    }
}
/*___getkinemagechoice()____________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****menuaboutoptions()******************************************************/
void    menuaboutoptions(void)
{
    sprintf(alertstr,"onewidth: All lines two pixels wide"
       " (vs line-width depth cuing)"
       "\015thinline: All line one pixel wide"
       "\015perspective: Front larger, rear smaller (vs orthographic)"
       "\015white bkg: Colors on white background"
       "\015B&W monitor: Black on white (use with grayscale also)"
       );
    dosinglealert();  /*MACDLOG.C*/ /*MPCDLOG.C*/
}
/*___menuaboutoptions()_____________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****setwidthtoggle()********************************************************/
void    setwidthtoggle()
{
    mycheckitem(optiMenu, widthItem, Lonewidth=!Lonewidth);
             /*MACMENU.C*/ /*MPCMENU.C*/
    redrawvec();       /*MACDRAW.C*/ /*MPCDRAW.C -> redrawgraphics()*/
}
/*___setwidthtoggle()_______________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****setthinline()***********************************************************/
void    setthinline()
{
    mycheckitem(optiMenu, thinItem, Lthin=!Lthin);
             /*MACMENU.C*/ /*MPCMENU.C*/
    redrawvec();       /*MACDRAW.C*/ /*MPCDRAW.C -> redrawgraphics()*/
}
/*___setthinline()__________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****forcethinline()*********************************************************/
void    forcethinline()
{
    mycheckitem(optiMenu, thinItem, Lthin=1);
             /*MACMENU.C*/ /*MPCMENU.C*/
    if(Lmenu) redrawvec();    /*MACDRAW.C*/ /*MPCDRAW.C -> redrawgraphics()*/
}
/*___forcethinline()________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****setperspec()************************************************************/
void    setperspec()
{
    mycheckitem(optiMenu, perspecItem, Lperspec=!Lperspec);
             /*MACMENU.C*/ /*MPCMENU.C*/
    if(Lmenu) redrawvec();    /*MACDRAW.C*/ /*MPCDRAW.C -> redrawgraphics()*/
}
/*___setperspec()___________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****forceperspective()******************************************************/
void    forceperspective()   /*common name: MAC & PC */
{
    mycheckitem(optiMenu, perspecItem, Lperspec=1);
             /*MACMENU.C*/ /*MPCMENU.C*/
    if(Lmenu) redrawvec();    /*MACDRAW.C*/ /*MPCDRAW.C -> redrawgraphics()*/
}
/*___forceperspective()_____________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****setwhtbkg()*************************************************************/
void    setwhtbkg()
{
    if(IMAC)
    {
        mycheckitem(optiMenu, whtbkgItem, Lwhitebkg=!Lwhitebkg);/*MACMENU.C*/
    }
    /*if(IPC)*/
    else
    {
        mycheckitem(0, whtbkgItem, Lwhitebkg=!Lwhitebkg);/*MPCMENU.C*/
        /*PC just fakes a B&W monitor, so whtbkg and B&W related */
        /* if UNIX can do color, it just fakes a B&W screen*/
        if(!Lwhitebkg) Lcolor=1;
        mycheckitem(0, B_WItem, !Lcolor);
    }
    if(Lmenu) redrawvec();    /*MACDRAW.C*/ /*MPCDRAW.C -> redrawgraphics()*/
}
/*___setwhtbkg()____________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****menuaboutOther()********************************************************/
void    menuaboutOther(void)
{
    sprintf(alertstr,
            "stereo on: L&R images"
            "\015compare on: side-by-side pair of animated groups"
            "\015measures: simple & dihedral angles"
            "\015Find: point by name"
            "\015set reader's view as now displayed"
            "\015Kluges: submenu"
            );
    dosinglealert();  /*MACDLOG.C*/ /*MPCDLOG.C*/
}
/*___menuaboutOther()_______________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****setstereo()*************************************************************/
void    setstereo()
{
    mycheckitem(otherMenu, stereoItem, Lstereo=!Lstereo);
        /*MACMENU.C*/ /*MPCMENU.C*/
    if(Lstereo)
        myenableitem(otherMenu,compareItem, 0);/*disable compare*/
    else
        myenableitem(otherMenu,compareItem, 1);/*enable compare*/
    redrawvec();         /*MACDRAW.C*/ /*MPCDRAW ->redrawgraphics()*/
}
/*___setstereo()____________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****forcestereo()***********************************************************/
void    forcestereo()
{
    mycheckitem(optiMenu, stereoItem, Lstereo=1);
             /*MACMENU.C*/ /*MPCMENU.C*/
    if(Lmenu) redrawvec();    /*MACDRAW.C*/ /*MPCDRAW.C -> redrawgraphics()*/
}
/*___forcestereo()__________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****setcompare()************************************************************/
void    setcompare()
{
    mycheckitem(otherMenu, compareItem, Lcompareon=!Lcompareon);
        /*MACMENU.C*/ /*MPCMENU.C*/
    if(Lcompareon)
    {
        myenableitem(0,stereoItem, 0);/*disable stereo*/
        if(nanimate>0) mylabelbutton(animbox,"switch"); /*MPCMENU.C*/
                         /* dummied in MACMENU.C*/
        if(nnanimate>0) mylabelbutton(anim2box,"2switch"); /*MPCMENU.C*/

        adjustanimate(0);
        adjustanimate(1);
    }
    else
    {
        myenableitem(0,stereoItem, 1); /*enable stereo*/
        if(nanimate>0) mylabelbutton(animbox,"ANIMATE"); /*MPCMENU.C*/
                         /* dummied in MACMENU.C*/
        if(nnanimate>0) mylabelbutton(anim2box,"2ANIMATE"); /*MPCMENU.C*/
    }
    SetsinGrafWindow();  /*MAGEBBOX.C*/
    redrawvec();         /*MACDRAW.C*/ /*MPCDRAW ->redrawgraphics()*/
}
/*___setcompare()___________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****setmeasures()***********************************************************/
void    setmeasures()
{
    if(!Lmeasures)  /*have to make sure there is room to add lines to display*/
    {
    addmeasures(); /*tries to establish measures storage*/
    if(Lmeasures)  /*returns as TRUE if can set up measures*/
    {
        Lnewmeasures = 1;
        Lmeasureson = 1;
    }
    }
    else
    {
        Lmeasures = 0;
        Lmeasureson = 0;
        igrp[maxgrp+2][0] = 0; /* disable display*/
        if(!Ldrawline)
        {
            if(Lmarkers) maxnxyz = nxyz + nmarkers;
            else         maxnxyz = nxyz;
        }
    }
    mycheckitem(otherMenu, measureItem, Lmeasures); /*MACMENU.C*/ /*MPCMENU.C*/
    if(Lmenu)
    {
         SetsinGrafWindow();        /*MAGEBBOX.C*/
         redrawvec();         /*MACDRAW.C*/ /*MPCDRAW ->redrawgraphics()*/
    }
}
/*___setmeasures()__________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****menuaboutkluges()*******************************************************/
void    menuaboutkluges()
{
    sprintf(alertstr,
        "screen font size"
        "\015stereo: angle, separation"
        "\015XYZ: picked=shown"
        "\015gnomon: centered"
        "\015init angles: bond-rotations"
        );
    sprintf(alertstr2,
        "\015count: #lines on, total# points, time"
        "\015rate: updates/sec"
        "\015\015debug test: for programer"
        "\015keyboard tricks explained" 
        );
    sprintf(alertstr3," ");
    DoMageDLOGreport(); /*alertstr,alertstr2,alertstr3*/ /*___DLOG.C*/
}
/*___menuaboutkluges()______________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****setxyzpoint()***********************************************************/
void    setxyzpoint()
{
    mycheckitem(kludgeMenu, xyzpointItem, Lxyzpoint=!Lxyzpoint);
             /*MACMENU.C*/ /*MPCMENU.C*/
    if(Lmenu) redrawvec();    /*MACDRAW.C*/ /*MPCDRAW.C -> redrawgraphics()*/
}
/*___setxyzpoint()__________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****setgnomon()*************************************************************/
void    setgnomon()
{
    mycheckitem(kludgeMenu, gnomonItem, Lgnomon=!Lgnomon);
             /*MACMENU.C*/ /*MPCMENU.C*/

    if(Lgnomon)
    {
        ilist[maxlist+2][0] = 1; /*gnomon list display on*/
        ilist[maxlist+3][0] = 1; /*gnomon list display on*/
        if(Lmarkers)
        {
            igrp[maxgrp+1][0] = 1;
                /*markers group display on*/
#ifdef MACINTOSH
            SetCtlValue(grpbox[maxgrp+1], 1);
#endif
#ifdef PCWINDOWS
            SendMessage(buttons[markbox],BM_SETCHECK,1,0l);
#endif            

        }
    }
    else
    {
        ilist[maxlist+2][0] = 0; /*gnomon list display off*/
        ilist[maxlist+3][0] = 0; /*gnomon list display off*/
    }
    if(Lmenu)
    {
         rescalekinemage();   /*MAGEINPT.C*/
         redrawvec();         /*MACDRAW.C*/ /*MPCDRAW.C -> redrawgraphics()*/
    }
}
/*___setgnomon()____________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****setrate()***************************************************************/
void    setrate()
{
    mycheckitem(kludgeMenu, rateItem, Lrate=!Lrate);
             /*MACMENU.C*/ /*MPCMENU.C*/
}
/*___setrate()______________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****settest()***************************************************************/
void    settest()
{
    mycheckitem(kludgeMenu, testItem, Ltest=!Ltest); /*MACMENU.C*//*MPCMENU.C*/
}
/*___settest()______________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****menuaboutsecrets()******************************************************/
void    menuaboutsecrets()
{
    sprintf(alertstr,
        "keys:"
        "\015a: animate, b: 2animate"
        "\015z,Z,x,X: true recentering along screen Z axis"
        "\015 +1*, +10*, -1*, -10* motion"
        "\015 slow recalculation (ztran: just quick offset)"
        );
    sprintf(alertstr2,
        "toggles:"
        "\015s: keep-stereo, c: cross<->wall eyed"
        "\015t: keep-thinline"
        "\015p: keep-perspective"
        );
    sprintf(alertstr3," ");
    DoMageDLOGreport(); /*alertstr,alertstr2,alertstr3*/ /*___DLOG.C*/
}
/*___menuaboutsecrets()_____________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****setplotonly()***********************************************************/
void    setplotonly()
{
    mycheckitem(kludgeMenu,plotonlyItem,Lplotonly=!Lplotonly);
        /*MACMENU.C*//*MPCMENU.C*/
}
/*___setplotonly()__________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****setflat()***********************************************************/
void    setflat()
{
    mycheckitem(kludgeMenu,flatItem,Lflat=!Lflat);
        /*___MENU.C*/
}
/*___setflat()__________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****menuabouthelp()*********************************************************/
void    menuabouthelp()
{
    sprintf(alertstr,
        "other help about MAGE operations"
        "\015  --mouse operation for interactive control of graphics"
        "\015  --changing size of windows"
        );
    dosinglealert();  /*MACDLOG.C*/  /*MPCDLOG.C*/
}
/*___menuabouthelp()________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****menuaboutmouse()********************************************************/
void    menuaboutmouse()
{
    sprintf(alertstr,
"mouse operations:"
"\015MAGE cursor is a pointing arrow head."
"\015\015Clicking the mouse button while the arrow cursor tip touches"
"\015a point, writes that point's {point ID} to the screen."
"\015(If more than one, use the left button)"
      );
    sprintf(alertstr2,
"Moving the mouse while holding the button down (dragging) rotates the"
"\015graphics image."  
"\015Starting cursor in lower 3/4 screen rotates around x,y axes,"
"\015 cursor shows + in its tail."
"\015Starting in upper 1/4 of the screen, rotates around z axis,"
"\015 cursor shows o."
      );

    sprintf(alertstr3,
"\015The rotation of the image continues to be coupled to the hand motion"
"\015exactly as it started no matter where the cursor moves on the screen."
"\015\015Thus the reader (lecturer) can place the mouse where convenient"
"\015and can ignore it thereafter."
      );
    DoMageDLOGreport(); /*alertstr,alertstr2,alertstr3*/ /*___DLOG.C*/
}
/*___menuaboutmouse()_______________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****menuaboutresize()*******************************************************/
void    menuaboutresize()
{
    sprintf(alertstr,
"The windows can be resized and repositioned, but not shut or put behind."
"\015If a window gets hidden behind others, it can be brought to the front"
"\015by the Show commands under the Windows pull-down-menu"    
        );
    sprintf(alertstr2,
"A combination of moving and resizing using the hot point at the lower right"
"\015corner of the graphics window, allows control of the size and placement"
"\015of the image."    
        );
#ifdef MACINTOSH
    sprintf(alertstr3,
"The Mac graphics window expansion box is at the far right"
"\015of its title bar.  Large monitors may need greater than default memory size."
"\015Before running MAGE, Get-Info on the Macintosh File"    
"\015pull-down-menu allows increasing the Minimum and Preferred Size."
        );
#endif /*MACINTOSH*/
#ifdef PCWINDOWS
    sprintf(alertstr3,
"The PC graphics window and kinemage control buttons both float on a"
"\015parent window."
"\015Blindly expanding the graphics will cover those essential controls."    
"\015(The effective aspect of the PC graphics image is presently limited"
"\015to width = height, i.e. square.)"
        );
#endif /*PCWINDOWS*/

    DoMageDLOGreport(); /*alertstr,alertstr2,alertstr3*/ /*___DLOG.C*/
}
/*___menuaboutresize()______________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****checksurvival()*********************************************************/
int    checksurvival()  
{    
    int    isurvived,jsurvived,ksurvived,j,idied;

    idied = 0;
    for(ngrp = 1; ngrp <= maxgrp ; ngrp++) 
    {/*check all groups*/
      ksurvived = 0;/*presume this group is dead*/
      if(igrp[ngrp][0] > -50) /*survived pickshow deletion*/
      {/*group not deleted*/
        for(nset = igrp[ngrp][1]; nset <= igrp[ngrp][2] ; nset++)
        {/*check all sets*/
          jsurvived = 0;/*presume this set is dead*/
          if(iset[nset][0] > -50) /*survived pickshow deletion*/
          {/*set not deleted*/
              for(nlist = iset[nset][1]; nlist <= iset[nset][2] ; nlist++)
              {/*check all lists*/
                  isurvived = 0;/*presume this list dead*/
                  if(ilist[nlist][0] > -50) /*survived pickshow deletion*/
                  {/*list not deleted*/
                      for(j = ilist[nlist][1]; j <= ilist[nlist][2] ; j++)
                         if(xyz(0,j) < 100) isurvived = 1;/*survived pruning*/
                      if(isurvived) jsurvived = 1;/*some list alive down here*/
                      if(!isurvived) 
                      {/*this list died*/   /*very off for output*/
                          ilist[nlist][0] = ilist[nlist][0]-100;
                          ilist[nlist][6] = 3; /*nobutton for sure*/
                          idied = 1;                  
                      }/*this list died*/
                  }/*list not deleted*/
              }/*check all lists*/
              if(!jsurvived) /*flag for any alive list*/
              {/*this set died*/
                 iset[nset][0] = iset[nset][0]-100;/*very off for output*/
                 iset[nset][3] = 3;/*nobutton && dominant: no buttons below*/
                 idied = 1;
              }/*this set died*/
              if(jsurvived) ksurvived = 1; /*flag for any alive set*/
          }/*set not deleted*/ 
        }/*check all sets*/
        if(!ksurvived) /*flag for any alive list or set below*/
      {/*this group died*/
          igrp[ngrp][0] = igrp[ngrp][0]-100;/*very off for output*/
          igrp[ngrp][4] = 3;/*nobutton && dominant: no buttons below*/
          igrp[ngrp][3] = 0;/*remove from any animation sequence*/
          idied = 1;
      }/*this group died*/
      }/*group not deleted*/
    }/*check all groups*/
    return(idied);
}
/*___checksurvival()________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/

/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/






