/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/

#include "MAGE.H"
/*mageVect.c*/

/****getvects(c,Lnew)********************************************************/
void    getvects(int c,int Lnew)

{
static    int        Liden,Lnum,Lfirst,Lstartiden,Lsinglequotetoggle;
static    int        Lwords,Lstartwords;
static    int        ivect,nvect,LgotpointID,gotinstance;
static    char       vects[256], instancename[MAXNAMECHAR+1];
static    int        flowID,n,j,monitornxyz,monitornxyzold;
          int        mask,masterfound;
/*need some of these static since getvects() called repeatedly during input*/
enum    { idenID = 1, numbID = 2, skipID = 3, wordsID = 4 };

    /* initialize Lmove by Lnew for first vector of a vector list */
    if(Lnew) 
    {/*Lnew*/
        if(Lset == 0) 
        {/*@___list without a preceeding @subgroup, construct a subgroup set*/
            if(maxgrp == 0)  
            {/* @set without a preceeding @group, construct first group */
              ngrp++;
              maxgrp = ngrp;
              igrp[ngrp][0] = 1;/* start with display enabled */
                /*since @group expected before @set, first set number of */
                /* this coming group is the next nset, i.e. nset + 1, */
                /*  consistent with set number set soon*/
              igrp[ngrp][1] = nset + 1;/* starting set number of this group*/
              igrp[ngrp][2] = nset + 1;/*ending set number for now*/
              /*@set routines must adjust the set counters within the group*/
              igrp[ngrp][3] = 0; /* created group can't be an animation group*/
              igrp[ngrp][4] = 0; /* created group can't be a dominant group */
              igrp[ngrp][5] = 0; /*dummy, used to be for master button*/
              igrp[ngrp][6] = 0; /* initially not flagged for special output*/
              igrp[ngrp][7] = 0; /*presume an original, not an instance*/ 
              igrp[ngrp][8] = 0; /* created group can't have a moview flag */
              igrp[ngrp][9] = 0; /*presume no balllists to start*/ 
              for(n=0;n<=MAXNAMECHAR;n++) groupname[ngrp][n]= '\0';
                                 /*clear group name*/
              condition(groupname[ngrp]);
              groupmaster[ngrp] = 0; /*unsigned long for master button flags*/
            }/* @set without a preceeding @group, construct first group */
            nset++;
            maxset = nset;
            iset[nset][0] = 1;  /* start with display enabled */
                /*since @subgroup expected before @vector or @label or @dot,*/
                /*first list number of this coming set is the next nlist, */
                /*i.e. nlist + 1, consistent with list number set soon*/
            iset[nset][1] = nlist + 1;   /* starting list number of this set*/
            iset[nset][2] = nlist + 1;    
                                  /* ending list number of this set, so far */
              /*the @vectorlist & @labellist & @dotlist routines must adjust*/
              /*the list counters within the set */
              /*This is an invented set: not an explicit kinemage item*/
            iset[nset][3] = 3;/*1 dominant, 2 no button = 3 no kinemage item*/
               /* sublists revealed, but this set no button */
            iset[nset][4] = 0; /*dummy, used to be for master button*/
            iset[nset][5] = 0;
               /* initially not flagged for special output*/
            iset[nset][6] = 0; /* flag not used */
            iset[nset][7] = 0; /*presume an original, not an instance*/ 
            iset[nset][8] = 0; /*presume no balllists to start*/ 
            for(n=0;n<=MAXNAMECHAR;n++) setname[nset][n] = '\0';
                               /*clear subgroup name*/
            condition(setname[nset]);
            subgroupmaster[nset] = 0; /*unsigned long for master button flags*/
            Lset = 1;
            igrp[ngrp][2] = nset; 
            /*adjust counter in parent group to include this set*/
        }/*@___list without a preceeding @subgroup, construct a subgroup set*/
        Lfirst = 1;
        Lmove = 1;
        Lunpickable = 0;
        nvect = 0;  /* counts up to 3 to get vector triplet */
        Linstance = 0;
        Lmaster = 0;
        if(nlist >= MAXL-1) 
        {
             sprintf(alertstr,"too many lists: vectors, labels, or dots!");
             sprintf(word," ");
             listerrorreport(); /*alertstr and word*/ /*MAGEVECT.c*/
        }
        else            nlist++;
        maxlist = nlist;
        iset[nset][2] = nlist;  /*adjust set counter to know about this list*/
        ilist[nlist][0] = -1;     /*start with display tentatively disabled*/
          /* NOTE: If valid coord triples are to be displayed or instanced */
          /*  this vectorlist must be explicitly turned ON */
        ilist[nlist][1] = nxyz;  /* starting vector number of this list */
        ilist[nlist][2] = nxyz;  /*ending vector number of this list, so far*/    
/*C*/    /*defaultcolor();*/     /* assign default color for this set */    
        ilist[nlist][3] = 7; /* default is whiteFore on blackBack */
        
        ilist[nlist][4] = 0; /*dummy, used to be for master button*/
        ilist[nlist][5] = 0;/* initially not flagged for special output*/
                            /* used for bond-rotated vectors */
        ilist[nlist][6] = 0; /*initially not flagged for nobutton */                   
        ilist[nlist][7] = 0; /*presume an original, not an instance*/ 
        ilist[nlist][8] = 0; /*flag for this instance's own declared color*/   
        ilist[nlist][9] = 0; /*flag for static== no rotation, scaling,...*/   
        radiuslist[nlist] = 0.0; /*float property associated with this list*/

        for(n=0;n<=MAXNAMECHAR;n++) listname[nlist][n] = '\0'; 
            /* clear listname button id*/
        listmaster[nlist] = 0; /*unsigned long for master button flags*/
        xyz(0,nxyz) = 10; /*create dummy move==Point*/
        xyz(1,nxyz) = 0.0; /*dummy vector, in case none ever made*/
        xyz(2,nxyz) = 0.0;
        xyz(3,nxyz) = 0.0;
        
        Newscale = FALSE;  /* set scale logicals */
        
        flowID = skipID;
    
        iword = 0;
        word[0] = ' ';  /* give it a blank pointID to start */
        word[1] = '\0';
        Lnewlist = TRUE;  
        /* need to know this so check for duplicate triples which */
                          /*cannot carry across from previous list */
        
        Lsinglequotetoggle = 0; /* allows numbers as comments: '#' */
                                /* allows chaos labels in kinemage */
        LgotpointID = 0; /* flags when something in that will be used */
                         /* as a point ID */
        Lmustkeeppoint = 0; /* flags when comment or wordlist forces one */
                            /* to keep this point even if a duplicate. */
        Lcomment = 0;
        Lballhere = 0;    /*flags when a ball is expected at this point*/
                          /*vectorline is to be shortened by radiuslist */
        Lballthere = 0;
        if(Lball) 
        {
            iset[nset][8] = 1; /*flag balllist for this subgroup*/
            igrp[ngrp][9] = 1; /*flag balllist for this group*/  
           
        }
        Lwordsfont = 0;
        Lwordsface = 0;
        Lwordssize = 0;
        wordsfont[nlist] = 0;
        wordsface[nlist] = 0;
        wordssize[nlist] = 0;

    }/*Lnew*/
    /* test character and set flow controls  */

    /* screen for comment strings, may be used as wordlist to screen */
    if(c == '<' && flowID != idenID)  
    {/* start a comment or wordlist entry */ /*don't if inside curly brackets*/
        Lstartwords = 1;
        flowID = wordsID;
        Lwords = 0; /* Lwords set = 1 in case wordsID below */
        Lnum = 0; /* in any case, not still within a number*/
    }
    else if(c == '>' && flowID != idenID) 
    {/*end a comment or wordlist entry */ /*don't if inside curly brackets*/
        if(!Lwords)
        {
             sprintf(alertstr,"> without preceeding <,"
                              "\015 may be accumulating chars:");
             word[iword+1] = '\0';
             listerrorreport(); /*alertstr and word*/ /*MAGEVECT.c*/
        }
        Lwords = 0; /*reset flag*/
        Lnum = 0;
        flowID = skipID;
        if(!Lfirst) /* <comments> on first line are ignored */
        {/*got <comments> on other lines*/
         /*store possible pointID stuff, word[last] should == '\0' */
            word[iword] = '\0'; 
            for(n=0; n<=iword; n++) 
            {
                commentstr[n+3] = word[n];
            }
            Lmustkeeppoint = 1;
            Lcomment = 1;
            /*firstline may have defined: */
            commentstr[0] = wordsfont[nlist]; /*font: treat as integer quantity! */
            commentstr[1] = wordsface[nlist]; /*face: treat as integer quantity! */
            commentstr[2] = wordssize[nlist]; /*size: treat as integer quantity! */
        }
        /*clear the word[] */
        iword = 0;
        word[0] = ' ';
        word[1] = '\0'; 
    }
    /* screen for identifier strings */
    if(c == '{' && flowID != wordsID /*} comes later*/ ) /*balancing brace in if*/
    {/* start an identifier */ /*don't if inside <> */
        Lstartiden = 1;
        if(flowID == skipID) flowID = idenID;
        Liden = 0; /* Liden set = 1 in case idenID below */
        Lnum = 0; /* in any case, not still within a number*/
    }
    else if(/*{ came earlier*/  c == '}' && flowID != wordsID ) /*balancing brace*/
    {/*dealing with brackets*/ /* end of an identifier */ /*don't if inside <> */
        if(!Liden)
        {
/*c*/        sprintf(alertstr,"didn't find preceeding { for this }"
                              ",\015 may be accumulating chars:");
             word[iword+1] = '\0';
             listerrorreport(); /*alertstr and word*/ /*MAGEVECT.c*/
        }
        if(Lfirst) j = MAXNAMECHAR;  /* list & button names MAXNAMECHAR char*/
        else j = MAXPTIDCHAR;        /* point ID & labels MAXPTIDCHAR char */
        for(n=iword ; n<j ; n++) word[n] = '\0';
          /*revision930207 pad out identifier with '\0' rather than ' '*/
        word[j] = '\0'; /*pad & end the string in c manner, see insurance below*/
        Liden = 0;
        Lnum = 0;
        flowID = skipID;
        if(Lfirst)
        {
            if(Linstance)
            {/*should hold identifier of a previously defined ____list */
                /* _____list named, copy it to instancename */
                {

                    for(n=0; n<=MAXNAMECHAR ; n++)
                    {
                        instancename[n] = word[n];
                    }
                    instancename[MAXNAMECHAR] = '\0'; /*insurance*/
                    iword = 0;
                    word[0] = ' ';
                    word[1] = '\0'; 
                    
                }
/*Mx*/            condition(instancename);
                for(n=1;n<nlist;n++)
                {
                    if(strncompare(instancename,listname[n],MAXNAMECHAR+1) == 0)
                    {
                        /*ilist[nlist][0] = ilist[n][0];*//*inherit on-off 930912*/
                        ilist[nlist][0] = 1; /*950106,930204-912 display enabled*/     
                        ilist[nlist][1] = ilist[n][1];    
                            /* starting vector number of this list */
                        ilist[nlist][2] = ilist[n][2];    
                            /* ending vector number of this list */
                        if(ilist[nlist][8] == 0)/*flag for list's own color*/ 
                           ilist[nlist][3] =ilist[n][3];
                            /*unless a new color= has been read, */
                            /* use old color of original list*/
                        /*if(ilist[nlist][4] == 0)*/
                           /*ilist[nlist][4] = ilist[n][4];*/ 
                        if(listmaster[nlist] == 0)
                           listmaster[nlist] = listmaster[n]; 
                            /* master button flag for this list*/
                            /*unless a new master= has been read, */
                            /* use master of original list*/
                            /*this can be reset later on this first line*/
                        ilist[nlist][5] = ilist[n][5]; 
                            /* special output flag for this list*/     
                        ilist[nlist][6] = ilist[n][6]; 
                            /* nobutton flag for this list*/ 
                        ilist[nlist][7] = n; /*identity of original list*/   
                        gotinstance = 1;
                        break;
                    }
                 }
                 if(!gotinstance)
                 {
                     sprintf(alertstr,
                        "instance failed, no previous list has name: %s",
                        instancename);
                     listerrorreport(); /*alertstr and word*/ /*MAGEVECT.c*/
                 }
                 gotinstance = 0;
                 Linstance = 0;
            }
            else if(Lmaster)
            {/*should hold identifier of a master button for this list */
        
                /* master named,*/
                condition(word); /*make into a Pascal string if on Mac*/
            
                if(nmaster > 0) /*previous master button requested */ 
                {/*see if this one matches previous a master name */ 
                    masterfound = 0;
                    for(j=1;j<=nmaster;j++)
                    {
                      /*if(strncompare(word,mastername[j],MAXNAMECHAR+1) == 0)*/
                        if(strncompare(word,mastername[j],MAXNAMECHAR) == 0)
                        {
                           /*ilist[nlist][4] = j;*/
                             mask = 1<<(j-1);
                             listmaster[nlist] = mask + listmaster[nlist]; 
                                 /*add to any other*/           
                             masterfound = 1;
                        }
                    }
                }
              /*if(nmaster == 0 || ilist[nlist][4] == 0) */
                if(nmaster == 0 || masterfound == 0) 
                {/*make a new master button*/
                    if(nmaster+1 > 8*((int)sizeof(long)) )
                    {
                        sprintf(alertstr,
                           " number of master buttons limited to %d in %s",
                            8*((int)sizeof(long)),version); 
                        sprintf(word,"trouble at:");
                        listerrorreport(); /*alertstr and word*/ /*MAGEVECT.c*/
                    }
                    else
                    {
                        nmaster++;
                        for(n=0; n<=MAXNAMECHAR ; n++)
                        {    
                            mastername[nmaster][n] = word[n]; 
                        }
                      /*ilist[nlist][4] = nmaster;*/
                        mask = 1<<(nmaster-1);
                        listmaster[nlist] = mask + listmaster[nlist]; /*add to any other*/
                    }
                }                
                Lmaster = 0;
            }
            else /*should hold identifier of this ____list */    
            {
                /* _____list has a name, copy it to listname */
                {
                    for(n=0; n<=MAXNAMECHAR ; n++)
                    {
                        listname[nlist][n] = word[n];
                    }
                    listname[nlist][MAXNAMECHAR] = '\0'; /*insurance*/
                    /*array has MAXNAMECHAR+1 values indexed: 0,....,MAXNAMECHAR*/
                    iword = 0;
                    word[0] = ' ';
                    word[1] = '\0'; 
                }
                condition(listname[nlist]); /*MACMAIN.C, dummied in ___MAIN.c*/
            }
        }/*Lfirst for doing bracketed stuff on first line */
        else
        {/*got bracketed stuff on other lines*/
            if(LgotpointID) /*already have a current pointID */
            {/*check to see if anything useful in these brackets*/
                if(iword == 1 && (word[0] == 'U' || word[0] == 'u') ) 
                   Lunpickable = 1;
                   /*tightly bracketed U can be used for unpickable point*/
            }
            else
            {/*store possible pointID stuff, word[MAXPTIDCHAR] should == '\0' */
                for(n=0; n<= MAXPTIDCHAR; n++) 
                {
                    ptIDstr[n] = word[n];
                }
                ptIDstr[MAXPTIDCHAR] = '\0'; /*insurance*/
                /*array has MAXPTIDCHAR+1 values indexed: 0,....,MAXPTIDCHAR*/
                LgotpointID = 1; /*reset back to 0 after addanothervector()*/
            }
            /*clear the word[] */
            iword = 0;
            word[0] = ' ';
            word[1] = '\0'; 
        }
        /*clear the word[] */
        iword = 0;
        word[0] = ' ';
        word[1] = '\0'; 

    }/*dealing with brackets*/
    if(c == '\'' && !Lfirst && !Liden) 
    {
        if(Lsinglequotetoggle) Lsinglequotetoggle = 0;
        else                   Lsinglequotetoggle = 1;
    }
    /* now either in an identifier in which any other char accepted ... */
    /* or must check the char */
    if(   !Lstartiden  && !Liden  && (flowID != idenID )  
       && !Lstartwords && !Lwords && (flowID != wordsID)    )
    {
        if(Lfirst)  /* first line with @vector can have {button identifier} */
                    /* & color=colorname & off flag  */
        {
            Lfirst = (int)Vectfirstline(c,Lnew); /*MAGEVSUB.C*/
            if(!Lfirst && Ltest)
            {
                sprintf(alertstr,"debug test\015"
                    "nlist = %d, starting triplet# %d",nlist,ilist[nlist][1]);
                dosinglealert(); /*MACDLOG.C*/ /*MPCDLOG.C*/
            }
        }
        else if(Lsinglequotetoggle) flowID = skipID; /*skip*/
        else if(c == 'm'||c=='M'||c=='p'||c=='P')  /*flag a Move instruction*/
        {
            Lmove = 1;
            Lnum = 0;
            flowID = skipID;
        }
        else if(c == 'u'||c=='U')  /* flag an Unpickable triple */
        {
            Lunpickable = 1;
            Lnum = 0;
            flowID = skipID;
        }        
        else if(c == 'b'||c=='B')  /* flag a ball expected at this point */
        {
            LBcharflag = 1; /*actual specific entry request for shortened line*/
            Lballhere = 1; /*generic expectation of shortened line*/
            Lmustkeeppoint = 1;
            Lunpickable = 1;
            Lnum = 0;
            flowID = skipID;
        }        
        else if(  c==' '||c==','||c==';'||c=='\t' 
                ||c=='\015'||c=='\012'||c==EOL) 
        {/* generic white space */
            Lnum = 0;  /* might end a number, leave flowID alone */
        }
        else if(c=='0'||c=='1'||c=='2'||c=='3'||c=='4'||c=='5'||c=='6'||
            c=='7'||c=='8'||c=='9'||c=='.'||c=='-')
        {
            Lnum = 1;          /* actually got a digit of a number */
            flowID = numbID;
        }
    }
    /* Now control by flowID cases */
    /*begin-of-switch(flowID)*/                        
    switch(flowID)
    {/*switch(flowID)*/
        case idenID:
            if(Liden) /*expect identifier characters in curley braces */
            {
                if(Lfirst) j = MAXNAMECHAR;/*list & button names MAXNAMECHAR char*/
                else j = MAXPTIDCHAR;      /* point ID & labels MAXPTIDCHAR char */

                if(iword >= j)
                {
                    word[iword] = '\0';
                    if(Lfirst)
                    {
                        sprintf(alertstr,
                           "limited to %d char in {list name}"
                           "\015next char: %c, would make string below too long."
                           ,MAXNAMECHAR,c);
                        listerrorreport(); /*alertstr and word */ /*MAGEVECT.c*/
                    }
                    else if(LpointIDtoolong==0)
                    {
                        sprintf(alertstr,
                           "#char limited to %d for {pointIDs} and {labels}." 
                           "\015next char: %c, would make string below too long."
                           "\015 only first occurrance flagged, check for others"
                           ,MAXPTIDCHAR,c);
                        listerrorreport(); /*alertstr and word */ /*MAGEVECT.c*/
                        LpointIDtoolong = 1;
                    }
                    flowID = skipID; /*NOTE Liden still == 1 */
                }
                else
                {
                    word[iword] = c;
                    iword = iword + 1;
                }
            }
            else  /* just got the left curley brace char, so... */
            {
                Liden = 1; /* get ready for the actual identifier characters*/
                Lstartiden = 0;    
                iword = 0;
                word[0] = ' ';  /* give it a blank pointID to start */
                word[1] = '\0';
                ivect = 0;  
                /*{identifier} forces initialization of number accummulation*/
        
            }
        break;

        case wordsID:
            if(Lwords) /*expect wordlist or comment characters in <...> brackets*/
            {
              if(!Lfirst) /*first line <comments> are ignored */
              {/*not a first line*/
                if(iword > 254)
                {      /*index: 0,...,255  for 256 entries */
                     word[iword] = '\0';
                     sprintf(alertstr,"next char: \"%c\" "
                         "makes string (below) too long:"
                         "\015ignore input characters until \">\" bracket"
                         ,c);
                     listerrorreport(); /*alertstr and word */ /*MAGEVECT.c*/
                     flowID = skipID; /*NOTE Lwords still == 1 */
                }
                else
                {
                    word[iword] = c;
                    iword = iword + 1;                
                }
              }/*not a first line*/
            }
            else  /* just got the < char, so... */
            {
                Lwords = 1; /* get ready for the actual comment or */
                            /*wordlist characters*/
                Lstartwords = 0;    
                iword = 0;
                word[0] = '\0';
                ivect = 0;  
                /*<comment> forces initialization of number accummulation*/
        
            }
        break;
                            
        case numbID:
            if(Lnum)
            {
                if(ivect > 254)
                {
                    vects[ivect] = '\0';
                    sprintf(alertstr,
                        "next char: %c in vect string for numbers"
                        "\015 excessive length, fatal condition"
                        "\015 string is:",c);
                    sprintf(word,"%s",vects);
                    listerrorreport(); /*alertstr and word */ /*MAGEVECT.c*/
                    ExitToShell();
                }            
                vects[ivect] = c;
                ivect++;    
            }
            else  /* Lnum = 0, should be at end of a number */
            {/*-process-number*/
                vects[ivect] = '\0'; /* str end */
                if(Lstartiden) flowID = idenID; 
                    /*number was ended by next {...} */
                else      flowID = skipID; 
                   /*new number will have to reset flowID*/
                nvect++;
                sscanf(vects,"%f",&x[nvect]); /*c*/ /*read char str as a float*/
                ivect = 0;  /* reset for next number */
                if(nvect == 3)   /* triplet vector in, store it */
                {/*begin if triplet vector */
                  if(nxyz >= MAXNUM-2) /*-2 allows for balls*/
                  {/*try to allocate more storage and increase MAXNUM*/
                      allocdataarrays(1000); /*try for 1000 more coords*/
                  }
                  if(nxyz < MAXNUM) /*protection if allocation fails*/
                  {/*begin if can add another vector */
                    if(Ltest)
                    {
                        monitornxyz = nxyz/100;
                        if(monitornxyz > monitornxyzold + 4)
                        {
                             sprintf(alertstr,"reached triple number %d",nxyz); 
                             dosinglealert(); /*___DLOG.C*/
                             monitornxyzold = monitornxyz;
                        }
                    }
                  
                     addanothervector(); /*MAGEVSUB.C*/ 

                     Lsinglequotetoggle = 0; /*initialize this after each */
                        /*triple so things can't go too wrong */ 
                     LgotpointID = 0; /*expects pointID to be in ptIDstr[] */
                         /* when it puts away a triple as a vector */  
                     for(n=0; n< MAXPTIDCHAR; n++) ptIDstr[n] = ' '; 
                         /*clear pointID*/
                     ptIDstr[MAXPTIDCHAR] = '\0';
                     Lmustkeeppoint = 0;
                     
                  }/*endof if can add another vector */
                  else
                  {/*begin else can't add another vector */
                      if(Lexcessivepoints==0) 
                      {
                          sprintf(alertstr,
                              "%d points exceeds maximum at pointID: %s",ptIDstr);
                          sprintf(word,"No further warnings, expect truncated image");
                          listerrorreport(); /*alertstr and word */ /*MAGEVECT.c*/
                          Lexcessivepoints = 1;
                      }
                      LOK = 0;
                      nxyz = MAXNUM-1;
                  }/*endof else can't add another vector */
                  
                  nvect = 0;
                  iword = 0;
                  word[0] = ' ';
                  word[1] = '\0';
                  ivect = 0;
                  Lmove = 0;
                  Lunpickable = 0;
                  LBcharflag = 0; /*must be flagged for each point*/
                }/*endof if triplet vector */
            }/*-process-number*/
        break;

        case skipID:
        break;
   
    }/*switch(flowID)*/
    
}
/*___getvects(c,Lnew)_______________________________________________________*/

/****listerrorreport()*******************************************************/
void listerrorreport()
{
    recondition(groupname[ngrp]);  /*MACMAIN.C, dummied in MPCMAIN.C*/
    recondition(setname[nset]);
    recondition(listname[nlist]);
    sprintf(alertstr2,"%s",word);
    sprintf(alertstr3,
          "\015in group[%d]: %s,  (subgroup[%d]: %s ), list[%d]: %s"
          ,ngrp,groupname[ngrp],nset,setname[nset],nlist,listname[nlist]);
    DoMageDLOGreport(); /*alertstr,alertstr2,alertstr3*/ /*___DLOG.C*/
    condition(groupname[ngrp]);
    condition(setname[nset]);
    condition(listname[nlist]);
}
/*___listerrorreport()______________________________________________________*/

