/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/

#include "MAGE.H"
/*mageVsub.c*/

/****Vectfirstline()*********************************************************/
int        Vectfirstline(int c,int Lnew)
{
          int        j,ireturn,iwordsfont,iwordsface,iwordssize;
          float      angle;
        
    if(Lnew)  /* initialize first line array counters */
    {
        iword = 0;
        word[iword] = '\0'; 
        icolor = 0;
        Lcolnam = 0;
        Lbrot = 0;
        Lbang = 0;
        Lradius = 0;
        Lballhere = 0;
        Lballthere = 0;
        LBcharflag = 0;
    }
    if(  c == ' '||c == ','||c == ';'||c == '\t'
       ||c == '\015' || c == '\012' || c == EOL ) /* white space */
    {
        if(iword > 0)  /* after a word, i.e. not before any char of a word */
        {
            if( !(c == ' ' && icolor == 1) )  /* not blank within "color =" */
            {    
                word[iword] = '\0';  /* end string in c manner */
                if(Lcolnam)
                {
/*C*/                setlistcolor(); 
                        /*this should be the only call to setlistcolor()*/
                        /* sets ilist[nlist][3] = color number of MAGE palette*/
                        /*ilist[nlist][3] can also be set by instance*/
                    ilist[nlist][8] = 1; /*flag for this instance's own color=*/    
                    Lcolnam = 0;
                }
                else if(Lbrot && !Lbang) /* interpret as float angle value*/
                {
                    sscanf(word,"%f",&angle);
                    Lbang = 1;
                    while(angle < -180.0) angle = angle + 360;
                    while(angle >  180.0) angle = angle - 360;
                }
                else if(Lwordsfont)
                {/*interpret as an int, convert to short, pack in char*/
                    sscanf(word,"%d",&iwordsfont);
                    wordsfont[nlist] = iwordsfont;
                    Lwordsfont = 0;
                }
                else if(Lwordsface)
                {/*interpret as an int, convert to short, pack in char*/
                    sscanf(word,"%d",&iwordsface);
                    wordsface[nlist] = iwordsface;
                    Lwordsface = 0;
                }
                else if(Lwordssize)
                {/*interpret as an int, convert to short, pack in char*/
                    sscanf(word,"%d",&iwordssize);
                    wordssize[nlist] = iwordssize;
                    Lwordssize = 0;
                }
                else if(Lradius) /* interpret as float value*/
                {
                    sscanf(word,"%f",&radiuslist[nlist]);
                    Lradius = 0;
                }

                else
                {
/*.*/                interpretlistkeyword();
                }
                iword = 0;
            }
        }
    }
    else if(c == '=')  /* check for color parameter */
    {
        if( icolor == 1)  /* the "color=" parameter */
        {
            word[iword+1] = '\0';
            Lcolnam = 1;
            iword = 0;
            icolor = 0;
        }
        else /* see if now have "color=" or "instance=" */
        {
            word[iword] = c;
            iword = iword + 1;  
            word[iword] = '\0';  /* set c-type end to string */    
/*.*/        interpretlistkeyword();
            iword = 0;  /* reset counter for a new word after this one */
        }
    }
    else if(c == '}') ; /*curly brace leaked through, ignore it*/
    else  /* accummulate character in word */
    {
/*c*/    c = tolower(c);  /*make lowercase so case independent */
        word[iword] = c;
        iword = iword + 1;
    }
    ireturn = 1;
   /*if(c == '\015')*//* must hit CR or newline before can get on with vectors*/
    if(c == EOL) /* must hit CR or newline before can get on with vectors*/
    {    /* first line ending stuff */
        ireturn = 0;  /* ends first line */
        if(Lbrot) /*bondrot flag */ 
        {/*bondrot flag */
            if(nblev > 0) /* not just an ending*/
            {   /*set up new bond rotation stuff*/
                Lbondrotscope = 1;           
                nbondrot = nbondrot+1;
                bondrotin[nbondrot]  = angle;
                bondrotout[nbondrot] = angle;
                for(j=0; j<MAXNAMECHAR+1; j++) 
                    bondname[nbondrot][j]=listname[nlist][j];
                bondset[nbondrot][0] = nblev;
                bondset[nbondrot][1] = nxyz+2; /*starting xyz point of scope*/
                bondset[nbondrot][2] = nxyz+2; /*ending xyz point of scope*/
                /*this presumes there will be something attached to rotate*/
                /* the end of scope will be reset later by a bondrot command*/
                bondset[nbondrot][3] = nxyz; /*starting xyz point of bond*/
                bondset[nbondrot][4] = nxyz+1; /*ending xyz point of bond*/
                /*this is the vector of the rotation its points don't change*/
                /*end scope of any previous bondrots if necessary*/
                if(nbondrot > 1)
                    for(j=1; j<nbondrot; j++)
                      if(bondset[j][0] >= nblev)
                        if(bondset[j][2] == bondset[j][1]) /*not ended yet*/
                          bondset[j][2] = nxyz-1;/*ending xyz point of scope*/
                /*set flags so rotated things can be identified */
                igrp[ngrp][6] = 1;    /*and written out*/
                iset[nset][5] = 1;
                ilist[nlist][5] = nbondrot; /* ID tied to specific rotation*/
            }
            else /*Lblev == 0, is just an ending*/
            {    /*end all current bond rotation stuff*/
                for(j=1; j<=nbondrot; j++)
                  if(bondset[j][2] == bondset[j][1]) /*not ended yet*/
                    bondset[j][2] = nxyz-1;/*ending xyz point of scope*/
                Lbondrotscope = 0;
                ilist[nlist][5] = -1; 
                /*flags dummy vectlist that ends rotations*/
                if(Ltest) 
                {
                    sprintf(alertstr,"ilist[ %d ][5] = %d\015"
                                "iset[ %d ][1] = %d, iset[ %d ][2] = %d\015"
                                "igrp[ %d ][1] = %d, igrp[ %d ][2] = %d"
                                ,nlist,ilist[nlist][5]
                                ,nset,iset[nset][1],nset,iset[nset][2]
                                ,ngrp,igrp[ngrp][1],ngrp,igrp[ngrp][2]
                                );
                    dosinglealert(); /*MACDLOG.C*/ /*MPCDLOG.C*/
                }
            }
            Lbrot = 0; /*clear flag*/
        }/*bondrot flag */
        else if(Lbondrotscope)  /*vectorlist imbedded in a rotation*/
        {
            /*set flags so rotated things can be identified and written out*/
            igrp[ngrp][6] = 1;
            iset[nset][5] = 1;
            ilist[nlist][5] = 100; /*flagged >0 but not a separate rotation*/   
            if(Ltest) 
            {
                sprintf(alertstr,"ilist[ %d ][5] = %d\015"
                                "iset[ %d ][1] = %d, iset[ %d ][2] = %d\015"
                                "igrp[ %d ][1] = %d, igrp[ %d ][2] = %d"
                                ,nlist,ilist[nlist][5]
                                ,nset,iset[nset][1],nset,iset[nset][2]
                                ,ngrp,igrp[ngrp][1],ngrp,igrp[ngrp][2]
                                );
                dosinglealert(); /*MACDLOG.C*/ /*MPCDLOG.C*/
            }
        }
        if(Ltest)  /*MAGE_3_2*/
        {
            recondition(groupname[ngrp]);
            recondition(setname[nset]);
            recondition(listname[nlist]);
            sprintf(alertstr,"new list#%d: %s, in subgrp#%d: %s, in group#%d:%s"
               ,nlist,listname[nlist],nset,setname[nset],ngrp,groupname[ngrp]);
            dosinglealert(); /*MACDLOG.C*/ /*MPCDLOG.C*/
            condition(listname[nlist]);
            condition(setname[nset]);
            condition(groupname[ngrp]);
        }
    }
return(ireturn);
}
/*___Vectfirstline()________________________________________________________*/

/****interpretlistkeyword()**************************************************/
void    interpretlistkeyword()
{
/*I*/   /*strncompare(char,char,int)*/
    if(strncompare(word,"off",3) == 0) ilist[nlist][0] = 0;
                                /* starts with display disabled */ 
    if(strncompare(word,"-",1) == 0) ilist[nlist][0] = 0; /*historic*/
    if(strncompare(word,"*",1) == 0) ilist[nlist][0] = 0; /*historic*/
    if(strncompare(word,"nobutton",8) == 0) ilist[nlist][6] = 1;
    if(strncompare(word,"color",5) == 0) icolor = 1;
    if(strncompare(word,"color=",6) == 0)
                                       {(Lcolnam) = 1;icolor = 0;}
    if(strncompare(word,"instance=",9) == 0) Linstance = TRUE;
    if(strncompare(word,"master=",7) == 0) Lmaster = TRUE;
         /* variables with scope of file MAGEVSUB.C: nblev,Lbrot,Lbang*/
    if(strncompare(word,"0bondrot",8) == 0){nblev=0;Lbrot=1;Lbang=0;}
    if(strncompare(word,"1bondrot",8) == 0){nblev=1;Lbrot=1;Lbang=0;}
    if(strncompare(word,"2bondrot",8) == 0){nblev=2;Lbrot=1;Lbang=0;}
    if(strncompare(word,"3bondrot",8) == 0){nblev=3;Lbrot=1;Lbang=0;}
    if(strncompare(word,"4bondrot",8) == 0){nblev=4;Lbrot=1;Lbang=0;}
    if(strncompare(word,"5bondrot",8) == 0){nblev=5;Lbrot=1;Lbang=0;}
    if(strncompare(word,"6bondrot",8) == 0){nblev=6;Lbrot=1;Lbang=0;}
    if(strncompare(word,"7bondrot",8) == 0){nblev=7;Lbrot=1;Lbang=0;}
    if(strncompare(word,"8bondrot",8) == 0){nblev=8;Lbrot=1;Lbang=0;}
    if(strncompare(word,"9bondrot",8) == 0){nblev=9;Lbrot=1;Lbang=0;}
    if(strncompare(word,"face=",5) == 0) Lwordsface = TRUE;
    if(strncompare(word,"font=",5) == 0) Lwordsfont = TRUE;
    if(strncompare(word,"size=",5) == 0) Lwordssize = TRUE;
    if(strncompare(word,"radius=",7) == 0) Lradius = 1;
    if(strncompare(word,"static",6) == 0) 
        ilist[nlist][9] = 1; /*special display flag, static== no rotation*/
}
/*___interpretlistkeyword()_________________________________________________*/

/****addanothervector()******************************************************/
void    addanothervector()
{
        int     j,n,k,ifoundone;
static  int     monitornxyz,monitornxyzold;
        float   xx[4],xxx[4];
        float   fvectorx,fvectory,fvectorz,veclength;
static  float   hereradius,thereradius;

/* duplicate triples are a bit complicated:  if a duplicate move point after*/
/* a draw  P a,b,c   L d,e,f   P d,e,f   L g,h,i   then don't do middle move*/
/*   so in a vectorlist;  if a move duplicates a draw, don't do the move    */
/* if a null vector:  P a,b,c   L a,b,c   then do the pair of move-draw so */
/*                                                    get the point */
/*   so in a vectorlist:  if a draw duplicate a move, do the draw */
/* if the sequence bridges over from one list to another:         */
/*  Vectorlist: P a,b,c   L d,e,f      Dotlist:  P d,e,f         */
/*   so if not a vectorlist:  do all specified moves &  draws         */
/* final logic: if vectorlist and if a move then don't do duplicate */
                     
    /*default radius 0.2, see ___DRAW/balltoscreen()*/
    if(radiuslist[nlist] < .001) hereradius = .2;
    else hereradius = radiuslist[nlist]; /*make local so can override */
                               /*if gets a new radius from a balllist*/
    if(Lvect && igrp[ngrp][9] == 1) /*balllist flag for this group*/ 
    {/*balllist in this group*/
     
      ifoundone = 0;
      for(n=igrp[ngrp][1]; n<=igrp[ngrp][2]; n++)
      {/*check subgroups*/
        if(iset[n][8]==1) /*is a balllist in this subgroup*/
        {/*balllist in this subgroup*/
          for(k=iset[n][1]; k<=iset[n][2];k++)
          {/*check lists*/
            for(j=ilist[k][1]; j<=ilist[k][2];j++)
            {/*check list entries*/
                if( xyz(0,j) == 25)
                {/*a ball*/
                     if(   ( x[1] <= fxyz(0,j)+.001 && x[1] >= fxyz(0,j)-.001)
                        && ( x[2] <= fxyz(1,j)+.001 && x[2] >= fxyz(1,j)-.001)
                        && ( x[3] <= fxyz(2,j)+.001 && x[3] >= fxyz(2,j)-.001) )
                     {
                         Lballhere = 1;
                         Lmustkeeppoint = 1;
                         /*Lunpickable = 1;*/ /*not forced here*/
                         ifoundone = 1;
                         /*default radius 0.2, see ___DRAW/balltoscreen()*/
                         /*already applied to hereradius, if radius not */
                         /* defined for this vectorlist */
                         if(radiuslist[k] > .001) /*radius of ball at point*/ 
                             hereradius = radiuslist[k]; /* override */
                     }
                }/*a ball*/
                if(ifoundone==1) break;
            }/*check list entries*/
            if(ifoundone==1) break;
          }/*check lists*/
        }/*balllist in this subgroup*/
        if(ifoundone==1) break;
      }/*check subgroups*/
    }/*balllist in this group*/
    
    if(!Lmustkeeppoint && !Lnewlist && Lvect && Lmove && (x[1] == x2) && 
                        (x[2] == y2) && (x[3] == z2) )
    {
        ;  /* skip */
    }
    else
    {/*--not duplicate vector-move triple, so enter it */
        /*do point ID stuff first, since might change nxyz to duplicate point*/
        /* ptIDstr holds either the pointID or a blank */
        
/*Mx*/   condition(ptIDstr); /* change to Pascal str for Mac*/

        /* 911110: offset for giant character array */ 
        /*  16*2048=32768  so if nxyz > 2048, icom must be long! */
        /* even worse with (MAXPTIDCHAR+1) which started as 21 */
        /*use pointer arith to avoid using a long integer as an array index:*/
        
        for(n=0; n<MAXPTIDCHAR+1; n++)  /* copy char str to storage */
        {
            icom = (long)(MAXPTIDCHAR+1)*(long)nxyz + (long)n;
            /*pcom() defined differently for Mac and PC */
            pcom1(icom) = ptIDstr[n];  /* see K&R A7.7 pg 205 2nd ed.: */
            /*pointer + integer: integer promoted to make new pointer work*/
            /* for its type*/
        }
        if(Lmustkeeppoint && Lcomment) /*for a comment or wordlist*/
        {
            /*store starting position in index array*/
            pinwordcom( (long)nxyz ) = nwordcom;
            /*store directly in giant character array */
            for(n=0; n<255  ; n++)
            {
                if(nwordcom >= MAXWORDCOM-1) /* 950110 */
                {/*try to allocate more storage and increase MAXWORDCOM*/
                    allocwordcomarray(1000); /*try for 1000 more */
                }
                if(nwordcom < MAXWORDCOM-1) /*insurance */
                {
                    if(n>2 && commentstr[n]=='\0') break;/*put '\0' on later*/
                      /*pwordcom() defined differently for Mac and PC */
                      /*this is really pointer to array start plus nwordcom*/
                    pwordcom( (long)nwordcom ) = commentstr[n];  
                      /* see K&R A7.7 pg 205 2nd ed.: */
                      /*pointer + integer: integer promoted to make */
                      /*new pointer work for its type*/
                    nwordcom++;
                }
            }
            pwordcom((long)nwordcom) = '\0'; /*ends word-comment characters */
            nwordcom++;
/*
 for(n=3;commentstr[n]!='\0';n++) word[n-3]=commentstr[n]; word[n-2]='\0';
 sprintf(alertstr,"store for %d: font: %d, face: %d, size: %d \015%s\015index:%d"
,nxyz, commentstr[0],commentstr[1],commentstr[2],word
,pinwordcom( (long)nxyz )  );
 dosinglealert();        
*/
        }
        else
        {/*no comment or wordlist associated with this point*/
            pinwordcom((long)nxyz) = 0;
        }

        /*Now set flags for this point*/

        /* -1 set so an empty vector list will not try to display*/
        if(ilist[nlist][0] == -1) ilist[nlist][0] = 1; /*turn on*/
        Lnewlist = FALSE;
        if(Lunpickable) n = 1;
        else n = 0;
        if(Label)         xyz(0,nxyz) = 30;    /* label */
        else if(Lword)    xyz(0,nxyz) = 40;     /* words */
        else if(Ldot)     xyz(0,nxyz) = 20;     /* dot   */
        else if(Lball)    xyz(0,nxyz) = 25;     /* ball   */
        else if(Lmove)    xyz(0,nxyz) = 10 + n;     /* move  */
        else              xyz(0,nxyz) =  0 + n;    /* draw  */

/*
sprintf(alertstr,"triple# %d assigned %d",nxyz,xyz(0,nxyz));
dosinglealert(); 
*/                                            
        /*local rotation and centering */
        if(Llocalprecenter)
        {    /*acts like pickcenter*/
             /*use this with x,y,z to do rotation about axis through*/
             /* a point not at 0,0,0 : see Llocalpostcenter below */
             xx[1] = x[1] - fxcenterold[0];
             xx[2] = x[2] - fycenterold[0];
             xx[3] = x[3] - fzcenterold[0];
        }
        else
        {
             xx[1] = x[1];
             xx[2] = x[2];
             xx[3] = x[3];        
        }
        if(Llocalrotation)
        {
            a11 = ma[0][1];
            a12 = ma[0][2];
            a13 = ma[0][3];
            a21 = ma[0][4];
            a22 = ma[0][5];
            a23 = ma[0][6];
            a31 = ma[0][7];
            a32 = ma[0][8];
            a33 = ma[0][9];
            xxx[1] = (xx[1]*a11 + xx[2]*a21 + xx[3]*a31);
            xxx[2] = (xx[1]*a12 + xx[2]*a22 + xx[3]*a32);
            xxx[3] = (xx[1]*a13 + xx[2]*a23 + xx[3]*a33);                
            xx[1] = xxx[1];
            xx[2] = xxx[2];
            xx[3] = xxx[3];
        }
        if(Llocalpostcenter)
        {    /*further recentering, use this with -x,-y,-z to do */
             /* rotation around point x,y,z */
             xx[1] = xx[1] - fxcenterold[MAXRESETS+1];
             xx[2] = xx[2] - fycenterold[MAXRESETS+1];
             xx[3] = xx[3] - fzcenterold[MAXRESETS+1];
        }
        
        
        
        if(xx[1]>=0.0) xyz(1,nxyz) = xx[1] + .5;
        else           xyz(1,nxyz) = xx[1] - .5;
        if(xx[2]>=0.0) xyz(2,nxyz) = xx[2] + .5;
        else           xyz(2,nxyz) = xx[2] - .5;
        if(xx[3]>=0.0) xyz(3,nxyz) = xx[3] + .5;
        else           xyz(3,nxyz) = xx[3] - .5;
                        
        if(Lscale)
        {
            fxyz(0,nxyz) = xx[1];
            if(xx[1] < fxmin) fxmin = xx[1];
            if(xx[1] > fxmax) fxmax = xx[1];
            fxyz(1,nxyz) = xx[2];
            if(xx[2] < fymin) fymin = xx[2];
            if(xx[2] > fymax) fymax = xx[2];
            fxyz(2,nxyz) = xx[3];
            if(xx[3] < fzmin) fzmin = xx[3];
            if(xx[3] > fzmax) fzmax = xx[3];

            nscale = nxyz;
        }
        if( !Lmove && (Lballhere || Lballthere) )
        /*presume a previous move-to point from which to shorten*/
        {/*drawn line needs shortening*/
           n = nxyz; /*current last entry at this point number*/
           if( nxyz+1 >= MAXNUM) /*if wouldn't be able to add another vector */
           {/*try to allocate more storage and increase MAXNUM*/      /*950110*/
               allocdataarrays(1000); /*try for 1000 more coords*/
           }
           if(Lballhere && nxyz+1 < MAXNUM) /*if can add another vector */
           {/*build a new move-to point so can truncate this one*/
                
                nxyz = nxyz + 1;
                fxyz(0,nxyz) = fxyz(0,n);
                fxyz(1,nxyz) = fxyz(1,n);
                fxyz(2,nxyz) = fxyz(2,n);
                xyz(1,nxyz)  = xyz(1,n);
                xyz(2,nxyz)  = xyz(2,n);
                xyz(3,nxyz)  = xyz(3,n);
                
                /*assign new point as a stored point*/
                if(xyz(0,n) ==  1) 
                    if(LBcharflag) xyz(0,nxyz)  = 53; /*unpickable Line L U B*/
                    else           xyz(0,nxyz)  = 51; /*unpickable Line L U  */
                else if(xyz(0,n) ==  0) 
                    if(LBcharflag) xyz(0,nxyz)  = 52; /*  pickable Line L   B*/
                    else           xyz(0,nxyz)  = 50; /*  pickable Line L    */
                   /*50,51,52,53 stored, not displayed, output as L*/
                /*assign the old point as a modifiable, displayable L point*/
                /*if(xyz(0,n) == 1) */
                    xyz(0,n)=3; /*unpickable U */ /*always set this unpickable*/
                /*else xyz(0,n)=2;*//*2,3 displayed draw point, not for output*/
/*
sprintf(alertstr,"new triple# %d assigned %d\015old triple# %d assigned %d"
,nxyz,xyz(0,nxyz),n,xyz(0,n));dosinglealert();            
*/
                for(j=0; j<MAXPTIDCHAR+1; j++)  
                    /* use same point Id for this new point */
                {
                    icom = (long)(MAXPTIDCHAR+1)*(long)nxyz + (long)j;
                    pcom1(icom) = ptIDstr[j]; 
                }
                pinwordcom((long)nxyz)=0;/*no comment for this invented point*/
                Lmove = 1; /*this is now a move for the next point*/
           }

           {/*shorten line between last two entered triples and update*/
               /* n is the number of the last actual input points*/
               fvectorx = fxyz(0,n) - fxyz(0,n-1);
               fvectory = fxyz(1,n) - fxyz(1,n-1);
               fvectorz = fxyz(2,n) - fxyz(2,n-1);
               veclength = sqrt(     fvectorx*fvectorx + 
                                     fvectory*fvectory + 
                                     fvectorz*fvectorz  );
     /*beware of points too close together!*/
     if(  (veclength > 0.000001) /*this protects from divide-by-zero*/
        &&(  ( Lballthere &&  Lballhere && (veclength>thereradius+hereradius))
           ||( Lballthere && !Lballhere && (veclength>thereradius)           )
           ||(!Lballthere &&  Lballhere && (veclength>hereradius)            )
          )
       )
             {/*vector long enough for shortening to be meaningful*/
               /*normalize: */
               fvectorx = fvectorx/veclength;
               fvectory = fvectory/veclength;
               fvectorz = fvectorz/veclength;
               /*add to n-1, subtract from n to make */
               /*shortened line end positions*/
               if(Lballthere)
               { 
                 fxyz(0,n-1) = fxyz(0,n-1) + thereradius*fvectorx;
                 fxyz(1,n-1) = fxyz(1,n-1) + thereradius*fvectory;
                 fxyz(2,n-1) = fxyz(2,n-1) + thereradius*fvectorz;
                 /* reload integer display list */
                 j = n-1;
                 if(fxyz(0,j)>=0.0) xyz(1,j)=fxyz(0,j)+.5;
                 else               xyz(1,j)=fxyz(0,j)-.5;
                 if(fxyz(1,j)>=0.0) xyz(2,j)=fxyz(1,j)+.5;
                 else               xyz(2,j)=fxyz(1,j)-.5;
                 if(fxyz(2,j)>=0.0) xyz(3,j)=fxyz(2,j)+.5;
                 else               xyz(3,j)=fxyz(2,j)-.5;
                 if(xyz(0,j) == 10) xyz(0,j) = 11;
                 if(xyz(0,j) ==  0) xyz(0,j) =  1;
               }
               if(Lballhere)
               {
                 fxyz(0,n) = fxyz(0,n) - hereradius*fvectorx;
                 fxyz(1,n) = fxyz(1,n) - hereradius*fvectory;
                 fxyz(2,n) = fxyz(2,n) - hereradius*fvectorz;
                 /* reload integer display list */
                 j = n;
                 if(fxyz(0,j)>=0.0) xyz(1,j)=fxyz(0,j)+.5;
                 else               xyz(1,j)=fxyz(0,j)-.5;
                 if(fxyz(1,j)>=0.0) xyz(2,j)=fxyz(1,j)+.5;
                 else               xyz(2,j)=fxyz(1,j)-.5;
                 if(fxyz(2,j)>=0.0) xyz(3,j)=fxyz(2,j)+.5;
                 else               xyz(3,j)=fxyz(2,j)-.5;
                 if(xyz(0,j) == 10) xyz(0,j) = 11;
                 if(xyz(0,j) ==  0) xyz(0,j) =  1;
               }
             }/*vector long enough for shortening to be meaningful*/
           }/*shorten line between last two entered triples and update*/
        }/*drawn line needs shortening*/
        if(Lballhere &&  Lmove) /*note creating stored point sets Lmove=1*/
        {/*set up to shorten the vector from here when get drawn-to-point */
            Lballthere = 1;/* flag that line is to be shortened*/
            thereradius = hereradius;
           if( nxyz+1 >= MAXNUM) /*if wouldn't be able to add another vector */
           {/*try to allocate more storage and increase MAXNUM*/      /*950110*/
               allocdataarrays(1000); /*try for 1000 more coords*/
           }
           if( nxyz+1 < MAXNUM) /*if can add another vector */
           {/*build a new move-to point to be truncated later*/
                n = nxyz; /*current last entry at this point number*/
                nxyz = nxyz + 1;
                fxyz(0,nxyz) = fxyz(0,n);
                fxyz(1,nxyz) = fxyz(1,n);
                fxyz(2,nxyz) = fxyz(2,n);
                xyz(1,nxyz)  = xyz(1,n);
                xyz(2,nxyz)  = xyz(2,n);
                xyz(3,nxyz)  = xyz(3,n);
                
                /*assign the new point as a modifiable, displayable P point*/
                xyz(0,nxyz)  = 13; /*unpickable U */
                   /*12,13 displayed move point, not for output*/
                /*assign old point as stored point,*/
                /* flagged by original attributes*/
                if(xyz(0,n) == 11) 
                    if(LBcharflag) xyz(0,n)  = 63; /*unpickable Point P U B*/
                    else           xyz(0,n)  = 61; /*unpickable Point P U  */
                else if(xyz(0,n) == 10) 
                    if(LBcharflag) xyz(0,n)  = 62; /*  pickable Point P   B*/
                    else           xyz(0,n)  = 60; /*  pickable Point P    */
                   /*60,61,62,63 stored, not displayed, output as P*/
                   /*if not 10,11 then P made earlier from an L and set 50-53 */
                /* use same point Id for this new point */
                for(j=0; j<MAXPTIDCHAR+1; j++)  
                {
                    icom = (long)(MAXPTIDCHAR+1)*(long)nxyz + (long)j;
                    pcom1(icom) = ptIDstr[j]; 
                }
                pinwordcom((long)nxyz)=0;/*no comment for this invented point*/
                Lmove = 1; /*this is now a move for the next point*/
           }/*build a new move-to point to be truncated later*/
        }/*set up to shorten the vector from here when get drawn-to-point */
        else Lballthere = 0; /*clears flag in all other cases*/
        Lballhere = 0; /*must be flagged for each point*/
        LBcharflag = 0; /*must be flagged for each point*/

        if(Ltest)
        {
                        
            monitornxyz = nxyz/100;
            if(monitornxyz > monitornxyzold + 4)
            {
/*Mx*/           recondition(ptIDstr);
#if 0                                      /*920619 rmw conditional*/
/*c*/            sprintf(alertstr,
                    "at triple number %d\015index = %ld, text= %s"
                    ,nxyz,com1(icom),ptIDstr); 
                dosinglealert(); /*MACDLOG.C*/ /*MPCDLOG.C*/
#endif
                monitornxyzold = monitornxyz;
            }
        }

        x2 = x[1]; y2 = x[2]; z2 = x[3];

        ilist[nlist][2] = nxyz;    /* current ending vector of this set */
        nxyz++;        /* increment counter for next vector */        
        if(Lplotonly)
        {
            nxyz--;  /* restore counter */
            Lplotpoint = TRUE;
            redrawvec();  /* plot point, point not stored! */
            Lplotpoint = FALSE;
        }                                                             
    }/*--not duplicate vector-move triple, so enter it */

}
/*___addanothervector()_____________________________________________________*/
