                     
#include "MAGE.H"

/****DoMageinitDLOGreport()***************************************************/
void    DoMageinitDLOGreport()
{
    DoMageDLOGreport();
}
/*___DoMageinitDLOGreport()__________________________________________________*/
/****dosinglealert()**********************************************************/
void    dosinglealert()
{
    alertstr2[0] = '\0';
    alertstr3[0] = '\0';
    DoMageDLOGreport();
}
/*___dosinglealert()_________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/ 
/****reportOK_CB**************************************************************/
void reportOK_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{/*remove the report dialog widget from the screen*/
    XtUnmanageChild(reportbox);
    /*clear alertstrs*/
    alertstr[0] = '\0';
    alertstr2[0] = '\0';
    alertstr3[0] = '\0';
}
/*___reportOK_CB_____________________________________________________________*/

/****DoMageDLOGreport()*******************************************************/
void    DoMageDLOGreport()
{                   /*create a dialogbox for reports and alerts, etc */
  static int ireportdialog = 0; /*static to remember if dialog created*/
  XmFontList fontList;

 if(!ireportdialog)
 {/*!ireportdialog*/
  buttonFont =				/* find the font we want for buttons */
    XLoadQueryFont(XtDisplay(topgraf), "-*-Helvetica-Bold-R-Normal--14*");
  if (buttonFont)
    fontList = XmFontListCreate(buttonFont, XmSTRING_DEFAULT_CHARSET);

/*overall reportbox*/
  n = 0; 
  XtSetArg(args[n], XmNvisual, magevisual); n++;
  XtSetArg(args[n], XmNdepth, magedepth); n++;
  XtSetArg(args[n], XmNcolormap, colormap); n++;
  /*now n = 3, all widgets share these first three args */
  XtSetArg(args[n], XmNwidth, 800); n++;
  XtSetArg(args[n], XmNheight, 600); n++;
  XtSetArg(args[n], XmNx, 10); n++;
  XtSetArg(args[n], XmNy, 100); n++;
  XtSetArg(args[n], XmNdialogStyle, XmDIALOG_FULL_APPLICATION_MODAL); n++;
  if (buttonFont) { XtSetArg(args[n], XmNfontList, fontList); n++; }
  reportbox = XmCreateFormDialog(grafwindow,"MAGE",args,n);
  /*XtCreateWidget("MAGE" ,xmRowColumnWidgetClass,grafwindow,args,n);*/
  XtManageChild(reportbox);

/*container for alertstrs and buttons: reports*/
  n = 0; 
  XtSetArg(args[n], XmNvisual, magevisual); n++;
  XtSetArg(args[n], XmNdepth, magedepth); n++;
  XtSetArg(args[n], XmNcolormap, colormap); n++;
  n = 3; 
  XtSetArg(args[n], XmNheight, 400); n++;
  XtSetArg(args[n], XmNwidth, 800); n++;
  XtSetArg(args[n], XmNorientation, XmVERTICAL); n++;
  reports = XtCreateWidget("alerts", xmRowColumnWidgetClass,reportbox,args,n);
  XtManageChild(reports);

/*the 3 alert regions, report1,report2,report3*/
  n = 3;
  XtSetArg(args[n], XmNheight, 100); n++;
  XtSetArg(args[n], XmNwidth, 800); n++;
  report1 = XtCreateWidget("alert1", xmTextWidgetClass,reports,args,n);
  XtManageChild(report1);

  n = 3;
  XtSetArg(args[n], XmNheight, 100); n++;
  XtSetArg(args[n], XmNwidth, 800); n++;
  report2 = XtCreateWidget("alert2", xmTextWidgetClass,reports,args,n);
  XtManageChild(report2);

  n = 3;
  XtSetArg(args[n], XmNheight, 100); n++;
  XtSetArg(args[n], XmNwidth, 800); n++;
  report3 = XtCreateWidget("alert3", xmTextWidgetClass,reports,args,n);
  XtManageChild(report3);

/*container for Proceed and Abort buttons*/
  n = 3; 
  XtSetArg(args[n], XmNheight, 100); n++;
  XtSetArg(args[n], XmNwidth, 800); n++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNorientation, XmHORIZONTAL); n++;
  XtSetArg(args[n], XmNpacking, XmPACK_COLUMN); n++;
  reportbuts=XtCreateWidget("buttons",xmRowColumnWidgetClass,reports,args,n);
  XtManageChild(reportbuts);
/*the 2 buttons */
  n = 3; 
  if (buttonFont) { XtSetArg(args[n], XmNfontList, fontList); n++; }
  reportbutOK = XmCreatePushButton(reportbuts,"Proceed",args,n);
  XtAddCallback(reportbutOK, XmNactivateCallback,  reportOK_CB, NULL); 
  XtManageChild(reportbutOK);

  n = 3; 
  if (buttonFont) { XtSetArg(args[n], XmNfontList, fontList); n++; }
  reportbutabort = XmCreatePushButton(reportbuts,"Abort Program",args,n);
  XtAddCallback(reportbutabort, XmNactivateCallback,  quit_CB, NULL); 
  XtManageChild(reportbutabort);

  ireportdialog = 1;
 }/*!ireportdialog*/
 else
 {
     XtManageChild(reportbox);
 }

  XmTextReplace(report1, 0, XmTextGetLastPosition(report1), alertstr);
  XmTextReplace(report2, 0, XmTextGetLastPosition(report2), alertstr2);
  XmTextReplace(report3, 0, XmTextGetLastPosition(report3), alertstr3);
}
/*___DoMageDLOGreport()______________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/ 
