                      /*MUX_MENU.C*/
#include "MAGE.H"

/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****mycheckitem()********************************************************/
void    mycheckitem(Widget themenu, Widget theitem, int thestate)
{                                  /*common name: MAC & PC & UNIX*/
    XmToggleButtonSetState(theitem, thestate, 0);
     /* 0: don't generate a callback*/
}
/*___mycheckitem()_______________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****checkcurrentviewmenu()**************************************************/
void  checkcurrentviewmenu(int i)
{
    int icheck,imark;
    Widget theItem;
    
    /*awful code since Widgets individually named, not enumerated*/
    for(icheck = 1; icheck <= MAXRESETS; icheck++)
    {
        if(icheck== i) imark = 1;
        else imark = 0;
        if(icheck==1)      theItem = reset1Item;
        else if(icheck==2) theItem = reset2Item;
        else if(icheck==3) theItem = reset3Item;
        else if(icheck==4) theItem = reset4Item;
        else if(icheck==5) theItem = reset5Item;
        else if(icheck==6) theItem = reset6Item;
        else if(icheck==7) theItem = reset7Item;
        else if(icheck==8) theItem = reset8Item;
        else if(icheck==9) theItem = reset9Item;
        else if(icheck==10) theItem = resetRItem;
        XmToggleButtonSetState(theItem, imark, 0);
    }
}
/*___checkcurrentviewmenu()_________________________________________________*/

/****checkmarkmenu()*********************************************************/
void  checkmarkmenu(int ion,MenuHandle menu, Widget item, int iredraw)
{
    XmToggleButtonSetState(item, ion, 0);
}
/*___checkmarkmenu()________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****resetmenuchecks()************************************/
void    resetmenuchecks()
{
#ifdef UNDEFINED
printf("about to resetmenuchecks  in MUX_MENU.c\n");
printf("about to resetmenuchecks of drawlineItem to %d in MUX_MENU.c\n"
,Ldrawline);
printf("about to resetmenuchecks of superpickItem in MUX_MENU.c\n");
printf("about to resetmenuchecks of pickshowItem in MUX_MENU.c\n");
printf("about to resetmenuchecks of pruneItem in MUX_MENU.c\n");
printf("did resetmenuchecks  in MUX_MENU.c\n");
#endif
    XmToggleButtonSetState( (Widget)drawlineItem,Ldrawline, 0);
    XmToggleButtonSetState( superpickItem, Lsuperpick, 0);
    XmToggleButtonSetState( pickshowItem, Lpickshow, 0);
    XmToggleButtonSetState( pruneItem, Lprune, 0);

    XmToggleButtonSetState( widthItem, Lonewidth, 0);
    XmToggleButtonSetState( thinItem, Lthin, 0);
    XmToggleButtonSetState( perspecItem, Lperspec, 0);
    XmToggleButtonSetState( whtbkgItem, Lwhitebkg, 0);
    XmToggleButtonSetState( stereoItem, Lstereo, 0);
    XmToggleButtonSetState( compareItem, Lcompareon, 0);
    XmToggleButtonSetState( measureItem, Lmeasures, 0);

    XmToggleButtonSetState( xyzpointItem, Lxyzpoint, 0);
    XmToggleButtonSetState( gnomonItem, Lgnomon, 0);
    XmToggleButtonSetState( rateItem, Lrate, 0);
    XmToggleButtonSetState( testItem, Ltest, 0);
    XmToggleButtonSetState( plotonlyItem, Lplotonly, 0);

         AdjustMenus();
}
/*___resetmenuchecks()___________________________________*/




/****fileok_CB****************************************************************/
void fileok_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
/*     Widget w;                       */
/*     caddr_t client_data;            */
/*     XmAnyCallbackStruct *call_data; */
{
  char *filename;
  int  j;

  /*See D.A.Young,1994,pg239*/
  
  
  XmFileSelectionBoxCallbackStruct *cbs =                           
                     (XmFileSelectionBoxCallbackStruct *)call_data; 
  XtUnmanageChild(w); /*remove the file dialog widget from the screen*/
  /*retrieve the filename character string from the compound string format*/
  XmStringGetLtoR(cbs->value, XmSTRING_DEFAULT_CHARSET, &filename);
      /*NameStr[256] is declared in MAGE.H*/
  for(j=0; j<256; j++)
  {
      NameStr[j] = filename[j];
      if(NameStr[j]=='\0') break;
  }
  Lnewfile = 1; /*flag that new file name is available*/
}
/*___fileok_CB_______________________________________________________________*/

/****filecancel_CB************************************************************/
void filecancel_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    /*See D.A.Young,1994,pg240*/
    XtUnmanageChild(w); /*remove the file dialog widget from the screen*/
    Lnewfile = 0; /*flag that new file name is NOT available*/
}
/*___filecancel_CB___________________________________________________________*/

/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/

/****open_CB******************************************************************/
void open_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    /*See D.A.Young,1994,pg238*/
    static Widget dialog = NULL; /*static to remember if dialog created*/

    ireturnflag = 1;
    /*if(Lpruneactive||Ldrawactive) DoChangeCheckDialog();*/
         /*check dialog sets ireturnflag*/
    if(ireturnflag)
    {
        if(!dialog)
        {/*first time: create dialog*/
  n = 0;
  XtSetArg(args[n], XmNvisual, magevisual); n++;
  XtSetArg(args[n], XmNdepth, magedepth); n++;
  XtSetArg(args[n], XmNcolormap, colormap); n++;

            dialog = 
               XmCreateFileSelectionDialog(grafwindow,"openFileDialog",args,n);
            XtAddCallback(dialog, XmNokCallback, fileok_CB, NULL);
            XtAddCallback(dialog, XmNcancelCallback, filecancel_CB, NULL);
        }
        XtManageChild(dialog); /*puts the file dialog widget on screen */
    }
}
/*___open_CB_________________________________________________________________*/

/****quit_CB******************************************************************/
void quit_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    if (call_data->reason == XmCR_ACTIVATE)
    {
       ireturnflag = 1; /*common, to allow multi-step dialog handling*/
       /*if(Lpruneactive||Ldrawactive) DoChangeCheckDialog();*/
           /*check dialog sets ireturnflag*/
       if(ireturnflag) done = True; /* event processing exit flag*/
           /*Get_events will stop processing events*/
    }
}
/*___quit_CB_________________________________________________________________*/

/****alert_CB()***************************************************************/
void alert_CB(Widget alertButton,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
     setMageinitDLOGreport(); /*message*/  /*MAGEINIT.C*/
     DoMageinitDLOGreport(); /*MUX_DLOG.c */
}
/*___alert_CB()______________________________________________________________*/

/****option_CB()**************************************************************/
void option_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
   /*reportwindow();*/
   Lwhitebkg = !Lwhitebkg;
   ;
}
/*___option_CB()_____________________________________________________________*/

/****dummy_CB()***************************************************************/
void dummy_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    ;
}
/*___dummy_CB()______________________________________________________________*/

/****writeabout_CB()**********************************************************/
void writeabout_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    menuaboutwrite(); /*MAGEUTIL*/
}
/*___writeabout_CB()_________________________________________________________*/

/****editabout_CB()**********************************************************/
void editabout_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    menuaboutedit(); /*MAGEUTIL*/
}
/*___editabout_CB()_________________________________________________________*/

/****next_CB()****************************************************************/
void next_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
   getnextkinemage(); /*MAGEFILE.C*/
}
/*___next_CB()_______________________________________________________________*/

/****choose_CB()**************************************************************/
void choose_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    ireturnflag = 1;
    if(Lpruneactive||Ldrawactive) DoChangeCheckDialog();
    if(ireturnflag)
    {
         DokineDialog();  /*MACDLOG.C*/ /*MPCDLOG.C*/
    }
        /*getkinemagechoice();*/
       /*MAGEUTIL->mesvmotf/DokineDialog(),->MAGEFILE/findkinemage()*/
       /*findkinemage() has to be called from late callback routines */
}
/*___choose_CB()_____________________________________________________________*/

/****optionsabout_CB()********************************************************/
void optionsabout_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    menuaboutoptions(); /*MAGEUTIL*/
}
/*___optionsabout_CB()_______________________________________________________*/

/****width_CB()***************************************************************/
void width_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
   setwidthtoggle();  /*MAGEUTIL.c*/
}
/*___width_CB()______________________________________________________________*/

/****thin_CB()****************************************************************/
void thin_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
   setthinline();   /*MAGEUTIL.c*/
}
/*___thin_CB()_______________________________________________________________*/

/****perspec_CB()*************************************************************/
void perspec_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
   setperspec();   /*MAGEUTIL.c*/
}
/*___perspec_CB()____________________________________________________________*/

/****whtbkg_CB()**************************************************************/
void whtbkg_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
   setwhtbkg(); /*MAGEUTIL.C*/
}
/*___whtbkg_CB()_____________________________________________________________*/

/****B_W_CB()*****************************************************************/
void B_W_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    /*if color possible, UNIX just fakes a B&W monitor*/
    Lcolor=!Lcolor;
    mycheckitem(optiMenu, B_WItem, !Lcolor);
    if(!Lcolor) Lwhitebkg = 1;
    mycheckitem(optiMenu, whtbkgItem, Lwhitebkg);
}
/*___B_W_CB()________________________________________________________________*/

/****view1_CB()***************************************************************/
void view1_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    resetrot(1);   /*MAGEANGL.C*/
#ifdef UNIX_PEX
    resetalltransformations(); /*MUXPHIG.c*/
    knobmotionhandler();       /*MUXPHIG.c*/
#endif
    redrawvec();   /*___DRAW.c*/
}
/*___view1_CB()______________________________________________________________*/

/****view2_CB()***************************************************************/
void view2_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
   resetrot(2);
#ifdef UNIX_PEX
   resetalltransformations(); /*MUXPHIG.c*/
   knobmotionhandler();       /*MUXPHIG.c*/
#endif
   redrawvec();
}
/*___view2_CB()______________________________________________________________*/

/****view3_CB()***************************************************************/
void view3_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
   resetrot(3);
#ifdef UNIX_PEX
   resetalltransformations(); /*MUXPHIG.c*/
   knobmotionhandler();       /*MUXPHIG.c*/
#endif
   redrawvec();
}
/*___view3_CB()______________________________________________________________*/

/****view4_CB()***************************************************************/
void view4_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
   resetrot(4);
#ifdef UNIX_PEX
   resetalltransformations(); /*MUXPHIG.c*/
   knobmotionhandler();       /*MUXPHIG.c*/
#endif
   redrawvec();
}
/*___view4_CB()______________________________________________________________*/

/****view5_CB()***************************************************************/
void view5_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
   resetrot(5);
#ifdef UNIX_PEX
   resetalltransformations(); /*MUXPHIG.c*/
   knobmotionhandler();       /*MUXPHIG.c*/
#endif
   redrawvec();
}
/*___view5_CB()______________________________________________________________*/

/****view6_CB()***************************************************************/
void view6_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
   resetrot(6);
#ifdef UNIX_PEX
   resetalltransformations(); /*MUXPHIG.c*/
   knobmotionhandler();       /*MUXPHIG.c*/
#endif
   redrawvec();
}
/*___view6_CB()______________________________________________________________*/

/****view7_CB()***************************************************************/
void view7_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
   resetrot(7);
#ifdef UNIX_PEX
   resetalltransformations(); /*MUXPHIG.c*/
   knobmotionhandler();       /*MUXPHIG.c*/
#endif
   redrawvec();
}
/*___view7_CB()______________________________________________________________*/

/****view8_CB()***************************************************************/
void view8_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
   resetrot(8);
#ifdef UNIX_PEX
   resetalltransformations(); /*MUXPHIG.c*/
   knobmotionhandler();       /*MUXPHIG.c*/
#endif
   redrawvec();
}
/*___view8_CB()______________________________________________________________*/

/****view9_CB()***************************************************************/
void view9_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
   resetrot(9);
#ifdef UNIX_PEX
   resetalltransformations(); /*MUXPHIG.c*/
   knobmotionhandler();       /*MUXPHIG.c*/
#endif
   redrawvec();
}
/*___view9_CB()______________________________________________________________*/

/****viewR_CB()***************************************************************/
void viewR_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
   resetrot(10);
#ifdef UNIX_PEX
   resetalltransformations(); /*MUXPHIG.c*/
   knobmotionhandler();       /*MUXPHIG.c*/
#endif
   redrawvec(); 
}
/*___viewR_CB()______________________________________________________________*/

/****otherabout_CB()********************************************************/
void otherabout_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    menuaboutOther(); /*MAGEUTIL*/
}
/*___otherabout_CB()_______________________________________________________*/


/****stereo_CB()**************************************************************/
void stereo_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
     setstereo();  /*MAGEUTIL.C*/
}
/*___stereo_CB_______________________________________________________________*/

/****compare_CB()*************************************************************/
void compare_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
     setcompare();  /*MAGEUTIL.C*/
}
/*___compare_CB______________________________________________________________*/

/****measure_CB()*************************************************************/
void measure_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
     int   k;
   
     setmeasures(); 

#ifdef UNIX_PEX
     setpexmeasures();
#endif /*UNIX_PEX*/

     SetsinGrafWindow(); /*deal with measures toggle button*/
}
/*___measure_CB()____________________________________________________________*/

/****search_CB()*************************************************************/
void search_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
     /*DoSearchDialog();*/  /*___DLOG.c*/
   ;
}
/*___search_CB______________________________________________________________*/

/****readersview_CB()*********************************************************/
void readersview_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
     sprintf(viewcom[MAXRESETS],"Reader's View");
     sprintf(temps,"%s",viewcom[MAXRESETS]);
     condition(temps);
     /*SetItem(viewMenu,MAXRESETS,(unsigned char *)temps);*/

     setrotview(MAXRESETS); /*MAXRESETS==reader's view*/ /*MAGEANGL.C*/
     AdjustMenus(); /*MACMENU.C*/
}
/*___readersview_CB__________________________________________________________*/

/****kludgesabout_CB()********************************************************/
void kludgesabout_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
   menuaboutkluges(); /*MAGEUTIL.c*/
}
/*___kludgesabout_CB_________________________________________________________*/

/****GFont_CB()********************************************************/
void GFont_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    ; /*DoSetgraffontsDialog(); */  /*___DLOG.c*/
}
/*___GFont_CB_________________________________________________________*/

/****sterang_CB()********************************************************/
void sterang_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    ; /*DostereoDialog(); */  /*___DLOG.c*/
}
/*___sterang_CB_________________________________________________________*/

/****xyzpoint_CB()********************************************************/
void xyzpoint_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    setxyzpoint();       /*MAGEUTIL.C*/
}
/*___xyzpoint_CB_________________________________________________________*/

/****gnomon_CB()********************************************************/
void gnomon_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    setgnomon();       /*MAGEUTIL.C*/
}
/*___gnomon_CB_________________________________________________________*/

/****brotangle_CB()********************************************************/
void brotangle_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    reinitialbondrots();       /*MAGEANGL.C*/
}
/*___brotangle_CB_________________________________________________________*/

/****count_CB()********************************************************/
void count_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
   ;/* Lcount = 1;*/ /*tested in mainloop in ___MAIN.C */
}
/*___count_CB_________________________________________________________*/

/****rate_CB()********************************************************/
void rate_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    setrate();       /*MAGEUTIL.C*/
}
/*___rate_CB_________________________________________________________*/

/****test_CB()********************************************************/
void test_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    settest();       /*MAGEUTIL.C*/
}
/*___test_CB_________________________________________________________*/

/****secret_CB()********************************************************/
void secret_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    menuaboutsecrets();       /*MAGEUTIL.C*/
}
/*___secret_CB_________________________________________________________*/

/****plotonly_CB()********************************************************/
void plotonly_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    setplotonly(); /*kalide*/      /*MAGEUTIL.C*/
}
/*___plotonly_CB_________________________________________________________*/

/****helpabout_CB()********************************************************/
void helpabout_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    menuabouthelp();    /*MAGEUTIL.C*/
}
/*___helpabout_CB_________________________________________________________*/

/****mousehelp_CB()********************************************************/
void mousehelp_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    menuaboutmouse();    /*MAGEUTIL.C*/
}
/*___mousehelp_CB_________________________________________________________*/

/****resizehelp_CB()********************************************************/
void resizehelp_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    menuaboutresize();    /*MAGEUTIL.C*/
}
/*___resizehelp_CB_________________________________________________________*/

/****drawArea_CB()************************************************************/
void drawArea_CB(Widget drawArea,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
  if (call_data->reason == XmCR_EXPOSE)
#ifdef UNDEFINED
    predraw_all_structs(WS, PFLAG_ALWAYS);
#endif
    redrawvec();
;
    /*redraws all structures on the workstation*/
}
/*___drawArea_CB_____________________________________________________________*/

/****resize_CB()**************************************************************/
void resize_CB(Widget drawArea,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
  if (call_data->reason == XmCR_RESIZE)
  {
     ;
  }
}
/*___resize_CB()_____________________________________________________________*/

/****kinecancel_CB************************************************************/
void kinecancel_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    Lcancel = 1; /* flag to not do anything */
    XtUnmanageChild(kinebox);/*remove the kine dialog widget from the screen*/
}
/*___kinecancel_CB___________________________________________________________*/

/****kinenext_CB**************************************************************/
void kinenext_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    nextkinenum = kinemagenum;
            /* There is a next number known*/
    Lnextkine = 1;  /* take whatever is next */
    Lcancel = 0; 
    XtUnmanageChild(kinebox);/*remove the kine dialog widget from the screen*/
    findkinemage();  /*MAGEFILE.C*/
}
/*___kinenext_CB_____________________________________________________________*/

/****kineOK_CB****************************************************************/
void kineOK_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    nextkinenum = intpass; /*set the next number to that in global storage*/
    Lnextkine = 0; /* do not just take whatever is next*/
    Lcancel = 0; 
    XtUnmanageChild(kinebox);/*remove the kine dialog widget from the screen*/
    /*however, findkinemage() as called in MAC and PC expects to find */
    /* nextkinenum held as a character string in "word" */
    sprintf(word,"%d",nextkinenum);
    findkinemage();  /*MAGEFILE.C*/
}
/*___kineOK_CB_______________________________________________________________*/

/****kinenumber_CB************************************************************/
void kinenumber_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    char *ins;

    ins = XmTextGetString(kinenum);
    intpass = intfromstr(ins); /*mageutil.c*/ /*set the next number*/
    /*intpass global integer*/
}
/*___kinenumber_CB___________________________________________________________*/

 
/****DokineDialog()***********************************************************/
void    DokineDialog()
{                   /*create a dialogbox for choose kinemage */
  static int ikinedialog = 0; /*static to remember if dialog created*/
  XmFontList fontList;

 if(!ikinedialog)
 {/*!ikinedialog*/
  buttonFont =				/* find the font we want for buttons */
    XLoadQueryFont(XtDisplay(topgraf), "-*-Helvetica-Bold-R-Normal--14*");
  if (buttonFont)
    fontList = XmFontListCreate(buttonFont, XmSTRING_DEFAULT_CHARSET);
  n = 0; 
  XtSetArg(args[n], XmNvisual, magevisual); n++;
  XtSetArg(args[n], XmNdepth, magedepth); n++;
  XtSetArg(args[n], XmNcolormap, colormap); n++;
  XtSetArg(args[n], XmNwidth, 300); n++;
  XtSetArg(args[n], XmNheight, 200); n++;
  XtSetArg(args[n], XmNx, 10); n++;
  XtSetArg(args[n], XmNy, 100); n++;
  if (buttonFont) { XtSetArg(args[n], XmNfontList, fontList); n++; }
  kinebox = XtCreateWidget("choose", xmRowColumnWidgetClass,grafwindow,args,n);
  XtManageChild(kinebox);
  n = 0; 
  XtSetArg(args[n], XmNvisual, magevisual); n++;
  XtSetArg(args[n], XmNdepth, magedepth); n++;
  XtSetArg(args[n], XmNcolormap, colormap); n++;
  XtSetArg(args[n], XmNorientation, XmHORIZONTAL); n++;
  kinerow = XtCreateWidget("num", xmRowColumnWidgetClass,kinebox,args,n);
  XtManageChild(kinerow);
  n = 0; 
  XtSetArg(args[n], XmNvisual, magevisual); n++;
  XtSetArg(args[n], XmNdepth, magedepth); n++;
  XtSetArg(args[n], XmNcolormap, colormap); n++;
  if (buttonFont) { XtSetArg(args[n], XmNfontList, fontList); n++; }
  XtSetArg(args[n], XmNlabelString,
	   XmStringCreate("Enter kinemage number",
			  XmSTRING_DEFAULT_CHARSET)); n++;
  kinemsg = XtCreateWidget("msg", xmLabelGadgetClass,kinerow,args,n);
  XtManageChild(kinemsg);
  n = 0; 
  XtSetArg(args[n], XmNvisual, magevisual); n++;
  XtSetArg(args[n], XmNdepth, magedepth); n++;
  XtSetArg(args[n], XmNcolormap, colormap); n++;
  kinenum = XtCreateWidget("num", xmTextWidgetClass,kinerow,args,n);
  XtAddCallback(kinenum, XmNvalueChangedCallback,  kinenumber_CB, NULL); 
  XtManageChild(kinenum);
  n = 0; 
  XtSetArg(args[n], XmNvisual, magevisual); n++;
  XtSetArg(args[n], XmNdepth, magedepth); n++;
  XtSetArg(args[n], XmNcolormap, colormap); n++;
  kinenow = XtCreateWidget("now", xmTextWidgetClass,kinebox,args,n);
  XtManageChild(kinenow);

  n = 0; 
  XtSetArg(args[n], XmNvisual, magevisual); n++;
  XtSetArg(args[n], XmNdepth, magedepth); n++;
  XtSetArg(args[n], XmNcolormap, colormap); n++;
  XtSetArg(args[n], XmNorientation, XmHORIZONTAL); n++;
  XtSetArg(args[n], XmNpacking, XmPACK_COLUMN); n++;
  kinebut = XtCreateWidget("but", xmRowColumnWidgetClass,kinebox,args,n);
  XtManageChild(kinebut);
  n = 0; 
  XtSetArg(args[n], XmNvisual, magevisual); n++;
  XtSetArg(args[n], XmNdepth, magedepth); n++;
  XtSetArg(args[n], XmNcolormap, colormap); n++;
  if (buttonFont) { XtSetArg(args[n], XmNfontList, fontList); n++; }
  kinebutok = XmCreatePushButtonGadget(kinebut,"OK",args,n);
  XtAddCallback(kinebutok, XmNactivateCallback,  kineOK_CB, NULL); 
  XtManageChild(kinebutok);
  n = 0; 
  XtSetArg(args[n], XmNvisual, magevisual); n++;
  XtSetArg(args[n], XmNdepth, magedepth); n++;
  XtSetArg(args[n], XmNcolormap, colormap); n++;
  if (buttonFont) { XtSetArg(args[n], XmNfontList, fontList); n++; }
  kinebutnext = XmCreatePushButtonGadget(kinebut,"Next",args,n);
  XtAddCallback(kinebutnext, XmNactivateCallback,  kinenext_CB, NULL); 
  XtManageChild(kinebutnext);
  n = 0; 
  XtSetArg(args[n], XmNvisual, magevisual); n++;
  XtSetArg(args[n], XmNdepth, magedepth); n++;
  XtSetArg(args[n], XmNcolormap, colormap); n++;
  if (buttonFont) { XtSetArg(args[n], XmNfontList, fontList); n++; }
  kinebutcan = XmCreatePushButtonGadget(kinebut,"Cancel",args,n);
  XtAddCallback(kinebutcan, XmNactivateCallback,  kinecancel_CB, NULL); 
  XtManageChild(kinebutcan);

  ikinedialog = 1;
 }/*!ikinedialog*/
 else
 {
     XtManageChild(kinebox);
 }

  sprintf(word,"This kinemage: %d, next: %d",
                  thiskinenum,kinemagenum); /*920619 dcr*/
     /*Note: thiskinemage is the current number*/
     /* kinemagenum is the next "number" found when this current*/
     /* one was terminated by reaching @kinemage "number" */
  XmTextReplace(kinenow, 0, XmTextGetLastPosition(kinenow), word);
  intpass = 0; /*global storage for an integer*/
  sprintf(word,"%d",intpass);
  XmTextReplace(kinenum, 0, XmTextGetLastPosition(kinenum), word);


}
/*___DokineDialog()__________________________________________________________*/

/****showthegrafwindow()******************************************************/
void showthegrafwindow()
{
    XRaiseWindow(XtDisplay(topgraf),topgraf);
}
/*___showthegrafwindow()_____________________________________________________*/
/*MUX_MENU.c*/
