/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/*MAGE.H decalrations for all mage files: */
/*   invokes include MAGE.HDR with subroutine and function prototypes*/
/*  main defines EXTERN as nothing ( "" ), so really does the declarations */
/* if EXTERN not defined, then it is defined as "extern"  so only referenced*/
/*   thus declarations are idempotent */
/*The specific compiler for each computer defines its own name control */
/*e.g. for Mac: THINK_C defined; for PC __BORLANDC__ defined */
/*  Beware of this for different compilers, different platforms*/
/* The Weiss Borland Workshop resource compiler chokes on*/
/* function declarations; thus all function declarations are kept in */
/* MAGE.HDR (invoked at end of this file) */
/*           (this is a useful distinction anyway) */
/* Furthermore, the Richardson Borland Workshop can't find standard */
/* includes; so all variables needed for menus and dialogs are kept */
/* in magemenu.h, PCWmage.rc just #includes MAGEMENU.H */
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/

/*#include "MAGEMENU.H"*/  /*separate MENU & DIALOG defined variables*/
/*#include "MAGE.HDR" */ /*these includes are at the end of this mage.h file*/

/*JULY 93 merge of MAGE and EGAM:  force a definition here, and all files */
/* will be recompiled! */

/*#define EGAM*/     /*comment out this definition for MAGE! */

/*#define UNIXMPESV */ /*unix X, motif, phigs, E&S esv*/
    /*don't know a compiler specifc flag for these */
#define UNIX_X11      /* unix X11 */
#define UNIX_MOTIF    /* unix motif */
/*#define UNIX_PEX */     /* unix PEX (phigs) */
/*#define UNIX_GL  */     /* unix GL (SGI) */
/*#define UNIX_OGL */     /* unix OpenGL (SGI+others) */
/*#define UNIX_ESV */     /* unix ESV (E&S special extensions, mainly to PEX) */

#ifdef THINK_C              /*compiler specific*/
#define MACINTOSH
#undef PCWINDOWS
#undef UNIXMPESV
#undef UNIX_X11  /* unix X11 */
#undef UNIX_MOTIF    /* unix motif */
#undef UNIX_PEX    /* unix PEX (phigs) */
#undef UNIX_GL   /* unix GL (SGI) */
#undef UNIX_OGL  /* unix OpenGL (SGI+others) */
#undef UNIX_ESV  /* unix ESV (E&S special extensions, mainly to PEX) */
#endif

#ifdef __BORLANDC__         /*compiler specific*/
#define PCWINDOWS
#undef MACINTOSH
#undef UNIXMPESV
#undef UNIX_X11  /* unix X11 */
#undef UNIX_MOTIF    /* unix motif */
#undef UNIX_PEX    /* unix PEX (phigs) */
#undef UNIX_GL   /* unix GL (SGI) */
#undef UNIX_OGL  /* unix OpenGL (SGI+others) */
#undef UNIX_ESV  /* unix ESV (E&S special extensions, mainly to PEX) */
#endif

#ifdef EXTERN
#undef EXTERN
#define EXTERN
#define MAGE_INIT
#else
#define EXTERN extern
#endif


#ifdef MACINTOSH
#include <MacHeaders>
#include <GestaltEqu.h>
#include <AppleEvents.h>
#include <Palette.h>
#endif /*MACINTOSH*/

#ifdef PCWINDOWS
#include <windows.h>
#include <string.h>
#include <time.h>
#include <io.h>
#include <fcntl.h>
  #ifndef _MAX_PATH
    #define _MAX_PATH 80
  #endif
#endif /*PCWINDOWS*/

#ifdef UNIX_X11
#include <string.h>
#include <X11/Xlib.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#endif  /*UNIX_X11*/

 
/* common include files: */
#include <stdio.h>
/*#include <stdlib.h>*/
#include <math.h>

#ifdef UNIX_MOTIF
#include <Xm/Xm.h> /*grafwindow*/
#include <Xm/Form.h> /*grafwindow*/
#include <Xm/DrawingA.h> /*actual drawing region*/
#include <Xm/PushB.h>
#include <Xm/PushBG.h>
#include <Xm/RowColumn.h> /*menuBar widget*/
#include <Xm/CascadeB.h> /*for individual menus */
#include <Xm/MessageB.h>
#include <Xm/ToggleB.h> /*for button boxes on screen */
#include <Xm/ToggleBG.h> /*for button boxes on screen */
#include <Xm/Text.h>
#include <Xm/FileSB.h>
#include <Xm/ScrolledW.h>
#include <Xm/ScrollBar.h>
#include <Xm/Label.h>
#include <Xm/LabelG.h>
#endif /*UNIX_MOTIF*/


#ifdef UNIX_X11
#define TRUE    1
#define FALSE   0
typedef Widget  MenuHandle;
typedef Widget  ControlHandle;
typedef Widget  WindowPtr;
#define XTR     dpy,offscreen,offgc,it(1,i),it(2,i),
#define LineTo  XDrawLine
EXTERN   struct brect { int left; int top; int right; int bottom;} brect ;
#define getnextchar() getc(fp)   
#endif  /*UNIX_X11*/

#ifdef UNIX_X11      /*MAGE_4.0 great redo of all DLOG reports*/
#define CRLF "\012"  /* \n, use CRLF outside of "..." in sprintf */
#define EOL    012   /*octal 012, hex A, use as a character: if(c == EOL)...*/
#else
#define CRLF "\015"  /* \r, use CRLF outside of "..." in sprintf */
#define EOL    015   /*octal 015, hex D, decimal 13 */
#endif


   /* array sizes */
/*#define MAXNUM    3500*/ /* total number of move triplets & draw triplets */
/*#define MAXDRAWS  3500*/ /* maximum number of 2-D Move-Draws displayable */
/*MAXNUM MAXDRAWS not used now in compilation, size can be a run time choice*/

#define MAXG       151        /* -1 = number of groups, index 1,...,MAXG */
#define MAXS       151        /* -1 = number of subgroups, index 1,...,MAXS */
#define MAXL       201        /* -1 = number of lists, index 1,...,MAXL */
                /*beware! if this >255 get in trouble with wordsfont, etc.*/
#define MAXM   8*((int)sizeof(long)) + 1 /*32?, # of master button boxes, old 51*/
#define MAXXG       17  /*number of extra groups: markers,measures,drawgroup*/
#define MAXRESETS   10  /*number of resets (matrix,zoom,centering) views */
#define MM_BUTTONINDEX  10000  /*PC index to define buttons as menu commands*/
#define MAXBONDROT  10  /*number of bond rotations provided*/
#define MAXQUESTIONS  101  /*number of questions for hypertext mode*//*931108*/
#define MAXQCHAR       25  /*number of characters in an answer */ /*931108*/
   /*this can effect, e.g., text char counter in MAGETEXT.C*/
#define MAXNAMECHAR    12 /*# char excluding terminator of group,etc names*/
#define MAXPTIDCHAR    20 /*# char excluding terminator of point ID */
                          /*orig 15, change to 20 9412*/
#define MAXVIEWIDCHAR  15 /*# char excluding terminator of view ID */

#define  xyz(i,j)    xyz[i][j]
#define fxyz(i,j)   fxyz[i][j]
#define   it(i,j)     it[i][j]
#define  com1(i)     (com+i)
#define pcom1(i)    *(com+i)
#define  com2(i)     com[i] 
#define  pinwordcom(i)  *(inwordcom+i)
#define    pwordcom(i)    *(wordcom+i)

/*---------------allocated big storage arrays-------------------------------*/
  /* these arrays may be defined differently in different machines*/
EXTERN    int      *xyz[5];  /* array of pointers, for xyz[5][MAXNUM] */
     /*integer_flag,x,y,z,int_color internal data list */

EXTERN    char     *com;
     /* pointer to start of 2D array com[MAXNUM][MAXPTIDCHAR+1]*/
     /* PointID for each x,y,z;  (MAXPTIDCHAR==15 originally, later==20) */

EXTERN    float    *fxyz[3];    /* array of pointers, for fxyz[3][MAXNUM] */
     /* original floating pt coords, except as modified during input */

EXTERN    int      *it[8];      /* array of pointers, for it[8][MAXDRAWS] */
     /* internal 2-D display list, regenerated by display loop: MAGEDRAW.C*/

EXTERN    int   *inwordcom; /*pointer to start of index into wordcom array*/
                                /* limited to MAXNUM */
EXTERN   char   *wordcom;    /* pointer to start of array of text char */
                                /* limited to MAXWORDCOM */

#ifdef MACINTOSH
  /*Mac specific definitions*/
  #define XTR
  #define getnextchar() getc(fp)   
  #define filerewind() rewind(fp)
  #define ARRAYSDONE
#endif /*MACINTOSH*/

#ifdef PCWINDOWS
  #define TEXTLENGTH 0
  #define TEXTLINESTOTAL 4
  #define TEXTLINECURRENT 8
  #define TEXTHANDLE 12
  #define TEXTLINESTARTHANDLE 14
  #define TEXTSCROLLBARHANDLE 16

  EXTERN HANDLE ghtextbuf; /* handle for "text" accumulation buffer */
  EXTERN int textsize; /* size of "text" accumulation buffer */
  EXTERN int textuse; /* amount of "text" accumulation buffer in use */
  EXTERN HANDLE ghcaptsbuf; /* handle for caption accumulation buffer */
  EXTERN int captssize; /* size of caption accumulation buffer */
  EXTERN int captsuse; /* amount of caption accumulation buffer in use */

  #define ARRAYSDONE
  #define XTR cDC,   /*the comma is part of the definition*/
         /* extra field needed in PC MoveTo, DrawTo commands */
#endif /*PCWINDOWS*/

#ifdef UNIX_X11
EXTERN Display *dpy;
/*EXTERN char *ProgramName;*/ /*used in shortway of archaic XtInitialize */
EXTERN  Arg args[100];
EXTERN  int n;
EXTERN  Widget topLevel, topgraf, toptext, topcapt, topbrot;
EXTERN  Widget grafwindow, textwindow, captwindow, brotwindow;
EXTERN  Widget quitButton, resetButton, drawArea;
EXTERN  Widget msgbox,optionItem,message;
EXTERN  Widget alertButton;
EXTERN  Widget kinebox,kinerow,kinemsg,kinenum,kinenow;
EXTERN  Widget kinebut,kinebutok,kinebutnext,kinebutcan;
EXTERN  Widget reportbox,reports,report1,report2,report3;
EXTERN  Widget reportbuts,reportbutOK,reportbutabort;
/*slider Widgets == ControlHandle vgrafzoom,vgrafzclip,vgrafztran;*/
/*slider Widgets == ControlHandle  hgrafbondrot[MAXBONDROT+1];*/
/*value label widgets for sliders: */
EXTERN  Widget zoomvalue, zclipvalue, ztranvalue;/*the 3 in the grafwindow*/
EXTERN  Widget bondrotvalue[MAXBONDROT+1], bondrotstart[MAXBONDROT+1];
EXTERN  Widget bondrotname[MAXBONDROT+1]; 
EXTERN  XtPointer Callbackvalue;
EXTERN  XFontStruct *buttonFont;
EXTERN  Window  drawWindow;                     /* drawing window */
/*mage stuff below here */
EXTERN int Lnew,icount,c;
EXTERN Pixel   icolorindex[256];
EXTERN Boolean done;
EXTERN float rotx, roty, rotz;
EXTERN GC gc,offgc,ggc;
EXTERN Pixmap offscreen;
EXTERN Colormap colormap;
EXTERN XtAppContext app_context;
EXTERN Visual* magevisual;
EXTERN int magedepth,windowbackground,windowborder;
EXTERN unsigned long  incolor[256]; /*index to colormap */
#endif /*UNIX_X11*/

#ifdef PCWINDOWS
  typedef HWND WindowPtr;
  typedef HWND ControlHandle;
  typedef RECT Rect;
  typedef HWND TEHandle;
  typedef HANDLE PaletteHandle;
  typedef HANDLE DialogPtr;
  typedef HANDLE GrafPort;
  typedef HANDLE CGrafPort;
  typedef HANDLE BitMap;
  typedef HANDLE PixMap;
  typedef HANDLE MenuHandle;
  typedef HANDLE CursHandle;
  typedef int EventRecord;
  #define pascalvoid void pascal
  #define pascalBOOL BOOL pascal
#endif /*PCWINDOWS*/

#ifdef MACINTOSH
  #define pascalvoid pascal void
  #define pascalBOOL pascal Boolean
#endif

   /* array sizes */
EXTERN  int  MAXNUM; /*3500*//*total number of move triplets & draw triplets*/
EXTERN  int  MAXDRAWS;/*3500*//*maximum number of 2-D Move-Draws displayable*/
EXTERN  int  MAXWORDCOM; /*total number of characters of comment or textlist */
/*MAXNUM MAXDRAWS MAXWORDCOM not used in compilation, run time dynamic alloc*/

EXTERN  int  nwordcom; /*just an ordinary int*/
EXTERN  int  IMAC,IPC,IUX,IUXM,IUXP,IESV; /*flow control during execution */
/*kludge to get results of crossproduct calculation, avoids passing pointers*/
EXTERN    double        dblx,dbly,dblz;
/*group of variables with Mac specific declarations that must be PC,PEX valid*/
EXTERN WindowPtr  MageDLOGreportBox,filedialogBox,kinedialogBox,bindialogBox;
EXTERN WindowPtr  drawlinedialogBox,stereodialogBox,constructdialogBox;
EXTERN WindowPtr  MageinitDLOGreportBox,arraydBox,pickshowdialogBox;
EXTERN WindowPtr  QuesdialogBox,colorshowdialogBox;/*931108,931127*/
EXTERN WindowPtr  ViewsdialogBox,ChangeCheckdialogBox,SearchdialogBox;
EXTERN WindowPtr  textWindow,captWindow,grafWindow,SetgraffontsdialogBox;
EXTERN WindowPtr  PostScriptdialogBox;
EXTERN ControlHandle  vtextScroll,vcaptScroll,vgrafzoom,vgrafzclip,vgrafztran;
EXTERN ControlHandle  hgrafbondrot[MAXBONDROT+1];
EXTERN ControlHandle  grpbox[MAXG+MAXXG],setbox[MAXS],listbox[MAXL];
EXTERN ControlHandle  masterbox[MAXM];
/* group of variables with Mac specific declarations that must be PC valid*/

#ifndef UNIX_X11
EXTERN Rect           dragRect, windowBounds, boxBounds;
EXTERN TEHandle       theText, textText, captText;
EXTERN Rect   destRect, textdRect, captdRect, viewRect, textvRect, captvRect;
EXTERN PaletteHandle    makePalette(), MagePalette, makegrayPalette();
EXTERN GrafPort      offScreenPort;
EXTERN CGrafPort     CoffScreenPort;
EXTERN BitMap        offScreenBits;
EXTERN PixMap        CoffScreenBits;
EXTERN CursHandle    waitcursor,magecursor,xyrotcursor,zrotcursor;
EXTERN Rect brect;  /*920619 pass window rect for PC MAGE button placement*/
#endif  /*!UNIX_X11*/

EXTERN  int        grafwinportRectleft, grafwinportRecttop;
EXTERN  int        grafwinportRectright, grafwinportRectbottom;
EXTERN  int        grafwinportBitsleft, grafwinportBitstop;
EXTERN  int        grafwinportBitsright, grafwinportBitsbottom;
EXTERN  int        Gorigtop,Gorigleft,Gorigbottom,Gorigright;
/* variables with generic c declarations */
/*computer monitor characteristics as set for this mage run */
EXTERN    int     Lcolor,LCscrn,LLcolor,Lread_writecolors;
EXTERN    int     GWIDTH, GHEIGHT, CHEIGHT, BWIDTH,ZWIDTH, ibigfont;
EXTERN    int     GZDEEP, MHEIGHT; 
EXTERN    int     ROTSWIDTH;    /* allowance for bondrot scroll bars */
EXTERN    int     RWIDTH;   /*variable for bondrotsliders in MAC, PC graf window*/
EXTERN    int     ROTWINDWIDTH;/*constant, bondrotsliders separate UNIX window*/
EXTERN    int     isavewidth,igrafscrntall;

EXTERN    int     Liveoffscreenbitmap; /*flag for off-screen bitmap */    
EXTERN    int            npixelbits; /*screen depth*/
EXTERN    float   fdiff,fudge;
EXTERN    long    maxtextchar;
EXTERN    int     Limittext,lineWorth,imove,target;
EXTERN    short   startValue,endValue;
EXTERN    short   lineHeight,textHeight,captHeight,widMax,maxValue,minValue;
EXTERN    int     nLines, viewLines, textLines, captLines, scrolLines;
/*other general variables */
EXTERN    char    NameStr[128],KineName[128];/*file names, char # limited*/
EXTERN    char    version[128],modification[128];/*about this MAGE version*/
EXTERN    int     width,ipick,pickx,picky,pickvec,Lpick,Lprepick;
EXTERN    int     Lsuperpick,ipickgrp,ipickset,ipicklist,imodify,Lpickwhen;
EXTERN    int     irotxy;
EXTERN    int     Lcancel,Lerase,Lprocessing;
EXTERN    int     mousex, mousey, mousexold, mouseyold;
EXTERN    int     nxyz,maxnxyz;
EXTERN    int     Llocalrotation,Llocalprecenter,Llocalpostcenter;/*input*/
EXTERN    long    icom;
EXTERN    float   x[4],x2,y2,z2;
EXTERN    int     IOerr,atEOF,LOK,Lkinemagecount;
EXTERN    int  kinemagenum,nextkinenum,Lnextkine,thiskinenum,LnextOK,Lkinfile;
EXTERN    int     igrp[MAXG][10],ngrp,maxgrp,nanimate,nnanimate,Lmoview;
EXTERN    int     iset[MAXS][9],nset,maxset,nmaster,Lmaster,mymaster;
EXTERN    int     ilist[MAXL][10],nlist,maxlist;
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
EXTERN    char ptIDstr[MAXPTIDCHAR+1]; /*input between MAGEVECT & MAGEVSUB */
EXTERN    int  iptIDstr;

EXTERN    char groupname[MAXG][MAXNAMECHAR+2];/*allow animate flag & \0 ending*/

EXTERN    char listname[MAXL][MAXNAMECHAR+1],setname[MAXS][MAXNAMECHAR+1];
EXTERN    char bondname[MAXBONDROT+1][MAXNAMECHAR+1];
EXTERN    char mastername[MAXM][MAXNAMECHAR+1];

EXTERN unsigned long groupmaster[MAXG],subgroupmaster[MAXS],listmaster[MAXL];
EXTERN    char    thisanswer[MAXQUESTIONS][MAXQCHAR];
EXTERN    char    grafselection[2][MAXQCHAR];
EXTERN    int     mQuestion,nQuestion,Lgographics,Lisgraphics,Lredohyperbutton;
EXTERN    int     Lqueskin,Nqueskin[MAXQUESTIONS],oldNqueskin,Lquesanswers;
EXTERN    int     Lquesview,Nquesview[MAXQUESTIONS],oldNquesview;
EXTERN    int     Lquesmaster[MAXM],Nquesmaster[MAXM],Lquesfind,itextoffset;
EXTERN    char      Qstring[256]; /*question*/
EXTERN    int       iQstring; /*question*/

EXTERN    float   bondrotin[MAXBONDROT+1], bondrotout[MAXBONDROT+1];
EXTERN    int     nbondrot,Lbondrotscope,bondset[MAXBONDROT+1][5];
EXTERN    int     Lcolnam,icolor,nblev,Lbrot,Lbang;
EXTERN    int     Lwordsfont,Lwordsface,Lwordssize;
EXTERN    int     Lradius,Lball,Lballhere,Lballthere,Lcomment,LBcharflag;
EXTERN    float   radiuslist[MAXL];
EXTERN    char    draglinestr[16];
EXTERN    char    wordsfont[MAXL],wordsface[MAXL],wordssize[MAXL];
EXTERN    int     animbox,anim2box,markbox,pickbox,zclipbox,measurebox;
EXTERN    int     drawlabelsbox,drawlinebox,draglinebox,constructlinebox;
EXTERN    int     prunebox,punchbox,undopbox,pickshowbox,drawgroupbox;
EXTERN    int     monitorbox,eraselinebox;
EXTERN    int     nn,Lpickshow,Lpickshowon;
EXTERN    int     marker[23][4],drawpt[8][4];
EXTERN    float   fmarker[23][3],fdrawpt[8][3];
EXTERN    float   fxcenternew,fycenternew,fzcenternew,scalenew;
EXTERN    float   fxcenterold[MAXRESETS+2],fycenterold[MAXRESETS+2];
EXTERN    float   fzcenterold[MAXRESETS+2];
EXTERN    int     imarker;
EXTERN    FILE    *fp;
EXTERN    FILE    *fpout;
EXTERN    float   a11,a12,a13,a21,a22,a23,a31,a32,a33;
EXTERN    float   ma[MAXRESETS+1][10];
EXTERN    int     ixctr,iyctr,izctr,WIDTH,HEIGHT,ISOSCALE;
EXTERN    int    Lscale,DOscale,Newscale;
EXTERN    int    Lgrp,Lset,Lvect,Ldot,Label,Lmove,Lword; /*input control flags*/
EXTERN    int    Lbegin,Lnewfile,Lreentry,Lcount,Lrecalculate; /*main loop flags*/
EXTERN    int    LAELaunched,Lappleevents; /*Mac AppleEvent flags*/
EXTERN    int    Lexcessivepoints,LpointIDtoolong; /*only first instance warning*/

EXTERN    int    Lrate,Ltest,Lcursoractive,Lflat;
EXTERN    int    Lspecialloop,Lpostscript,LspecialPS; /*PostScript*/
EXTERN    int    Lcarry,Lcarry1,Lcarry2; /*MUX_MAIN ?? */
EXTERN    int    Lonewidth,Lthin,Lperspec,Lwhitebkg,Lxyzpoint,Lmarkers;
EXTERN    int    Lnewmeasures,Lmeasureson,Lmeasures,Lgnomon;
EXTERN    int    Lprune,Lpruneon,Lpunchon,Lundop,nundop,Lpruneactive;
EXTERN    int    Ldrawactive,Lnewviewactive;
EXTERN    int    nprune[11][3],Lnewlabels,Lnewlabels,Lnewlabelson;
EXTERN    int    Lnewdrawline,Ldrawline,Ldrawlineon,Lpoint,Loriginatctr;
EXTERN    int    Lconstructline,Lconstructon,Ldrawunpickable;
EXTERN    int    Ldragline,Lnewdrag,Lnewmatrix,Ldraglineactive,Ldraglineon;
EXTERN    int    Lmonitor,Lmonitoron,nlast,nprelast;
EXTERN    float     distmeasure,anglemeasure,dihedralmeasure;
EXTERN    float     distconstruct,angleconstruct,dihedralconstruct;
EXTERN    float     distuser,angleuser,dihedraluser;
EXTERN    float     diststored,anglestored,dihedralstored;
EXTERN    float     fxcenter,fycenter,fzcenter,scale,oldxyz[4],zclip;
EXTERN    float     zoom,zoomold[MAXRESETS+1];
EXTERN    int       maxwide,nscale,nmarkers,maxmeasures,ndrawpoint,numberline;
EXTERN    int       oldmaxwide;
EXTERN    float     fxmax,fxmin,fymax,fymin,fzmax,fzmin;
EXTERN    char      alertstr[256],alertstr2[256],alertstr3[256]; /*alert strings*/
EXTERN    char      comstr[256],dstring[256],commentstr[256],focusxyzstr[256];
EXTERN    char      word[256],temps[256],numstr[256]; /*general strings*/
EXTERN    int       iword, itemps, inumstr;
EXTERN    int       Lmenu, Lmustkeeppoint;
EXTERN    long      totalrunticks,firstloopticks,secondloopticks,nmovedraws;
EXTERN    long      predrawticks, preloopticks, postcopyticks, postdrawticks;
EXTERN    float     mousetickrate;
EXTERN    long      icountticks,ncountticks,mouseticks,anysize;
EXTERN    int       Linstance,Lplotonly,Lfirstcall,Lplotpoint,Lstereo;
EXTERN    int        Lnewpickcenter,Lzoom,Lcompareon,Lcompare,Lcomparestart;
EXTERN    int        nextanimategroup;
EXTERN    int       Lzoomer[MAXRESETS+1],Lcenter[MAXRESETS+1];
EXTERN    int       Lzcliper[MAXRESETS+1],Lztraner[MAXRESETS+1];
EXTERN    int        Lzclip,Lzclipon,Lztran;
EXTERN    int        Lpickcenter,Lpickon,Lcenterpoint;
EXTERN    float     fzclip; /*scales zclip to screen box size*/
EXTERN    int            izclip,izclipold[MAXRESETS+1];
EXTERN    int            iztran,iztranold[MAXRESETS+1];
EXTERN    int            ixtran,iytran;
EXTERN    int    jx1,jy1,jz1,jx2,jy2,jz2;
EXTERN    char       viewcom[MAXRESETS+1][MAXVIEWIDCHAR+1];
EXTERN    int        Lmultibins;
EXTERN    int            multibins;
EXTERN    int        Lreset[MAXRESETS+1],Lview[MAXRESETS+1],iviewset;
EXTERN    int            Lstartfile;
EXTERN    int        Lnewlist;
EXTERN    float          stereoangle,defaultangle;
EXTERN    int            ieyewide, ieyedefault;
EXTERN    int        Lmiddle;
EXTERN    int        xmin,xmax,ymin,ymax;
EXTERN    int        Lcaptsize,Ltextsize;
EXTERN    int        Lfile;
EXTERN    int        Lunpickable;
EXTERN    float      fcenterx,fcentery,fcenterz,shortenline;
EXTERN    int        Lkeepstereo,Lkeepthinline,Lkeepperspective;
EXTERN    double      zoomfac, slabfac, tranfac;
EXTERN    int        Lsearchbegin,Lsearched,Lsearchatend;
EXTERN    int        ngrpsearch,nsetsearch,nlistsearch,jsearch;
EXTERN    int        isearch1,isearch2;
EXTERN    char       trystr[(MAXPTIDCHAR+1)];  
EXTERN    char       search1str[(MAXPTIDCHAR+1)],search2str[(MAXPTIDCHAR+1)];
EXTERN long ntotaltext; /*920720 dcr total number of chars in text window*/
EXTERN int ireturnflag; /*940125 lets dialog return a T/F value */
EXTERN    float     floatpass; /*global to pass a float*/
EXTERN    int       intpass;   /*global to pass an int */

#ifdef PCWINDOWS
  EXTERN LPSTR filearg
    #ifdef MAGE_INIT
      = NULL
    #endif
    ;

  /* count number of locks on large arrays */
  EXTERN int nfxyz
    #ifdef MAGE_INIT
      = 0
    #endif
    ;
  EXTERN int nxxyz
    #ifdef MAGE_INIT
      = 0
    #endif
    ;
  EXTERN int ncom
    #ifdef MAGE_INIT
      = 0
    #endif
    ;
  EXTERN int nit
    #ifdef MAGE_INIT
      = 0
    #endif
    ;
  EXTERN int ninwordcom
    #ifdef MAGE_INIT
      = 0
    #endif
    ;
  EXTERN int nwordcom
    #ifdef MAGE_INIT
      = 0
    #endif
    ;

  EXTERN  char szDirName[256];   /*current directory */

  EXTERN FILE *fpout
    #ifdef MAGE_INIT
      = NULL
    #endif
    ;
  EXTERN HANDLE hInst;          /* current instance   */
  EXTERN HANDLE hFileContents
    #ifdef MAGE_INIT
      = 0
    #endif
    ;

  EXTERN char huge *filebuf;
  EXTERN char huge *captstart;
  EXTERN char huge *captend;
  
  EXTERN HWND MageWindow;
  EXTERN int DisplaySizeX;
  EXTERN int DisplaySizeY;
  EXTERN int fontheight;
  EXTERN int fontwidth;
  EXTERN int fontmaxwidth;
  /*EXTERN int fontverticalspace;*/ /*need this for MAGEDRAW.C*/
  EXTERN char ofilename[FILENAME_MAX];
  EXTERN char startpath[_MAX_PATH];
  
  EXTERN HDC cDC, DC, newDC;
  
  #define MAGEGRAPHID 1       /*child windows of MageWindow*/
  #define MAGETEXTID 2         /*must be unique at parent-child level*/
  #define MAGESCROLLID 3       /* 3 scroll bars: zoom, zslab, ztran */
  #define MAGEBONDROTID 10     /* up to MAXBONDROT ( = 10 ) 10 --- 19 */

  EXTERN HWND gWindow;
  EXTERN HMENU gMenu;
  EXTERN HWND tWindow;
  EXTERN HMENU tMenu;

  EXTERN HWND captionWindow;
  EXTERN HWND bondrotWindow[MAXBONDROT+1]
    #ifdef MAGE_INIT
      = {0,0,0,0,0,0,0,0,0,0,0}
    #endif
    ;
  EXTERN HWND sWindow;
  EXTERN HWND slabWindow;
  EXTERN HWND ztranWindow;
  EXTERN HWND zoommvWindow,zslabmvWindow,ztranmvWindow; /* to set values*/
  /*so input value of zoom, izclip, iztran will position the slider bars */
  EXTERN HWND zoomedWindow,zslabedWindow,ztranedWindow; /* to set values*/
  /*so input of zoom,izclip,iztran will be set text value of the slider bars*/

  #define MAXBUTTONS  MAXG+MAXXG+MAXS+MAXL+MAXM /*allows up to MAXM masters*/
  EXTERN HWND buttons[MAXBUTTONS];

  EXTERN HANDLE hPalette   /*920619 rmw*/
    #ifdef MAGE_INIT
      = 0
    #endif
    ;
  EXTERN LOGPALETTE *lpPalette   /*920619 rmw*/
    #ifdef MAGE_INIT
      = NULL
    #endif
    ;

  EXTERN  int xsize, ysize;
  EXTERN  int xmiddle,ymiddle;
  EXTERN  int polynum;

  EXTERN  int hasnewDC;
  EXTERN  HDC newDC;
  EXTERN  HBITMAP defBitmap, newBitmap;
  EXTERN  HANDLE hBckGrndBrush;
  EXTERN  int tracking;
  EXTERN  int xold, yold;
  EXTERN  HPEN oldPen,newPen;
  EXTERN  HBRUSH oldBrush,newBrush;

  EXTERN  long oldticks
    #ifdef MAGE_INIT
      = 0
    #endif
    ;

#endif   /* PC stuff */

EXTERN int Initialized;
EXTERN int SliderWidth;
EXTERN int fontverticalspace;
EXTERN short  oldfontsize,labelsfontsize,infofontsize,wordsfontsize;

#ifdef MACINTOSH
  EXTERN    RGBColor rgbColor;
#else
  EXTERN  struct { unsigned red; unsigned green; unsigned blue; } rgbColor;
#endif
#ifdef UNIX_X11
#define MAXBUTTONS  MAXG+MAXXG+MAXS+MAXL+MAXM /*allows up to MAXM masters*/
EXTERN Widget buttons[MAXBUTTONS];
#endif /*UNIX_X11*/

#include "MAGEMENU.H"  /*separate MENU & DIALOG defined variables*/
#include "MAGE.HDR"

/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
