/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/

#include "MAGE.H"

/****domeasures()*************************************************************/
void    domeasures()
{
static  int       nmeasures = 0;
        double    angle,dihedral;
        int       i,j,k,n,nn,nnn,nnnn;
        float     sum,value,fxyztemp[3];        
        
        if(Lnewmeasures)
        {
            nmeasures = 0;
            Lnewmeasures = 0;
            anglemeasure = 0.0;
            dihedralmeasure = 0.0;
            igrp[maxgrp+2][0] = 1; /* enable display of this measures group*/
            ilist[maxlist+5][0] = 0; /*start with list of points off */
            ilist[maxlist+6][0] = 0; /*start with list of average dots off */
        }
        
        if(nmeasures < 4) nmeasures++; /*up to four successive picked points */
        
        n = nxyz + nmarkers + 1; /* first of point indices */
        nn = nxyz + nmarkers + nmeasures; /* last of current point indices */
        ilist[maxlist+5][2] = nn; /*added to show list*/
        nnn = nxyz + nmarkers + 5; /* first average dot index */
        nnnn = nxyz + nmarkers + 5 + (nmeasures - 2); 
                        /*store in 5 when nmeasures = 2 */
        if(nnnn < nnn) nnnn = nnn; /* has to be equal or greater*/
        ilist[maxlist+6][2] = nnnn; /*added to show list*/
            /* ilist[maxlist+5][1] defined in addmeasures()  */
            /* ilist[maxlist+6][1] defined in addmeasures()  */
            /* store vectors along the picked path as Move-Draw-Draw-Draw*/
            /* then up to 3 Dots for the average of 2, 3, 4 picked points*/
            /* these are in the different list structures */

        /*store values temporarily in case pickvec is a measures point*/
        fxyztemp[0] = fxyz(0,pickvec);
        fxyztemp[1] = fxyz(1,pickvec);
        fxyztemp[2] = fxyz(2,pickvec);
            
        if(nmeasures > 1) /* for all later picks after first */
        {
            for(j=nmeasures; j>1 ; j--) /*shift values up by one position*/
            {
                k = nxyz + nmarkers + j;
                fxyz(0,k) = fxyz(0,k-1);
                fxyz(1,k) = fxyz(1,k-1);
                fxyz(2,k) = fxyz(2,k-1);
            }
        }
            /* put last pick point into working list at position 1 */
        fxyz(0,n) = fxyztemp[0];
        fxyz(1,n) = fxyztemp[1];
        fxyz(2,n) = fxyztemp[2];
        
        if(nmeasures >= 2)  
        {    /*calculate average, put into next triple position*/
            fxyz(0,nnn) = (fxyz(0,n) + fxyz(0,n+1))/2.0;
            fxyz(1,nnn) = (fxyz(1,n) + fxyz(1,n+1))/2.0;
            fxyz(2,nnn) = (fxyz(2,n) + fxyz(2,n+1))/2.0;
            ilist[maxlist+5][0] = 1; /*turn list of points on for first line*/
            ilist[maxlist+6][0] = 1; /*turn list of average dots on */
        }
        
        if(nmeasures >= 3)  /*calculate angle*/
        {
            /*going backwards in n, so lowest n indexes for latest angle*/
/*.*/        angle = angle3pt(    fxyz(0,n),fxyz(1,n),fxyz(2,n),
                                fxyz(0,n+1),fxyz(1,n+1),fxyz(2,n+1),
                                fxyz(0,n+2),fxyz(1,n+2),fxyz(2,n+2)   );
            anglemeasure = angle; /* transfer by common storage */
            
            /*calculate average of 3, */
            /* put into triple position beyond average of 2 */
            fxyz(0,nnn+1) = (fxyz(0,n) + fxyz(0,n+1) + fxyz(0,n+2))/3.0;
            fxyz(1,nnn+1) = (fxyz(1,n) + fxyz(1,n+1) + fxyz(1,n+2))/3.0;
            fxyz(2,nnn+1) = (fxyz(2,n) + fxyz(2,n+1) + fxyz(2,n+2))/3.0;
        }
        
        if(nmeasures == 4)  /*calculate dihedral*/
        {
/*.*/        dihedral = dihedral4pt(    fxyz(0,n),fxyz(1,n),fxyz(2,n),
                                    fxyz(0,n+1),fxyz(1,n+1),fxyz(2,n+1),
                                    fxyz(0,n+2),fxyz(1,n+2),fxyz(2,n+2),
                                    fxyz(0,n+3),fxyz(1,n+3),fxyz(2,n+3) );
                                    
            dihedralmeasure = dihedral; /* transfer by common storage */
            
            /*calculate average of 4, */
            /*put into triple position beyond average of 3 */
            sum = 0.0;
            for(j=0 ; j < 4 ; j++) sum = sum + fxyz(0,n+j);
            value = sum/4.0;
            fxyz(0,nnn+2) = value;
            sum = 0.0;
            for(j=0 ; j < 4 ; j++) sum = sum + fxyz(1,n+j);
            value = sum/4.0;
            fxyz(1,nnn+2) = value;
            sum = 0.0;
            for(j=0 ; j < 4 ; j++) sum = sum + fxyz(2,n+j);
            value = sum/4.0;
            fxyz(2,nnn+2) = value;
        }/*nmeasures == 4*/             
          
            /* vectors + markers + picked points + average points */
        if(Ltest)
        {    
/*c*/        sprintf(alertstr,"load integer display list  %d to %d; %d to %d ",
                n,nn,nnn,nnnn );
             dosinglealert(); /*MACDLOG.C*/ /*MPCDLOG.C*/
        }

        for(j=n; j<= nnnn ; j++) /* load integer display list */
        {
          if(j<= nn || j >= nnn)
          {
            if(fxyz(0,j)>=0.0) xyz(1,j)=scalenew*(fxyz(0,j)-fxcenternew)+.5;
            else                xyz(1,j)=scalenew*(fxyz(0,j)-fxcenternew)-.5;
            if(fxyz(1,j)>=0.0) xyz(2,j)=scalenew*(fxyz(1,j)-fycenternew)+.5;
            else                xyz(2,j)=scalenew*(fxyz(1,j)-fycenternew)-.5;
            if(fxyz(2,j)>=0.0) xyz(3,j)=scalenew*(fxyz(2,j)-fzcenternew)+.5;
            else                xyz(3,j)=scalenew*(fxyz(2,j)-fzcenternew)-.5;
          }
        }
}
/*___domeasures()____________________________________________________________*/

/****angle3pt()*************************************************************/
double    angle3pt(    double p1x,double p1y,double p1z,
                    double p2x,double p2y,double p2z,
                    double p3x,double p3y,double p3z )
{
        double    ax,ay,az,bx,by,bz;
        double    amag,bmag,dot;
        double    angle;
        
            /* angle defined between two vectors with a common base*/
            /* so subtract middle point from the two end points */
            ax = p1x - p2x;
            ay = p1y - p2y;
            az = p1z - p2z;
            bx = p3x - p2x;
            by = p3y - p2y;
            bz = p3z - p2z;
            
        /* these have to be normalized by dividing by their magnitudes, */
        /*this can be done either before taking the dot product or after*/
/*.*/    dot = (double)dotproduct(ax,ay,az,bx,by,bz);
/*c*/    amag = sqrt(ax*ax + ay*ay + az*az);
/*c*/    bmag = sqrt(bx*bx + by*by + bz*bz);
        if(amag*bmag <0.0001) 
        {
            angle = 0.0;
        }    
/*c*/    else angle = acos( dot/(amag*bmag) );
        angle = angle*360.0/(2*3.14159);
        return(angle);
}
/*___angle3pt()____________________________________________________________*/

/****crossproduct()***********************************************************/
void    crossproduct(    double ax,double ay,double az,
                        double bx,double by,double bz)
{
    double gx,gy,gz;
    gx = (ay)*(bz) - (az)*(by);
    gy = (az)*(bx) - (ax)*(bz);
    gz = (ax)*(by) - (ay)*(bx);
    /*(*rx) = gx;*/
    /*(*ry) = gy;*/
    /*(*rz) = gz;*/
    dblx = gx;
    dbly = gy;
    dblz = gz;
        if(Ltest)
        {    
/*c*/        sprintf(alertstr,    "cross product routine:\015"
                                "    %f = %f = %f x %f - %f x %f\015"
                                "    %f = %f = %f x %f - %f x %f\015"
                                "    %f = %f = %f x %f - %f x %f\015",
                                    dblx,gx,(ay),(bz),(az),(by),
                                    dbly,gy,(az),(bx),(ax),(bz),
                                    dblz,gz,(ax),(by),(ay),(bx)    );
             dosinglealert(); /*MACDLOG.C*/ /*MPCDLOG.C*/
        }
}
/*___crossproduct()__________________________________________________________*/

/****dotproduct()***********************************************************/
double        dotproduct(    double ax,double ay,double az,
                        double bx,double by,double bz )
{
    return(ax*bx + ay*by + az*bz);
}
/*___dotproduct()__________________________________________________________*/

/****dihedral4pt()************************************************************/
double    dihedral4pt(  double p1x,double p1y,double p1z,
                        double p2x,double p2y,double p2z,
                        double p3x,double p3y,double p3z,
                        double p4x,double p4y,double p4z )
{
        double    angle,angledhdrl,dot,dmag,emag,fmag;
        double    ax,ay,az,bx,by,bz,cx,cy,cz;
        double    dx,dy,dz,ex,ey,ez;
        double    fx,fy,fz;
        double    gx,gy,gz; 
        
        /* a,b,c 3 vectors between 4 points, */
        /* d,e   2 crossproduct vectors referenced as pointers*/
        /* f     a crossproduct vector  referenced as pointer */
        /* if d = a x b and e = b x c, then d orth a & b, e orth b & c */
        /* d & e both perpendicular to b */
        /* so d dot e is the dihedral, that is */
        /*   same angle as a to c if a & c were projected on a plane*/
        
        /* angle defined between two vectors with a common base*/
        /* so subtract middle point from the two end points */
        ax = p1x - p2x;
        ay = p1y - p2y;
        az = p1z - p2z;
        bx = p3x - p2x;
        by = p3y - p2y;
        bz = p3z - p2z;
            
        /* d = a x b */
/*.*/    crossproduct(ax,ay,az,bx,by,bz); /*return vector is dblx,dbly,dblz */
        dx = dblx;
        dy = dbly;
        dz = dblz;
        
        /* angle defined between two vectors with a common base*/
        /* so subtract middle point from the two end points, */
        /* redefining b for cross product around third point (b = -b)*/
        bx = p2x - p3x;   /* -b as far as d is concerned */
        by = p2y - p3y;
        bz = p2z - p3z;
        cx = p4x - p3x;
        cy = p4y - p3y;
        cz = p4z - p3z;
        
        /* e = b x c */
/*.*/    crossproduct(bx,by,bz,cx,cy,cz); /*return vector is dblx,dbly,dblz */
        ex = dblx;
        ey = dbly;
        ez = dblz;
        
        /*Now for d dot e  pass values to dotproduct()*/
/*.*/    dot = dotproduct(dx,dy,dz,ex,ey,ez);
        /*normalization factors*/
/*c*/    dmag = sqrt( (dx)*(dx) + (dy)*(dy) + (dz)*(dz) );
/*c*/    emag = sqrt( (ex)*(ex) + (ey)*(ey) + (ez)*(ez) );
        if(dmag*emag <0.0001) 
        {
            angle = 0.0;
        }    
/*c*/    else angle = acos( dot/(dmag*emag) );
        angledhdrl = angle*360.0/(2*3.14159);
        if(Ltest)
        {    
/*c*/        sprintf(alertstr,    "angle = %f  radians\015angle = %f  degrees"
                        ,angle,angledhdrl);
             dosinglealert(); /*MACDLOG.C*/ /*MPCDLOG.C*/
        }
        
        /* Now, need to establish correct handedness */
        /* d x -b is vector pointing in same sort of direction as orig a */
        /* f = d x -b = d x b as b was redefined for e calculation */
/*.*/    crossproduct(dx,dy,dz,bx,by,bz); /*return vector is dblx,dbly,dblz */
        fx = dblx;
        fy = dbly;
        fz = dblz;
        
        /*Now for f dot e  pass values to dotproduct()*/
/*.*/    dot = dotproduct(fx,fy,fz,ex,ey,ez);

        /*normalization factors*/
/*c*/    fmag = sqrt( (fx)*(fx) + (fy)*(fy) + (fz)*(fz) );

        if(fmag*emag <0.0001) 
        {
            angle = 0.0;
        }    
/*c*/    else angle = acos( dot/(fmag*emag) );
        if(Ltest)
        {    
/*c*/        sprintf(alertstr,    "angle = %f  radians",angle    );
             dosinglealert(); /*MACDLOG.C*/ /*MPCDLOG.C*/
        }

        angle = angle*360.0/(2*3.14159);
        if(angle > 90.0) angledhdrl = -angledhdrl;
        if(Ltest)
        {    
/*c*/        sprintf(alertstr,    "signed angle = %f  degrees"
                        ,angledhdrl);
             dosinglealert(); /*MACDLOG.C*/ /*MPCDLOG.C*/
        }

        return(angledhdrl);

}
/*___dihedral4pt()__________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****dodrawline()************************************************************/
void    dodrawline()
{
        int        i,j,k,n,nn;
        long    pickedcom;
        float    fvectorx,fvectory,fvectorz,veclength;
        
        if(Lnewdrawline)
        {
            numberline = 0;
            Lnewdrawline = 0;
            ilist[maxlist+8][0] = 0; /*start with drawn lines off*/ /*950113*/
            igrp[maxgrp+3][0] = 1; /* enable display */
        }
        numberline++;
        n = nxyz + nmarkers + maxmeasures + 3*ndrawpoint + numberline;
        if( n > (MAXNUM-1) ) 
        {
/*c*/        sprintf(alertstr,"vector array too small to draw more lines");
             dosinglealert(); /*MACDLOG.C*/ /*MPCDLOG.C*/
             numberline--;
             return;
        }
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
        /* get this last picked point into coordinate list at new position */
        
        fxyz(0,n) = fxyz(0,pickvec);
        fxyz(1,n) = fxyz(1,pickvec);
        fxyz(2,n) = fxyz(2,pickvec);
        if(fxyz(0,n)>=0.0) xyz(1,n)=scalenew*(fxyz(0,n)-fxcenternew)+.5;
        else                xyz(1,n)=scalenew*(fxyz(0,n)-fxcenternew)-.5;
        if(fxyz(1,n)>=0.0) xyz(2,n)=scalenew*(fxyz(1,n)-fycenternew)+.5;
        else                xyz(2,n)=scalenew*(fxyz(1,n)-fycenternew)-.5;
        if(fxyz(2,n)>=0.0) xyz(3,n)=scalenew*(fxyz(2,n)-fzcenternew)+.5;
        else                xyz(3,n)=scalenew*(fxyz(2,n)-fzcenternew)-.5;
        nprelast = nlast;
        nlast = pickvec;
        /*copy pointID into new position in com array */
        
        icom = (long)(MAXPTIDCHAR+1)*(long)n; /* offset for giant character array */ 
        pickedcom = (long)(MAXPTIDCHAR+1)*(long)pickvec;  /*950113*/
        /*copy pointID*/
        for(i=0; i<(MAXPTIDCHAR+1); i++) com2(icom+(long)i) = com2(pickedcom+(long)i); 
        
        /*if a Point, the next entry will define a line and */
        /* constructing the actual, possibly shortened, drawn line */
        if(Lpoint > 1) /*Lnewlabels never lets Lpoint>0 */
        {/*second of Point-Line sequence*/
           if(shortenline > 0.0001 || shortenline < -0.0001) 
           /* i.e. surely non-zero */
           {/*shorten line between last two entered triples and update*/
                
               fvectorx = fxyz(0,n) - fxyz(0,n-1);
               fvectory = fxyz(1,n) - fxyz(1,n-1);
               fvectorz = fxyz(2,n) - fxyz(2,n-1);
               veclength = sqrt(     fvectorx*fvectorx + 
                                     fvectory*fvectory + 
                                     fvectorz*fvectorz  );
               /*normalize: */
               fvectorx = fvectorx/veclength;
               fvectory = fvectory/veclength;
               fvectorz = fvectorz/veclength;
               /*add to n-1, subtract from n to make */
               /*shortened line end positions*/
                
               fxyz(0,n-1) = fxyz(0,n-1) + shortenline*fvectorx;
               fxyz(1,n-1) = fxyz(1,n-1) + shortenline*fvectory;
               fxyz(2,n-1) = fxyz(2,n-1) + shortenline*fvectorz;
               fxyz(0,n) = fxyz(0,n) - shortenline*fvectorx;
               fxyz(1,n) = fxyz(1,n) - shortenline*fvectory;
               fxyz(2,n) = fxyz(2,n) - shortenline*fvectorz;
             /* reload integer display list */
             for(j=n-1 ; j<=n ; j++)
             {
              if(fxyz(0,j)>=0.0) xyz(1,j)=scalenew*(fxyz(0,j)-fxcenternew)+.5;
              else               xyz(1,j)=scalenew*(fxyz(0,j)-fxcenternew)-.5;
              if(fxyz(1,j)>=0.0) xyz(2,j)=scalenew*(fxyz(1,j)-fycenternew)+.5;
              else               xyz(2,j)=scalenew*(fxyz(1,j)-fycenternew)-.5;
              if(fxyz(2,j)>=0.0) xyz(3,j)=scalenew*(fxyz(2,j)-fzcenternew)+.5;
              else               xyz(3,j)=scalenew*(fxyz(2,j)-fzcenternew)-.5;
             }
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/        
           }/*shorten line between last two entered triples and update*/
           ilist[maxlist+8][2] = n; /*add this line to show list*/ /*950113*/
           maxnxyz = n;
           /* ilist[maxlist+8][1] defined in adddrawline()  */ /*950113*/
            
           /* store vectors as (Move-Draw)s, 2 entries per drawline*/
           /* but done sequentially as they come in as Point, Line */
           /* if shortened usually don't allow picking, set Ldrawunpickable */
           if(Ldrawunpickable == 1 )
           {
                xyz(0,n-1) = 11;  /* Point == Move, Unpickable */
                xyz(0,n) = 1;  /* Line == Draw, Unpickable */
           }
           else
           {
                xyz(0,n-1) = 10;  /* Point == Move */
                xyz(0,n) = 0;  /* Line == Draw */            
           }
           ilist[maxlist+8][0] = 1; /*insure: drawn lines are on*/ /*950113*/
        }/*second of Point-Line sequence*/
        if(Lnewlabelson == 1)
        {
            if(fxyz(0,n)>=0.0)  xyz(1,n)=scalenew*(fxyz(0,n)-fxcenternew)+.5;
            else                xyz(1,n)=scalenew*(fxyz(0,n)-fxcenternew)-.5;
            if(fxyz(1,n)>=0.0)  xyz(2,n)=scalenew*(fxyz(1,n)-fycenternew)+.5;
            else                xyz(2,n)=scalenew*(fxyz(1,n)-fycenternew)-.5;
            if(fxyz(2,n)>=0.0)  xyz(3,n)=scalenew*(fxyz(2,n)-fzcenternew)+.5;
            else                xyz(3,n)=scalenew*(fxyz(2,n)-fzcenternew)-.5;
           ilist[maxlist+8][2] = n; /*add this line to show list*/ /*950113*/
           maxnxyz = n;
           /* ilist[maxlist+8][1] defined in adddrawline()  */ /*950113*/
           xyz(0,n) = 30;  /* Label */   
           ilist[maxlist+8][0] = 1; /*insure: labels are on*/ /*950113*/
           Lpoint = 0;
        }
}
/*___dodrawline()____________________________________________________________*/

/****doeraseline()************************************************************/
void    doeraseline()
{
    int        n;

        n = nxyz + nmarkers + maxmeasures + 3*ndrawpoint + numberline;
        if(Lpoint > 0 && Lconstructon) 
        {
            Lpoint = 0;
        }
        /*else if(Lpoint > 0||Lnewlabels==1)*/
        else if(Lpoint > 0 || (xyz(0,n) >= 20 && xyz(0,n) < 50) )
        {/*point start is one position, as is a label*/
            numberline = numberline - 1;
            Lpoint = 0;
        }
        else 
        {/*full point-line is 2 positions*/
            numberline = numberline - 2;
        }
        if(numberline <= 0) 
        {
            numberline = 0;
            n = nxyz + nmarkers + maxmeasures + 3*ndrawpoint + 1;
            ilist[maxlist+8][2] = n; /*reset show list*/ /*950113*/
            maxnxyz = n;
            ilist[maxlist+8][0] = 0; /*turn off list*/ /*950113*/
        }
        else
        {
            n = nxyz + nmarkers + maxmeasures + 3*ndrawpoint + numberline;
            ilist[maxlist+8][2] = n; /*reset show list*/ /*950113*/
            maxnxyz = n;
        }
        ilist[maxlist+7][0] = 0; /*turn off pointer*/ /*950113*/
}
/*___doeraseline()__________________________________________________________*/

/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****doconstructline()*******************************************************/
void    doconstructline()
{
        int        i,j,k,n,nn;
        long    pickedcom;
        float    fvectorx,fvectory,fvectorz,veclength;
static  float fcxyz[3][6];  
        double    angle,angledhdrl,dot,cmag,dmag,emag,fmag;
        double    ax,ay,az,bx,by,bz,cx,cy,cz;
        double    dx,dy,dz,ex,ey,ez;
        double    fx,fy,fz;
        double    gx,gy,gz; 
       
        if(Lnewdrawline)
        {
            numberline = 0;
            Lnewdrawline = 0;
            ilist[maxlist+8][0] = 0; /*start with drawn lines off*/ /*950113*/
            igrp[maxgrp+3][0] = 1; /* enable display */
        }
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
        /* get this last picked point into coordinate list at new position */
        
        fcxyz[0][Lpoint] = fxyz(0,pickvec);
        fcxyz[1][Lpoint] = fxyz(1,pickvec);
        fcxyz[2][Lpoint] = fxyz(2,pickvec);
        
        
        /*if a Point, wait for 3 entries to define a line before */
        /* constructing the actual, possibly shortened, drawn line */
        if(Lpoint >= 3)
        {
           numberline = numberline + 2;
           n = nxyz + nmarkers + maxmeasures + 3*ndrawpoint + numberline;
           if( n > (MAXNUM-1) ) 
           {
/*c*/         sprintf(alertstr,"vector array too small to draw more lines");
              dosinglealert(); /*MACDLOG.C*/ /*MPCDLOG.C*/
              numberline = numberline - 2;
              return;
           }
           /*get this last picked point into coordinate list at new position*/
        
           fxyz(0,n-1) = fxyz(0,pickvec);
           fxyz(1,n-1) = fxyz(1,pickvec);
           fxyz(2,n-1) = fxyz(2,pickvec);
        
           /*copy pointID into new position in com array */
  /*950113*****/         
           icom = (long)(MAXPTIDCHAR+1)*(long)(n-1); /* offset for giant character array*/ 
           pickedcom = (long)(MAXPTIDCHAR+1)*(long)pickvec; 
           /*copy pointID*/
           for(i=0;i<(MAXPTIDCHAR+1);i++) com2(icom+(long)i)=com2(pickedcom+(long)i); 
           
           icom = (long)(MAXPTIDCHAR+1)*(long)(n); /*offset for giant character array*/ 
           sprintf(word,"construction");
/*Mx*/     condition(word);  /* == CtoPstr(word)  on Mac */
           for(i=0; i<(MAXPTIDCHAR+1); i++) com2(icom+(long)i) = word[i]; 
  /*950113____*/
           /*get values for distconstruct, angleconstruct, dihedralconstruct*/
           DoconstructDialog();
           
           /*calculate the new line from points 1,2,3, */
           /* dist 3-4, angle 2-3-4, dihedral 1-2-3-4 */
           /* cross:  (2->3)X(2->1) ==> (2->5), aXb ==> c at dihedral 90*/
           ax = fcxyz[0][3] - fcxyz[0][2];
           ay = fcxyz[1][3] - fcxyz[1][2];
           az = fcxyz[2][3] - fcxyz[2][2];
           bx = fcxyz[0][1] - fcxyz[0][2];
           by = fcxyz[1][1] - fcxyz[1][2];
           bz = fcxyz[2][1] - fcxyz[2][2];
           /* c = a x b */
/*.*/      crossproduct(ax,ay,az,bx,by,bz);/*return vector is dblx,dbly,dblz*/
           cx = dblx;cy = dbly;cz = dblz;
           /*normalization factor*/

/*c*/      cmag = sqrt( (cx)*(cx) + (cy)*(cy) + (cz)*(cz) );

           /*place c at correct distance*/
           if(cmag > 0.000001)
           {
               cx = cx*distconstruct/cmag;
               cy = cy*distconstruct/cmag;
               cz = cz*distconstruct/cmag;
           }
           /*place c at correct distance from 3rd point,*/
           /* as xproduct it is at a dihedral of 90 to a vector*/
           cx = cx + fcxyz[0][3];
           cy = cy + fcxyz[1][3];
           cz = cz + fcxyz[2][3];
           /*load actual array with only-distance-set point*/
           fxyz(0,n) = cx;
           fxyz(1,n) = cy;
           fxyz(2,n) = cz;
           /*rotate around 2->3 for correct dihedral*/
           angledhdrl = dihedralconstruct - 90.0;
           ax = fcxyz[0][2];
           ay = fcxyz[1][2];
           az = fcxyz[2][2];
           bx = fcxyz[0][3];
           by = fcxyz[1][3];
           bz = fcxyz[2][3];
           doaxisrot(n,angledhdrl, ax, ay, az
                                   , bx, by, bz);
           /* cross:  (3->4)X(3->2) ==> (3->6), aXb ==> c at dihedral 90*/
           ax = fxyz(0,n) - fcxyz[0][3];
           ay = fxyz(1,n) - fcxyz[1][3];
           az = fxyz(2,n) - fcxyz[2][3];
           bx = fcxyz[0][2] - fcxyz[0][3];
           by = fcxyz[1][2] - fcxyz[1][3];
           bz = fcxyz[2][2] - fcxyz[2][3];
           /* c = a x b */
/*.*/      crossproduct(ax,ay,az,bx,by,bz);/*return vector is dblx,dbly,dblz*/
           cx = dblx;cy = dbly;cz = dblz;
           /*normalization factor*/

/*c*/      cmag = sqrt( (cx)*(cx) + (cy)*(cy) + (cz)*(cz) );
           if(cmag > 0.000001)
           {
               cx = cx/cmag;
               cy = cy/cmag;
               cz = cz/cmag;
           }

           /*rotate around 3->6 for correct angle*/
           angledhdrl = 90.0 - angleconstruct;
           ax = fcxyz[0][3];
           ay = fcxyz[1][3];
           az = fcxyz[2][3];
           cx = cx + fcxyz[0][3];
           cy = cy + fcxyz[1][3];
           cz = cz + fcxyz[2][3];
           bx = cx;
           by = cy;
           bz = cz;
           doaxisrot(n,angledhdrl, ax, ay, az
                                   , bx, by, bz);
 
           /*stop for now and see if this is reasonable so far*/
           if(shortenline > 0.0001 || shortenline < 0.0001) 
           /* i.e. surely non-zero */
           {    /*shorten line between last two entered triples and update*/
                
                fvectorx = fxyz(0,n) - fxyz(0,n-1);
                fvectory = fxyz(1,n) - fxyz(1,n-1);
                fvectorz = fxyz(2,n) - fxyz(2,n-1);

                veclength = sqrt(   fvectorx*fvectorx +
                                    fvectory*fvectory + 
                                    fvectorz*fvectorz  );
                /*normalize: */
                if(veclength > 0.000001)
                {
                    fvectorx = fvectorx/veclength;
                    fvectory = fvectory/veclength;
                    fvectorz = fvectorz/veclength;
                }
                /*add to n-1, subtract from n to make */
                /*shortened line end positions*/
                
                fxyz(0,n-1) = fxyz(0,n-1) + shortenline*fvectorx;
                fxyz(1,n-1) = fxyz(1,n-1) + shortenline*fvectory;
                fxyz(2,n-1) = fxyz(2,n-1) + shortenline*fvectorz;
                fxyz(0,n) = fxyz(0,n) - shortenline*fvectorx;
                fxyz(1,n) = fxyz(1,n) - shortenline*fvectory;
                fxyz(2,n) = fxyz(2,n) - shortenline*fvectorz;
           }
           /* load integer display list */
           for(j=n-1 ; j<=n ; j++)
           {
            if(fxyz(0,j)>=0.0) xyz(1,j)=scalenew*(fxyz(0,j)-fxcenternew)+.5;
            else                xyz(1,j)=scalenew*(fxyz(0,j)-fxcenternew)-.5;
            if(fxyz(1,j)>=0.0) xyz(2,j)=scalenew*(fxyz(1,j)-fycenternew)+.5;
            else                xyz(2,j)=scalenew*(fxyz(1,j)-fycenternew)-.5;
            if(fxyz(2,j)>=0.0) xyz(3,j)=scalenew*(fxyz(2,j)-fzcenternew)+.5;
            else                xyz(3,j)=scalenew*(fxyz(2,j)-fzcenternew)-.5;
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/        
           }
           ilist[maxlist+8][2] = n; /*add this line to show list*/ /*950113*/
           maxnxyz = n;
           /* ilist[maxlist+8][1] defined in adddrawline()  */ /*950113*/
            
           /* store vectors as (Move-Draw)s, 2 entries per drawline*/
           /* but done sequentially as they come in as Point, Line */
           /* originally, if shortened, don't allow picking */
           /*if(shortenline > 0.0001 )*/
           if(Ldrawunpickable == 1) /*explicitly control unpickable-ness*/
           {
                xyz(0,n-1) = 11;  /* Point == Move, Unpickable */
                xyz(0,n) = 1;  /* Line == Draw, Unpickable */
           }
           else
           {
                xyz(0,n-1) = 10;  /* Point == Move */
                xyz(0,n) = 0;  /* Line == Draw */            
           }
           ilist[maxlist+8][0] = 1; /*insure: drawn lines are on*/ /*950113*/
        }
}
/*___doconstructline()______________________________________________________*/

/****doaxisrot()*************************************************************/
void    doaxisrot(int i,float theta, double ax,double ay,double az
                                   , double bx,double by,double bz)
{
    double xx,yy,zz,cosn1,cosn2,cosn3,costheta,sintheta;
    int   j;
    double fx1,fy1,fz1,fx2,fy2,fz2;
    double a11,a12,a13,a21,a22,a23,a31,a32,a33,det;
    
    xx = bx - ax;
    yy = by - ay;
    zz = bz - az;
    if(xx*xx + yy*yy + zz*zz > 0.000001)
    {
        cosn1 = (xx)/sqrt(xx*xx + yy*yy + zz*zz);
        cosn2 = (yy)/sqrt(xx*xx + yy*yy + zz*zz);
        cosn3 = (zz)/sqrt(xx*xx + yy*yy + zz*zz);
    }
    while(theta >  360.0) theta = theta - 360.0;
    while(theta < -360.0) theta = theta + 360.0;
    if(theta >  180) theta = theta - 360.0;
    if(theta < -180) theta = theta + 360.0;
    costheta = cos( (double)theta*3.14159*2.0/360.0);
    sintheta = sin( (double)theta*3.14159*2.0/360.0);

a11=( cosn1*cosn1 + (1-cosn1*cosn1)*costheta);
a12=( cosn1*cosn2*(1-costheta) + cosn3*sintheta );
a13=( cosn1*cosn3*(1-costheta) - cosn2*sintheta );

a21=( cosn1*cosn2*(1-costheta) - cosn3*sintheta );
a22=( cosn2*cosn2 + (1-cosn2*cosn2)*costheta);
a23=( cosn2*cosn3*(1-costheta) + cosn1*sintheta );

a31=( cosn1*cosn3*(1-costheta) + cosn2*sintheta );
a32=( cosn2*cosn3*(1-costheta) - cosn1*sintheta );
a33=( cosn3*cosn3 + (1-cosn3*cosn3)*costheta);
/*det=a11*(a22*a33-a23*a32)-a12*(a21*a33-a23*a31)+a13*(a21*a32-a22*a31);*/

        fx1 = ( fxyz(0,i) - bx );
        fy1 = ( fxyz(1,i) - by );
        fz1 = ( fxyz(2,i) - bz );

        fx2 = (   fx1*a11 + fy1*a21 + fz1*a31 );
        fy2 = (   fx1*a12 + fy1*a22 + fz1*a32 );
        fz2 = (   fx1*a13 + fy1*a23 + fz1*a33 );
                       
        fxyz(0,i) = fx2 + bx; 
        fxyz(1,i) = fy2 + by; 
        fxyz(2,i) = fz2 + bz; 
}
/*___doaxisrot()____________________________________________________________*/    
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****dobondrot()*************************************************************/
void    dobondrot(int i,float theta)
{
    double xx,yy,zz,cosn1,cosn2,cosn3,costheta,sintheta;
    int   j;
    double fx1,fy1,fz1,fx2,fy2,fz2;
    double a11,a12,a13,a21,a22,a23,a31,a32,a33,det;

    xx = fxyz(0,bondset[i][4])-fxyz(0,bondset[i][3]);
    yy = fxyz(1,bondset[i][4])-fxyz(1,bondset[i][3]);
    zz = fxyz(2,bondset[i][4])-fxyz(2,bondset[i][3]);
    cosn1 = (xx)/sqrt(xx*xx + yy*yy + zz*zz);
    cosn2 = (yy)/sqrt(xx*xx + yy*yy + zz*zz);
    cosn3 = (zz)/sqrt(xx*xx + yy*yy + zz*zz);
    while(theta >  360.0) theta = theta - 360.0;
    while(theta < -360.0) theta = theta + 360.0;
    if(theta >  180) theta = theta - 360.0;
    if(theta < -180) theta = theta + 360.0;
    costheta = cos( (double)theta*3.14159*2.0/360.0);
    sintheta = sin( (double)theta*3.14159*2.0/360.0);

a11=( cosn1*cosn1 + (1-cosn1*cosn1)*costheta);
a12=( cosn1*cosn2*(1-costheta) + cosn3*sintheta );
a13=( cosn1*cosn3*(1-costheta) - cosn2*sintheta );

a21=( cosn1*cosn2*(1-costheta) - cosn3*sintheta );
a22=( cosn2*cosn2 + (1-cosn2*cosn2)*costheta);
a23=( cosn2*cosn3*(1-costheta) + cosn1*sintheta );

a31=( cosn1*cosn3*(1-costheta) + cosn2*sintheta );
a32=( cosn2*cosn3*(1-costheta) - cosn1*sintheta );
a33=( cosn3*cosn3 + (1-cosn3*cosn3)*costheta);

/*
det=a11*(a22*a33-a23*a32)-a12*(a21*a33-a23*a31)+a13*(a21*a32-a22*a31);

             sprintf(alertstr,"vectors: %d, %d  define:"
               "\015rotation about: %.3f, %.3f, %.3f to  %.3f, %.3f, %.3f"
               "\015scope: %d, %d"
               "\015angle of: %f, cos= %f,  sin= %f"
               "\015direction cosines: %f, %f, %f"
               "\015determinant: %f"
                                 ,bondset[i][3]
                                 ,bondset[i][4]
                                 ,fxyz(0,bondset[i][3])
                                 ,fxyz(1,bondset[i][3])
                                 ,fxyz(2,bondset[i][3])
                                 ,fxyz(0,bondset[i][4])
                                 ,fxyz(1,bondset[i][4])
                                 ,fxyz(2,bondset[i][4])
                                 ,bondset[i][1]
                                 ,bondset[i][2]
                                 ,theta,costheta,sintheta
                                 ,cosn1,cosn2,cosn3
                                 ,det
               );
             dosinglealert();
*/
    for(j=bondset[i][1]; j<=bondset[i][2]; j++)
    {   /*new coord = (transto000,* matrix elements, transback)*/
        /*matrix components from Rogers & Adams pg. 55 */

        fx1 = ( fxyz(0,j) - fxyz(0,bondset[i][4]) );
        fy1 = ( fxyz(1,j) - fxyz(1,bondset[i][4]) );
        fz1 = ( fxyz(2,j) - fxyz(2,bondset[i][4]) );

        fx2 =          (   fx1*a11
                         + fy1*a21
                         + fz1*a31
                       );

        fy2 =          (   fx1*a12
                         + fy1*a22
                         + fz1*a32
                       );

        fz2 =          (   fx1*a13
                         + fy1*a23
                         + fz1*a33
                       );

        fxyz(0,j) = fx2 + fxyz(0,bondset[i][4]);
        fxyz(1,j) = fy2 + fxyz(1,bondset[i][4]);
        fxyz(2,j) = fz2 + fxyz(2,bondset[i][4]);

    }
}
/*___dobondrot()____________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****reinitialbondrots()*************************************************/
void reinitialbondrots()
{
  int i;
  float theta,thetain,thetaout;
  
  if(nbondrot > 0)
  {
       for(i=1; i<=nbondrot; i++)
       {
              if(bondrotin[i]<0.0) thetain = 360.0 + bondrotin[i];
              else thetain = bondrotin[i];
              if(bondrotout[i]<0.0) thetaout = 360.0 + bondrotout[i];
              else thetaout = bondrotout[i];
              theta = thetain - thetaout;
              if(theta >  180.0) theta =  theta - 360.0;
              if(theta < -180.0) theta =  theta + 360.0;
              dobondrot(i,theta);
              bondrotout[i] = bondrotin[i];
       }
            SetsinGrafWindow();       /*MAGEBBOX.C*/
            Lrecalculate = 1;
  }
}
/*___reinitialbondrots()________________________________________________*/

/****initrot()*****initialize stored rotation matrix*************************/
void    initrot()
{
    int        i;
    
    for(i=1; i<=MAXRESETS ; i++)
    {
        ma[i][1] = 1.0;  
        ma[i][2] = 0.0;
        ma[i][3] = 0.0;
        ma[i][4] = 0.0;
        ma[i][5] = -1.0;  /* handedness of screen coordinates, */
        ma[i][6] = 0.0;        /* y mapped down from upper left, we map y up*/
        ma[i][7] = 0.0;
        ma[i][8] = 0.0;
        ma[i][9] = 1.0;
     }
 }
/*___initrot()______________________________________________________________*/

/****resetrot()*****reset rotation matrix, etc ******************************/
void    resetrot(int i)
{
    int j;  /* resetting is tricky since matrix, centering, zcliping can all*/
            /*  be set separately.  So undefined ones for a particular i  */
            /*  are reset to the 1st resetting */
    
    if(i <= MAXRESETS);
    {
        iviewset = i;
    /*---------------------------------*/
        if(Lreset[i]) j = i;
        else          j = 1;

        a11 = ma[j][1];
        a12 = ma[j][2];
        a13 = ma[j][3];
        a21 = ma[j][4];
        a22 = ma[j][5];
        a23 = ma[j][6];
        a31 = ma[j][7];
        a32 = ma[j][8];
        a33 = ma[j][9];

    /*---------------------------------*/
        if(Lzoomer[i]) j = i;
        else           j = 1;
        zoom = zoomold[j];
        scalenew = scale*zoom;
        Lzoom = Lzoomer[j];
/*Zx*/  resetgrafzoomBar(); 

    /*---------------------------------*/
        if(Lcenter[i]) j = i;
        else           j = 1;
        fxcenternew = fxcenterold[j];
        fycenternew = fycenterold[j];
        fzcenternew = fzcenterold[j];
    /*----------------------------------*/
        if(Lzcliper[i]) j = i;
        else            j = 1;
        Lzclip = Lzcliper[j];
        if(IMAC)
        {
            fzclip =  ((float)oldmaxwide/400.0) ;
                /*oldmaxwide set by last SetUpGrafPort()*/
                /*fzclip scales zclip to resized screen box*/
        }
        izclip = izclipold[j]*fzclip; /*fzclip==1.0 for PC*/
        resetgrafzclipBar();  /*___BAR.C*/
    /*----------------------------------*/
        if(Lztraner[i]) j = i;
        else            j = 1;
        Lztran = Lztraner[j];
        iztran = iztranold[j];
        resetgrafztranBar();  /*___BAR.C*/
    /*----------------------------------*/

    /*flatland only changes ixtran, iytran reset to zero anyway*/
        ixtran = 0;
        iytran = 0;

        checkcurrentviewmenu(i);  /*___MENU.C*/

        rescalekinemage(); /*MAGEINPT.c*/
    }
}
/*___resetrot()_____________________________________________________________*/

/****setrotview()*****reset rotation matrix, etc ****************************/
void    setrotview(int i)
{    
    iviewset = i; /*current last-set view */
    Lreset[i] = 1;  /* there is ith matrix */
    Lview[i] = 1;   /* there is ith view */
    
    ma[i][1] = a11;
    ma[i][2] = a12;
    ma[i][3] = a13;
    ma[i][4] = a21;
    ma[i][5] = a22;
    ma[i][6] = a23;
    ma[i][7] = a31;
    ma[i][8] = a32;
    ma[i][9] = a33;

    if(Lzoom)  Lzoomer[i] = 1;
    else       Lzoomer[i] = 0;
    Lzoomer[i] = 1;
    zoomold[i] = zoom;
    /*scaleold[i] = scalenew;*/

    Lcenter[i] = 1;

    fxcenterold[i] = fxcenternew;
    fycenterold[i] = fycenternew;
    fzcenterold[i] = fzcenternew;

    if(Lzclip)  Lzcliper[i] = 1;
    else        Lzcliper[i] = 0;
    Lzcliper[i] = 1;
    izclipold[i] = izclip/fzclip;/*fzclip scales zclip to resized screen box*/
    
    if(Lztran) Lztraner[i] = 1;
    else       Lztraner[i] = 0;
    Lztraner[i] = 1;
    iztranold[i] = iztran;
    
}
/*___setrotview()___________________________________________________________*/

/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/

