/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/*mageText.c*****************************************************************/

#include "MAGE.H"
/*mageText.c*/

/****GetTextFromFile()*******************************************************/
void    GetTextFromFile()
{

static    char    wkeys[256], texts[256],buffs[256];
static    int     c,i,itext,ibuff,cm0,cm1,cm2,cm3,hyperflag,quesflag;
static    int     n,LCRLF,ido,Lastchar,ikeyw;
static    int        flowID;  /* switch controls for input */
    enum
        {
            neutID = 1,
            keywID,
            textID,
            kineID
        };     
static    int        Ltext=0, Lkine=0, Lnew=1;
                /* Logicals for input flow */
static    int        Ltextstate=0; 
                /* Logical to help allow @ to be a character inside of text */

       /*IOerr = 0;*/  /* Start by presuming no IO error */

       /*IOerr = getfiletext();*/  /*MACFILE.C*/
                      /* Mac just opens file, PC has already opened file,*/
                      /* and set up for individual char passing */
                      /* gettextfromfile is called by findkin(): MPCFILE.C */
                      /* getfiletext(); is dummied in MPCFILE.C */
      Lkinemagecount = 0; /*as far as one knows at this stage*/
      if(IOerr == 0)
      { /*valid input file*/

        atEOF = 0;
        Lfile = TRUE;
        
        sprintf(texts,CRLF" Looking for kinemages in file: %s"CRLF,NameStr);/*950113*/
        cleartexts();         /*MACTEXT.C MPCTEXT.C */
        inserttexts(texts);   /*MACTEXT.C MPCTEXT.C */
        n = 0;
        i = 0;
        ibuff = 0;
        itext = 0;
        ntotaltext = 0;
        flowID = neutID;
        /* flow controls and logicals together direct the flow */
        LCRLF = 0; /*flag so can make CRLF -> CR */
        Lastchar = 0; /*flag_char so can tell if @ starts a line*/
        ido = 1; /*flag that allows a character to be considered*/

        /*clean up Answer storage for putative Questions in text*/
        for(i=0;i<MAXQUESTIONS;i++) thisanswer[i][0] = '\0';
        nQuestion = 0; /*Question counter*/
        hyperflag = 0; /*signels hypertext control region*/
        quesflag = 0; /*signels question is active*/
        oldNqueskin = 0;
        oldNquesview = 0;

if(Ltest){sprintf(alertstr,"GetTextFromFile()"
"\015 Looking for kinemages in file: %s \015",NameStr);
dosinglealert();}

        while ((c = getnextchar() ) != EOF)
/*c*/   /* c = getc(fp) replaced:*/
        /* #define getnextchar()  getc(fp) for Mac & ESV in MAGE.H */
        /*  MPCFILE.C getnextchar() return(*filebuf++) or EOF */
        {/*individual char input loop while file not at EOF */
            ido = 1; /*expect a valid character to be processed*/


/*#ifndef PCWINDOWS */ /*940810 try with both Mac and PC */
/*problem MAC vs PC:  MAC seems to need CRLF to be flattened into CR:\015 */
/* PC gets double line ends unless NOTHING is done to CRLF possible characters*/

            if (c == '\n' || c == '\r') /*some mixture of LF:\012 and CR:\015*/
            {/*CRLF character type*/
                /*whatever newline is, it needs to be just single CR in text */
                /*this section flattens \012\015 pairs, but respects singles*/
                if(LCRLF>0)
                {/*previous character was CRLF type*/
                    if(c=='\012' && LCRLF=='\015')
                    {/*already got a CR, ignore this LF*/
                        ido = 0;
                        LCRLF = 0; /*clear flag*/
                    }
                    else if(c=='\015' && LCRLF=='\012')
                    {/*already got a LF, ignore this CR*/
                        ido = 0;
                        LCRLF = 0; /*clear flag*/
                    }
                    else
                    {/*previous character the same, so serious new line again!*/
                        c = '\015';
                        LCRLF = 0; /*clear flag*/
                        /*note if \n || \r are not either \012 || \015 */
                        /*  this routine treats them as singles and makes a */
                        /*  new line for each! */
                    }
                }/*previous character was CRLF type*/
                else
                {/*a new occurance of CRLF character type*/
                    if(c=='\012') LCRLF = '\012';  /*set flag*/
                    else if(c=='\015') LCRLF = '\015';  /*set flag*/
                    c = '\015';/*accept, and make standard new line indicator*/
#ifdef UNIX_X11
                    c = '\n';
#endif
                }
            }/*CRLF character type*/
            else LCRLF = 0; /*not CRLF: make sure flag is clear*/
/*#endif*/ /*!PCWINDOWS*/

            if (   c == '@' && Lastchar == 0
                || c == '@' && Lastchar == '\r'
                || c == '@' && Lastchar == '\n')
            {/*keywords @text and @kinemage must begin a new line*/

                flowID = keywID; /* need to get begin's key word */
                iword = 0;       /* set keyword character counter */
                if(Ltext)
                {
                    Ltextstate = 1;
                    /*set flag so if @ part of text it can be recovered*/
                    ibuff = 0;  /* set counter to track this text segment */
                }
                if(Ltest)
                {
                     sprintf(alertstr,"found @");dosinglealert();
                }
            }
            if(ido)      /*wx931123*/
            {/*ido*/
            switch(flowID)
            {
                case neutID:
                    /* neutral: no flow designated, discard characters */
                break;

                case textID:
                   /*accummulate 4 successive characters, allows special input*/
                    cm3=cm2;cm2=cm1;cm1=cm0;cm0=c;
                    /* text expected, send characters to textText */
                    texts[itext] = c;
                    if(cm1=='*'&&cm0=='{')  
                    {
                        hyperflag = 1;
                        iQstring = 0;
                    }
                    if(cm1=='}'&&cm0=='*') 
                    {
                        hyperflag = 0;
                        Qstring[iQstring-1] = '\0';/*overwrite closing bracket*/
                        Dotexthyperbutton(0);/* 0 for setup *//*MAGEFILE.C*/
                        if(quesflag)
                        {
                            for(i=0;i<MAXQCHAR+2;i++) texts[++itext] = '_';
                                /* underscores: extra on each end*/
                            quesflag = 0;
                        }
                    }
                    if(hyperflag>0)
                    {
                        hyperflag++;
                        if(hyperflag>2) Qstring[iQstring++] = c;
                    }
                    if(cm3=='*'&&cm2=='{'&&cm1=='Q'&&cm0==':')
                    {/*Question, insert a question number*/
                        Lquesanswers = 1;/*flag that there are questions*/
                        nQuestion++;
                        if(nQuestion < MAXQUESTIONS)
                        {
                            sprintf(word," %d ",nQuestion);
                            for(i=0;word[i]!='\0';i++) texts[++itext]=word[i];
                         for(i=0;word[i]!='\0';i++) Qstring[iQstring++]=word[i];
                            quesflag = 1;
                        }
                        else
                        {
                            sprintf(alertstr,"*{Q: questions exceed %d, "
                                "no more can be assigned numbers"
                                ,MAXQUESTIONS-1);  
                            dosinglealert();
                        }
                    }
                    if (itext >= 200 || c == '\015') /*allows for insertions */
                    {
                        texts[itext+1] = '\0'; /*make array of characters*/
                                            /* into properly ended C string*/
/*Tx*/                  inserttexts(texts); /*MACTEXT.C MPCTEXT.C */
                        itext = 0;
                    }
                    else
                    {
                        itext++;
                        ntotaltext++;
                    }
                break;

                case keywID:
                    /*try to interpret next set of characters as a key word*/
                    if(Ltextstate && ibuff<255)
                    {    /*in case this is not a key word*/
                        buffs[ibuff] = c; /*continue to accummulate text */
                        ibuff++;        /*in case this is not a key word*/
                        if(hyperflag) Qstring[iQstring++] = c; 
                            /*continue to accumulate hypertext string */
                    }
                   /*@keyword must be contiguous characters as a single word*/

                    if(c == '@')
                    {
                        ;  /* @ discarded */
                    }
                    else
                    {/*looking only for text to start, and kinemage to end */
                        iword = iword + 1;
                            /* iword set = 0 when flowID set = keywID */
                        word[iword] = c;
                        word[iword] = tolower(word[iword]); /*c*/
                                    /*case independent */
                           /*beware: ctype.h  redefines tolower wrong*/
                        if( (c == ' ')||(c == '\015')||(c == ',')||
                            (c == ';')||(iword > 8)||(c == '\n')     )
                        {   /*stop looking when hit white space or 8 char*/
                            /* pad ends so can treat wkeys as a real string */
                            word[iword] = '\0';
                            word[0] = ' ';

                            /* try to interpret as a keyword string */

                           /*search for text as key word, note leading space*/
                            Ltext = 0;
                            if(strncompare(word," text",5) == 0) Ltext = 1;
                                 /*MAGEINPT.C*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
                            if(Ltext)
                            {/*CONSIDER THIS A VALID FILE WITH AT LEAST TEXT*/
                                /*clear text window! */
                                cleartexts();     /*MACTEXT.C MPCTEXT.C */
                                flowID = textID;
                                itext = 0;
                                Lkine = 0;
                                /* text and kinemage figure are exclusive */
                                if(Ltest)
                                {
                                    sprintf(alertstr,"Found @text");
                                    dosinglealert();    
                                }
                            }
                            /* search for kinemage as key word,*/
                            Lkine = 0;            /* note leading space*/
                            if(strncompare(word," kinemage",9) == 0) Lkine =1;
                                 /*MAGEINPT.C*/
                            if(Lkine)
                            {
                                /* finish out anything in text buffer */
                                texts[itext+1] = '\0';
                                /*completetext();????*/
                                if ( itext >  0 )
                                {
                                    inserttexts(texts); /*MACTEXT.C MPCTEXT.C*/
                                }
                                completetext();/*MPCTEXT.C, MACTEXT.C(dummied)*/
                                flowID = kineID;
                                Ltext = 0;  /* text and figure are exclusive*/
                                Lnew = 1;  
                                    /*flag start of scan for kinemage number*/
                            }
                            iword = 0;
                            
                            /* end try to interpret as control string */
                            if(Lkine && Ltextstate) Ltextstate = 0; 
                                                    /* clear flag */
                            if(!Lkine && Ltextstate) 
                            {/*write key word buffer to text*/
                                for(n=0;n<ibuff;n++)
                                {
                                    texts[itext] = buffs[n];
                                    if (itext == 254 || c == '\015')
                                    {
                                        texts[itext+1] = '\0';     
                                      inserttexts(texts);/*MACTEXT.C MPCTEXT.C*/
                                        itext = 0;
                                    }
                                    else
                                    {
                                        itext++;
                                        ntotaltext++;
                                    }
                                }
                                flowID = textID; /* restore control */
                                Ltext = 1;
                                ibuff = 0;
                            }
                        }/* stop looking when hit white space or 8 char max */
                    }/*looking only for text to start, and kinemage to end */
                break; /* case = keywID */
                
                case kineID: 
                    /* marks the only legitimate end to the text section */
                    /*when done, getkinemagenum returns as 1, */
                    /*this ends text section */
                    if( getkinemagenum(c,Lnew) ) /*MAGETEXT.C*/
                    {
                        Lkinfile = 1;
                        AdjustMenus();  /*MACMENU.C, MPCMENU.C*/
                            /*affects kinemage menu*/
                        if(Ltest)
                        {
                            sprintf(alertstr,"Found @kinemage %d "
                            ,kinemagenum);
                            dosinglealert();   
                        }                        
                        goto finished;/*JUMP OUT OF THIS PLACE*/
                    }
                    Lnew = 0;
                break;
            }/* loop switch cases */
            }/*ido*/
            Lastchar = c; /*however c is set, allows testing for new line*/
        }/*individual char input loop while file not at EOF */
        
        /*EOF section******************/
        if(Ltext || Ltextstate)  /* finish out anything in text buffer */
        {  

            texts[itext+1] = '\0';
            if ( itext >  0 )
            {
                 inserttexts(texts);  /*MPCTEXT.C, MACTEXT.C */
            }
            completetext();/*MPCTEXT.C, MACTEXT.C(dummied) */
            /* Can only get here if hit EOF while reading the text section */
            /* Do NOT Warn the reader: */
            /*  this may be a legitimate table of contents, etc. */
            IOerr = 0; 
                      
        }
        else
        {
            printf("EOF reached while looking for text,"
            " no kinemage recognized in this file\n");
            sprintf(alertstr,"EOF reached while looking for text,"
            " no kinemage recognized in this file");
            dosinglealert();
            IOerr = 1;
        }
        atEOF = 1;
        makecursoractive(); /*MACMAIN.C*/ /*reader needs control of cursor*/ 
        /*EOF section___________________*/
        
      } /* loop with valid input file */
    
      finished: ;    
      return;
}
/*___GetTextFromFile()______________________________________________________*/

/****getkinemagenum(c,Lnew)**************************************************/  
int        getkinemagenum(char c,int Lnew)  
        /*sucessful acquisition of number sets IOerr = 0 */
{
    int        ireturn;
    
    ireturn = 0;
    if(Lnew)
    {
        inumstr = 0;
    }
    if(c==' ' && inumstr==0)
    {
        ;  /* skip beginning spaces */
    }
    else if(c=='0'||c=='1'||c=='2'||c=='3'||c=='4'||
            c=='5'||c=='6'||c=='7'||c=='8'||c=='9'  )
    {
        numstr[inumstr] = c;
        inumstr++;
    }
    else  /* anything besides numerals ends a number*/
    {
        numstr[inumstr] = '\0';  /* ends a number */
        if(inumstr == 0)
        {
            kinemagenum = 0;
        }
        else
        {
            sscanf(numstr,"%d",&kinemagenum);
        }
/*c*/   sprintf(KineName,"Kinemage  %d - ",kinemagenum);

        ireturn = 1;  /* some number was retrieved or invented*/
        IOerr = 0; 
    }
    return(ireturn);
}
/*___getkinemagenum()_______________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****kinesearch()************************************************************/
int     kinesearch()
{
static    int     c,flowID;  /* switch controls for input */
    enum{ neutID = 1, keywID, kineID };     
static        int        Lkine, Lnew; /* Logicals for input flow */

        flowID = neutID;
      /*while ((c = getc(fp)) != EOF)*/
        while ((c = getnextchar() ) != EOF)
/*c*/   /* c = getc(fp) replaced:*/  
        /* #define getnextchar()  getc(fp) for Mac */
        /*  MENUCMD3.C PCMAGE getnextchar() return(*filebuf++) or EOF */

        /* flow controls and logicals together direct the flow */
        {
            if (c == '\n') c = '\015';
                /* whatever newline is, it needs to be CR in text */
            if (c == '@') 
            {
                flowID = keywID; /* need to get begin's key word */
                iword = 0;  /* set keyw character counter */
            }
            switch(flowID)
            {
                case neutID:  
                    /* neutral: no flow designated, discard characters */
                break;
                    
                case keywID: 
                    /*try to interpret next set of characters as a key wor*/
                   /*@keyword must be contiguous characters as a single word*/
                    if(c == '@')
                    {
                        ;  /* @ discarded */
                    }
                    else
                    {/* this routine only looks for kinemage to end */
                        iword++; /* ikeyw set =0 when flowID set = keywID */
                        word[iword] = c;
/*c*/                    word[iword] = tolower(word[iword]);  
                                        /*case independent*/
                        if( (c == ' ')||(c == '\015')||(c == ',')||
                            (c == ';')||(iword >= 8)||(c == '\n') )
                        {/* stop looking when hit white space or 8 char max */
                            /* pad ends so can treat word as a real string */
                            word[iword+1] = '\0';
                            word[0] = ' ';
                            
                            /* try to interpret as a keyword string */
                            
                            /* search for kinemage as key word */
                            Lkine = 0;
/*I*/                       if(strncompare(word," kinemage",9) == 0) Lkine =1;

                            if(Lkine) 
                            {
                                flowID = kineID; 
                                Lnew = 1;  
                                /* flag start of scan for kinemage number */
                            }
                            else
                            {
                                flowID = neutID; /* clear flowID */
                            }
                            
                            iword = 0;
                            
                        }/* stop looking when hit white space or 8 char max */
                        
                    }/* this routine only looks for kinemage to end */
                break; /* case = keywID */
                
                case kineID: 
                    /*when done, getkinemagenum returns as 1 */
                    if( getkinemagenum(c,Lnew) ) 
                    {
                        if(kinemagenum == nextkinenum) return(1);
                            /* found desired number */
                        if(nextkinenum == 0) return(1); 
                            /* accept first encountered kinemage */
                        flowID = neutID; 
                           /*wrong number, keep looking for another kinemage*/
                    }
                    Lnew = 0;
                break;
            }/*loop switch cases */
                  
        }/*loop while file not at EOF */
        /*Warn the reader: make sure they have the mouse to click the box*/
        makecursoractive();
        sprintf(alertstr,"reached EOF while searching, "
                            "target kinemage not recognized!");
        dosinglealert();  /*MPCDLOG.C*/
        IOerr = 0;
        atEOF = 1;
        return(0);
}
/*___kinesearch()___________________________________________________________*/

/****findkinemage()**********************************************************/
void    findkinemage()
{
        Lreentry = 0;  /*920619 dcr, overloading this flag with PC use also*/
        AdjustMenus(); /*MACMENU.C*/ /*MPCMENU.C*/
        /* now interpret in terms of which kinemage to go to next */
        if (Lnextkine) 
        {
            if(atEOF)
            {
                LnextOK = 0;
                AdjustMenus(); /*MACMENU.C*/ /*MPCMENU.C*/
                Lreentry = 0;
                Lprocessing = 0; /*finished trying to bring in a kinemage */
                makecursoractive(); 
                return;
            }
            else
            {
                LnextOK = 1;
                AdjustMenus(); /*MACMENU.C*/ /*MPCMENU.C*/
                Lreentry = 1;
                return;
            }
        }
        if (Lcancel) 
        {
            makecursoractive(); /*MACMAIN.C*/  /*MPCMAIN.C*/
            return;
        }
        /*word[] has the character string for the kinemagenumber*/
        sscanf(word,"%d",&nextkinenum);  /*c*/
        /* note: kinemagenum holds kinemage flag of next one */
        /*since that's what stopped this one */

        if(nextkinenum < 0) nextkinenum = 0;  /*911124*/

        if(Ltest)
        {
             sprintf(alertstr,"now at kinemage# %d, "         /*c*/
                            "going to look for kinemage# %d"
                            ,kinemagenum,nextkinenum);
             dosinglealert();  /*MACDLOG.C*/ /*MPCDLOG.C*/
        }

        if(nextkinenum < kinemagenum)    
        {
            LnextOK = 1;
            AdjustMenus();   /*MACMENU.C*/ /*MPCMENU.C*/
            filerewind();                     
                /*MAGE.H #ifdef MACINTOSH  #define filerewind() rewind(fp)  */
                /*MPCFILE.C*/
            Lfile = TRUE;    
            atEOF = 0;
            if(Ltest)
            {
                 sprintf(alertstr,"rewind");  /*c*/
                 dosinglealert(); /*MACDLOG.C*/ /*MPCDLOG.C*/
            }

        }
        if(nextkinenum != kinemagenum)    
        {

            if(Ltest)
            {
                sprintf(alertstr,"now at kinemage# %d, "     /*c*/
                    "now really go look for kinemage# %d"
                    ,kinemagenum,nextkinenum);
                dosinglealert(); /*MACDLOG.C*/ /*MPCDLOG.C*/
            }

            if( kinesearch() ) /*search for desired kinemage*/ /*MAGEFILE.C*/
            {
                Lreentry = 1;
                
            if(Ltest)
            {
                sprintf(alertstr,"found something: used to be "   /*c*/
                    "at kinemage# %d, now at kinemage# %d"
                    ,kinemagenum,nextkinenum);
                dosinglealert(); /*MACDLOG.C*/ /*MPCDLOG.C*/
            }
                

            }
            else /* not successful, reset to present kinemage */
            {
                 makecursorwait(); /* waiting cursor again */
                                     /*MACMAIN.C*/ /*MPCMAIN.C*/
                 nextkinenum = thiskinenum; /* reset to present kinemage */
                       
                 filerewind();                     
                    /*MAGE.H #ifdef MACINTOSH #define filerewind() rewind(fp) */
                    /*MPCFILE.C*/
                 
                 atEOF = 0;
                 Lfile = TRUE;
                 LnextOK = 1;
                 AdjustMenus();  /*MACMENU.C*/ /*MPCMENU.C*/
            if(Ltest)
            {
                 sprintf(alertstr,"NOT FOUND: used to be at "   /*c*/
                    "kinemage# %d, now look for kinemage# %d"
                    ,kinemagenum,nextkinenum);
                 dosinglealert();  /*MACDLOG.C*/ /*MPCDLOG.C*/
            }

                 if( kinesearch() ) Lreentry = 1; /*MAGEFILE.C*/
            }
        }
        else if(nextkinenum == kinemagenum)
        {
            if(Ltest)
            {
                 sprintf(alertstr," at kinemage# %d, "  /*c*/ 
                    "now should be at kinemage# %d"
                    ,kinemagenum,nextkinenum);
                 dosinglealert();  /*MACDLOG.C*/ /*MPCDLOG.C*/
            }
            Lreentry = 1;
        }
        /* Lreentry  sets goto entry point where */
        /*old kinemage cleared and next one read in */
        return;    
}
/*___findkinemage()_________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****setkinemage()***********************************************************/
void    setkinemage(int nkingo)     /*931105*/
{
    int          n,m,OK,j;
    char         s[256];

        nextkinenum = nkingo;
        Lreentry = 0;  /*920619 dcr, overloading this flag with PC use also*/
/*P*/   AdjustMenus(); /*PC EXTRA.C*//*PC dummy*/
/*Mx*/  /*makecursorwait();*/ /*PC EXTRA.C*//*PC dummy*/
        /* now interpret in terms of which kinemage to go to next */
        /* note: kinemagenum holds kinemage flag of next one */
        /*since that's what stopped this one */
        if( thiskinenum != nextkinenum)
        {
            if(nextkinenum < 0) nextkinenum = 0;  /*911124*/

            if(Ltest)
            { 
/*c*/            sprintf(alertstr,"now at kinemage# %d, "
                            "going to look for kinemage# %d"
                            ,kinemagenum,nextkinenum);
/*Mx*/           dosinglealert();  /*PC EXTRA.C*/
            }

            if(nextkinenum < kinemagenum)    
            {
                LnextOK = 1;
/*P*/           AdjustMenus(); /*PC EXTRA.C*//*PC dummy*/
/*c*/           /* rewind(fp);*/   /*Mac  #define filerewind() rewind(fp)  */
                               /* PC filerewind() MENUCMD3.C resets */
                filerewind();                     
                Lfile = TRUE;    
                atEOF = 0;
                if(Ltest)
                {
/*c*/                sprintf(alertstr,"rewind");
/*Mx*/               dosinglealert(); /*PC EXTRA.C*/
                }

            }
            if(nextkinenum != kinemagenum)    
            {

                if(Ltest)
                {
/*c*/               sprintf(alertstr,"now at kinemage# %d, "
                        "now really go look for kinemage# %d"
                        ,kinemagenum,nextkinenum);
/*Mx*/              dosinglealert(); /*PC EXTRA.C*/
                }

/*T*/           if( kinesearch() ) /* search for desired kinemage */
                {
                    Lreentry = 1;
                
                    if(Ltest)
                    {
/*c*/                   sprintf(alertstr,"found something: used to be "
                            "at kinemage# %d, now at kinemage# %d"
                            ,kinemagenum,nextkinenum);
/*Mx*/                  dosinglealert(); /*PC EXTRA.C*/
                    }
                }
                else /* not successful, reset to present kinemage */
                {
/*Mx*/              makecursorwait(); /* waiting cursor again */
                                     /* PC dummy *//*PC EXTRA.C*/
                    nextkinenum = thiskinenum; /* reset to present kinemage */

/*c*/               /* rewind(fp);*/   /*Mac  #define filerewind() rewind(fp)  */
                               /* PC filerewind() MENUCMD3.C resets */
                    filerewind();                     

                    atEOF = 0;
                    Lfile = TRUE;
                    LnextOK = 1;
/*P*/               AdjustMenus();  /*PC dummy */ /*PC EXTRA.C*/
                    if(Ltest)
                    {
/*c*/                   sprintf(alertstr,"NOT FOUND: used to be at "
                            "kinemage# %d, now look for kinemage# %d"
                            ,kinemagenum,nextkinenum);
/*Mx*/                  dosinglealert();  /*PC EXTRA.C*/
                    }

/*T*/               if( kinesearch() ) Lreentry = 1;
                }
            }
            else if(nextkinenum == kinemagenum)
            {
                if(Ltest)
                {
/*c*/                sprintf(alertstr,"nextkinenum == kinemagenum"
                        " at kinemage# %d, "
                        "now should be at kinemage# %d"
                        ,kinemagenum,nextkinenum);
/*Mx*/               dosinglealert();  /*PC EXTRA.C*/
                }
                Lreentry = 1;
            }
            /* Lreentry  sets goto entry point where */
            /*old kinemage cleared and next one read in */
            if(Lreentry) /*entry();*/ /*do this here, not in master loop*/
            {                      /*PC doesn't have entry()*/

/*x*/   makecursorwait();
        maxgrp = 0;                    
        igrp[maxgrp][0] = 0; /* turn off all display*/
        Lmarkers = FALSE; /*now could call redrawvec() to blank graphics*/
/*x*/   /*showallwindows();*/ /*make visible capt, text, graf windows*/
/*R*/   initrot();

/*I*/   GetStuffFromFile(); /* should end on new kinemage number, or EOF */
/*B*/   SetsinGrafWindow();

        if(nmaster > 0)
                   for(j=1 ; j<=nmaster; j++)
/*B*/                             resetmaster(j);

        resetrot(1);         /*macPxMc.c*/ 
/*x*/   makecursorwait();
/*x*/   /*choosefrontwindow(); */
/*x*/   /*clearfocusxyzstr();  */


            }
            Lreentry = 0;
            return; 
        }   
}
/*___setkinemage()__________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****Dotexthyperbutton********************************************************/
void    Dotexthyperbutton(int isetup) /*931105,931204*/ 
{/*isetup==0 at input, 1 for run time*/

/* Note for Authors:
     Kinemage number and View number are carried forward from the last time
they were set during the linear input of the TEXT window material.  
Thus kinemage and view can be presumed for the go-to-graphics option of
a new question.  However, if these are to re-defined for the current question,
this must be done before any master-button or FIND controls are specified.
*/

    char    wkeys[256];
    int     j,n,c,ikeyw,Lprekey,flowID,Lknow,Lidn;
    int  Lnew,Lthisisaquestion,Nthismaster,Nonoff,Lsetmaster,Lquote,Lpass;
    int  Lsetsearch;
        
    enum
    {
         neutID = 1
        ,idenID = 2
        ,keywID = 3
        ,kineID = 4
        ,quesID = 5
        ,viewID = 6
        ,mastID = 7
        ,onID   = 8
        ,offID  = 9
    };     

  Lredohyperbutton=1; /*flag so can set kinemage, then do master selection*/
  Lpass = 0;
  
  while(Lredohyperbutton)
  {/*while Lredohyperbutton==1 */
    Lnew=1;        /*initialize first encounter of an object */
    Lknow = 0;
    flowID = keywID; /* need to get begin's key word */
    ikeyw = 0;  /* set keyw character counter */
    wkeys[0]=' '; /*blank inserted to make keyword logic here same as at input*/
    Lprekey = 1; /* Logical to skip blank spaces before key*/
    Lthisisaquestion = 0; /*flag to do question dialog */
    Nthismaster = 0;
    for(j=0;j<=MAXM;j++){Lquesmaster[j]=0;Nquesmaster[j]=0;}/*clearmasterflags*/
    Lquesfind = 0;/*clear search specified flag*/ 
    Nonoff = 1; /*default to start is true*/
    
    Lgographics = 0; /*flag for really go to gographics*/
    Lsetmaster = 0;  /*flag to look for a master button name*/
    Lsetsearch = 0; /*flag to do a FIND operation for a given string*/
    Lquote = 0; /*flag to signel quoted string, like a button name*/

    /*set default parameters for this hypertext control region*/
    if(isetup==0) Nqueskin[nQuestion]=oldNqueskin;/* 0 : go to first kinemage*/
    if(isetup==0) Nquesview[nQuestion] = oldNquesview; /* 0 should set view1 */ 
    /*only kinemage # and view # are carried to next hypertext*/

    Lqueskin = 1; /* kinemage set flag, all questions have associated kinemage*/
    Lquesview = 1;/* view set flag, all questions have associated view*/
    Lisgraphics = 1; /*flag to tell ques-dialog something to gographics for*/
    
    Lpass++;  
    Lredohyperbutton=0; /*one pass unless needed for master selection*/
    for(j=0; j<=iQstring; j++)
    {/*scan all characters*/
        c = Qstring[j];

        if(c == '\{' && Lquote==0)  /* start a button identifier */
        {
            Lidn = 0; /* Lidn only set = 1 after next identifier char read */
            Lquote = 1;
            iword = 0;
            flowID = idenID;
        }
        else if(c == '\}' && Lquote==1) 
        {/*end a button identifier, require both "..." */
            Lquote = 0;
            for(n=iword ; n<16 ; n++) word[n] = '\0';
            /*revision930207 pad out identifier to " with '\0' rather than ' '*/
            word[16] = '\0';  /* pad & end the string in c manner */

            if(Lsetmaster && isetup>0) /* only do this at run time*/
            {/*should hold identifier of a master button for this kinemage */
              if(Lqueskin && thiskinenum!=Nqueskin[nQuestion])
              {/*cannot do master button until new kinemage read in*/
                  Lredohyperbutton=1;
              }
              else
              {/*at kinemage for which master button name applies*/
                /* master named,*/
                condition(word); /*make into a Pascal string if on Mac*/
            
                if(nmaster > 0) /*previous master button requested */ 
                {/*see if this one matches previous a master name */ 
                    for(n=1;n<=nmaster;n++)
                    {
                        if(strncompare(word,mastername[n],13) == 0)
                        {
                            Lquesmaster[0] = 1;      /*a master specified*/ 
                            Nthismaster = n;   /*current master specified*/
                            Lquesmaster[n] = 1;/*this master specified*/ 
                            Nquesmaster[n] = Nonoff;/*current on-off flag*/ 
                            Lisgraphics = 1; /*something to gographics for*/
                  /*  
                    sprintf(alertstr,"master: Nquesmaster[%d] = %d"
                       ,Nthismaster,Nonoff);
                    dosinglealert();
                  */
                        }
                    }
                }
                Lsetmaster = 0;
              }/*at kinemage for which master button name applies*/

            }/*should hold identifier of a master button for this kinemage */
            if(Lsetsearch && isetup>0)
            {/*should hold identifier of a search pointID for this kinemage */
                if(Lqueskin && thiskinenum!=Nqueskin[nQuestion])
                {/*cannot do search until new kinemage read in*/
                    Lredohyperbutton=1;
                }
                else
                {/*at kinemage for which search is valid*/
                     /* pointID named,*/
                     /* Do NOT condition(word), search expects C-str*/
                     for(n=0;n<16;n++) search1str[n]=word[n];
                     isearch1 = iword;
                     isearch2 = 0;
                     Lquesfind = 1;/*search specified*/ 
                     Lisgraphics = 1; /*something to gographics for*/
                  /*  
                     sprintf(alertstr,"search string: %s",search1str);
                     dosinglealert();
                  */
                     Lsetsearch = 0;
                }/*at kinemage for which search is valid*/
            }
            iword = 0;
            Lidn = 0;
            flowID = keywID;
        }

            switch(flowID)
            {/*switch*/
                case neutID:  
                    /* neutral: no flow designated, discard characters */
                break;                    
                case idenID:
                    if(Lidn)
                    {
                        if(iword > 255) 
                        {
                             sprintf(alertstr,
                              "quoted string getting excess char: %s, %c\n",
                                  word,c);
                             dosinglealert();
                             ExitToShell();                                    
                        }
                        word[iword] = c;
                        iword = iword + 1;
                    }
                    else
                    {
                        Lidn = 1; /*get ready for the actual quoted characters*/                                
                    }
                break;
                    
                case keywID: 

                    /* skip blank spaces, or tabs, in the beginning */
                    /* Lprekey set = 1 where keywID set */
                    if(Lprekey && (c == ' ') || Lprekey && (c == '\t'))  
                    {
                        ;  /* skip white space */
                    }
                    else
                    {/*non-blank character*/
                        Lprekey = 0;  /* hit a non-blank character */
                        ikeyw++; /* ikeyw set =0 when flowID set = keywID */
                        
                        wkeys[ikeyw] = c;
                        
/*c*/                    wkeys[ikeyw] = tolower(wkeys[ikeyw]);  
                                        /*case independent */
                        
                        if(  (c == ' ')||(c =='\015')||(c == ',')||(c == ';')
                           ||(c =='\t')||(c =='\n')||(c == '?')||(ikeyw >= 21) )
                        {/*stop looking when hit white space or 20 char max*/
                            /* pad ends so can treat wkeys as a real string */
                            wkeys[ikeyw] = '\0';
                            wkeys[0] = ' ';
                            /* try to interpret as a keyword string */
                            
                            if(Ltest)
                            {
/*c*/                        sprintf(alertstr,"Putative hyperbutton: %s",wkeys);
                             dosinglealert();
                            }
                          if(!Lknow) 
                          {
/*.*/                       if(strncompare(wkeys," q:",3) == 0) Lknow=1;
                            if(Lknow) 
                            {
                                flowID = quesID; 
                                Lnew = 1;  /* flag start of scan for number */
                            }
                          }

                          if(!Lknow)
                          {
/*.*/                       if(strncompare(wkeys," kinemage",9) == 0) Lknow=1;
                            if(Lknow) 
                            {
                                flowID = kineID; 
                                Lnew = 1;  /* flag start of scan for number */
                            }
                          }
                          if(!Lknow)
                          {
/*.*/                       if(strncompare(wkeys," view",5) == 0) Lknow=1;
                            if(Lknow) 
                            {
                                flowID = viewID; 
                                Lnew = 1;  /* flag start of scan for number */
                            }
                          }
                          if(!Lknow)
                          {
/*.*/                       if(   strncompare(wkeys, " master",7) == 0
                                ||strncompare(wkeys," master=",8) == 0) Lknow=1;
                            if(Lknow) 
                            {
                                Lsetmaster = 1;
                            }
                          }
                          if(!Lknow)
                          {
/*.*/                       if(   strncompare(wkeys, " find",5) == 0
                                ||strncompare(wkeys," find=",6) == 0) Lknow=1;
                            if(Lknow) 
                            {
                                Lsetsearch = 1;
                            }
                          }

                          if(!Lknow)
                          {
/*.*/                       if(strncompare(wkeys," on",3) == 0) Lknow=1;
                            if(Lknow) 
                            {
                                flowID = onID; 
                            }
                          }
                          if(!Lknow)
                          {
/*.*/                       if(strncompare(wkeys," off",4) == 0) Lknow=1;
                            if(Lknow) 
                            {
                                flowID = offID; 
                            }
                          }

                          /* reset search flags: */
                          Lknow = 0;
                          
                          ikeyw=0;  
                          wkeys[0]=' '; 
                          Lprekey=1; 
                            
                        }/*stop looking when hit white space or 20 char max*/
                    }/*non-blank character*/
                break;
                case quesID: 
                    /*when done, getinteger returns as 1  */
                    if( getinteger(c,Lnew) ) /*MAGEINPT.C*/
                    {
                        nQuestion = intpass;  
                        /*intpass global to pass int back */
                        Lthisisaquestion = 1;
                        flowID=keywID; /* reset for next key word */
                        /*set default parameters for this question*/
                        if(isetup==0) Nqueskin[nQuestion] = oldNqueskin; 
                        if(isetup==0) Nquesview[nQuestion] = oldNquesview;   
                     /*only kinemage # and view # are carried to next question*/
                    }
                    Lnew = 0;
                break;
                
                case kineID: 
                    /*when done, getinteger returns as 1  */
                    if( getinteger(c,Lnew) ) /*MAGEINPT.C*/
                    {
                        Nqueskin[nQuestion] = intpass;  
                            /*intpass global to pass int back */
                        if(isetup==0) oldNqueskin=intpass; /*for next question*/
                        Lqueskin = 1;
                        flowID=keywID; /* reset for next key word */
                        Lisgraphics = 1; /*something to gographics for*/
                    }
                    Lnew = 0;
                break;
                
                case viewID: 
                    /*when done, getinteger returns as 1  */
                    if( getinteger(c,Lnew) ) /*MAGEINPT.C*/
                    {
                        if(intpass > 0 && intpass <= MAXRESETS)
                        {/*intpass global to pass int back */
                            Nquesview[nQuestion] = intpass;  
                            if(isetup==0) oldNquesview = intpass; 
                              /*for next question*/
                            Lquesview = 1;
                            Lisgraphics = 1; /*something to gographics for*/
                        }
                        flowID=keywID; /* reset for next key word */
                    }
                    Lnew = 0;
                break;

                case onID:
                    Nonoff = 1;
                    if(Nthismaster > 0) 
                        Nquesmaster[Nthismaster] = Nonoff;
                                                     /*current on-off flag*/
                    Nthismaster = 0; /*clear so can't hit same master twice*/
                    flowID=keywID; /* reset for next key word */
                break;
                
                case offID:
                    Nonoff = 0;
                    if(Nthismaster > 0) 
                        Nquesmaster[Nthismaster] = Nonoff;
                                                     /*current on-off flag*/
                    flowID=keywID; /* reset for next key word */
                    Nthismaster = 0; /*clear so can't hit same master twice*/
                break;

            }/*switch*/ 
               
     }/*scan all characters*/ 
     
     if( isetup>0 && Lthisisaquestion==1 && Lpass==1) 
     {
         DoQuesDialog();
         if(Lgographics==0) Lredohyperbutton=0; /*no redo if no graphics*/
     }
     else if( isetup>0 && Lisgraphics) Lgographics = 1;

     if( isetup>0 && Lgographics==1) gographics(); /*MAGEFILE.C*/
     if( isetup>0 && Lgographics==2)
     {

#ifdef MACINTOSH
         ShowWindow(grafWindow);
         SelectWindow(grafWindow);
#endif
#ifdef PCWINDOWS
         ShowWindow(grafWindow, SW_SHOW);
         BringWindowToTop(gWindow);
#endif
#ifdef UNIX_X11
         showthegrafwindow(); /*MUX_MENU.c*/
#endif
     }
     if( isetup==0)  Lredohyperbutton=0;
  }/*while Lredohyperbutton==1 */             
}
/*____Dotexthyperbutton______________________________________________________*/

/****gographics()*************************************************************/
void    gographics()    /*931113*/
{
    int   j;
    
    Lgographics = 0;
    if(Lqueskin) setkinemage(Nqueskin[nQuestion]);
    
    if(Lquesview) 
    {
        resetrot(Nquesview[nQuestion]); /*MAGEROTN.C*/
        /*redrawvec();*/ /*MACDXMC*/
    }
    if(Lquesmaster[0]>0) /* 0th set if any are*/
    {
        if(nmaster > 0)
        {
            for(j=1; j<=nmaster; j++)
            {
                 if(Lquesmaster[j] > 0) 
                     adjustmaster(j, Nquesmaster[j]); /*MAGEBBOX.C*/
            }
        }
    }
    if(Lquesfind)
    {
        Lsearchbegin = 1; /*search whole kinemage*/
        if( Lmarkers) /*markers are in maxgrp+1 if there was room */
        {       
            /*if there are markers available and nothing is on that*/
            /*will flag that a search was successful, turn markers on*/
            if(!Lnewlabelson && !Lpickon && !igrp[maxgrp+1][0])
                 igrp[maxgrp+1][0]=1;/*force on*/
            SetsinGrafWindow();  /*MAGEBBOX.C*/
#ifdef MACINTOSH
/*m*/       DrawControls(grafWindow);
#endif
        }

        if( mysearchpointID() ) ; /*MAGEUTIL.C*/
        else 
        {
             sprintf(alertstr,"%s\015 NOT FOUND",search1str);
             dosinglealert();
             Lsearchatend = 1;
        }
    }
       redrawvec();

#ifdef MACINTOSH
         ShowWindow(grafWindow);
         SelectWindow(grafWindow);
#endif
#ifdef PCWINDOWS
         ShowWindow(grafWindow, SW_SHOW);
         BringWindowToTop(gWindow);
#endif
#ifdef UNIX_X11
         showthegrafwindow(); /*MUX_MENU.c*/
#endif


}
/*___gographics()____________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****entry()*****************************************************************/
void    entry()
{
        int        j,isave,i;

        Lreentry = 0;
        makecursorwait(); /*MACMAIN.C*/ /*MPCMAIN.C*/
        maxgrp = 0;                    
        igrp[maxgrp][0] = 0; /* turn off all display*/
        Lmarkers = FALSE; /*now could call redrawvec() to blank graphics*/
        showallwindows(); /*make visible capt, text, graf windows*/
                          /*MACWIND.C*/ /*MPCWIND.C*/
        initrot(); /*MAGEANGL.C*/

        GetStuffFromFile(); /* should end on new kinemage number, or EOF */
                            /*MAGEINPT.C*/
        SetsinGrafWindow(); /*MAGEBBOX.C*/

        if(nmaster > 0)
            for(j=1 ; j<=nmaster; j++)
                resetmaster(j); /*MAGEBBOX.C*/

        resetrot(1);         /*MAGEANGL.C*/
        
        choosefrontwindow(); /*MACWIND.C*/ /*MPCWIND.C*/

        Lnewfile = 0; 
        clearfocusxyzstr();  /*MAGEINIT.C*/
        redrawvec(); /*MACDRAW.C*/ /*MPCDRAW.C ->redrawgraphics()*/
        makecursoractive();    /*MACMAIN.C*/ /*MPCMAIN.C*/
}
/*___entry()________________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****getnextkinemage()*******************************************************/
void    getnextkinemage(void)
{
    ireturnflag = 1;
    if(Lpruneactive||Ldrawactive) DoChangeCheckDialog(); 
        /*MACDLOG.C,MPCDLOG.C sets ireturnflag, ireturnflag==1 OK to proceed*/
    if(ireturnflag && !atEOF && !Lprocessing) 
    {   /*not at EOF and not in the middle of previous nextItem */
        Lprocessing = 1; /*flag bringing in this kinemage */
        Lnextkine = 1;
        findkinemage(); /*MAGEFILE.C, set Lreentry=1 if next kinemage OK*/
                        /*if(Lreentry==1) -> entry() MAGEFILE.C*/
    }
}
/*___getnextkinemage()______________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
