/*MAC && PC defined things, many are embedded in common code */
/* strings */
#define ST_ZOOM_TITLE   1
#define ST_ZSLAB_TITLE  2
#define ST_ZTRAN_TITLE  3

#define OK_ITEM      1  /* definitions for dialogBox  */
#define CANCEL_ITEM  2
#define TEXT_ITEM    3

#ifdef PCWINDOWS
/* Dialog box items IDC_ is used by PCwindows, DO NOT USE IDC_ */
#define MAGE_OK      901  /*OK, Yes, accept, proceed*/
#define MAGE_CANCEL  902  /*CANCEL, no action*/
#define MAGE_NO      903  /*NO, abort, kill */
#define MAGE_TEXT    904  /*TEXT, information, message to reader*/
#define MAGE_OPTION  905  /*OPTION, change, write, do something else*/
#define MAGE_OPT1    906  /*OPTION, change, write, do something else*/
#define MAGE_OPT2    907  /*OPTION, change, write, do something else*/
#define MAGE_OPT3    908  /*OPTION, change, write, do something else*/
#define MAGE_OPT4    909  /*OPTION, change, write, do something else*/

#define MAGE_EDIT1   911  /*TEXT, or any changeable stuff*/
#define MAGE_EDIT2   912  /*TEXT, or any changeable stuff*/
#define MAGE_EDIT3   913  /*TEXT, or any changeable stuff*/
#define MAGE_EDIT4   914  /*TEXT, or any changeable stuff*/
#define MAGE_EDIT5   915  /*TEXT, or any changeable stuff*/
#define MAGE_EDIT6   916  /*TEXT, or any changeable stuff*/
#define MAGE_EDIT7   917  /*TEXT, or any changeable stuff*/
#define MAGE_EDIT8   918  /*TEXT, or any changeable stuff*/
#define MAGE_EDIT9   919  /*TEXT, or any changeable stuff*/
#define MAGE_RADIO1  921  /*RADIO BUTTON*/
#define MAGE_RADIO2  922  /*RADIO BUTTON*/
#define MAGE_RADIO3  923  /*RADIO BUTTON*/
#define MAGE_RADIO4  924  /*RADIO BUTTON*/
#define MAGE_ICON    933  /*unique id for icon */

#define MAGE_DEFAULT     110
#define MAGE_ANGLE       111
#define MAGE_SEPARATION  112
#define MAGE_DEFAULTANGLE 113
#define MAGE_CURRENTANGLE 114
#define MAGE_DEFAULTSEPARATION 115
#define MAGE_CURRENTSEPARATION 116
#define MAGE_DRAWLINESON       130
#define MAGE_DRAWLINESOFF      131
#define MAGE_DRAWLINESWRITE    132
#define MAGE_DRAWLINESSHORTEN  133
#define MAGE_DRAWLINESUNPICK   134
#define MAGE_DRAWLINESMONITOR  135

/* menu items */
#define aboutItem           100
#define openItem            101
#define quitItem            102
#define writeaboutItem      110 
#define writeviewItem       111
#define writefocusItem      112
#define writedrawnewItem    113
#define writekinItem        114
#define writerottedItem     115
#define writePostScriptItem 116
#define writeQAItem         117

#define editaboutItem    200 
#define editviewItem     201
#define drawlineItem     202
#define superpickItem    203
#define pickshowItem     204
#define pruneItem        205

#define showtextItem     301
#define showcaptionItem  302
#define showgraphicsItem 303

#define nextItem         401
#define chooseItem       402

#define reset1Item       501
#define reset2Item       502
#define reset3Item       503
#define reset4Item       504
#define reset5Item       505
#define reset6Item       506
#define reset7Item       507
#define reset8Item       508
#define reset9Item       509
#define resetRItem       510

#define optionsaboutItem        601
#define widthItem               602
#define thinItem                603
#define perspecItem             604
#define whtbkgItem              605
#define B_WItem                 606

#define otheraboutItem          701
#define stereoItem              702
#define compareItem             703
#define measureItem             704
#define searchItem              705
#define readersviewItem         706
#define kludgeItem              707
#define helpItem                708
                              
#define kludgesaboutItem        801
#define GFontItem               802
#define sterangItem             803
#define xyzpointItem            804
#define gnomonItem              805
#define brotangleItem           806
#define countItem               807
#define rateItem                808
#define testItem                809
#define secretItem              810
#define plotonlyItem            811
#define flatItem                812

#define helpaboutItem          1001
#define mousehelpItem          1002
#define resizehelpItem         1003
#endif /*PCWINDOWS*/

/* these menu enum items are embedded in the code, must be defined*/
/* PC  does a typedef to HANDLE for MenuHandle */
/* UNIX_X11 does a typedef to Widget for MenuHandle */
EXTERN MenuHandle    fileMenu,writeMenu,editMenu,windMenu,kineMenu;
EXTERN MenuHandle    optiMenu,viewMenu,otherMenu,kludgeMenu,helpMenu;
EXTERN MenuHandle    appleMenu,mastersMenu,colorMenu;

/* Mac does the menu items enumerated, PC does them as arbitrary numbers */
/* but X-Windows does all buttons as Widgets, so these are redefined below*/
#ifdef MACINTOSH
  enum    
  {
      writeviewItem=2   /* write matrix,center,zoom,slab of current view */
     ,writefocusItem    /* focusItem: write focus point choice */
     ,writedrawnewItem
     ,writekinItem    
     ,writerottedItem
     ,writePostScriptItem
     ,writeQAItem       
  };

  enum    
  {
       editviewItem=2      /*old matrixItem*/
      ,drawlineItem
      ,superpickItem 
      ,pickshowItem  
      ,pruneItem             
  };

  enum    
  {
       showtextItem=1
      ,showcaptionItem
      ,showgraphicsItem
  };
  enum    
  {
      widthItem=2
     ,thinItem
     ,perspecItem
     ,whtbkgItem
     ,B_WItem
  };

  enum    
  {
      stereoItem=2
     ,compareItem
     ,measureItem
     ,searchItem 
     ,readersviewItem     
     ,kludgeItem
     ,helpItem
  };      
  enum    
  {
      GFontItem=2
     ,sterangItem
     ,xyzpointItem
     ,gnomonItem
     ,brotangleItem
     ,countItem
     ,rateItem
     ,testItem
     ,secretItem
     ,plotonlyItem /*kalide*/
     ,flatItem     /*flatland*/
  };
  enum    {appleID = 1,fileID,writeID,editID,windID,kineID,optiID
                      ,viewID,otherID,kludgeID,colorID,mastersID,helpID};
  enum    { nextItem = 1, chooseItem = 2 };

  enum    { openItem = 1,d2Item,aboutItem,d4Item,writeItem,d6Item,quitItem };
  enum    { reset1Item = 1,reset2Item,reset3Item,reset4Item,reset5Item
           ,reset6Item,reset7Item,reset8Item,reset9Item,resetRItem };

  enum    { mousehelpItem=2,resizehelpItem }; /* help  menu */
EXTERN  int theitem,theotheritem;
#endif /* MACINTOSH*/

#ifdef UNIX_X11
EXTERN  Widget theitem,theotheritem;
EXTERN  Widget openItem,aboutItem,writeItem,quitItem;
EXTERN  Widget writeaboutItem,editaboutItem,optionsaboutItem,otheraboutItem;
EXTERN  Widget writeviewItem,writefocusItem,writedrawnewItem,writekinItem;
EXTERN  Widget writerottedItem,writePostScriptItem,writeQAItem;
EXTERN  Widget editviewItem,drawlineItem,superpickItem,pickshowItem;
EXTERN  Widget pruneItem,showtextItem,showcaptionItem,showgraphicsItem;
EXTERN  Widget nextItem,chooseItem;
EXTERN  Widget widthItem,thinItem,perspecItem,whtbkgItem,B_WItem;
EXTERN  Widget reset1Item,reset2Item,reset3Item,reset4Item,reset5Item;
EXTERN  Widget reset6Item,reset7Item,reset8Item,reset9Item,resetRItem;
EXTERN  Widget stereoItem,compareItem,measureItem;
EXTERN  Widget searchItem,readersviewItem,kludgeItem,helpItem;
EXTERN  Widget GFontItem,sterangItem,xyzpointItem,gnomonItem,brotangleItem;
EXTERN  Widget countItem,rateItem,testItem,secretItem,plotonlyItem,flatItem;
EXTERN  Widget mousehelpItem,resizehelpItem;
EXTERN  Widget menuBar,fileButton,writeButton,editButton,windButton,kineButton;
EXTERN  Widget    optiButton,viewButton,otherButton,kludgeButton,helpButton;
EXTERN  Widget kludgesaboutItem,helpaboutItem;
#endif /*UNIX_X11*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/

