/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/*MUXMBAR.c*/
#include "MAGE.H"

/****zoom_CB*****************************************************************/
void zoom_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
/*     Widget w;                       */
/*     caddr_t client_data;            */
/*     XmAnyCallbackStruct *call_data; */
{
    int                shiftPlace;
    short    maxValue=8192,minValue=32;    /*over-rides for zoom range */
    XmScrollBarCallbackStruct *cbs = (XmScrollBarCallbackStruct *)call_data;
    shiftPlace = cbs->value;
    /*shiftPlace = zoom*( (maxValue - minValue)/5.0 );*/
    zoom = shiftPlace/( (maxValue - minValue)/5.0 );
    resetgrafcntlbar(&vgrafzoom,shiftPlace); /*___BAR.C*/
    writezoomvalue(); /*___BAR.C*/
    scalenew = scale*zoom;
    rescalekinemage(); /*MAGEINPT.C*/
    redrawvec(); /*MACDRAW.C*/
}
/*___zoom_CB________________________________________________________________*/

/****zclip_CB****************************************************************/
void zclip_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
/*     Widget w;                       */
/*     caddr_t client_data;            */
/*     XmAnyCallbackStruct *call_data; */
{
    int                shiftPlace;
    short    maxValue=800,minValue=10;    /*over-rides for zoom range */
    XmScrollBarCallbackStruct *cbs = (XmScrollBarCallbackStruct *)call_data;
    shiftPlace = cbs->value;
    resetgrafcntlbar(&vgrafzclip,shiftPlace); /*___BAR.C*/
    izclip = (int)(shiftPlace*fzclip);
    writezclipvalue(); /*___BAR.C*/
    redrawvec(); /*MACDRAW.C*/
}
/*___zclip_CB_______________________________________________________________*/

/****ztran_CB****************************************************************/
void ztran_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
/*     Widget w;                       */
/*     caddr_t client_data;            */
/*     XmAnyCallbackStruct *call_data; */
{
    int                shiftPlace;
    short    maxValue=500,minValue=-500;    /*over-rides for zoom range */
    XmScrollBarCallbackStruct *cbs = (XmScrollBarCallbackStruct *)call_data;
    shiftPlace = cbs->value;
    iztran = shiftPlace;
    resetgrafcntlbar(&vgrafztran,shiftPlace); /*___BAR.C*/
    writeztranvalue(); /*___BAR.C*/
    redrawvec(); /*MACDRAW.C*/
}
/*___ztran_CB_______________________________________________________________*/

/****bondrot_CB**************************************************************/
void bondrot_CB(Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
/*     Widget w;                       */
/*     caddr_t client_data;            */
/*     XmAnyCallbackStruct *call_data; */
{
    XmScrollBarCallbackStruct *cbs = (XmScrollBarCallbackStruct *)call_data;
    int i;
    float theta;

    i = (int)client_data;
    theta = cbs->value - bondrotout[i];
    bondrotout[i] = cbs->value;
    writebondrotvalue(i); /*___BAR.C*/
    /* do bond rotation matrix update and apply, then... */
    /* rotation done on float array entries*/ /*MAGEANGL.C*/
    dobondrot(i,theta); /*MAGEANGL.C*/
    rescalekinemage();  /* rescale rebuilds from float arrary*/ /*MAGEINPT.C*/
    redrawvec();
}
/*___bondrot_CB_____________________________________________________________*/

#ifdef UNDEFINED
/****bondrot_CB**************************************************************/
void bondrot_CB[2](Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    XmScrollBarCallbackStruct *cbs = (XmScrollBarCallbackStruct *)call_data;
    bondrotout[2] = cbs->value;
    writebondrotvalue(2); /*___BAR.C*/
    dobondrot(2,(float)bondrotout[2]); /*MAGEANGL.C*/
    rescalekinemage();  /* rescale rebuilds from float arrary*/ /*MAGEINPT.C*/
}
/*___bondrot_CB_____________________________________________________________*/
/****bondrot_CB**************************************************************/
void bondrot_CB[3](Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    XmScrollBarCallbackStruct *cbs = (XmScrollBarCallbackStruct *)call_data;
    bondrotout[3] = cbs->value;
    writebondrotvalue(3); /*___BAR.C*/
    dobondrot(3,(float)bondrotout[3]); /*MAGEANGL.C*/
    rescalekinemage();  /* rescale rebuilds from float arrary*/ /*MAGEINPT.C*/
}
/*___bondrot_CB_____________________________________________________________*/
/****bondrot_CB**************************************************************/
void bondrot_CB[4](Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    XmScrollBarCallbackStruct *cbs = (XmScrollBarCallbackStruct *)call_data;
    bondrotout[4] = cbs->value;
    writebondrotvalue(4); /*___BAR.C*/
    dobondrot(4,(float)bondrotout[4]); /*MAGEANGL.C*/
    rescalekinemage();  /* rescale rebuilds from float arrary*/ /*MAGEINPT.C*/
}
/*___bondrot_CB_____________________________________________________________*/
/****bondrot_CB**************************************************************/
void bondrot_CB[5](Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    XmScrollBarCallbackStruct *cbs = (XmScrollBarCallbackStruct *)call_data;
    bondrotout[5] = cbs->value;
    writebondrotvalue(5); /*___BAR.C*/
    dobondrot(5,(float)bondrotout[5]); /*MAGEANGL.C*/
    rescalekinemage();  /* rescale rebuilds from float arrary*/ /*MAGEINPT.C*/
}
/*___bondrot_CB_____________________________________________________________*/
/****bondrot_CB**************************************************************/
void bondrot_CB[6](Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    XmScrollBarCallbackStruct *cbs = (XmScrollBarCallbackStruct *)call_data;
    bondrotout[6] = cbs->value;
    writebondrotvalue(6); /*___BAR.C*/
    dobondrot(6,(float)bondrotout[6]); /*MAGEANGL.C*/
    rescalekinemage();  /* rescale rebuilds from float arrary*/ /*MAGEINPT.C*/
}
/*___bondrot_CB_____________________________________________________________*/
/****bondrot_CB**************************************************************/
void bondrot_CB[7](Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    XmScrollBarCallbackStruct *cbs = (XmScrollBarCallbackStruct *)call_data;
    bondrotout[7] = cbs->value;
    writebondrotvalue(7); /*___BAR.C*/
    dobondrot(7,(float)bondrotout[7]); /*MAGEANGL.C*/
    rescalekinemage();  /* rescale rebuilds from float arrary*/ /*MAGEINPT.C*/
}
/*___bondrot_CB_____________________________________________________________*/
/****bondrot_CB**************************************************************/
void bondrot_CB[8](Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    XmScrollBarCallbackStruct *cbs = (XmScrollBarCallbackStruct *)call_data;
    bondrotout[8] = cbs->value;
    writebondrotvalue(8); /*___BAR.C*/
    dobondrot(8,(float)bondrotout[8]); /*MAGEANGL.C*/
    rescalekinemage();  /* rescale rebuilds from float arrary*/ /*MAGEINPT.C*/
}
/*___bondrot_CB_____________________________________________________________*/
/****bondrot_CB**************************************************************/
void bondrot_CB[9](Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    XmScrollBarCallbackStruct *cbs = (XmScrollBarCallbackStruct *)call_data;
    bondrotout[9] = cbs->value;
    writebondrotvalue(9); /*___BAR.C*/
    dobondrot(9,(float)bondrotout[9]); /*MAGEANGL.C*/
    rescalekinemage();  /* rescale rebuilds from float arrary*/ /*MAGEINPT.C*/
}
/*___bondrot_CB_____________________________________________________________*/
/****bondrot_CB**************************************************************/
void bondrot_CB[10](Widget w,caddr_t client_data,XmAnyCallbackStruct *call_data)
{
    XmScrollBarCallbackStruct *cbs = (XmScrollBarCallbackStruct *)call_data;
    bondrotout[10] = cbs->value;
    writebondrotvalue(10); /*___BAR.C*/
    dobondrot(10,(float)bondrotout[10]); /*MAGEANGL.C*/
    rescalekinemage();  /* rescale rebuilds from float arrary*/ /*MAGEINPT.C*/
}
/*___bondrot_CB_____________________________________________________________*/
#endif /*UNDEFINED*/

#ifdef UNIX_MOTIF
/****creategrafzoomBar()*****************************************************/
void    creategrafzoomBar() 
{
    short    maxValue=8192,minValue=32;    /*over-rides for zoom range */
    /*originally 8192, 391 */
    char    name[13];
    int     left,top,right,bottom;
    int     gleft,gtop,gright,gbottom;    
    
        /* define vertical scroll bar */
        getgrafwinedges(&gleft,&gtop,&gright,&gbottom); /*___BAR.C*/
        /*UNIX drawArea width,height: gright,gbottom*/
        
        left = ZWIDTH;/*offset of left with respect to right grafwindow*/
        top = 5; /* % offset from top of grafWindow*/
        right = 0;/*offset from right side of grafwindow, always flush in UNIX*/
        bottom = 33; /* % offset from top of grafWindow*/
        /* upper third for zoom bar */
            
        makegrafcntlbar(&vgrafzoom
                        ,left,top,right,bottom
                        ,minValue,maxValue);    /*___BAR.C*/
        XtAddCallback(vgrafzoom,XmNvalueChangedCallback,zoom_CB,NULL);
        makegrafcntllabel(&zoomvalue,&vgrafzoom); /*___BAR.C*/
        writezoomvalue(); /*___BAR.C*/
      /*  hilitegrafcntlbar(&vgrafzoom);*/ /*MACBAR.C*/
}
/*___creategrafzoomBar()____________________________________________________*/
#endif

#ifdef UNIX_MOTIF

/****resetgrafzoomBar()***************************************************/
void    resetgrafzoomBar()
{
    int                shiftPlace;
    short    maxValue=8192,minValue=32;    /*over-rides for zoom range */
    /*originally 8192, 391 */
          shiftPlace = zoom*( (maxValue - minValue)/5.0 );
          resetgrafcntlbar(&vgrafzoom,shiftPlace); /*___BAR.C*/
          writezoomvalue(); /*___BAR.C*/
}
/*___resetgrafzoomBar()__________________________________________________*/

#endif

#ifdef UNIX_MOTIF
/****writezoomvalue()****************************************************/
void    writezoomvalue()
{

/*c*/   sprintf(word,"- ZOOM+");  /* 7 char in word, a global variable*/

/*c*/   sprintf(numstr,"%4.2f",zoom); /*numstr is a global variable*/
                        
        writecntlbarvalue(&zoomvalue); /*___BAR.C*/
}
/*___writezoomvalue()___________________________________________________*/

#endif

#ifdef UNDEFINED
/****erasezoomvalue()****************************************************/
void    erasezoomvalue()
{
    int     left,top,right,bottom;
    int     ileft,gtop,gright,gbottom;    

/*c*/   sprintf(word,"       ");  /* 7 char in word, a global variable*/

/*c*/   sprintf(numstr,"        "); /*numstr is a global variable*/
        condition(numstr);   /*MACMAIN.C*/
        getgrafwinedges(&gleft,&gtop,&gright,&gbottom); /*MACBAR.C*/
        /*UNIX drawArea width,height: gright,gbottom*/
        left = gright-RWIDTH-30;
        top = gtop;
        right = gright-RWIDTH;
        bottom = 1*igrafscrntall/3;
                        
        writecntlbarvalue(left,top,right,bottom); /*MACBAR.C*/
}
/*___erasezoomvalue()___________________________________________________*/

#endif

#ifdef UNIX_MOTIF

/****creategrafzclipBar()*****************************************************/
void    creategrafzclipBar()
{
    short    maxValue=800,minValue=10;    /*over-rides for zclip range */
    char    name[13];
    int     left,top,right,bottom;
    int     gleft,gtop,gright,gbottom;    
    
        /* define vertical scroll bar */
        getgrafwinedges(&gleft,&gtop,&gright,&gbottom); /*___BAR.C*/
        /*UNIX drawArea width,height: gright,gbottom*/

        left = +ZWIDTH;/*offset of left with respect to right grafwindow*/
        top = 38; /* % offset from top of grafwindow*/
        right = 0;/*offset from right side of grafwindow, always flush in UNIX*/
        bottom = 67; /* % offset from top of grafwindow*/

        /* middle third for zclip bar */
        makegrafcntlbar(&vgrafzclip
                        ,left,top,right,bottom
                        ,minValue,maxValue);   /*___BAR.C*/
        XtAddCallback(vgrafzclip,XmNvalueChangedCallback,zclip_CB,NULL);

        makegrafcntllabel(&zclipvalue,&vgrafzclip); /*___BAR.C*/
        writezclipvalue(); /*___BAR.C*/
        /*hilitegrafcntlbar(&vgrafzclip);*/ /*MACBAR.C*/
}
/*___creategrafzclipBar()____________________________________________________*/

#endif

#ifdef UNIX_MOTIF
/****resetgrafzclipBar()***************************************************/
void    resetgrafzclipBar()
{
          resetgrafcntlbar(&vgrafzclip,(int)(izclip/fzclip)); /*___BAR.C*/
          writezclipvalue(); /*___BAR.C*/
}
/*___resetgrafzclipBar()__________________________________________________*/

#endif

#ifdef UNIX_MOTIF
/****writezclipvalue()****************************************************/
void    writezclipvalue()
{

/*c*/   sprintf(word,"-ZSLAB+");  /* 7 char in word, a global variable*/

/*c*/   sprintf(numstr,"%4d",(int)(izclip/fzclip)); 
              /*numstr is a global variable*/
                        
        writecntlbarvalue(&zclipvalue); /*___BAR.C*/
}
/*___writezclipvalue()___________________________________________________*/

#endif

#ifdef UNDEFINED
/****erasezclipvalue()****************************************************/
void    erasezclipvalue()
{
    int     left,top,right,bottom;
    int     gleft,gtop,gright,gbottom;    

/*c*/   sprintf(word,"       ");  /* 7 char in word, a global variable*/

/*c*/   sprintf(numstr,"        "); /*numstr is a global variable*/
        condition(numstr);  /*MACMAIN.C*/
        getgrafwinedges(&gleft,&gtop,&gright,&gbottom); /*MACBAR.C*/
        /*UNIX drawArea width,height: gright,gbottom*/
        left = gright-RWIDTH-30;
        top = gtop +igrafscrntall/3;
        right = gright-RWIDTH;
        bottom = 2*igrafscrntall/3;
                        
        writecntlbarvalue(left,top,right,bottom); /*MACBAR.C*/

}
/*___erasezclipvalue()___________________________________________________*/

#endif

#ifdef UNIX_MOTIF

/****creategrafztranBar()*****************************************************/
void    creategrafztranBar()
{
    short    maxValue=500,minValue=-500;    /*over-rides for ztran range */
    int     left,top,right,bottom;
    int     gleft,gtop,gright,gbottom;    
    
        /* define vertical scroll bar */
        getgrafwinedges(&gleft,&gtop,&gright,&gbottom); /*___BAR.C*/
        /*UNIX drawArea width,height: gright,gbottom*/

        left = +ZWIDTH;/*offset of left with respect to right grafwindow*/
        top = 72; /* % offset from top of grafWindow*/
        right = 0;/*offset from right side of grafwindow, always flush in UNIX*/
        bottom = 99; /* % offset from top of grafWindow*/
        /* bottom third for zclip bar */
        makegrafcntlbar(&vgrafztran
                        ,left,top,right,bottom
                        ,minValue,maxValue);   /*___BAR.C*/
        XtAddCallback(vgrafztran,XmNvalueChangedCallback,ztran_CB,NULL);

        makegrafcntllabel(&ztranvalue,&vgrafztran); /*___BAR.C*/
        writeztranvalue(); /*___BAR.C*/
        /*hilitegrafcntlbar(&vgrafztran);*/ /*MACBAR.C*/
}
/*___creategrafztranBar()____________________________________________________*/

#endif

#ifdef UNIX_MOTIF
/****resetgrafztranBar()***************************************************/
void    resetgrafztranBar()
{
          resetgrafcntlbar(&vgrafztran,iztran); /*___BAR.C*/
          writeztranvalue(); /*___BAR.C*/
}
/*___resetgrafztranBar()__________________________________________________*/

#endif

#ifdef UNIX_MOTIF
/****writeztranvalue()****************************************************/
void    writeztranvalue()
{

/*c*/   sprintf(word,"-ZTRAN+");  /* 7 char in word, a global variable*/

/*c*/   sprintf(numstr,"%4d",iztran); /*numstr is a global variable*/
                        
        writecntlbarvalue(&ztranvalue); /*___BAR.C*/
}
/*___writeztranvalue()___________________________________________________*/

#endif

#ifdef UNDEFINED
/****eraseztranvalue()****************************************************/
void    eraseztranvalue()
{
    int     left,top,right,bottom;
    int     gleft,gtop,gright,gbottom;    

/*c*/   sprintf(word,"       ");  /* 7 char in word, a global variable*/

/*c*/   sprintf(numstr,"        "); /*numstr is a global variable*/
        condition(numstr);  /*MACMAIN.C*/
        getgrafwinedges(&gleft,&gtop,&gright,&gbottom); /*MACBAR.C*/
        /*UNIX drawArea width,height: gright,gbottom*/
        left = gright-RWIDTH-30;
        top = gtop +2*igrafscrntall/3;
        right = gright-RWIDTH;
        bottom = 3*igrafscrntall/3 ;
                        
        writecntlbarvalue(left,top,right,bottom); /*MACBAR.C*/

}
/*___eraseztranvalue()___________________________________________________*/

/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
#endif
#ifdef UNIX_MOTIF
/****makegrafcntlbar()********************************************************/
void    makegrafcntlbar(Widget *vgrafcntl
                        ,int left,int top,int right,int bottom
                        ,short minValue,short maxValue)
{
/*printf("makegrafcntlbar():L,T,R,B: %d, %d, %d, %d\n",left,top,right,bottom);*/
  n = 0;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_OPPOSITE_FORM); n++;
  XtSetArg(args[n], XmNleftOffset, -left); n++;

  XtSetArg(args[n], XmNtopAttachment, XmATTACH_POSITION); n++;
  XtSetArg(args[n], XmNtopPosition, top); n++;

  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNrightOffset, right); n++;

  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_POSITION); n++;
  XtSetArg(args[n], XmNbottomPosition, bottom); n++;

  XtSetArg(args[n], XmNmaximum, maxValue); n++;
  XtSetArg(args[n], XmNminimum, minValue); n++;
  XtSetArg(args[n], XmNorientation, XmVERTICAL); n++;
  XtSetArg(args[n], XmNsliderSize,20); n++;
  (*vgrafcntl) = XtCreateWidget("NAME", xmScrollBarWidgetClass,
                                     grafwindow, args, n);
  /* add an activation callback */
  /*XtAddCallback((*vgrafcntl),XmNvalueChangedCallback,buttonscallback,NULL);*/
  XtManageChild((*vgrafcntl));
}
/*___makegrafcntlbar()_______________________________________________________*/

/****makegrafcntllabel()******************************************************/
void    makegrafcntllabel(Widget *cntlvalue, Widget *vgrafcntl)
{
/*printf("makegrafcntllabel()\n");*/

  n = 0;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_OPPOSITE_WIDGET); n++;
  XtSetArg(args[n], XmNleftWidget, *vgrafcntl); n++;

  XtSetArg(args[n], XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET); n++;
  XtSetArg(args[n], XmNtopWidget, *vgrafcntl); n++;
  XtSetArg(args[n], XmNtopOffset, -25); n++;

  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNrightOffset,0); n++;

  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_WIDGET); n++;
  XtSetArg(args[n], XmNbottomWidget, *vgrafcntl); n++;
  XtSetArg(args[n], XmNbottomOffset,2); n++;

  (*cntlvalue) = XtCreateWidget(" ", xmLabelWidgetClass, grafwindow, args, n);
  XtManageChild(*cntlvalue);
}
/*___makegrafcntllabel()_____________________________________________________*/
#endif
#ifdef UNDEFINED 
/****hilitegrafcntlbar()******************************************************/
void    hilitegrafcntlbar(ControlHandle *vgrafcntl)
{
    WindowPtr    oldPort;
    
/*m*/   GetPort(&oldPort);
/*m*/   SetPort(grafWindow);

/*m*/   HLock((Handle)(*vgrafcntl));
/*m*/   if (grafWindow != FrontWindow())  
        {       /* un-hilite scroll bars if window not front */
/*m*/        HiliteControl((*vgrafcntl),0); /*first, turn them on*/
/*m*/        HiliteControl((*vgrafcntl),255);
        }
        else   /* hilite scroll bars of front window */
/*m*/        HiliteControl((*vgrafcntl),0);
/*m*/   HUnlock((Handle)(*vgrafcntl));
/*m*/   SetPort(oldPort);
}
/*___hilitegrafcntlbar()_____________________________________________________*/
#endif

#ifdef UNIX_MOTIF

/****resetgrafcntlbar()*******************************************************/
void    resetgrafcntlbar(ControlHandle *vgrafcntl,int shiftPlace)
{
    int thumb; /*size*/
    int step; /*step when click in arrow*/
    int page; /*page move when click in body*/
    int notify; /*1 notifies changed-value call back, 0 does not */
    thumb = 20;
    step = 10;
    page = 50;
    notify = 0;
    XmScrollBarSetValues(*vgrafcntl,shiftPlace,thumb,step,page,notify);
}
/*___resetgrafcntlbar()______________________________________________________*/
#endif
#ifdef UNIX_MOTIF

/****getgrafwinedges()********************************************************/
void    getgrafwinedges(int *left,int *top,int *right,int *bottom)
{
        /*UNIX drawArea width,height: gright,gbottom*/
  Dimension width, height;

  n=0;
  XtSetArg(args[n], XtNwidth, &width); n++;
  XtSetArg(args[n], XtNheight, &height); n++;
  
  XtGetValues(drawArea,args,n);
/*printf("width== %d, height== %d\n",width,height);*/

      *left = 0;
      *top = 0;
      *right =  width;
      *bottom =  height;
}
/*___getgrafwinedges()_______________________________________________________*/

#endif

#ifdef UNDEFINED 
/****writecntlbarvalue********************************************************/
void    writecntlbarvalue(int left,int top,int right,int bottom)
{
    char    shtstr[3];
    
    WindowPtr    oldPort;
    
/*m*/     GetPort(&oldPort);
/*m*/    SetPort(grafWindow);

        shtstr[0] = '\2'; /* will be a pascal string of length 2  */
        shtstr[2] = ' ';  /*extra blank needed to wipe proportionally spaced*/
                            /* characters */
/*m*/    TextMode(srcCopy);

        shtstr[1] = word[0];
/*m*/    MoveTo(    right-13,top + 30);
/*m*/    DrawString((unsigned char *)shtstr);

        shtstr[1] = word[1];
/*m*/    MoveTo(    right-13,bottom-76);
/*m*/    DrawString((unsigned char *)shtstr);

        shtstr[1] = word[2];
/*m*/    MoveTo(    right-13,bottom-61);
/*m*/    DrawString((unsigned char *)shtstr);

        shtstr[1] = word[3];
/*m*/    MoveTo(    right-13,bottom-46);
/*m*/    DrawString((unsigned char *)shtstr);

        shtstr[1] = word[4];
/*m*/    MoveTo(    right-13,bottom-31);
/*m*/    DrawString((unsigned char *)shtstr);

        shtstr[1] = word[5];
/*m*/    MoveTo(    right-13,bottom-16);
/*m*/    DrawString((unsigned char *)shtstr);

        shtstr[1] = word[6];
/*m*/    MoveTo(    right-13,bottom-1);
/*m*/    DrawString((unsigned char *)shtstr);

/*m*/    /*MoveTo(    right-30,top+17);*/
/*m*/    /*DrawString("\p0    0");*/     /*clear value*/
/*m*/    MoveTo(    right-30,top+17);
/*m*/    DrawString((unsigned char *)numstr);
XSetForeground(dpy,gc,incolor[255]);
XSetForeground(dpy,gc,BlackPixel(dpy,DefaultScreen(dpy)));
    XDrawString(dpy,offscreen,offgc,ix,iy,string,strlen(string));


/*m*/   SetPort(oldPort);
}
/*____writecntlbarvalue______________________________________________________*/
#endif

#ifdef UNIX_MOTIF
/****writecntlbarvalue********************************************************/
void    writecntlbarvalue(Widget *cntllabel )
{
/*printf("writecntlbarvalue()\n");*/
    n = 0;
    XtSetArg(args[n], XmNlabelString
           ,XmStringCreate(numstr,XmSTRING_DEFAULT_CHARSET) ); n++;
    XtSetValues(*cntllabel, args, n);

}
/*____writecntlbarvalue______________________________________________________*/
#endif

#ifdef UNDEFINED 
/****writespecialmark()********************************************************/
void    writespecialmark(int left,int top,int right,int bottom)
{
    char    shtstr[3];
    
    WindowPtr    oldPort;
    
/*m*/     GetPort(&oldPort);
/*m*/    SetPort(grafWindow);

        shtstr[0] = '\2'; /* will be a pascal string of length 2  */
        shtstr[2] = ' ';  /*extra blank needed to wipe proportionally spaced*/
                            /* characters */
/*m*/    TextMode(srcCopy);

         shtstr[1] = '\306';
/*m*/    MoveTo(    right-7,bottom-1);
/*m*/    DrawString((unsigned char *)shtstr);


/*m*/   SetPort(oldPort);
}
/*____writespecialmark()______________________________________________________*/


/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
#endif

#ifdef UNDEFINED 

/******settextScrollBar*******************************************************/
void    settextScrollBar()
{
    Rect            vTScrollRect;
    
    HLock((Handle)vtextScroll);
    if (textWindow != FrontWindow())  
        /* un-hilite scroll bars if window not front */
        HiliteControl(vtextScroll,255);
    else  /* hilite scroll bars of front window, and redo scroll bars */
    {
        HiliteControl(vtextScroll,0);
        
        SetRect(&vTScrollRect,    (*textWindow).portRect.right-15,
                            (*textWindow).portRect.top-1,
                            (*textWindow).portRect.right+1,
                            (*textWindow).portRect.bottom-14);
        (**vtextScroll).contrlRect = vTScrollRect;
    
        DrawControls(textWindow);
        DrawGrowIcon(textWindow);
    }
    HUnlock((Handle)vtextScroll);
}
/*____settextScrollBar_______________________________________________________*/

#endif

#ifdef UNDEFINED 
/******setcaptScrollBar*******************************************************/
void    setcaptScrollBar()
{
    Rect            vTScrollRect;
    
    HLock((Handle)vcaptScroll);
    if (captWindow != FrontWindow())  
        /* un-hilite scroll bars if window not front */
        HiliteControl(vcaptScroll,255);
    else  /* hilite scroll bars of front window, and redo scroll bar */
    {
        HiliteControl(vcaptScroll,0);
        
        SetRect(&vTScrollRect,    (*captWindow).portRect.right-15,
                            (*captWindow).portRect.top-1,
                            (*captWindow).portRect.right+1,
                            (*captWindow).portRect.bottom-14);
        (**vcaptScroll).contrlRect = vTScrollRect;
    
        DrawControls(captWindow);
        DrawGrowIcon(captWindow);
    }
    HUnlock((Handle)vcaptScroll);
}
/*___________________________________________________________________________*/

#endif

#ifdef UNDEFINED 
/*****gettextTextarea*********************************************************/
void    gettextTextarea()
{
    BlockMove(&textWindow->portRect, &textvRect, sizeof(Rect)); 
        /* define text area of window */
    textvRect.right -= 16;      /* allow for vertical scroll bar */  
    BlockMove(&textvRect, &textdRect, sizeof(Rect));      
        /* redefine destRect to be that area */
     textdRect.left     += 4;     /* indent for readability */
      textdRect.top     += 4;
      textdRect.right     -= 4;
      textdRect.bottom -= 4;
}
/*___gettextTextarea_________________________________________________________*/

#endif

#ifdef UNDEFINED 
/*****getcaptTextarea*********************************************************/
void    getcaptTextarea()
{
    BlockMove(&captWindow->portRect, &captvRect, sizeof(Rect)); 
        /* define text area of window */
    captvRect.right -= 16;      /* allow for vertical scroll bar */  
    BlockMove(&captvRect, &captdRect, sizeof(Rect));      
        /* redefine destRect to be that area */
     captdRect.left     += 4;     /* indent for readability */
      captdRect.top     += 4;
      captdRect.right     -= 4;
      captdRect.bottom -= 4;
}
/*___getcaptTextarea_________________________________________________________*/

#endif

#ifdef UNDEFINED 
/*****settextTextarea*********************************************************/
void    settextTextarea()
{
    int         lineshifted, moveHeight,lineWorth;
    maxValue=10000;
    minValue = 0;
    HLock((Handle)textText);
    HLock((Handle)vtextScroll);
    (*textText)->destRect = textdRect; /*into which text is tried to be drawn*/
    (*textText)->viewRect = textvRect;
    TECalText(textText);
    nLines = (*textText)->nLines;  /* total lines of text */
    viewLines = (textdRect.bottom - textdRect.top)/textHeight; 
        /* lines viewed in window */
    textLines = nLines - viewLines;
    if (nLines <= viewLines) 
    {
        textLines = 1;
        Ltextsize = FALSE;   /*nothing to scroll for */
    }
    else
    {
        Ltextsize = TRUE;   /* textLines of text off window to scroll for */
    }

    (*textText)->destRect = textdRect; /*into which text is drawn completely*/
    TECalText(textText);
    startValue = GetCtlValue(vtextScroll);
    lineWorth = (maxValue -minValue)/textLines;
    if(lineWorth == 0) lineWorth = 1;
    lineshifted = (startValue - minValue)/lineWorth;
    moveHeight = lineshifted * textHeight;                  
    TEScroll(0, -moveHeight, textText);  /* move contents */
    HUnlock((Handle)textText);
    HUnlock((Handle)vtextScroll);
}
/*___settextTextarea_________________________________________________________*/

#endif

#ifdef UNDEFINED 
/*****setcaptTextarea*********************************************************/
void    setcaptTextarea()
{
    int         lineshifted, moveHeight,lineWorth;
    maxValue=10000;
    minValue = 0;
    HLock((Handle)captText);
    HLock((Handle)vcaptScroll);
    (*captText)->destRect = captdRect; /*into which text is tried to be drawn*/
    (*captText)->viewRect = captvRect;
    TECalText(captText);
    nLines = (*captText)->nLines;  /* total lines of text */
    viewLines = (captdRect.bottom - captdRect.top)/captHeight; 
        /* lines viewed in window */
    captLines = nLines - viewLines;
    if (nLines <= viewLines) 
    {
        captLines = 1;
        Lcaptsize = FALSE;   /*nothing to scroll for */
    }
    else
    {
        Lcaptsize = TRUE;   /* captLines of text off window to scroll for */
    }
/*    captdRect.bottom = captHeight*nLines + captdRect.top;*/
    (*captText)->destRect = captdRect; 
        /*into which caption is drawn completely*/
    TECalText(captText);
    startValue = GetCtlValue(vcaptScroll);
    lineWorth = (maxValue -minValue)/captLines;
    if(lineWorth == 0) lineWorth = 1;
    lineshifted = (startValue - minValue)/lineWorth;
    moveHeight = lineshifted * captHeight;                  
    TEScroll(0, -moveHeight, captText);  /* move contents */
    HUnlock((Handle)captText);
    HUnlock((Handle)vcaptScroll);
}
/*___setcaptTextarea_________________________________________________________*/

#endif

#ifdef UNDEFINED 
/****captupdate()*************************************************************/
void    captupdate()
{
    WindowPtr    oldPort;

            GetPort(&oldPort);
            SetPort(captWindow);
              BeginUpdate(captWindow);
              InvalRect(&captWindow->portRect);
                  setcaptScrollBar();
                  getcaptTextarea();
                  setcaptTextarea();
                  HLock((Handle)captText);
                  TEActivate(captText);
                  TEUpdate(&captdRect,captText);
                  HUnlock((Handle)captText);
                  ValidRect(&captWindow->portRect); 
                      /*tell window manager window is ok*/
              EndUpdate(captWindow);
            SetPort(oldPort);
}
/*___captupdate()____________________________________________________________*/

#endif

#ifdef UNDEFINED 
/****textupdate()*************************************************************/
void    textupdate() { ; }
/*___textupdate()____________________________________________________________*/
#endif

#ifdef UNIX_MOTIF
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/*BOND ROTATION CONTROLS */
/****creategrafbondrotBar()*********common name: MAC and PC and UNIX *********/
void    creategrafbondrotBar(int i)
{
    short    maxValue=180,minValue=-180; /*over-rides for bond rotation range*/
    char    name[13];
    int     left,top,right,bottom;
    int     gleft,gtop,gright,gbottom;    
    
       
        /*getgrafwinedges(&gleft,&gtop,&gright,&gbottom);*/ /*___BAR.C*/
        /*UNIX drawArea width,height: gright,gbottom*/
        
        /* define horizontal scroll bar in UNIX separate window*/
        left = 0; /*offset*/
        top = i*10; /* % offset from top of separate window height */
        right = 0; /*offset*/
        bottom = top+2; /* % offset from top of separate window height */
            
        makegrafbondrotbar(&hgrafbondrot[i]
                        ,left,top,right,bottom
                        ,minValue,maxValue);   /*___BAR.C*/
        XtAddCallback(hgrafbondrot[i],XmNvalueChangedCallback,bondrot_CB,i);
        makebondrotlabels(i); /*___BAR.C*/
        writebondrotvalue(i); /*___BAR.C*/
        /*hilitegrafcntlbar(&hgrafbondrot[i]);*/ /*MACBAR.C*/
}
/*___creategrafbondrotBar()_________________________________________________*/
#endif

#ifdef UNIX_MOTIF
/****makegrafbondrotbar()*********common name: MAC and PC and UNIX **********/
void    makegrafbondrotbar(Widget *hgrafcntl
                        ,int left,int top,int right,int bottom
                        ,short minValue,short maxValue)
{                                        
/*
printf("makegrafbondrotbar():L,T,R,B: %d, %d, %d, %d\n",left,top,right,bottom);
*/
  n = 0;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n++;

  XtSetArg(args[n], XmNtopAttachment, XmATTACH_POSITION); n++;
  XtSetArg(args[n], XmNtopPosition, top); n++;

  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n++;

  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_POSITION); n++;
  XtSetArg(args[n], XmNbottomPosition, bottom); n++;

  XtSetArg(args[n], XmNmaximum, maxValue); n++;
  XtSetArg(args[n], XmNminimum, minValue); n++;
  XtSetArg(args[n], XmNorientation, XmHORIZONTAL); n++;
  XtSetArg(args[n], XmNsliderSize,20); n++;
  (*hgrafcntl)=XtCreateWidget("NAME",xmScrollBarWidgetClass,brotwindow,args,n);
  XtManageChild((*hgrafcntl));
}
/*___makegrafbondrotbar()___________________________________________________*/
#endif

#ifdef UNIX_MOTIF
/****makebondrotlabels()*********common name: MAC and PC and UNIX **********/
void    makebondrotlabels(int i)
{                                        
    int left, top, right, bottom;

/*printf("makebondrotlabels(%d)\n",i);*/
        /*stack three labels onto slider*/
        left = 0; /*offset from brotwindow left edge*/
        top = 20; /*offset from Widget below*/
        right = 0; /*offset from brotwindow right edge*/
        bottom = 2; /*offset from Widget below */
makebondrotlabelwidget(&bondrotvalue[i],&hgrafbondrot[i],left,top,right,bottom);
makebondrotlabelwidget(&bondrotstart[i],&bondrotvalue[i],left,top,right,bottom);
makebondrotlabelwidget(&bondrotname[i],&bondrotstart[i],left,top,right,bottom);
}
/*___makebondrotlabels()___________________________________________________*/
#endif

#ifdef UNIX_MOTIF
/****makebondrotlabelwidget()********* just UNIX *****************************/
void    makebondrotlabelwidget(Widget *thiswidget, Widget *lastwidget
                        ,int left,int top,int right,int bottom)
{                                        
/*printf("makebondrotlabelwidget()\n");*/
  n = 0;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n++;

/*
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET); n++;
  XtSetArg(args[n], XmNtopWidget, *lastwidget); n++;
  XtSetArg(args[n], XmNtopPosition, 25); n++;
*/

  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n++;

  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_WIDGET); n++;
  XtSetArg(args[n], XmNbottomWidget, *lastwidget); n++;
  XtSetArg(args[n], XmNbottomOffset, bottom); n++;

  (*thiswidget)=XtCreateWidget("NAME",xmLabelWidgetClass,brotwindow,args,n);
  XtManageChild((*thiswidget));
}
/*___makebondrotlabelwidget()________________________________________________*/
#endif

#ifdef UNIX_MOTIF
/****resetgrafbondrotBar()**************common name: MAC and PC and UNIX *****/
void    resetgrafbondrotBar(int i)  
{
    int                shiftPlace;
    short   maxValue=180,minValue=-180;   /*over-rides for zoom range */

          shiftPlace = (short)(bondrotout[i]+.5);
          resetgrafcntlbar(&hgrafbondrot[i],shiftPlace); /*___BAR.C*/
          writebondrotvalue(i); /*___BAR.C*/
}
/*___resetgrafbondrotBar()__________________________________________________*/
#endif

#ifdef UNIX_MOTIF
/****writebondrotvalue()************common name: MAC and PC and UNIX ********/
void    writebondrotvalue(int i)  
{
        sprintf(numstr,"%4.2f",bondrotout[i]);/*numstr global variable*/
        writecntlbarvalue(&bondrotvalue[i]);
        sprintf(numstr,"%4.2f",bondrotin[i]);
        writecntlbarvalue(&bondrotstart[i]);
        sprintf(numstr,"%s",bondname[i]);
        writecntlbarvalue(&bondrotname[i]);
}
/*___writebondrotvalue()____________________________________________________*/
#endif

#ifdef UNDEFINED 
/****erasebondrotvalue()************common name: MAC and PC******************/
void    erasebondrotvalue(int i)  
{
    int     left,top,right,bottom;
    int     gleft,gtop,gright,gbottom;    
         /*need lots of spaces to erase proportional type */
/*c*/    sprintf(word,"                      "); 
         condition(word);     /*MACMAIN.C*/ 
/*c*/    sprintf(numstr,"          "); 
         condition(numstr);   /*MACMAIN.C*/  
/*c*/    sprintf(alertstr,"          "); 
         condition(alertstr); /*MACMAIN.C*/  

        getgrafwinedges(&gleft,&gtop,&gright,&gbottom); /*MACBAR.C*/
        /*UNIX drawArea width,height: gright,gbottom*/
        left = gright-RWIDTH;
        top = gtop+(i*45);
        right = gright;
        bottom = top+10;
                        
        writebondrotbarvalue(left,top,right,bottom); /*MACBAR.C*/
}
/*___erasebondrotvalue()____________________________________________________*/

#endif

#ifdef UNDEFINED 
/****writebondrotbarvalue()****common name: MAC and PC***********************/
void    writebondrotbarvalue(int left,int top,int right,int bottom)
{                          
    char    shtstr[3];
    
    WindowPtr    oldPort;
    
/*m*/     GetPort(&oldPort);
/*m*/    SetPort(grafWindow);

/*m*/    TextMode(srcCopy);

/*m*/    MoveTo(left,top-10);
/*m*/    DrawString((unsigned char *)word);


/*m*/    MoveTo(right-35,top-18);
/*m*/    DrawString((unsigned char *)alertstr);
/*m*/    MoveTo(right-35,top-3);
/*m*/    DrawString((unsigned char *)numstr);


/*m*/   SetPort(oldPort);
}
/*____writebondrotbarvalue__________________________________________________*/

#endif

#ifdef UNDEFINED 
/******grafbondrotter()******************************************************/
pascal void    grafbondrotter(ControlHandle theControl,short partcode)
{
    /*theControl should have been locked by calling routine */
    short    maxValue=180,minValue=-180;    /*over-rides for bond rot range */
    int                lineWorth, imove = 0, target, i;
    float   theta;
    
    startValue = GetCtlValue(theControl); 
    viewLines = 10;
    lineWorth = 1;
      switch(partcode)
      {
         case inUpButton:
           if (startValue >= minValue)
             imove = +1;
             target = startValue - (imove*lineWorth);
             if( target < minValue) target = maxValue+target-minValue;
                                             /*target negative*/
           break;
         case inPageUp:
           if (startValue > minValue)
             imove = +viewLines;
             target = startValue - (imove*lineWorth);
             if( target < minValue) target = minValue;
           break;
         case inDownButton:
           if (startValue <= maxValue)
             imove = -1;
             target = startValue - (imove*lineWorth);
             if( target > maxValue) target = minValue+target-maxValue;
          break;
         case inPageDown:
           if (startValue < maxValue)
             imove = -viewLines;
             target = startValue - (imove*lineWorth);
             if( target > maxValue) target = maxValue;
           break;
      }
     if (imove != 0)
      {
             HLock((Handle)theControl);
             SetCtlValue(theControl, target); /* move thumb */
             HUnlock((Handle)theControl);
        
           /*now have to figure out again which bondrot called this*/
            for(i=1; i<=nbondrot; i++)
            {
              if(theControl == hgrafbondrot[i]) 
              {
                  theta = target - bondrotout[i];
                  bondrotout[i] = target;
            
                  writebondrotvalue(i); /*MACBAR.C*/

                 /* do bond rotation matrix update and apply, then... */
                 dobondrot(i,theta); /* rotation done on float array entries*/
                     /*MAGEANGL.C*/
                 rescalekinemage();  /* rescale rebuilds from float arrary*/
                     /*MAGEINPT.C*/
                 break;
              }                        
            }
             
            redrawvec(); /*MACDRAW.C*/
      }
    endValue = GetCtlValue(theControl);
}
/*____grafbondrotter()______________________________________________________*/

/*BOND ROTATION CONTROLS */
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/

#endif

