/*MUXMBBOX.c*/
#include "MAGE.H"  

/****buttonscallback()******************************************************/
void buttonscallback(Widget w, XtPointer clientData, XtPointer callData)
{/*should be a message from a checkbox*/
 /*general callback routine for all check box gadgets*/
    int i,ion,indexPC;

    XmToggleButtonCallbackStruct *cbs = 
                (XmToggleButtonCallbackStruct * ) callData;
        {/*button clicked*/
          /*Mac Mage button stuff is in DografContentClick() in macmain.c*/ 
          /*PC  Mage button stuff is in MainWndProc() in mpcmain.c*/ 
          /* beware: all possible check boxes have index numbers */ 
          /* even if not created, */
          /* so search by same hierarchy that created them */



          for(ngrp = 1; ngrp <= maxgrp+1; ngrp++)
          {/*groups*/         /*maxgrp+1 gets markers*/
            if(igrp[ngrp][4] < 2)
            {/*not nobutton group with no buttons*/
              indexPC = ngrp;
              if(w == buttons[indexPC])
              {
                igrp[ngrp][0] = cbs->set;
              }
              if(igrp[ngrp][4] == 0)
              {/*not a dominant group hiding subgroups and lists*/
                for(nset = igrp[ngrp][1]; nset <= igrp[ngrp][2];nset++)
                {/*sets*/
                  if(iset[nset][3] <= 1) /*set button not shown if >= 2 */
                  {
                  indexPC = MAXG+MAXXG + nset;
                    if(w == buttons[indexPC])
                    {
                      iset[nset][0] = cbs->set;
                    }
                  }    
                  if(iset[nset][3] == 0 || iset[nset][3] >= 2)
                  {/*not hidden lists */
                    /*NOTE: set nobutton allows list buttons*/
                    for(nlist = iset[nset][1];nlist<=iset[nset][2];nlist++)
                    {/*lists*/
                      if(ilist[nlist][6] == 0)
                      {/*not nobutton*/
                        indexPC = MAXG+MAXXG+MAXS + nlist;
                        if(w == buttons[indexPC])
                        {
                           ilist[nlist][0] = cbs->set;
                        }
                      }/*not nobutton*/
                    }/*lists*/
                  }/*not hidden lists */
                }/*sets*/
              }/*not a dominant group hiding subgroups and lists*/
            }/*not nobutton group with no buttons*/
          }/*groups*/
        }/*button clicked*/
        if(nmaster > 0)
        {
          for(i=1; i<=nmaster; i++)
          {
            indexPC = MAXG+MAXXG+MAXS+MAXL+i;
            if( w == buttons[indexPC] )
            {
              ion = cbs->set;
              adjustmaster(i,ion);
            }
          }
        }
        if( (nanimate > 1) && (w == buttons[animbox]) )
        {
          XmToggleButtonSetState(buttons[animbox],0,0); /*no x mark*/
          adjustanimate(1);
        }
        if( (nnanimate > 1) && (w == buttons[anim2box]) )
        {
          XmToggleButtonSetState(buttons[anim2box],0,0); /*no x mark*/
          adjustanimate(2);
        }

        if(w == buttons[pickbox])
        {
          Lpickon = cbs->set;
          if(Lpickon)
          {
            if(Lmeasureson)
               XmToggleButtonSetState(buttons[measurebox],Lmeasureson=0,0);
            if(Ldrawlineon)
               XmToggleButtonSetState(buttons[drawlinebox],Ldrawlineon=0,0);
            if(Lconstructon)
          XmToggleButtonSetState(buttons[constructlinebox],Lconstructon=0,0);
            if(Ldraglineon)
               XmToggleButtonSetState(buttons[draglinebox],Ldraglineon=0,0);
            if(Lnewlabelson)
              XmToggleButtonSetState(buttons[drawlabelsbox],Lnewlabelson=0,0);
          }
        }
        if(w == buttons[pickshowbox])
        {
          Lpickshowon = cbs->set;
        }

        if(w == buttons[zclipbox])
        {
          Lzclipon = cbs->set;
#ifdef UNIX_PEX
          setpexclipplanes();  /*MUXPHIG.c*/
#endif /*UNIX_PEX*/
        }
        if(w == buttons[measurebox])
        {
          Lmeasureson = cbs->set;
          if(Lmeasureson)
          {
              Lnewmeasures = 1; /* start again */
              if(Lpickon)
              {
                  Lpickon = 0;
                  XmToggleButtonSetState(buttons[pickbox],0,0);
              }
          }
        }
        if(w == buttons[drawlinebox])
        {
          Ldrawlineon = cbs->set;
          if(Ldrawlineon)
          {
              if(Lconstructon == 1)
              {
                  Lpoint = 0; /*clear point marked flag*/
                  Lconstructon = 0; /*draw exclusive-or construct*/
                  XmToggleButtonSetState(buttons[constructlinebox],0,0);
                  ilist[maxlist+7][0] = 0; /*turn off point indicater*/
              }
              if(Ldraglineon == 1)
              {
                  Lpoint = 0; /*clear point marked flag*/
                  Ldraglineon = 0; /*draw exclusive-or construct*/
                  XmToggleButtonSetState(buttons[draglinebox],0,0);
                  ilist[maxlist+7][0] = 0; /*turn off point indicater*/
              }
              if(Lnewlabelson == 1)
              {
                  Lnewlabelson = 0; /*draw exclusive-or construct*/
                  XmToggleButtonSetState(buttons[drawlabelsbox],0,0);
                  ilist[maxlist+7][0] = 0; /*turn off point indicater*/
              }

              if(Lpickon)
              {
                  Lpickon = 0;
                  XmToggleButtonSetState(buttons[pickbox],0,0);
              }
          }
        }
        if(w == buttons[constructlinebox])
        {
          Lconstructon = cbs->set;
          if(Lconstructon)
          {
              if(Ldrawlineon == 1)
              {
                    Ldrawlineon = 0; /*draw exclusive-or construct*/
                    XmToggleButtonSetState(buttons[drawlinebox],0,0);
                    if(Lpoint > 0) doeraseline();
                        /*back out of a drawline start*/
                    ilist[maxlist+7][0] = 0; /*turn off point indicater*/
              }
              if(Ldraglineon == 1)
              {
                  Lpoint = 0; /*clear point marked flag*/
                  Ldraglineon = 0; /*draw exclusive-or construct*/
                  XmToggleButtonSetState(buttons[draglinebox],0,0);
                  ilist[maxlist+7][0] = 0; /*turn off point indicater*/
              }
              if(Lnewlabelson == 1)
              {
                  Lnewlabelson = 0; /*draw exclusive-or construct*/
                  XmToggleButtonSetState(buttons[drawlabelsbox],0,0);
                  ilist[maxlist+7][0] = 0; /*turn off point indicater*/
              }

              if(Lpickon)
              {
                  Lpickon = 0;
                  XmToggleButtonSetState(buttons[pickbox],0,0);
              }
          }
          else /*Lconstructon turned off*/
          {
               Lpoint = 0; /*clear point marked flag*/
               ilist[maxlist+7][0] = 0; /*turn off point indicater*/
          }
        }
        if(w == buttons[draglinebox])
        {
          Ldraglineon = cbs->set;
          if(Ldraglineon)
          {
              if(Ldrawlineon == 1)
              {
                    Ldrawlineon = 0; /*draw exclusive-or construct*/
                    XmToggleButtonSetState(buttons[drawlinebox],0,0);
                    if(Lpoint > 0) doeraseline();
                        /*back out of a drawline start*/
                    ilist[maxlist+7][0] = 0; /*turn off point indicater*/
              }
              if(Lconstructon == 1)
              {
                  Lpoint = 0; /*clear point marked flag*/
                  Lconstructon = 0; /*draw exclusive-or construct*/
                  XmToggleButtonSetState(buttons[constructlinebox],0,0);
                  ilist[maxlist+7][0] = 0; /*turn off point indicater*/
              }

              if(Lnewlabelson == 1)
              {
                  Lnewlabelson = 0; /*draw exclusive-or construct*/
                  XmToggleButtonSetState(buttons[drawlabelsbox],0,0);
                  ilist[maxlist+7][0] = 0; /*turn off point indicater*/
              }

              if(Lpickon)
              {
                  Lpickon = 0;
                  XmToggleButtonSetState(buttons[pickbox],0,0);
              }
          }
          else /*Ldraglineon turned off*/
          {
               Lpoint = 0; /*clear point marked flag*/
               ilist[maxlist+7][0] = 0; /*turn off point indicater*/
          }
        }
        if(w == buttons[drawlabelsbox])
        {
          Lnewlabelson = cbs->set;
          if(Lnewlabelson)
          {
              if(Ldrawlineon == 1)
              {
                    Ldrawlineon = 0; /*draw exclusive-or construct*/
                    XmToggleButtonSetState(buttons[drawlinebox],0,0);
                    if(Lpoint > 0) doeraseline();
                        /*back out of a drawline start*/
                    ilist[maxlist+7][0] = 0; /*turn off point indicater*/
              }
              if(Lconstructon == 1)
              {
                  Lpoint = 0; /*clear point marked flag*/
                  Lconstructon = 0; /*draw exclusive-or construct*/
                  XmToggleButtonSetState(buttons[constructlinebox],0,0);
                  ilist[maxlist+7][0] = 0; /*turn off point indicater*/
              }
              if(Ldraglineon == 1)
              {
                  Lpoint = 0; /*clear point marked flag*/
                  Ldraglineon = 0; /*draw exclusive-or construct*/
                  XmToggleButtonSetState(buttons[draglinebox],0,0);
                  ilist[maxlist+7][0] = 0; /*turn off point indicater*/
              }
              if(Lpickon)
              {
                  Lpickon = 0;
                  XmToggleButtonSetState(buttons[pickbox],0,0);
              }
          }
        }

        if(w == buttons[monitorbox])
        {
            Lmonitoron = cbs->set;
        }

        if(w == buttons[eraselinebox])
        {
            XmToggleButtonSetState(buttons[eraselinebox],0,0); /*no x mark*/
            doeraseline();
        }
        if(w == buttons[drawgroupbox])
        {
            igrp[maxgrp+3][0] = cbs->set;
        }

        if(w == buttons[prunebox])
        {
          Lpruneon = cbs->set;
          if(Lpruneon)
          {
              if(Lpunchon == 1) 
              {
                  Lpunchon = 0; /*prune exclusive-or punch*/
                  XmToggleButtonSetState(buttons[punchbox],0,0);
              }
              if(Lpickon)
              {
                  Lpickon = 0;
                  XmToggleButtonSetState(buttons[pickbox],0,0);
              }
          }
        }
        if(w == buttons[punchbox])
        {
          Lpunchon = cbs->set;
          if(Lpunchon)
          {
              if(Lpruneon == 1)
              {
                    Lpruneon = 0; /*punch exclusive-or prune*/
                    XmToggleButtonSetState(buttons[prunebox],0,0);
              }
              if(Lpickon)
              {
                  Lpickon = 0;
                  XmToggleButtonSetState(buttons[pickbox],0,0);
              }
          }
        }
        if(w == buttons[undopbox])
        {
            XmToggleButtonSetState(buttons[undopbox],0,0);/*no x mark*/
            doundoprune();
        }

        redrawgraphics();
#ifdef UNIX_PEX
        updatevisibility();
#endif /*UNIX_PEX*/
}/*should be a message from a checkbox*/
/*___buttonscallback______________________________________________________*/

/****makebuttonbox()****************common name: MAC, PC, ESV**************/
void makebuttonbox(Widget *buttonbox,int left,int top,int right,int bottom
      ,char name[13],int onoff,int nbox,int nn,int index)
{
    int longeststring;

    longeststring = 12;
    buttonbox = buttonbox;   /*avoid not used warning */
    left = left; /*offset from drawArea */
    top = nn*nbox; /*offset from form grafwindow top */
    right = ZWIDTH; /*offset from form grafwindow right edge*/
    bottom = GHEIGHT+MHEIGHT-(top + nn); /*offset from form grafwindow bottom */

    /*    &grpbox[ngrp],             */ /*HANDLE: not used */
    /*    brect->left,               */ /*int left:   x */
    /*    i*fontverticalspace+3,     */ /*int top:    y */
    /*    35+longeststring*fontwidth,*/ /*int right:  width in pixels */
    /*    fontverticalspace,         */ /*int bottom: height in pixels */
    /*    groupname[i],              */ /*char name:  name */
    /*    igrp[ngrp][0],             */ /*int onoff:  flag */
    /*    nbox                       */ /*int      :  number of button */
    /*    nn                         */ /*int      :  height in pixels */
    /*    index                      */ /*int      :  index of button */
/*printf("makebuttonbox():L,T,R,B: %d, %d, %d, %d\n",left,top,right,bottom);*/

/*???*/
  n = 0;
  /*left offset changes to distinguish groups,subgroups,lists*/

  XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
  XtSetArg(args[n], XmNleftWidget, drawArea); n++;
  XtSetArg(args[n], XmNleftOffset, left); n++;

  XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNtopOffset, top); n++;

/*seems that inherent size can cause problems, let slop to right */
/*
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNrightOffset, right); n++;
*/

  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_OPPOSITE_FORM); n++;
  XtSetArg(args[n], XmNbottomOffset, -top-nn); n++;

  XtSetArg(args[n], XmNselectColor, (Pixel)1  ); n++;
  XtSetArg(args[n], XmNfillOnSelect, 1 ); n++;
  XtSetArg(args[n], XmNlabelString,
        XmStringCreate(name, XmSTRING_DEFAULT_CHARSET)); n++;
  buttons[index] = XtCreateWidget(name, xmToggleButtonGadgetClass,
                                     grafwindow, args, n);
  /* add an activation callback */
 XtAddCallback(buttons[index],XmNvalueChangedCallback,buttonscallback,NULL);
  XtManageChild(buttons[index]);
  XmToggleButtonSetState(buttons[index],onoff,0);
}
/*___makebuttonbox()________________________________________________________*/

/***mybuttonspacer()************************common name: MAC, PC, ESV********/
void   mybuttonspacer(int left,int top ,char name[13]) /*macbbox.c mpcbbox.c*/
{
    ;
}
/*___mybuttonspacer()_______________________________________________________*/

/****getbuttonplace()*920605 dcr**************common name: MAC, PC, ESV******/
void   getbuttonplace()
{
    /*Since Motif can set toggle buttons crt drawArea edge, does not need to*/
    /*allow for sliders to right of buttons & button box,name,insets*/
    /* top is 0 for the Form Widget the buttons are in */
    /* bottom is the Widget height! See MUXMINIT.c for grafwindow*/

    brect.left = 0;
    brect.right = 0;
    brect.top =   0;
    brect.bottom = GHEIGHT+MHEIGHT;
}
/*___getbuttonplace()_______________________________________________________*/


/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/

/****setgrpboxcheck()*********************common name: MAC, PC, ESV**********/
void setgrpboxcheck(int ngrp,int icheck)
{
  /*PEX index for structures is up from lists where nlist==index*/
  if(buttons[ngrp])
    XmToggleButtonSetState(buttons[ngrp],icheck,0);
}
/*___setgrpboxcheck()_______________________________________________________*/

/****setsetboxcheck()**********************common name: MAC, PC, ESV*********/
void setsetboxcheck(int nset,int icheck)
{
  /*PEX index for structures is up from lists where nlist==index*/
  if(buttons[MAXG+MAXXG+nset])
    XmToggleButtonSetState(buttons[MAXG+MAXXG+nset],icheck,0);
}
/*___setsetboxcheck()____________________________________________________*/

/****setlistboxcheck()**********************common name: MAC & PC*********/
void setlistboxcheck(int nlist,int icheck)
{
  /*PEX index for structures is up from lists where nlist==index*/
  if(buttons[MAXG+MAXXG+MAXS+nlist])
    XmToggleButtonSetState(buttons[MAXG+MAXXG+MAXS+nlist],icheck,0);
}
/*___setlistboxcheck()____________________________________________________*/

/****masterboxcheck()**********************common name: MAC & PC***********/
void masterboxcheck(int i,int icheck)
{
  /*PEX index for structures is up from lists where nlist==index*/
  /*but past all lists, sets, and groups comes the masters*/
  if(buttons[MAXG+MAXXG+MAXS+MAXL+i])
    XmToggleButtonSetState(buttons[MAXG+MAXXG+MAXS+MAXL+i],icheck,0);
}
/*___masterboxcheck()____________________________________________________*/

/****placewindowresizemark()*****SetsinGrafWindow() MAGEBBOX.C************/
void    placewindowresizemark()
{
   ;
}
/*___placewindowresizemark()_____________________________________________*/


/****createbuttons()*920605 dcr**********************************************/
void createbuttons(void)
{
    SetsinGrafWindow();
}
/*___createbuttons()*920605 dcr_____________________________________________*/

/****destroybuttons()******************************************************/
void destroybuttons(void)
{
  int i;
  for (i = 0; i < MAXBUTTONS; ++i) 
  {
    if (buttons[i] != 0) 
    {
        XtDestroyWidget(buttons[i]);
        buttons[i] = 0;
    }
  }
}
/*___destroybuttons()_____________________________________________________*/

/****killgrafcontrols()********<-SetsinGrafWindow(),MAGEBBOX.C*************/
void   killgrafcontrols() 
{
    destroybuttons(); 
} 
/*___killgrafcontrols()___________________________________________________*/

