    /*MUX_MAIN.C*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
#define EXTERN   /* as nothing, this file has the main() */
#include "MAGE.H"   

/****main()*******************************************************************/
main(int argc, char** argv)
{
  XEvent report;
  int i,k;

  /*ProgramName = argv[0];*/
  done = 0; /*master flag, set true exits program */
  Lnewfile = 0; /*no file in mind*/
  Lstartfile = 0; /*mage not launched by a file*/
  if(argc>1) 
  {
      strcpy(NameStr,argv[1]); /*file name copied into MAGE input file Name*/
      Lnewfile=1;   /*file is present*/
      Lstartfile=1; /*file launched mage, use it*/
  }
/*printf("about to do mainsetup()\n");*/
  mainsetup(argc, argv); /*MUXMINIT.C*/

#ifdef UNIX_PEX
/*printf("about to do OpenPhigs()\n");*/
  OpenPhigs();   /*MUXPHIG.c*/
#endif /*UNIX_PEX*/


/*listofevents();*/ /*MUX_EXTRA.c*/

/*printf("about to enter main master loop\n   %d == LASTEvent\n",LASTEvent);*/

    Lcarry = 0;
    while (!done) /* until user wants to quit... */
    {/*master event loop*/
      if(Lbegin) 
      {
/*printf("about to do beginnings()\n");*/
          beginnings();   /*MUXMINIT.C*/
/*printf("just returned from beginnings()\n");*/
      }
      if(Lnewfile)
      {
          /*printf("from mainloop: about to newfile()\n");*/
          newfile();   /*MUX_FILE.c*/
      }
      if(Lreentry)
      {
          /*printf("from mainloop: about to entry()\n");*/
          entry();     /*MAGEFILE.c*/
#ifdef UNIX_PEX
          makepexstructures();       /*MUXPHIG.c*/
          updatevisibility();        /*MUXPHIG.c*/
          resetalltransformations(); /*MUXPHIG.c*/
          knobmotionhandler();       /*MUXPHIG.c*/
#endif /*UNIX_PEX*/
      } 
      if(Lrecalculate)
      {
           /*printf("from mainloop: about to rescalekinemage()\n");*/
           rescalekinemage();    /*MAGEINPT.C*/
           redrawvec();          /*MUXMDRAW.C*/
      }

      /*XtNextEvent(&report);*/  /* get the next event */
                         /*XEvent report;*/
      XtAppNextEvent(app_context,&report); /* get the next event */
#ifdef UNIX_PEX
      if (report.type < LASTEvent)
#endif
      {
/*printf("from mainloop: about to XtDispatchEvent(), report.type==%d\n"*/
/* ,report.type);*/
          XtDispatchEvent(&report);
      }
#ifdef UNIX_PEX
      else
      {
/*printf("from mainloop: about to dospecialevent(), report.type==%d\n"*/
/* ,report.type);*/
          dospecialevent(&report);  /*MUXPHIG.c*/
      }
#endif /*UNIX_PEX*/

    }/*master event loop*/

#ifdef UNIX_PEX
    Cleanup();  /*Cleanup phigs structures, close workstation */
#endif /*UNIX_PEX*/

}
/*___main()_________________________________________________________________*/


void pick_CB(Widget drawArea,caddr_t client_data,XmDrawingAreaCallbackStruct *call_data)
{
/*equivalent to MPCMAIN/WMLButtonDown(), MACMAIN/DografContentClick() */
static int oldx,oldy;
Window *root, *child;
int *root_x,*root_y,*child_x,child_y;
unsigned int keys_buttons;
XEvent *report;
int idelx,idely;

XButtonPressedEvent *bpress = (XButtonPressedEvent *) call_data->event;
XPointerMovedEvent *mousemove = (XPointerMovedEvent *) call_data->event;
    
   if (call_data->reason == XmCR_INPUT)
   {/*call_data->reason == XmCR_INPUT*/
/*printf("%d call_data->event->type\n",call_data->event->type);*/
      switch (call_data->event->type)
      {/*switch call_data->event->type*/
	case ButtonPress:
	  if (bpress->button == Button1)
          {/*Button1*/
          
#ifdef UNIX_PEX
             doxpick(call_data->window,  bpress->x, bpress->y); /*MUXPHIG.c*/ 
#else /*NOT UNIX_PEX*/
              mousex = bpress->x;
              mousexold = bpress->x;
              mousey = bpress->y;
              mouseyold = bpress->y;

              irotxy = 0;
              if( mousey > (GHEIGHT/6) ) irotxy = 1; 
              if(irotxy==1) makecursorxyrot(); /*___MAIN.C*/ 
              else          makecursorzrot();  /*___MAIN.C*/ 


              ipick = 2; /*flag for pick point recognition for button press*/
              pickx = mousex;
              picky = mousey;
              Lpick = 0; /*flag nothing picked yet */
              if(Ldraglineon)
              {
                  Lnewdrag = 1;
                  Lnewmatrix = 1;
              }

              redrawvec();
              Lcarry = 1;

              if(Lpick) redrawvec(); /*MACDRAW.C*/
                     /*to move marker to picked atom if any near */
#endif /*if---else of UNIX_PEX*/
              break;
          }/*Button1*/
	  else
          {/*some other button pressed*/
            ;
#ifdef UNIX_PEX
            doxprepick(call_data->window,  bpress->x, bpress->y); /*MUXPHIG.c*/
#endif /*UNIX_PEX*/
          }
	break; /*from case ButtonPress */
	case ButtonRelease:
          Lcarry = 0;
#ifdef UNIX_PEX
	 doxpickpredraw(); /*MUXPHIG.c*/ 
#endif /*UNIX_PEX*/
	break; /*from case ButtonRelease*/
      }/*switch call_data->event->type*/
   }/*call_data->reason == XmCR_INPUT*/
}
/*___pick_CB()_______________________________________________________________*/

/****motion_handler***********************************************************/
/*void motion_handler(Widget widget,caddr_t client_data,XEvent *event,Boolean *continue_to_dispatch)*/

void motion_handler(widget, client_data, event)
     Widget widget;                 
     caddr_t client_data;           
     register XPointerMovedEvent  *event;                  /*Vol 4, 218*/
  /* Boolean *continue_to_dispatch; */

/*equivalent to MPCMAIN/WMMouseMove(), MACDRAW/Drawgraf( internal loop ) */

{
int idelx,idely;
              
  mousex = event->x; 
  mousey = event->y; 

  if(XtAppPending(app_context) == 0)
  {
    idelx = (mousex - mousexold);
    idely = (mousey - mouseyold);
    if(idelx!=0 || idely!=0)
    {/*no pending events*/ /*so caught up to latest mouse movement*/
         mousexold = mousex;
         mouseyold = mousey;
         pickx = mousex; /*dragline needs this updated*/
         picky = mousey;

         getrot(idelx,idely); /*MAGEDRAW.c*/
         redrawvec();
    }
  }/*no pending events*/
}
/*___motion_handler()________________________________________________________*/

/****condition()*************************************************************/
void    condition(char strg[256]){;}
/*___condition()____________________________________________________________*/
/****recondition()***********************************************************/
void    recondition(char strg[256]){;}
/*___recondition()__________________________________________________________*/

/****makecursoractive()******************************************************/
void    makecursoractive(){;}
/*___makecursoractive()_____________________________________________________*/

/****makecursorwait()********************************************************/
void    makecursorwait(){;}
/*___makecursorwait()_______________________________________________________*/

/****makecursorxyrot()*******************************************************/
void    makecursorxyrot(){;}
/*___makecursorxyrot()______________________________________________________*/

/****makecursorzrot()********************************************************/
void    makecursorzrot(){;}
/*___makecursorzrot()_______________________________________________________*/

/****theclockcount()********************950113*********/
long    theclockcount()
{
    return(0);
}
/*___theclockcount()____________________________*/

/*
				Get_events

  This routine processes events requested by the program.  XtNextEvent
  obtains the next event from the input queue and places it in report.  The
  type of the event is then examined to determine if it is an extension
  event or a regular X event.  The constant LASTEvent (defined in X.h) is
  bigger than the event type of any X event and can be used to
  differentiate extension events from normal X events.

  Regular events are handled by the toolkit dispatch mechanism via
  XtDispatchEvent.  Extension events (DeviceMotion and picking events) are
  handled on a case-by-case basis.

  When a DeviceMotion event is encountered, all device motion events are
  removed from the event queue and accumulated into knob_totals, since the
  dials box reports relative changes.  Event explosion is a very real
  possibility since every device motion event requires 2 XEvent structures
  (only 6 axes' worth of data fit in a single XEvent) and the sample rate
  of the dials box is high.  Since this program is only concerned with
  cumulative changes in the dials values, it is safe to condense the device
  motion events via XCheckTypedEvent.  Since XCheckTypedEvent can remove
  events that are not at the head of the event queue, it may not be
  appropriate for situations where the semantics of a device motion event
  can be changed by another event (for instance, a key or button press).

  When a pick event is encountered, the picked structure element is identified
  and the corresponding list is searched for the nearest point to the picked
  coordinates.  If pick-centering is on, then the local MAGE center is updated
  and the display redrawn.  If markers are on, the markers are placed on the
  closest point to the pick-place.
*/
